#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <string.h>
#include <dos.h>
#include "2draw.h"
#include "names.h"

#define TICSPERFRAME 3

//Status list 0: Power-ups
//Status list 1: Monsters
//Status list 2: Bullets
//Status list 3: Explosions

void (__interrupt __far *oldtimerhandler)();
void __interrupt __far timerhandler(void);

	//Player variables
static long posx[MAXPLAYERS], posy[MAXPLAYERS], zoom[MAXPLAYERS];
static short ang[MAXPLAYERS], vel[MAXPLAYERS], svel[MAXPLAYERS];
static short angvel[MAXPLAYERS], zoomvel[MAXPLAYERS];
static long lastshoottime[MAXPLAYERS], health[MAXPLAYERS];
static long deadspinx[MAXPLAYERS], deadspiny[MAXPLAYERS];
static char prepboardflag[MAXPLAYERS];

#define NUMOPTIONS 8
#define NUMKEYS 19
static long chainxres[4] = {256,320,360,400};
static long chainyres[11] = {200,240,256,270,300,350,360,400,480,512,540};
static long vesares[7][2] = {320,200,640,400,640,480,800,600,1024,768,
									  1280,1024,1600,1200};
static char option[NUMOPTIONS] = {0,0,0,0,0,0,1,0};
static char keys[NUMKEYS] =
{
	0xc8,0xd0,0xcb,0xcd,0x2a,0x9d,0x1d,0x39,
	0x1e,0x2c,0xd1,0xc9,0x47,0x49,
	0x9c,0x1c,0xd,0xc,0xf,
};

static long digihz[7] = {6000,8000,11025,16000,22050,32000,44100};

static long lockclock = 0, ototalclock = 0, ready2send = 0;
static long oposx[MAXPLAYERS], oposy[MAXPLAYERS], ozoom[MAXPLAYERS];
static short oang[MAXPLAYERS];

static long cposx[MAXPLAYERS], cposy[MAXPLAYERS], czoom[MAXPLAYERS];
static short cang[MAXPLAYERS];

static long ospritex[MAXSPRITES];
static long ospritey[MAXSPRITES];
static long ospritezoom[MAXSPRITES];
static short ospriteang[MAXSPRITES];

static char palette[768], boardfilename[13], moustat = 0;
static short boardnum = 0;

	//Sprite variables
static struct spritetype
{
	long vel, time;
	short angvel, owner, health;
};
struct spritetype sprite[MAXSPRITES];

static char tempbuf[546];
static short screenpeek = 0;
static long masterslavetexttime;

	//ENGINE CONTROLLED MULTIPLAYER VARIABLES:
extern short numplayers, myconnectindex;
extern short connecthead, connectpoint2[MAXPLAYERS];   //Player linked list variables (indeces, not connection numbers)
extern char syncstate;

	//Local syncing variables
static signed char locmousx, olocmousx;
static signed char locmousy, olocmousy;
static short locbits, olocbits;

	//Send/Receiving syncing variables
static signed char fsyncmousx[MAXPLAYERS], osyncmousx[MAXPLAYERS], syncmousx[MAXPLAYERS];
static signed char fsyncmousy[MAXPLAYERS], osyncmousy[MAXPLAYERS], syncmousy[MAXPLAYERS];
static short fsyncbits[MAXPLAYERS], osyncbits[MAXPLAYERS], syncbits[MAXPLAYERS];

#define MOVEFIFOSIZE 128
static long movefifoplc, movefifoend;
static signed char baksyncmousx[MOVEFIFOSIZE][MAXPLAYERS];
static signed char baksyncmousy[MOVEFIFOSIZE][MAXPLAYERS];
static short baksyncbits[MOVEFIFOSIZE][MAXPLAYERS];

	//Record/Playback variables
static long reccnt, recstat = 1;
static signed char recsyncmousx[16384][2];
static signed char recsyncmousy[16384][2];
static short recsyncbits[16384][2];

	//Variables that let you type messages to other player
static char getmessage[162], getmessageleng;
static long getmessagetimeoff;
static char typemessage[162], typemessageleng = 0, typemode = 0;
static char scantoasc[128] =
{
	0,0,'1','2','3','4','5','6','7','8','9','0','-','=',0,0,
	'q','w','e','r','t','y','u','i','o','p','[',']',0,0,'a','s',
	'd','f','g','h','j','k','l',';',39,'`',0,92,'z','x','c','v',
	'b','n','m',',','.','/',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};
static char scantoascwithshift[128] =
{
	0,0,'!','@','#','$','%','^','&','*','(',')','_','+',0,0,
	'Q','W','E','R','T','Y','U','I','O','P','{','}',0,0,'A','S',
	'D','F','G','H','J','K','L',':',34,'~',0,'|','Z','X','C','V',
	'B','N','M','<','>','?',0,'*',0,32,0,0,0,0,0,0,
	0,0,0,0,0,0,0,'7','8','9','-','4','5','6','+','1',
	'2','3','0','.',0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
};

#pragma aux klabs =\
	"test eax, eax",\
	"jns skipnegate",\
	"neg eax",\
	"skipnegate:",\
	parm [eax]\

	//eax = (unsigned min)umin(eax,ebx)
#pragma aux umin =\
	"sub eax,ebx",\
	"sbb ecx,ecx",\
	"and eax,ecx",\
	"add eax,ebx",\
	parm [eax][ebx]\
	modify [ecx]\

	//eax = (unsigned max)umax(eax,ebx)
#pragma aux umax =\
	"sub eax,ebx",\
	"sbb ecx,ecx",\
	"not ecx",\
	"and eax,ecx",\
	"add eax,ebx",\
	parm [eax][ebx]\
	modify [ecx]\

#pragma aux mulscale =\
	"imul ebx",\
	"shrd eax, edx, cl",\
	parm [eax][ebx][ecx]\
	modify [edx]\

main(short int argc,char **argv)
{
	short waitplayers, other, tempbufleng;
	long x, y, i, j, k, l, fil, templong;

	if (argc >= 2)
	{
		strcpy(&boardfilename,argv[1]);
		if(strchr(boardfilename,'.') == 0)
			strcat(boardfilename,".map");
	}
	else
		strcpy(&boardfilename,"boards.map");

	if ((fil = open("setup.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&option[0],NUMOPTIONS);
		read(fil,&keys[0],NUMKEYS);
		close(fil);
	}
	if (option[3] != 0) moustat = initmouse();

	switch(option[0])
	{
		case 0: init2draw(0,chainxres[option[6]&15],chainyres[option[6]>>4]); break;
		case 1: init2draw(1,vesares[option[6]&15][0],vesares[option[6]&15][1]); break;
		case 2: init2draw(2,320L,200L); break;
		case 3: init2draw(3,320L,200L); break;
		case 4: init2draw(4,320L,200L); break;
		case 5: init2draw(5,320L,200L); break;
		case 6: init2draw(6,320L,200L); break;
	}
	inittimer();

	initmultiplayers(option[4],option[5]);
	loadpics("tiles000.art");

	initsb(option[1],option[2],digihz[option[7]>>4],((option[7]&4)>0)+1,((option[7]&2)>0)+1,60,option[7]&1);
	loadsong("flysong.kdm");
	musicon();

	loadpalette("palette.dat");
	setviewboundaries();
	permanentwritesprite(0,0,STATUSBAR);

	reccnt = 0;
	prepareboard(boardfilename,boardnum);

	if (option[4] > 0)
	{
		for(i=0;i<MAXPLAYERS;i++) prepboardflag[i] = 0;

		sendlogon();
		if (option[4] < 5) waitplayers = 2; else waitplayers = option[4]-3;
		while (numplayers < waitplayers)
		{
			sprintf(tempbuf,"%ld of %ld players in...",numplayers,waitplayers);
			printext256(68L,84L,31,0,tempbuf);

			if (getpacket(&other,tempbuf) > 0)
				if (tempbuf[0] == 255) cleanexit();

			if (keystatus[1] > 0) cleanexit();
		}
		screenpeek = myconnectindex;
	}

	totalclock = 0;
	ototalclock = 0;
	masterslavetexttime = 0;

	ready2send = 1;
	while (keystatus[1] == 0)       //Main loop starts here
	{
		if (syncstate > 0)
		{
			syncstate--;
			wsayfollow("death.wav",3072L,256L,&posx[screenpeek],&posy[screenpeek],1);
		}
		while (movefifoplc != movefifoend) domovethings();
		drawscreen(screenpeek,(totalclock-ototalclock)*(65536/TICSPERFRAME));
	}
	cleanexit();
}

cleanexit()
{
	long i;

	ready2send = 0;
	sendlogoff();
	musicoff();
	uninitsb();
	uninitmultiplayers();
	uninittimer();
	i = uninit2draw();            //Prepare engine for exit to DOS
	printf("%d.%1d%1d frames per second\n",(i/100),((i/10)%10),(i%10));
	exit(0);
}

drawscreen(short snum, long smoothratio)
{
	long i, j, xvect, yvect, charsperline, templong, x, y, z, a;

	if (smoothratio < 0) smoothratio = 0;
	if (smoothratio > 65536) smoothratio = 65536;

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		cposx[i] = oposx[i]+mulscale(posx[i]-oposx[i],smoothratio,16);
		cposy[i] = oposy[i]+mulscale(posy[i]-oposy[i],smoothratio,16);
		czoom[i] = ozoom[i]+mulscale(zoom[i]-ozoom[i],smoothratio,16);
		cang[i] = oang[i]+mulscale(((ang[i]+1024-oang[i])&2047)-1024,smoothratio,16);
	}

	setears(cposx[snum],cposy[snum],(long)sintable[cang[snum]&2047],(long)sintable[(cang[snum]+1536)&2047]);

			//Draw the full 2-D board
	draw2board(cposx[snum],cposy[snum],czoom[snum],cang[snum]);

		//Draw power-ups
	for(i=headsprite[0];i>=0;i=nextsprite[i])
	{
		a = spriteang[i]-sprite[i].angvel;
		a += mulscale(((spriteang[i]+1024-a)&2047)-1024,smoothratio,16);
		drawsprite(spritex[i],spritey[i],spritezoom[i],a,spritepicnum[i],255);
	}

		//Draw bullets
	for(i=headsprite[2];i>=0;i=nextsprite[i])
	{
		x = ospritex[i]+mulscale(spritex[i]-ospritex[i],smoothratio,16);
		y = ospritey[i]+mulscale(spritey[i]-ospritey[i],smoothratio,16);
		z = ospritezoom[i]+mulscale(spritezoom[i]-ospritezoom[i],smoothratio,16);
		a = ospriteang[i]+mulscale(((spriteang[i]+1024-ospriteang[i])&2047)-1024,smoothratio,16);
		drawsprite(x,y,z,a,spritepicnum[i],255);
	}

		//Draw monsters
	for(i=headsprite[1];i>=0;i=nextsprite[i])
	{
		x = ospritex[i]+mulscale(spritex[i]-ospritex[i],smoothratio,16);
		y = ospritey[i]+mulscale(spritey[i]-ospritey[i],smoothratio,16);
		z = ospritezoom[i]+mulscale(spritezoom[i]-ospritezoom[i],smoothratio,16);
		a = ospriteang[i]+mulscale(((spriteang[i]+1024-ospriteang[i])&2047)-1024,smoothratio,16);

		if (sprite[i].time < totalclock)
			drawsprite(x,y,z,a,spritepicnum[i],255);
		else  //Sprite flash bright pink
			drawsprite(x,y,z,a,spritepicnum[i],254);
	}

		//Draw players
	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		if (health[i] >= 0)
		{
			if ((health[i] >= 4096) || ((totalclock&48) != 0))
				drawsprite(cposx[i],cposy[i],65536,cang[i],AIRPLANE,255);
			else  //Sprite flash red if you're practically dead (it rhymes!)
				drawsprite(cposx[i],cposy[i],65536,cang[i],AIRPLANE,159);
		}
		else
			drawsprite(deadspinx[i],deadspiny[i],65536+(health[i]<<8),ang[i]+(health[i]<<3),BURNINGAIRPLANE,255);
	}

	for(i=headsprite[3];i>=0;i=nextsprite[i])          //Draw explosions over it
	{
		x = ospritex[i]+mulscale(spritex[i]-ospritex[i],smoothratio,16);
		y = ospritey[i]+mulscale(spritey[i]-ospritey[i],smoothratio,16);
		z = ospritezoom[i]+mulscale(spritezoom[i]-ospritezoom[i],smoothratio,16);
		a = ospriteang[i]+mulscale(((spriteang[i]+1024-ospriteang[i])&2047)-1024,smoothratio,16);

		drawsprite(x,y,z,a,spritepicnum[i],255);
	}

		//Tell who's master or slave
	if (lockclock < masterslavetexttime+120)
	{
		if (option[4] == 0)
			printext256(152L,92L,31,-1,"Alone");
		else
		{
			if (myconnectindex == connecthead)
				printext256(152L,92L,31,-1,"Master");
			else
				printext256(152L,92L,31,-1,"Slave");
		}
	}

	if (typemode == 1)
	{
		charsperline = 36;

		for(i=0;i<=typemessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++)
				tempbuf[j] = typemessage[i+j];
			if (typemessageleng < i+charsperline)
			{
				tempbuf[(typemessageleng-i)] = '_';
				tempbuf[(typemessageleng-i)+1] = 0;
			}
			else
				tempbuf[charsperline] = 0;
			printext256(32L,(i/charsperline)<<3,191,-1,tempbuf);
		}
	}
	if (getmessageleng > 0)
	{
		charsperline = 36;

		for(i=0;i<=getmessageleng;i+=charsperline)
		{
			for(j=0;j<charsperline;j++)
				tempbuf[j] = getmessage[i+j];
			if (getmessageleng < i+charsperline)
				tempbuf[(getmessageleng-i)] = 0;
			else
				tempbuf[charsperline] = 0;

			printext256(32L,((i/charsperline)<<3)+(ydim-8)-(((getmessageleng-1)/charsperline)<<3),159,-1,tempbuf);
		}
		if (totalclock > getmessagetimeoff)
			getmessageleng = 0;
	}

	if (keystatus[88] > 0)   //F12
	{
		keystatus[88] = 0;
		screencapture();
	}

	nextpage();
}

getinput()
{
	long i;
	short mousx, mousy, bstatus;

	if (option[3] != 0)
		getmousevalues(&mousx,&mousy,&bstatus);
	else
		{ mousx = 0; mousy = 0; bstatus = 0; }

	locmousx = (signed char)max(min(mousx,127),-128);
	locmousy = (signed char)max(min(mousy,127),-128);
	locbits = 0;

	if (typemode == 0)
	{
		if (keystatus[keys[15]] > 0)  //Left ENTER
		{
			keystatus[keys[15]] = 0;
			screenpeek = connectpoint2[screenpeek];
			if (screenpeek < 0) screenpeek = connecthead;
		}

		if ((keystatus[0x13]&keystatus[keys[4]]) > 0)   //Sh.Sh.R (replay)
		{
			keystatus[0x13] = 0;
			playback();
			keystatus[1] = 1;
		}

		locbits = ((bstatus&1)<<15) + (((bstatus&6)>0)<<14);
		locbits += (keystatus[0x32]<<13);  //M (be master)
		locbits += (keystatus[keys[7]]<<12);
		locbits += (keystatus[0xd1]<<11) + (keystatus[0xc9]<<10);
		locbits += (keystatus[keys[6]]<<9) + (keystatus[keys[5]]<<8);
		locbits += (keystatus[keys[4]]<<7) + (keystatus[keys[9]]<<6);
		locbits += (keystatus[keys[8]]<<5) + (keystatus[keys[3]]<<4);
		locbits += (keystatus[keys[2]]<<3) + (keystatus[keys[1]]<<2);
		locbits += (keystatus[keys[0]]<<1) + keystatus[0x1];
	}
}

movethings()
{
	long i;

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		baksyncmousx[movefifoend][i] = fsyncmousx[i];
		baksyncmousy[movefifoend][i] = fsyncmousy[i];
		baksyncbits[movefifoend][i] = fsyncbits[i];
	}
	movefifoend = ((movefifoend+1)&(MOVEFIFOSIZE-1));
}

domovethings()
{
	long x, y, i, j, k, l, nexti, nextj;
	long dist1, dist2, mindist, xvect, yvect;
	short daang, dapic;

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		syncmousx[i] = baksyncmousx[movefifoplc][i];
		syncmousy[i] = baksyncmousy[movefifoplc][i];
		syncbits[i] = baksyncbits[movefifoplc][i];
	}
	movefifoplc = ((movefifoplc+1)&(MOVEFIFOSIZE-1));

	for(i=connecthead;i>=0;i=connectpoint2[i])
	{
		oposx[i] = posx[i];
		oposy[i] = posy[i];
		ozoom[i] = zoom[i];
		oang[i] = ang[i];
	}

	if ((numplayers <= 2) && (recstat == 1))
	{
		j = 0;
		for(i=connecthead;i>=0;i=connectpoint2[i])
		{
			recsyncmousx[reccnt][j] = syncmousx[i];
			recsyncmousy[reccnt][j] = syncmousy[i];
			recsyncbits[reccnt][j] = syncbits[i];
			j++;
		}
		reccnt++; if (reccnt > 16383) reccnt = 16383;
	}

	lockclock += TICSPERFRAME;

		//Go through power-up sprites
	i = headsprite[0];
	while (i != -1)
	{
		nexti = nextsprite[i];

		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);

		for(k=connecthead;k>=0;k=connectpoint2[k])
			if (klabs(spritex[i]-posx[k]) < 6291456)
				if (klabs(spritey[i]-posy[k]) < 6291456)
				{
					switch(spritepicnum[i])
					{
						case COIN:
							wsayfollow("getstuff.wav",4096L,256L,&spritex[i],&spritey[i],0);
							health[k] += 1024;
							break;
						case SUPERSPIRAL:
							wsayfollow("spiral.wav",4096L,256L,&spritex[i],&spritey[i],0);
							explode((short)i,8,SUPERSPIRALGET);
							health[k] += 4096;
							break;
					}
					deletesprite(i);
					goto nextsprite0;
				}

nextsprite0:
		i = nexti;
	}

		//Go through monster sprites
	i = headsprite[1];
	while (i != -1)
	{
		nexti = nextsprite[i];            //Back up pointer to next sprite

		ospritex[i] = spritex[i];
		ospritey[i] = spritey[i];
		ospriteang[i] = spriteang[i];
		ospritezoom[i] = spritezoom[i];

			//Move monster synctics steps
		j = sprite[i].vel*TICSPERFRAME;
		xvect = ((j*sintable[spriteang[i]])>>2);
		yvect = ((-j*sintable[(spriteang[i]+512)&2047])>>2);
		clipmove(&spritex[i],&spritey[i],xvect,yvect,2097152,1);
		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);

		dapic = spritepicnum[i];
		if ((dapic == AIRPLANE) || (dapic == CAR) || (dapic == CAR2))
		{
				//k = which player to attack
			mindist = 0x7fffffff; k = connecthead;
			for(j=connecthead;j>=0;j=connectpoint2[j])
			{
				dist1 = (posx[j]>>16)-(spritex[i]>>16); dist1 *= dist1;
				dist2 = (posy[j]>>16)-(spritey[i]>>16); dist2 *= dist2;
				if ((dist1+dist2) < mindist) mindist = (dist1+dist2), k = j;
			}

			if (dapic == AIRPLANE)
				if (mindist < (8<<18))
				{
					daang = ((getangle((posx[k]>>8)-(spritex[i]>>8),(posy[k]>>8)-(spritey[i]>>8))+512)&2047);
					if (((spriteang[i]-daang)&2047) < 1024)
						sprite[i].angvel = -(((spriteang[i]-daang)&2047)>>4);
					else
						sprite[i].angvel = (((daang-spriteang[i])&2047)>>4);
						//Enemy airplane randomly shoots a bullet
					if ((((spriteang[i]-daang)&2047) < 128) || (((daang-spriteang[i])&2047) < 128))
						if ((krand()&31) < TICSPERFRAME)
							if (canmovethrough(posx[k],posy[k],spritex[i],spritey[i],2) == 1)
								shootbullet((short)i);
				}
			if (dapic == CAR)
				if (mindist < (32<<18))
				{
					daang = ((getangle((posx[k]>>8)-(spritex[i]>>8),(posy[k]>>8)-(spritey[i]>>8))+512)&2047);
					if (((spriteang[i]-daang)&2047) < 1024)
						sprite[i].angvel = -(((spriteang[i]-daang)&2047)>>6);
					else
						sprite[i].angvel = (((daang-spriteang[i])&2047)>>6);
					//Enemy car randomly shoots a bullet
					if ((((spriteang[i]-daang)&2047) < 128) || (((daang-spriteang[i])&2047) < 128))
						if ((krand()&63) < TICSPERFRAME)   //Enemy car randomly shoots a bullet
							if (canmovethrough(posx[k],posy[k],spritex[i],spritey[i],2) == 1)
								shootbullet((short)i);
				}
			if (dapic == CAR2)
				if (mindist < (32<<18))
				{
					daang = ((getangle((posx[k]>>8)-(spritex[i]>>8),(posy[k]>>8)-(spritey[i]>>8))+512)&2047);
					if (((spriteang[i]-daang)&2047) < 1024)
						sprite[i].angvel = -(((spriteang[i]-daang)&2047)>>7);
					else
						sprite[i].angvel = (((daang-spriteang[i])&2047)>>7);
					//Enemy car randomly shoots a bullet
					if ((((spriteang[i]-daang)&2047) < 256) || (((daang-spriteang[i])&2047) < 256))
						if ((krand()&255) < TICSPERFRAME)   //Enemy car randomly shoots a bullet
							if (canmovethrough(posx[k],posy[k],spritex[i],spritey[i],2) == 1)
								shootbullet((short)i);
				}
		}

		if ((dapic == BROKENCAR) || (dapic == BROKENCAR2))
		{                    //Broken car slows down then shrinks
			if (sprite[i].vel > 0) sprite[i].vel = max(sprite[i].vel-(TICSPERFRAME>>1)-1,0);
			if (sprite[i].vel < 0) sprite[i].vel = min(sprite[i].vel+(TICSPERFRAME>>1)+1,0);
			if (sprite[i].vel == 0) spritezoom[i] -= (TICSPERFRAME<<9);
			if (spritezoom[i] <= 0)
			{                //When car shrinks to nothing, delete it
				deletesprite(i);
				goto nextsprite1;
			}
		}
nextsprite1:
		i = nexti;
	}

		//Go through bullet sprites...
	i = headsprite[2];
	while (i != -1)
	{
		nexti = nextsprite[i];            //Back up pointer to next sprite

		ospritex[i] = spritex[i];
		ospritey[i] = spritey[i];
		ospriteang[i] = spriteang[i];
		ospritezoom[i] = spritezoom[i];

			//Bullet gets deleted after 8 seconds of life (1sec. = 120ticks)
		if (lockclock > sprite[i].time+960)
		{
			deletesprite(i);
			goto nextsprite2;
		}

			//Move bullet synctics steps
		j = sprite[i].vel*TICSPERFRAME;
		xvect = ((j*sintable[spriteang[i]])>>2);
		yvect = ((-j*sintable[(spriteang[i]+512)&2047])>>2);
		clipmove(&spritex[i],&spritey[i],xvect,yvect,2097152,2);
		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);

			 //Check if the bullet hit any players
		for(j=connecthead;j>=0;j=connectpoint2[j])
			if (klabs(spritex[i]-posx[j]) < 6291456)
				if (klabs(spritey[i]-posy[j]) < 6291456)
					if (sprite[i].owner != j+4096)
						if (health[j] >= 0)
						{
							wsayfollow("ouch.wav",4096L+(krand()&511)-256,256L,&spritex[i],&spritey[i],0);
							health[j] -= 1024;
							if (health[j] < 0)
							{
								explode((short)j+4096,16,EXPLOSION);
								deadspinx[j] = posx[j];
								deadspiny[j] = posy[j];
								wsayfollow("death.wav",4096L,256L,&spritex[i],&spritey[i],1);
								health[j] = -1;
							}
							deletesprite(i);
							goto nextsprite2;
						}

			//Check if bullet hit any monsters
		j = headsprite[1];
		while (j != -1)
		{
			nextj = nextsprite[j];

			if (klabs(spritex[i]-spritex[j]) < 6291456)
				if (klabs(spritey[i]-spritey[j]) < 6291456)
					if (sprite[i].owner != j)
						switch(spritepicnum[j])
						{
							case AIRPLANE:
								sprite[j].health -= 1024;
								if (sprite[j].health < 0)
								{
									spritepicnum[j] = BURNINGAIRPLANE;
									spritezoom[j] = 49152;
									sprite[j].vel = 0;
									sprite[j].angvel = 0;
									explode((short)j,32,EXPLOSION);
									if (sprite[i].owner >= 4096)
										wsayfollow("blowup.wav",3584L,256L,&spritex[j],&spritey[j],1);
								}
								else if (sprite[i].owner >= 4096)
								{
									wsayfollow("bullseye.wav",4096L+(krand()&511)-256,256L,&spritex[j],&spritey[j],1);
									sprite[j].time = totalclock+8;    //Flashtime
								}

								deletesprite(i);
								goto nextsprite2;
							case CAR:
								sprite[j].health -= 2048;
								if (sprite[j].health < 0)
								{
									sprite[j].angvel = 0;
									explode((short)j,8,EXPLOSION);
									spritepicnum[j] = BROKENCAR;
									if (sprite[i].owner >= 4096)
										wsayfollow("blowup.wav",4096L,256L,&spritex[j],&spritey[j],1);
								}
								else if (sprite[i].owner >= 4096)
								{
									wsayfollow("bullseye.wav",4096L+(krand()&511),256L,&spritex[j],&spritey[j],1);
									sprite[j].time = totalclock+8;    //Flashtime
								}

								deletesprite(i);
								goto nextsprite2;
							case CAR2:
								if (sprite[i].owner < 4096)    //Don't want car2 to disappear too quickly!
									sprite[j].health -= 1024;
								else
									sprite[j].health -= 16384;
								if (sprite[j].health < 0)
								{
									sprite[j].angvel = 0;
									explode((short)j,8,EXPLOSION);
									spritepicnum[j] = BROKENCAR2;
									if (sprite[i].owner >= 4096)
										wsayfollow("blowup.wav",4608L,256L,&spritex[j],&spritey[j],1);
								}
								deletesprite(i);
								goto nextsprite2;
							case SKATEBOARDDUDE:
								if (sprite[i].owner >= 4096)    //Only a player can kill him!
								{
									sprite[j].angvel = 0;
									explode((short)j,16,BODYPART);
									wsayfollow("explode.wav",4096L,256L,&spritex[j],&spritey[j],1);
									deletesprite(j);
									goto nextsprite2;
								}
						}

			j = nextj;
		}

nextsprite2:
		i = nexti;
	}

	i = headsprite[3];
	while (i != -1)                      //Go through explosion sprites
	{
		nexti = nextsprite[i];

		ospritex[i] = spritex[i];
		ospritey[i] = spritey[i];
		ospriteang[i] = spriteang[i];
		ospritezoom[i] = spritezoom[i];

		if ((sprite[i].owner >= 0) && (sprite[i].owner < 4096))
			if (spritestat[sprite[i].owner] < MAXSTATUS)
			{
					//Keep momentum while dying
				j = sprite[sprite[i].owner].vel*TICSPERFRAME;
				spritex[i] += ((j*sintable[spriteang[sprite[i].owner]])>>3);
				spritey[i] += ((-j*sintable[(spriteang[sprite[i].owner]+512)&2047])>>3);
			}
		j = sprite[i].vel*TICSPERFRAME;
		spritex[i] += ((j*sintable[spriteang[i]])>>2);
		spritey[i] += ((-j*sintable[(spriteang[i]+512)&2047])>>2);
		spriteang[i] = ((spriteang[i]+sprite[i].angvel)&2047);
		spritezoom[i] -= (TICSPERFRAME<<9);

		if ((lockclock > sprite[i].time+240) || (spritezoom[i] <= 16))
		{
			deletesprite(i);
			goto nextsprite3;
		}

nextsprite3:
		i = nexti;
	}

		//Go through players
	for(k=connecthead;k>=0;k=connectpoint2[k])
		processinput((short)k);

	checkmasterslaveswitch();
}

checkmasterslaveswitch()
{
	long i, j;

	if (option[4] == 0) return;

	i = connecthead; j = connectpoint2[i];
	while (j >= 0)
	{
		if ((fsyncbits[j]&8192) > 0)
		{
			connectpoint2[i] = connectpoint2[j];
			connectpoint2[j] = connecthead;
			connecthead = (short)j;

			olocmousx = locmousx^0xff;
			olocmousy = locmousy^0xff;
			olocbits = locbits^0xffff;
			for(i=0;i<MAXPLAYERS;i++)
			{
				osyncmousx[i] = fsyncmousx[i]^0xff;
				osyncmousy[i] = fsyncmousy[i]^0xff;
				osyncbits[i] = fsyncbits[i]^0xffff;
			}

			totalclock = lockclock;
			ototalclock = lockclock;
			masterslavetexttime = lockclock;
			return;
		}
		i = j; j = connectpoint2[i];
	}
}

processinput(short snum)
{
	long x, y, xvect, yvect;
	short i, j, movez, mousx, mousy, mstrafe;

	if (health[snum] < 0)
	{
		health[snum] -= TICSPERFRAME;
		if (health[snum] <= -256)
		{
			warptorandomspot(&posx[snum],&posy[snum],&ang[snum]);
			health[snum] = 16383;
		}
		else
		{
			xvect = (((long)sintable[(-ang[snum])&2047])*((long)vel[snum]));
			yvect = (((long)sintable[(2560-ang[snum])&2047])*((long)vel[snum]));
			xvect += (((long)sintable[(2560-ang[snum])&2047])*((long)svel[snum]));
			yvect += (((long)sintable[(1024-ang[snum])&2047])*((long)svel[snum]));
			clipmove(&deadspinx[snum],&deadspiny[snum],xvect,yvect,2097152,1);
		}
		return;
	}

	mousx = syncmousx[snum];
	mousy = (((short)syncmousy[snum])<<3);
	mstrafe = 0;

	if (((syncbits[snum]&256) > 0) || ((syncbits[snum]&16384) != 0))   //Rt. Ctrl or Rt. mouse button
	{
		mstrafe = (mousx<<3);
		mousx = 0;
		if ((syncbits[snum]&8) > 0) mstrafe -= (TICSPERFRAME<<(4+((syncbits[snum]&128)>0)));
		if ((syncbits[snum]&16) > 0) mstrafe += (TICSPERFRAME<<(4+((syncbits[snum]&128)>0)));
	}
	else                       //Else turn
	{
		if ((syncbits[snum]&8) > 0) mousx -= (TICSPERFRAME<<(2+((syncbits[snum]&128)>0)));
		if ((syncbits[snum]&16) > 0) mousx += (TICSPERFRAME<<(2+((syncbits[snum]&128)>0)));
	}                          //Move forward / backward
	if ((syncbits[snum]&2) > 0) mousy -= (TICSPERFRAME<<(4+((syncbits[snum]&128)>0)));
	if ((syncbits[snum]&4) > 0) mousy += (TICSPERFRAME<<(4+((syncbits[snum]&128)>0)));

	i = angvel[snum];
	angvel[snum] = (((angvel[snum]<<2)+(angvel[snum]<<1)+angvel[snum]+mousx)>>3);
	if (i == angvel[snum])
	{
		if (mousx < angvel[snum]) angvel[snum]--;
		if (mousx > angvel[snum]) angvel[snum]++;
	}
	i = vel[snum];
	vel[snum] = ((i*7+mousy)>>3);
	if (i == vel[snum])
	{
		if (mousy < vel[snum]) vel[snum]--;
		if (mousy > vel[snum]) vel[snum]++;
	}
	i = svel[snum];
	svel[snum] = ((i*7+mstrafe)>>3);
	if (i == svel[snum])
	{
		if (mstrafe < svel[snum]) svel[snum]--;
		if (mstrafe > svel[snum]) svel[snum]++;
	}

	ang[snum] = ((ang[snum]+angvel[snum])&2047);
	xvect = (((long)sintable[(-ang[snum])&2047])*((long)vel[snum]));
	yvect = (((long)sintable[(2560-ang[snum])&2047])*((long)vel[snum]));
	xvect += (((long)sintable[(2560-ang[snum])&2047])*((long)svel[snum]));
	yvect += (((long)sintable[(1024-ang[snum])&2047])*((long)svel[snum]));
	clipmove(&posx[snum],&posy[snum],xvect,yvect,2097152,1);   //Actually move player!

	movez = 0;
	if ((syncbits[snum]&32) > 0) movez -= (TICSPERFRAME<<(7+(((syncbits[snum]&128)>0)<<1)));
	if ((syncbits[snum]&64) > 0) movez += (TICSPERFRAME<<(7+(((syncbits[snum]&128)>0)<<1)));

	i = zoomvel[snum];
	zoomvel[snum] = ((i*7+movez)>>3);
	if (i == zoomvel[snum])
	{
		if (movez < zoomvel[snum]) zoomvel[snum]--;
		if (movez > zoomvel[snum]) zoomvel[snum]++;
	}
	zoom[snum] += zoomvel[snum];
	if (zoom[snum] < 16384) zoom[snum] = 16384;
	if (zoom[snum] > 1048576) zoom[snum] = 1048576;

	if ((syncbits[snum]&(512+32768)) > 0)  //Left CTRL or Left mouse button
		if (lockclock > lastshoottime[snum]+20)
		{
			lastshoottime[snum] = lockclock;
			shootbullet(snum+4096);                 //You shoot a bullet!
		}

	if ((syncbits[snum]&4096) > 0)                    //Space bar
	{
		x = ((posx[snum]>>23)&63);
		y = ((posy[snum]>>23)&63);
		i = board2d[(x<<6)+y];

		if (board2d[((x+1)<<6)+y] == LOCKEDBLOCK) x++;
		else if (board2d[((x-1)<<6)+y] == LOCKEDBLOCK) x--;
		else if (board2d[(x<<6)+(y+1)] == LOCKEDBLOCK) y++;
		else if (board2d[(x<<6)+(y-1)] == LOCKEDBLOCK) y--;

		board2d[(x<<6)+y] = i;

		if (board2d[((x+1)<<6)+y] == LOCKEDBLOCK)
			board2d[((x+1)<<6)+y] = i;
		else if (board2d[((x-1)<<6)+y] == LOCKEDBLOCK)
			board2d[((x-1)<<6)+y] = i;
		else if (board2d[(x<<6)+(y+1)] == LOCKEDBLOCK)
			board2d[(x<<6)+(y+1)] = i;
		else if (board2d[(x<<6)+(y-1)] == LOCKEDBLOCK)
			board2d[(x<<6)+(y-1)] = i;
	}

	if ((syncbits[snum]&1024) > 0)   //PGUP - Jump to last level
	{
		if ((prepboardflag[snum]&1) == 0)
		{
			boardnum--; if (boardnum < 0) boardnum = nummaps-1;
			prepboardflag[snum] |= 1;
			prepareboard(boardfilename,boardnum);
		}
	}
	else
		prepboardflag[snum] &= ~1;

	if ((syncbits[snum]&2048) > 0)   //PGDN - Jump to next level
	{
		if ((prepboardflag[snum]&2) == 0)
		{
			boardnum++; if (boardnum >= nummaps) boardnum = 0;
			prepboardflag[snum] |= 2;
			prepareboard(boardfilename,boardnum);
		}
	}
	else
		prepboardflag[snum] &= ~2;

	if (typemode == 0)           //if normal game keys active
	{
		if (keystatus[keys[18]] > 0)   //Tab
		{
			keystatus[keys[18]] = 0;
			typemode = 1;
		}
	}
	else
	{
		for(i=0;i<128;i++)
			if (keystatus[i] > 0)
			{
				if ((keystatus[0x2a]|keystatus[0x36]) > 0)
				{
					if (scantoascwithshift[i] != 0)
					{
						if (typemessageleng < 159-4*4)
							typemessage[typemessageleng++] = scantoascwithshift[i];
						keystatus[i] = 0;
					}
				}
				else
				{
					if (scantoasc[i] != 0)
					{
						if (typemessageleng < 159-4*4)
							typemessage[typemessageleng++] = scantoasc[i];
						keystatus[i] = 0;
					}
				}
			}

		if (keystatus[0xe] > 0)   //Backspace
		{
				//Here's a trick of making key repeat after a 1/2 second
			if ((keystatus[0xe] == 1) || (keystatus[0xe] == 60))
			{
				if (typemessageleng > 0)
					typemessageleng--;
				else
					typemessageleng = 0, typemode = 0;
			}
			if (keystatus[0xe] < 60)
			{
				keystatus[0xe] += TICSPERFRAME;
				if (keystatus[0xe] > 60) keystatus[0xe] = 60;
			}
		}

		if ((keystatus[0x1c]|keystatus[0x9c]) > 0)  //Either ENTER
		{
			if (typemessageleng > 0)
			{
				i = 0;
				tempbuf[i++] = 2;          //Sending text is message type 2
				for(j=0;j<typemessageleng;j++)
					tempbuf[i++] = typemessage[j];

				for(j=connecthead;j>=0;j=connectpoint2[j])
					if (j != myconnectindex)
						sendpacket(j,tempbuf,i);
			}

			typemessageleng = 0;
			keystatus[0x1c] = 0;
			keystatus[0x9c] = 0;
			typemode = 0;
		}

		if ((keystatus[0xf]) > 0) //Tab
		{
			keystatus[0xf] = 0;
			typemode = 0;
		}
	}
}

shootbullet(short owner)
{
	long i, j;

	j = insertsprite(2);
	sprite[j].time = lockclock;
	sprite[j].owner = owner;

	if ((owner >= 0) && (owner < 4096))
	{
		spritex[j] = spritex[owner];
		spritey[j] = spritey[owner];
		spriteang[j] = spriteang[owner];

		if (spritepicnum[owner] == AIRPLANE)
		{
			spritezoom[j] = 65536+32768;
			spritepicnum[j] = BULLET;
			sprite[j].vel = 192;
			sprite[j].angvel = 0;
		}
		if (spritepicnum[owner] == CAR)
		{
			spritezoom[j] = 65536;
			spritepicnum[j] = BULLET;
			sprite[j].vel = 128;
			sprite[j].angvel = 0;
		}
		if (spritepicnum[owner] == CAR2)
		{
			spritezoom[j] = 32768;
			spritepicnum[j] = BULLET;
			sprite[j].vel = 64;
			sprite[j].angvel = 0;
		}
	}
	else if (owner >= 4096)
	{
		spritex[j] = posx[owner-4096];
		spritey[j] = posy[owner-4096];
		spriteang[j] = ang[owner-4096];
		spritezoom[j] = 65536;
		spritepicnum[j] = SILVERBULLET;
		sprite[j].vel = 128;
		sprite[j].angvel = 0;
		wsayfollow("zipguns.wav",4096L,128L,&spritex[j],&spritey[j],1);
	}
	ospritex[j] = spritex[j];
	ospritey[j] = spritey[j];
	ospritezoom[j] = spritezoom[j];
	ospriteang[j] = spriteang[j];
}

explode(short owner, short numfragments, short dapicnum)
{
	long i, j;

	for(i=0;i<numfragments;i++)
	{
		j = insertsprite(3);
		if (owner >= 4096)
		{
			spritex[j] = posx[owner-4096];
			spritey[j] = posy[owner-4096];
		}
		else if (owner >= 0)
		{
			spritex[j] = spritex[owner];
			spritey[j] = spritey[owner];
		}
		spritezoom[j] = 65536;
		spriteang[j] = (krand()&2047);
		spritepicnum[j] = dapicnum;
		sprite[j].vel = (krand()&63);
		sprite[j].angvel = (krand()&63)-32;
		sprite[j].time = lockclock;
		sprite[j].owner = owner;

		ospritex[j] = spritex[j];
		ospritey[j] = spritey[j];
		ospritezoom[j] = spritezoom[j];
		ospriteang[j] = spriteang[j];
	}
}

warptorandomspot(long *x, long *y, short *ang)
{
	long i;

	do
	{
		i = (krand()&4095);
	}
	while (((picanm[board2d[i]]>>24)&255) != 0);
	*x = ((i>>6)<<23)+4194304;
	*y = ((i&63)<<23)+4194304;
	*ang = (krand()&0x600);
}

loadpalette(char filename[20])
{
	long i, fil;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		close(fil);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
}

setviewboundaries()
{
	long i;

	setview(32L,0L,(long)xdim-1,(long)ydim-1);
	pivotx = ((xdim+32)>>1); //Screen coordinate pivot point that whole screen
	pivoty = ydim-32;        //rotates around (used to be 160, 100)
}

prepareboard(char *boardfilename, short daboardnum)
{
	long i, j, nextj;

	randomseed = 17L;

	typemode = 0;

	load2board(boardfilename,daboardnum,&posx[0],&posy[0],&zoom[0],&ang[0]);
	for(i=0;i<MAXPLAYERS;i++)
	{
		posx[i] = posx[0];
		posy[i] = posy[0];
		zoom[i] = zoom[0];
		ang[i] = ang[0];
		oposx[i] = posx[0];
		oposy[i] = posy[0];
		ozoom[i] = zoom[0];
		oang[i] = ang[0];
	}

	movefifoplc = 0; movefifoend = 0;

	j = headsprite[1];                      //Set up sprite variables
	while (j != -1)
	{
		nextj = nextsprite[j];

		sprite[j].health = 16383;
		sprite[j].time = -1;
		sprite[j].angvel = 0;
		sprite[j].vel = 0;
		sprite[j].owner = -1;

		ospritex[j] = spritex[j];
		ospritey[j] = spritey[j];
		ospritezoom[j] = spritezoom[j];
		ospriteang[j] = spriteang[j];

		if (spritepicnum[j] == AIRPLANE)
		{
			sprite[j].vel = 100;
			sprite[j].angvel = 0;
			changespritestat(j,1);
		}
		else if ((spritepicnum[j] == CAR) || (spritepicnum[j] == CAR2) || (spritepicnum[j] == SKATEBOARDDUDE))
		{
			sprite[j].vel = 50;
			sprite[j].angvel = (krand()&15)-8;
			changespritestat(j,1);
		}
		else if ((spritepicnum[j] == COIN) || (spritepicnum[j] == SUPERSPIRAL))
		{
			sprite[j].angvel = ((((spritex[j]>>23)&1)^((spritey[j]>>23)&1))<<1)-1;
			if (spritepicnum[j] == COIN) sprite[j].angvel <<= 4;
			if (spritepicnum[j] == SUPERSPIRAL) sprite[j].angvel <<= 5;
			changespritestat(j,0);
		}

		j = nextj;
	}

	for(i=0;i<MAXPLAYERS;i++)
	{
		vel[i] = 0;
		svel[i] = 0;
		zoomvel[i] = 0;
		angvel[i] = 0;
		health[i] = 16383;                       //Initialize my variables
		lastshoottime[i] = 0;
	}

	locmousx = 0; olocmousx = 0;
	locmousy = 0; olocmousy = 0;
	locbits = 0; olocbits = 0;
	for(i=0;i<MAXPLAYERS;i++)
	{
		fsyncmousx[i] = 0; osyncmousx[i] = 0;
		fsyncmousy[i] = 0; osyncmousy[i] = 0;
		fsyncbits[i] = 0; osyncbits[i] = 0;
	}

	lockclock = 0;
	totalclock = 0;
	ototalclock = 0;
	masterslavetexttime = 0;
}

playback()
{
	long i, j, k;

	ready2send = 0;
	recstat = 0; i = reccnt;
	while (keystatus[1] == 0)
	{
		while (totalclock >= lockclock+TICSPERFRAME)
		{
			if (i >= reccnt)
			{
				boardnum = 0; prepareboard(boardfilename,boardnum);
				i = 0;
			}
			k = 0;
			for(j=connecthead;j>=0;j=connectpoint2[j])
			{
				fsyncmousx[j] = recsyncmousx[i][k];
				fsyncmousy[j] = recsyncmousy[i][k];
				fsyncbits[j] = recsyncbits[i][k];
				k++;
			}
			movethings(); domovethings();
			i++;
		}
		drawscreen(screenpeek,(totalclock-lockclock)*(65536/TICSPERFRAME));

		if (keystatus[keys[15]] > 0)
		{
			keystatus[keys[15]] = 0;
			screenpeek = connectpoint2[screenpeek];
			if (screenpeek < 0) screenpeek = connecthead;
		}
	}
}

inittimer()
{
	outp(0x43,54); outp(0x40,9942&255); outp(0x40,9942>>8);  //120 times/sec
	oldtimerhandler = _dos_getvect(0x8);
	_disable(); _dos_setvect(0x8, timerhandler); _enable();
}

uninittimer()
{
	outp(0x43,54); outp(0x40,255); outp(0x40,255);           //18.2 times/sec
	_disable(); _dos_setvect(0x8, oldtimerhandler); _enable();
}

void __interrupt __far timerhandler()
{
	totalclock++;
	outp(0x20,0x20);
}

faketimerhandler()
{
	short other, tempbufleng;
	long i, j, k, l;

	if (totalclock < ototalclock+TICSPERFRAME) return;
	if (ready2send == 0) return;
	ototalclock = totalclock;

		//I am the MASTER (or 1 player game)
	if ((myconnectindex == connecthead) || (option[4] == 0))
	{
		if (option[4] != 0)
		{
			while ((tempbufleng = getpacket(&other,tempbuf)) > 0)
			{
				switch(tempbuf[0])
				{
					case 1:  //[1] (receive slave sync buffer)
						j = 2; k = tempbuf[1];
						if (k&1) fsyncmousx[other] = tempbuf[j++];
						if (k&2) fsyncmousy[other] = tempbuf[j++];
						if (k&4) fsyncbits[other] = ((fsyncbits[other]&0xff00)|((short)tempbuf[j++]));
						if (k&8) fsyncbits[other] = ((fsyncbits[other]&0x00ff)|(((short)tempbuf[j++])<<8));
						break;
					case 2:
						getmessageleng = tempbufleng-1;
						for(j=getmessageleng-1;j>=0;j--) getmessage[j] = tempbuf[j+1];
						getmessagetimeoff = totalclock+360+(getmessageleng<<4);
						break;
					case 255:  //[255] (logout)
						keystatus[1] = 1;
						break;
				}
			}
		}

		if (getoutputcirclesize() < 16)
		{
			getinput();
			fsyncmousx[myconnectindex] = locmousx;
			fsyncmousy[myconnectindex] = locmousy;
			fsyncbits[myconnectindex] = locbits;

			if (option[4] != 0)
			{
					//Prepare&send MASTER -> SLAVE packet
					//   (send master's synced collection of inputs to everyone else)
				tempbuf[0] = 0;

				j = ((numplayers+1)>>1)+1;
				for(k=1;k<j;k++) tempbuf[k] = 0;
				k = (1<<3);
				for(i=connecthead;i>=0;i=connectpoint2[i])
				{
					l = 0;
					if (fsyncmousx[i] != osyncmousx[i]) tempbuf[j++] = fsyncmousx[i], l |= 1;
					if (fsyncmousy[i] != osyncmousy[i]) tempbuf[j++] = fsyncmousy[i], l |= 2;
					if ((fsyncbits[i]&255) != (osyncbits[i]&255)) tempbuf[j++] = (fsyncbits[i]&255), l |= 4;
					if ((fsyncbits[i]|255) != (osyncbits[i]|255)) tempbuf[j++] = ((fsyncbits[i]>>8)&255), l |= 8;
					tempbuf[k>>3] |= (l<<(k&7));
					k += 4;

					osyncmousx[i] = fsyncmousx[i];
					osyncmousy[i] = fsyncmousy[i];
					osyncbits[i] = fsyncbits[i];
				}

					//Quick master packet - (to speed up modems when no changes)
				if ((numplayers == 2) && (tempbuf[1] == 0))
					tempbuf[0] = 3, j = 1;

				for(i=connectpoint2[connecthead];i>=0;i=connectpoint2[i])
					sendpacket(i,tempbuf,j);
			}
			movethings();
		}
	}
	else    //I am a SLAVE
	{
		while ((tempbufleng = getpacket(&other,tempbuf)) > 0)
		{
			switch(tempbuf[0])
			{
				case 0:  //[0] (receive master sync buffer)
					if (other == connecthead)
					{
						j = ((numplayers+1)>>1)+1; k = (1<<3);
						for(i=connecthead;i>=0;i=connectpoint2[i])
						{
							l = (tempbuf[k>>3]>>(k&7));
							if (l&1) fsyncmousx[i] = tempbuf[j++];
							if (l&2) fsyncmousy[i] = tempbuf[j++];
							if (l&4) fsyncbits[i] = (fsyncbits[i]&0xff00)+tempbuf[j++];
							if (l&8) fsyncbits[i] = (fsyncbits[i]&255)+(tempbuf[j++]<<8);
							k += 4;
						}
						movethings();
					}
					break;
				case 2:
					getmessageleng = tempbufleng-1;
					for(j=getmessageleng-1;j>=0;j--) getmessage[j] = tempbuf[j+1];
					getmessagetimeoff = totalclock+360+(getmessageleng<<4);
					break;
				case 3:         //Quick master packet
					if (other == connecthead) movethings();
					break;
				case 255:  //[255] (logout)
					keystatus[1] = 1;
					break;
			}
		}
		if (myconnectindex == connecthead) return;

		if (getoutputcirclesize() < 16)
		{
			getinput();

				//Prepare&send SLAVE -> MASTER packet
				//   (update slave's input for master)
			tempbuf[0] = 1; k = 0;   //bits of which bytes to send field
			j = 2;
			if (locmousx != olocmousx) tempbuf[j++] = locmousx, k |= 1;
			if (locmousy != olocmousy) tempbuf[j++] = locmousy, k |= 2;
			if ((locbits&255) != (olocbits&255)) tempbuf[j++] = (locbits&255), k |= 4;
			if ((locbits|255) != (olocbits|255)) tempbuf[j++] = ((locbits>>8)&255), k |= 8;
			tempbuf[1] = k;

			olocmousx = locmousx;
			olocmousy = locmousy;
			olocbits = locbits;

			sendpacket(connecthead,tempbuf,j);
		}
	}
}
