; "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
; Ken Silverman's official web site: "http://www.advsys.net/ken"
; See the included license file "BUILDLIC.TXT" for license info.

.386P

EXTRN _asm1 : dword
EXTRN _asm2 : dword
EXTRN _asm3 : dword
EXTRN _asm4 : dword
EXTRN _palookup : near

CODE SEGMENT BYTE PUBLIC USE32 'CODE'
ASSUME cs:CODE

PUBLIC sethlinesizes_
sethlinesizes_:
	neg al
	add al, 32
	mov byte ptr ds:[hxsiz1+2], al
	mov byte ptr ds:[hxsiz2+2], al
	mov byte ptr ds:[hxsiz3+2], al
	mov byte ptr ds:[hxsiz4+2], al
	mov byte ptr ds:[hxsiz5+2], al
	mov byte ptr ds:[hxsiz6+2], al
	mov byte ptr ds:[hxsiz7+2], al
	mov byte ptr ds:[hxsiz8+2], al
	mov byte ptr ds:[hxsiz9+2], al
	mov byte ptr ds:[hxsiz10+2], al
	mov byte ptr ds:[hxsiz11+2], al
	mov byte ptr ds:[hxsiz12+2], al
	mov byte ptr ds:[hxsiz13+2], al
	mov byte ptr ds:[hxsiz14+2], al
	mov al, bl
	mov byte ptr ds:[hysiz1+3], al
	mov byte ptr ds:[hysiz2+3], al
	mov byte ptr ds:[hysiz3+3], al
	mov byte ptr ds:[hysiz4+3], al
	mov byte ptr ds:[hysiz5+3], al
	mov byte ptr ds:[hysiz6+3], al
	mov byte ptr ds:[hysiz7+3], al
	mov byte ptr ds:[hysiz8+3], al
	mov byte ptr ds:[hysiz9+3], al
	mov byte ptr ds:[hysiz10+3], al
	mov byte ptr ds:[hysiz11+3], al
	mov byte ptr ds:[hysiz12+3], al
	mov byte ptr ds:[hysiz13+3], al
	mov byte ptr ds:[hysiz14+3], al
	ret

PUBLIC hlineasm64_
hlineasm64_:
	push ebp
	mov ebp, ebx
	mov eax, _asm1
	mov dword ptr ds:[mach1a+2], eax
	mov dword ptr ds:[mach1b+2], eax
	mov dword ptr ds:[mach1c+2], eax
	mov dword ptr ds:[mach1d+2], eax
	and edx, 0ffffff00h              ;clear dl permanently for counter
	and _asm2, 0ffffff00h            ;make sure increment doesn't change dl
	mov eax, _asm2
	mov dword ptr ds:[mach2a+2], eax
	mov dword ptr ds:[mach2b+2], eax
	mov dword ptr ds:[mach2c+2], eax
	mov dword ptr ds:[mach2d+2], eax
	xchg cl, ch

	shr dword ptr _asm3, 1
	mov dl, byte ptr _asm3[0]
	jnc skipthe1byte

	mov ebx, esi
hxsiz7: shr ebx, 26
hysiz7: shld ebx, edx, 6
	mov cl, byte ptr [ebp+ebx]
	mov al, byte ptr _palookup[ecx]
	add esi, _asm1
	add edx, _asm2
	mov byte ptr [edi], al
	inc edi

skipthe1byte:
	shr dl, 1
	jnc skipthe2byte

	mov ebx, esi
hxsiz5: shr ebx, 26
hysiz5: shld ebx, edx, 6
	mov cl, byte ptr [ebp+ebx]
	mov al, byte ptr _palookup[ecx]
	add esi, _asm1
	add edx, _asm2

	mov ebx, esi
hxsiz6: shr ebx, 26
hysiz6: shld ebx, edx, 6
	mov cl, byte ptr [ebp+ebx]
	mov ah, byte ptr _palookup[ecx]
	add esi, _asm1
	add edx, _asm2
	mov word ptr [edi], ax
	add edi, 2
skipthe2byte:

	or dl, dl
	jz skipthe4byte

beginhline64:

	mov ebx, esi
hxsiz1: shr ebx, 26
hysiz1: shld ebx, edx, 6
mach1a: add esi, 88888888h
	mov cl, byte ptr [ebp+ebx]
mach2a: add edx, 88888888h
	mov al, byte ptr _palookup[ecx]

	mov ebx, esi
hxsiz2: shr ebx, 26
hysiz2: shld ebx, edx, 6
mach1b: add esi, 88888888h
	mov cl, byte ptr [ebp+ebx]
mach2b: add edx, 88888888h
	mov ah, byte ptr _palookup[ecx]

	mov ebx, esi
	shl eax, 16
hxsiz3: shr ebx, 26
hysiz3: shld ebx, edx, 6
mach1c: add esi, 88888888h
	mov cl, byte ptr [ebp+ebx]
mach2c: add edx, 88888888h
	mov al, byte ptr _palookup[ecx]

	mov ebx, esi
hxsiz4: shr ebx, 26
hysiz4: shld ebx, edx, 6
mach1d: add esi, 88888888h
	mov cl, byte ptr [ebp+ebx]
mach2d: add edx, 88888888h
	mov ah, byte ptr _palookup[ecx]

	rol eax, 16
	mov dword ptr [edi], eax
	add edi, 4

	sub dl, 1
	jnz beginhline64

skipthe4byte:

	pop ebp
	ret



PUBLIC hchainasm64_
startx: dd ?
starty: dd ?
startp: dd ?
xc4: dd ?
yc4: dd ?
plane: db ?
startplane: db ?

hchainasm64_:
	push ebp
	mov ebp, edx

	mov cl, al
	mov al, 11h
	rol al, cl
	mov byte ptr ds:[plane], al
	cmp _asm3, 4
	jge hchainskip1
	mov cl, ah
	mov al, 11h
	rol al, cl
hchainskip1:
	mov byte ptr ds:[startplane], al
	mov cl, ch
	mov dword ptr ds:[startx], esi
	mov dword ptr ds:[starty], ebx
	mov dword ptr ds:[startp], edi
	mov eax, _asm1
	shl eax, 2
	mov dword ptr ds:[xc4], eax
	mov eax, _asm2
	shl eax, 2
	mov dword ptr ds:[yc4], eax
	mov dx, 03c4h
	mov al, 2
	out dx, al
hchain1:
	mov dx, 03c5h
	mov al, byte ptr ds:[plane]
	out dx, al
	mov esi, dword ptr ds:[startx]
	mov ebx, dword ptr ds:[starty]
	mov edi, dword ptr ds:[startp]
	mov ax, word ptr _asm3[0]
	shr ax, 2
	mov ch, al
	cmp ch, 3
	jl hchainskip2
hchainstart1:

	mov edx, esi
hxsiz8: shr edx, 26
hysiz8: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov al, byte ptr _palookup[edx]
	add esi, dword ptr ds:[xc4]
	add ebx, dword ptr ds:[yc4]

	mov edx, esi
hxsiz9: shr edx, 26
hysiz9: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov ah, byte ptr _palookup[edx]
	add esi, dword ptr ds:[xc4]
	add ebx, dword ptr ds:[yc4]

	shl eax, 16

	mov edx, esi
hxsiz10: shr edx, 26
hysiz10: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov al, byte ptr _palookup[edx]
	add esi, dword ptr ds:[xc4]
	add ebx, dword ptr ds:[yc4]

	mov edx, esi
hxsiz11: shr edx, 26
hysiz11: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov ah, byte ptr _palookup[edx]
	add esi, dword ptr ds:[xc4]
	add ebx, dword ptr ds:[yc4]

	rol eax, 16
	mov dword ptr [edi], eax
	add edi, 4

	sub ch, 4
	cmp ch, 3
	jge hchainstart1
hchainskip2:
	cmp ch, 1
	jl hchainskip3

	mov edx, esi
hxsiz12: shr edx, 26
hysiz12: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov al, byte ptr _palookup[edx]
	add esi, dword ptr ds:[xc4]
	add ebx, dword ptr ds:[yc4]

	mov edx, esi
hxsiz13: shr edx, 26
hysiz13: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov ah, byte ptr _palookup[edx]
	add esi, dword ptr ds:[xc4]
	add ebx, dword ptr ds:[yc4]

	mov word ptr [edi], ax
	add edi, 2

hchainskip3:
	test ch, 1
	jnz hchainskip4

	mov edx, esi
hxsiz14: shr edx, 26
hysiz14: shld edx, ebx, 6
	mov dl, byte ptr [ebp+edx]
	mov dh, cl
	mov al, byte ptr _palookup[edx]

	mov byte ptr [edi], al

hchainskip4:
	mov eax, _asm1
	add dword ptr ds:[startx], eax
	mov eax, _asm2
	add dword ptr ds:[starty], eax
	dec _asm3
	rol byte ptr ds:[plane], 1

	cmp byte ptr ds:[plane], 11h
	jne hchainskip5
	inc dword ptr ds:[startp]
hchainskip5:
	mov al, byte ptr ds:[plane]
	cmp al, byte ptr ds:[startplane]
	jne hchain1

	pop ebp
	ret

PUBLIC fixvlinesforchain_
fixvlinesforchain_:
	mov dword ptr ds:[fixchain1+2], 00000050h   ;50 hex = 80 decimal
	mov dword ptr ds:[fixchain1m+2], 00000050h
	mov dword ptr ds:[fixchain2+2], 00000050h
	ret

PUBLIC vlineasm1_
vlineasm1_:
	push ebp
	mov ebp, eax

	sub cl, 32
	neg cl
	mov byte ptr ds:[mach3a+2], cl
	mov dword ptr ds:[mach3b+2], ebx

	jmp beginvline

beginvline:
	mov ebx, edx
mach3a: shr ebx, 32
	mov bl, byte ptr [esi+ebx]
	add edx, ebp
mach3b: mov al, [ebx+88888888h]
	mov byte ptr [edi], al
fixchain1: add edi, 320
	sub ch, 1
	jnc beginvline

	pop ebp
	mov eax, edx
	ret

PUBLIC mvlineasm1_
mvlineasm1_:
	push ebp
	mov ebp, eax
	mov dword ptr ds:[maskmach3+2], ebx
	jmp beginmvline

beginmvline:
	xor ebx, ebx
	shld ebx, edx, cl
	mov bl, byte ptr [esi+ebx]
	cmp bl, 255
	je skipmask1
maskmach3: mov al, [ebx+88888888h]
	mov byte ptr [edi], al
skipmask1:
	add edx, ebp
fixchain1m: add edi, 320
	sub ch, 1
	jnc beginmvline

	pop ebp
	mov eax, edx
	ret

PUBLIC vlineasm4_
vlineasm4_:
	push ebp

	sub cl, 32
	neg cl
	mov byte ptr ds:[machv13+2], cl
	mov byte ptr ds:[machv14+2], cl
	mov byte ptr ds:[machv15+2], cl
	mov byte ptr ds:[machv16+2], cl

	mov ebp, dword ptr [edx+0]        ;palookupoffse
	mov dword ptr ds:[machv1+2], ebp
	mov ebp, dword ptr [edx+4]
	mov dword ptr ds:[machv4+2], ebp
	mov ebp, dword ptr [edx+8]
	mov dword ptr ds:[machv7+2], ebp
	mov ebp, dword ptr [edx+12]
	mov dword ptr ds:[machv10+2], ebp

	mov ebp, dword ptr [esi+0]        ;bufplce
	mov dword ptr ds:[machv2+2], ebp
	mov ebp, dword ptr [esi+4]
	mov dword ptr ds:[machv5+2], ebp
	mov ebp, dword ptr [esi+8]
	mov dword ptr ds:[machv8+2], ebp
	mov ebp, dword ptr [esi+12]
	mov dword ptr ds:[machv11+2], ebp

	mov ebp, dword ptr [ebx+0]        ;vince
	mov dword ptr ds:[machv3+2], ebp
	mov ebp, dword ptr [ebx+4]
	mov dword ptr ds:[machv6+2], ebp
	mov ebp, dword ptr [ebx+8]
	mov dword ptr ds:[machv9+2], ebp
	mov ebp, dword ptr [ebx+12]
	and ebp, 0ffffff00h           ;make sure cl (counter) doesn't get changed
	mov dword ptr ds:[machv12+2], ebp

	mov bl, ch
	mov _asm2, eax
	mov edx, dword ptr [eax+0]
	mov esi, dword ptr [eax+4]
	mov ebp, dword ptr [eax+8]
	mov ecx, dword ptr [eax+12]
	mov cl, bl

	jmp beginvlineasm4
beginvlineasm4:

	mov ebx, ebp
machv13: shr ebx, 32
machv9: add ebp, 88888888h ;vince[2]
machv7: mov bl, byte ptr [ebx+88888888h] ;bufplce[2]
machv8: mov al, byte ptr [ebx+88888888h] ;palookupoffs[2]

	mov ebx, ecx
machv14: shr ebx, 32
machv12: add ecx, 88888888h ;vince[3]
machv10: mov bl, byte ptr [ebx+88888888h] ;bufplce[3]
machv11: mov ah, byte ptr [ebx+88888888h] ;palookupoffs[3]

	mov ebx, edx
machv15: shr ebx, 32
	shl eax, 16
machv1: mov bl, byte ptr [ebx+88888888h] ;bufplce[0]
machv3: add edx, 88888888h ;vince[0]
machv2: mov al, byte ptr [ebx+88888888h] ;palookupoffs[0]

	mov ebx, esi
machv16: shr ebx, 32
machv6: add esi, 88888888h ;vince[1]
machv4: mov bl, byte ptr [ebx+88888888h] ;bufplce[1]
machv5: mov ah, byte ptr [ebx+88888888h] ;palookupoffs[1]

	mov dword ptr [edi], eax
fixchain2: add edi, 320

	sub cl, 1
	jnc beginvlineasm4

	mov eax, _asm2
	mov dword ptr [eax+0], edx
	mov dword ptr [eax+4], esi
	mov dword ptr [eax+8], ebp
	mov dword ptr [eax+12], ecx
	mov eax, edi

	pop ebp
	ret



CODE ENDS
END
