DECLARE SUB boxtrace (x&, y&, xvect&, yvect&)
DECLARE FUNCTION raytrace% (x&, y&, xvect&, yvect&, intx&, inty&)
DECLARE FUNCTION clockdir% ()
DECLARE SUB clipmove (x&, y&, xvect&, yvect&)
DECLARE SUB loadtables ()
DECLARE SUB drawlines ()
DECLARE FUNCTION inside% (x&, y&)
DECLARE SUB getlines ()
CONST xdim = 640, ydim = 350, MAXWALLS = 1024
COMMON SHARED numwalls%, pag%, posx&, posy&
DIM SHARED sintable&(2048)

COMMON SHARED clipnum%, walldist&
DIM SHARED cliplist%(256)

TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
END TYPE

DIM SHARED wall(MAXWALLS) AS walltype

CALL loadtables
CALL getlines

walldist& = 256
numhits% = 0
ang% = 1536
vel% = 32
angvel% = 0
DO
   LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
   CALL drawlines
   
   z$ = INKEY$
   IF z$ = CHR$(0) + CHR$(75) THEN angvel% = angvel% - 4
   IF z$ = CHR$(0) + CHR$(77) THEN angvel% = angvel% + 4
   IF z$ = CHR$(0) + CHR$(72) THEN vel% = vel% + 16
   IF z$ = CHR$(0) + CHR$(80) THEN vel% = vel% - 16
   IF z$ = " " THEN vel% = 0: angvel% = 0

   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   ang% = ((ang% + regs%(2) + angvel% + 2048) AND 2047)
  
   davel% = vel% - regs%(3)
   IF davel% <> 0 THEN
      cosang& = sintable&((ang% + 2560) AND 2047) * davel%
      sinang& = sintable&((ang% + 2048) AND 2047) * davel%
      CALL clipmove(posx&, posy&, cosang&, sinang&)
   END IF

   CIRCLE (posx& \ 16, posy& \ 16), 3, 15
  
   LINE ((posx& - walldist&) \ 16, (posy& - walldist&) \ 16)-((posx& + walldist&) \ 16, (posy& + walldist&) \ 16), 7, B
   LINE (posx& \ 16, posy& \ 16)-((posx& + sintable&((ang% + 2560) AND 2047) \ 64) \ 16, (posy& + sintable&((ang% + 2048) AND 2047) \ 64) \ 16), 15
  
   pag% = 1 - pag%: SCREEN 9, , pag%, 1 - pag%
   WAIT &H3DA, &H8, &H8
   WAIT &H3DA, &H8
LOOP WHILE z$ <> CHR$(27)
END

SUB boxtrace (x&, y&, xvect&, yvect&)
   goalx& = x& + xvect& \ 16384
   goaly& = y& + yvect& \ 16384
   wallhit% = -1
   slidevel% = 0
    
   farcorner% = 3 - (ABS(xvect& >= 0) + ABS(yvect& >= 0) * 2)
    
   stopx& = goalx&: stopy& = goaly&
   closestdist& = ABS(stopx& - x&) + ABS(stopy& - y&)
   xoffs& = -walldist&: yoffs& = -walldist&
   FOR z% = 0 TO 3
       
      IF z% <> farcorner% THEN
         dawall% = raytrace%(x& + xoffs&, y& + yoffs&, xvect& \ 64, yvect& \ 64, intx&, inty&)
         dadist& = ABS(intx& - xoffs& - x&) + ABS(inty& - yoffs& - y&)
         IF dadist& < closestdist& THEN
            stopx& = intx& - xoffs&
            stopy& = inty& - yoffs&
            closestdist& = dadist&
            wallhit% = dawall%
         END IF
      END IF
     
      xoffs& = -xoffs&
      IF z% = 1 THEN yoffs& = -yoffs&
   NEXT z%
  
  
   FOR zz% = 0 TO clipnum% - 1
      z% = cliplist%(zz%)
      IF (stopx& - walldist& < wall(z%).x) AND (wall(z%).x < stopx& + walldist&) THEN
         IF (stopy& - walldist& < wall(z%).y) AND (wall(z%).y < stopy& + walldist&) THEN
            IF xvect& <> 0 THEN
               intx1& = wall(z%).x
               IF xvect& > 0 THEN intx1& = intx1& - walldist& ELSE intx1& = intx1& + walldist&
               inty1& = (((intx1& - x&) * yvect&) \ xvect&) + y&
               IF ABS(inty1& - wall(z%).y) < walldist& THEN
                  dadist& = ABS(intx1& - x&) + ABS(inty1& - y&)
                  IF dadist& < closestdist& THEN
                     closestdist& = dadist&
               
                     wallhit% = -2
                     stopx& = intx1&
                     stopy& = inty1&
               
                     slidex& = 0
                     IF yvect& < 0 THEN slidey& = 16384 ELSE slidey& = -16384
                     slidevel% = ((goalx& - stopx&) * slidex& + (goaly& - stopy&) * slidey&) \ 16384
                     IF slidevel% < 0 THEN slidey& = -slidey&: slidevel% = -slidevel%
                  END IF
               END IF
            END IF
           
            IF yvect& <> 0 THEN
               inty2& = wall(z%).y
               IF yvect& > 0 THEN inty2& = inty2& - walldist& ELSE inty2& = inty2& + walldist&
               intx2& = (((inty2& - y&) * xvect&) \ yvect&) + x&
               IF ABS(intx2& - wall(z%).x) < walldist& THEN
                  dadist& = ABS(intx2& - x&) + ABS(inty2& - y&)
                  IF dadist& < closestdist& THEN
                     closestdist& = dadist&
               
                     wallhit% = -2
                     stopx& = intx2&
                     stopy& = inty2&
                     IF xvect& < 0 THEN slidex& = 16384 ELSE slidex& = -16384
                     slidey& = 0
                     slidevel% = ((goalx& - stopx&) * slidex& + (goaly& - stopy&) * slidey&) \ 16384
                     IF slidevel% < 0 THEN slidex& = -slidex&: slidevel% = -slidevel%
                  END IF
               END IF
            END IF
         END IF
      END IF
   NEXT zz%

   IF wallhit% = -1 THEN
      x& = goalx&
      y& = goaly&
   ELSEIF wallhit% = -2 THEN
      x& = stopx&
      y& = stopy&
   ELSE
      lx& = wall(wall(wallhit%).point2).x - wall(wallhit%).x
      ly& = wall(wall(wallhit%).point2).y - wall(wallhit%).y
      dist& = SQR(lx& * lx& + ly& * ly&)
     
      slidex& = (lx& * 16384) \ dist&
      slidey& = (ly& * 16384) \ dist&
      slidevel% = ((goalx& - stopx&) * slidex& + (goaly& - stopy&) * slidey&) \ 16384
      IF slidevel% < 0 THEN slidex& = -slidex&: slidey& = -slidey&: slidevel% = -slidevel%
      x& = stopx&
      y& = stopy&
   END IF
  
   xvect& = slidex& * slidevel%
   yvect& = slidey& * slidevel%

END SUB

SUB clipmove (x&, y&, xvect&, yvect&)
   clipnum% = 0
   FOR z% = 0 TO numwalls% - 1
      cliplist%(clipnum%) = z%: clipnum% = clipnum% + 1
   NEXT z%
  
   cnt% = 3
   WHILE (xvect& OR yvect&) <> 0 AND cnt% > 0
      CALL boxtrace(x&, y&, xvect&, yvect&)
      cnt% = cnt% - 1
   WEND

END SUB

FUNCTION clockdir%
   minx& = &H7FFFFFFF
   themin% = -1
   i% = -1
   DO
      i% = i% + 1
      IF (wall(wall(i%).point2).x < minx&) THEN
         minx& = wall(wall(i%).point2).x
         themin% = i%
      END IF
   LOOP WHILE (wall(i%).point2 <> 0)

   x0& = wall(themin%).x
   y0& = wall(themin%).y
   x1& = wall(wall(themin%).point2).x
   y1& = wall(wall(themin%).point2).y
   x2& = wall(wall(wall(themin%).point2).point2).x
   y2& = wall(wall(wall(themin%).point2).point2).y

   IF ((y1& >= y2&) AND (y1& <= y0&)) THEN clockdir% = 0: EXIT FUNCTION
   IF ((y1& >= y0&) AND (y1& <= y2&)) THEN clockdir% = 1: EXIT FUNCTION

   templong& = (x0& - x1&) * (y2& - y1&) - (x2& - x1&) * (y0& - y1&)
   IF (templong& < 0) THEN
      clockdir% = 0: EXIT FUNCTION
   ELSE
      clockdir% = 1: EXIT FUNCTION
   END IF

END FUNCTION

SUB drawlines
   FOR z% = 0 TO numwalls% - 1
      LINE (wall(z%).x \ 16, wall(z%).y \ 16)-(wall(wall(z%).point2).x \ 16, wall(wall(z%).point2).y \ 16), 12
     
      zz% = wall(z%).point2: zzz% = wall(zz%).point2
      IF (wall(zz%).x - wall(z%).x) * (wall(zzz%).y - wall(zz%).y) - (wall(zzz%).x - wall(zz%).x) * (wall(zz%).y - wall(z%).y) < 0 THEN
         LINE ((wall(zz%).x - walldist&) \ 16, (wall(zz%).y - walldist&) \ 16)-((wall(zz%).x + walldist&) \ 16, (wall(zz%).y + walldist&) \ 16), 12, B
      END IF
   NEXT z%
END SUB

SUB getlines
   DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
   pag% = 0: SCREEN 9, , pag%, pag%
   numwalls% = 0
   mousx& = xdim \ 2
   mousy& = ydim \ 2
   oldcol% = 0
   obstatus% = 1
   FOR z% = mousx& - 2 TO mousx& + 2
      FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
         PSET (z%, zz%), POINT(z%, zz%) XOR 15
      NEXT zz%
   NEXT z%
   DO
      DO
         z$ = INKEY$
         regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
         IF regs%(2) <> 0 OR regs%(3) <> 0 THEN
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
            mousx& = mousx& + regs%(2)
            mousy& = mousy& + regs%(3)
            IF mousx& < 0 THEN mousx& = 0
            IF mousx& >= xdim THEN mousx& = xdim - 1
            IF mousy& < 0 THEN mousy& = 0
            IF mousy& >= ydim THEN mousy& = ydim - 1
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
         END IF
         regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
         obstatus% = bstatus%: bstatus% = regs%(0)
      LOOP WHILE z$ = "" AND bstatus% = obstatus%
      IF z$ = " " OR (bstatus% AND 1) > (obstatus% AND 1) THEN
         SCREEN 9, , 1 - pag%, pag%
         LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
         wall(numwalls%).x = mousx&
         wall(numwalls%).y = mousy&
         IF numwalls% > 0 THEN wall(numwalls% - 1).point2% = numwalls%
         wall(numwalls%).point2 = 0
         numwalls% = numwalls% + 1
         FOR z% = 0 TO numwalls% - 1
            z2% = wall(z%).point2
            LINE (wall(z%).x, wall(z%).y)-(wall(z2%).x, wall(z2%).y), 12
         NEXT z%
         pag% = 1 - pag%: SCREEN 9, , pag%, pag%
         WAIT &H3DA, &H8, &H8
         WAIT &H3DA, &H8
      END IF
   LOOP WHILE z$ <> CHR$(13) AND (bstatus% AND 6) <= (obstatus% AND 6)
  
   IF clockdir% = 1 THEN
      FOR z% = 0 TO numwalls% \ 2 - 1
         SWAP wall(z%).x, wall(numwalls% - 1 - z%).x
         SWAP wall(z%).y, wall(numwalls% - 1 - z%).y
      NEXT z%
   END IF
  
   FOR z% = 0 TO numwalls% - 1
      wall(z%).x = wall(z%).x * 16
      wall(z%).y = wall(z%).y * 16
   NEXT z%
   posx& = mousx& * 16: posy& = mousy& * 16
END SUB

FUNCTION inside% (x&, y&)
   cnt% = 0
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
      IF (x1& >= x& OR x2& >= x&) THEN
         y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF (y1& <= y& AND y2& > y&) THEN
            IF x1& * (y& - y2&) + x2& * (y1& - y&) <= x& * (y1& - y2&) THEN cnt% = 1 - cnt%
         END IF
      END IF
   NEXT z%
   inside% = cnt%
END FUNCTION

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

FUNCTION raytrace% (x&, y&, xvect&, yvect&, intx&, inty&)
  
   x& = x& - xvect& \ 256: y& = y& - yvect& \ 256
   intx& = x& + xvect&: inty& = y& + yvect&: intline% = -1
   FOR zz% = 0 TO clipnum% - 1
      z% = cliplist%(zz%)
      x1& = wall(z%).x
      y1& = wall(z%).y
      x2& = wall(wall(z%).point2).x
      y2& = wall(wall(z%).point2).y

      bot& = ((y2& - y1&) * xvect& - (x2& - x1&) * yvect&) \ 16384
      IF bot& > 0 THEN
         top& = ((x1& - x&) * yvect& - (y1& - y&) * xvect&) * 4
         IF top& >= 0 AND bot& >= top& \ 65536 THEN
            ratio& = top& \ bot&
              
            nintx& = (x1& * (65536 - ratio&) + x2& * ratio&) \ 65536
            ninty& = (y1& * (65536 - ratio&) + y2& * ratio&) \ 65536
            IF ((nintx& - x&) * xvect& + (ninty& - y&) * yvect&) >= 0 THEN
               IF ABS(nintx& - x&) + ABS(ninty& - y&) < ABS(intx& - x&) + ABS(inty& - y&) THEN
                  intx& = nintx&
                  inty& = ninty&
                 
                  LINE (intx& \ 16, inty& \ 16)-(x& \ 16, y& \ 16), 8
                  PSET (intx& \ 16, inty& \ 16), 7
                  PSET (x& \ 16, y& \ 16), 7

                  intline% = z%
               END IF
            END IF
         END IF
      END IF
   NEXT zz%
  
   raytrace% = intline%
END FUNCTION

