// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

static char tempbuf[16384];
static char tempbuf2[16384];

static short xsiz[4096];
static short ysiz[4096];
static long flags[4096];
static char palette[768];

main()
{
	long version, i, x, y, totsiz, offs, fil, fil1, fil2, numtiles;

	if ((fil1 = open("pics.art",O_BINARY|O_RDWR,S_IREAD)) == -1)
	{
		printf("Do you really have PICS.ART or do I not know how to program?");
		return(-1);
	}
	if ((fil2 = open("tiles.art",O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) == -1)
		return(-1);

	setvmode(0x13);

	fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD);
	read(fil,&palette[0],768);
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	close(fil);

	read(fil1,&tempbuf[0],4096);

	version = 0L;
	write(fil2,&version,4);

	for(i=0;i<4096;i++)
	{
		xsiz[i] = (1<<(tempbuf[i]&15));
		ysiz[i] = (1<<(tempbuf[i]>>4));
	}
	numtiles = 4095L;
	while ((xsiz[numtiles] < 2) && (ysiz[numtiles] < 2))
		numtiles--;
	numtiles++;

	write(fil2,&numtiles,4);
	write(fil2,&xsiz[0],numtiles<<1);
	write(fil2,&ysiz[0],numtiles<<1);

	read(fil1,&tempbuf[0],4096);
	for(i=0;i<numtiles;i++)
		flags[i] = ((long)tempbuf[i]);
	write(fil2,&flags[0],numtiles<<2);

	for(i=0;i<numtiles;i++)
	{
		totsiz = xsiz[i]*ysiz[i];
		read(fil1,&tempbuf[0],totsiz);
		offs = 0;
		for(x=0;x<xsiz[i];x++)
			for(y=0;y<ysiz[i];y++)
				drawpixel(0xa0000+y*320+x,tempbuf[offs++]);
		write(fil2,&tempbuf[0],totsiz);
	}
	close(fil1);
	close(fil2);

	setvmode(0x3);
	return(0);
}
