// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#include <direct.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>

#define MAXTILES 4096
#define MAXMENUFILES 256
#define MAXTILEFILES 256
#define NUMPALOOKUPS 32
#define GIFBUFLEN 4096

static char *pic;
static short int mousx, mousy, bstatus, moustat, capturecount;
static unsigned char col, trailstatus, tempbuf[4096], frame[65536];
static short xfillbuf[4096], yfillbuf[4096];
static unsigned char printbuf[128];
static short tilesizx[MAXTILES], tilesizy[MAXTILES];
static long picanm[MAXTILES], artversion, numtiles, panx, pany, panxdim;
static unsigned char buf[1024][256], buf2[1024][256], buf3[1024][256];
static long waloff[MAXTILES], totpicmem, xdim, ydim, asksave, c, d, picnum;
static long pplc, totpicsiz, animspeed, frameplace, allasksave;
static short sintable[2048];

static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long curtilefile, numtilefiles;

static char names[MAXTILES][17];
static char menuname[MAXMENUFILES][17], curpath[80], menupath[80];
static long menunamecnt, menuhighlight;

static char textfont[128][8];
static char reversemask[16] = {0,8,4,12,2,10,6,14,1,9,5,13,3,11,7,15};

static char whitetext, browntext, yellowtext, pinktext, blacktext;

static unsigned char palookup[NUMPALOOKUPS][256], palette[768];
static char palette2[768], palookupe[256];

static unsigned char gifdata[GIFBUFLEN];
static unsigned char gifsuffix[4100], giffilbuffer[768], giftempstack[4096];
static short int gifprefix[4100];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux cleartopbox =\
	"mov dx, 0x3c4",\
	"mov ax, 0x0f02",\
	"out dx, ax",\
	"mov edi, 0xa1000",\
	"mov ecx, 15360",\
	"xor eax, eax",\
	"rep stosd",\
	modify [eax ecx edx edi]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi]",\
	parm [edi]\

#pragma aux drawchainpixel =\
	"mov dx, 0x3c4",\
	"mov ax, 0x0102",\
	"mov cx, di",\
	"and cl, 3",\
	"shl ah, cl",\
	"out dx, ax",\
	"shr edi, 2",\
	"mov byte ptr [edi+0xa0000], bl",\
	parm [edi][ebx]\
	modify [eax ecx edx]\

#pragma aux drawpixel =\
	"mov [edi], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov [edi], ax",\
	parm [edi][eax]\

#pragma aux drawpixelses =\
	"mov [edi], eax",\
	parm [edi][eax]\

#pragma aux setupmouse =\
	"mov ax, 0",\
	"int 33h",\
	"mov moustat,1",\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov bstatus, ax",\
	modify [eax ebx ecx edx]\

#pragma aux limitrate =\
	"mov dx, 0x3da",\
	"wait1: in al, dx",\
	"test al, 8",\
	"jnz wait1",\
	"wait2: in al, dx",\
	"test al, 8",\
	"jz wait2",\
	modify [edx]\

#pragma aux copytovideo =\
	"mov dx, 0x3c4",\
	"mov al, 2",\
	"out dx, al",\
	"inc dx",\
	"xor ebx, ebx",\
	"begallcopytovideo:",\
	"mov al, 1",\
	"mov cl, bl",\
	"shl al, cl",\
	"out dx, al",\
	"mov esi, frameplace",\
	"add esi, ebx",\
	"mov edi, 0xa0000",\
	"mov ecx, 16000",\
	"begit: lodsd",\
	"stosb",\
	"loop begit",\
	"inc bl",\
	"cmp bl, 4",\
	"jl begallcopytovideo",\
	modify [eax ebx ecx edx esi edi]\

#pragma aux drawrow =\
	"cld",\
	"mov ecx, 80d",\
	"mov esi, offset tempbuf",\
	"rep movsd",\
	parm [edi]\
	modify [edi esi ecx]\

#pragma aux cleartext =\
	"mov dx, 0x3c4",\
	"mov ax, 0x0f02",\
	"out dx, ax",\
	"mov edi, 0xa0800",\
	"mov ebx, 8",\
	"mov ah, browntext",\
	"mov al, ah",\
	"shl eax, 8",\
	"mov al, ah",\
	"shl eax, 8",\
	"mov al, ah",\
	"begclearit: mov ecx, 14",\
	"rep stosd",\
	"add edi, 200",\
	"sub ebx, 1",\
	"jnz begclearit",\
	modify [eax ebx ecx edx edi]\

	//the 200 above = 256-28chars*2

  //eax = (eax>>bitcnt)&((1<<numbits)-1);
#pragma aux gifgetdat =\
	"mov eax, dword ptr giffilbuffer[eax]",\
	"shr eax, cl",\
	"xchg ebx, ecx",\
	"mov ebx, 1",\
	"shl ebx, cl",\
	"dec ebx",\
	"and eax, ebx",\
	parm [eax][ebx][ecx]\
	modify [eax ebx ecx]\

main(short argc, char **argv)
{
	char ch, *keystateptr, keystate, tempchar, filename[80];
	char buffer[40], buffer2[40];
	long i, j, k, l, m, n, x, y, x2, y2, fil, templong, dat, good, vidpos;
	long markx, marky, markxlen, markylen;
	long xstep, ystep, lin, num, oxdim, oydim;

	initmenupaths(argv[0]);
	loadtables();
	setupmouse();

	frameplace = (long)(&frame[0]);
	mousx = 0;
	mousy = 0;
	bstatus = 0;
	if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		read(fil,&palookup[0][0],NUMPALOOKUPS*256);
		gettextcolors();
		close(fil);
	}
	strcpy(artfilename,"tiles000.art");

	totpicmem = 16777216L;            //allocate pic = rest of memory
	while ((pic = (char *)malloc(totpicmem)) == 0)
		totpicmem -= 4096L;
	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}
	loadnames();

	for(i=0;i<MAXTILEFILES;i++)
	{
		localtilestart[i] = -1;
		localtileend[i] = -1;
	}
	numtilefiles = 0;
	do
	{
		i = numtilefiles;
		strcpy(filename,artfilename);
		filename[7] = (numtilefiles%10)+48;
		filename[6] = ((numtilefiles/10)%10)+48;
		filename[5] = ((numtilefiles/100)%10)+48;
		if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1)
			{
				printf("Wrong art version");
				exit(0);
			}
			read(fil,&numtiles,4);
			read(fil,&localtilestart[numtilefiles],4);
			read(fil,&localtileend[numtilefiles],4);
			close(fil);
			numtilefiles++;
		}
	}
	while (numtilefiles != i);

	picnum = 0;
	curtilefile = -1;
	loadpics(picnum);
	capturecount = 0;
	menunamecnt = 0;
	menuhighlight = 0;
	keystateptr = (char *)0x417;
	col = 0;
	trailstatus = 0;
	ch = 0;
	loadwall(buf,picnum);
	c = (xdim>>1);
	d = (ydim>>1);
	markx = 0;
	marky = 0;
	markxlen = 0;
	markylen = 0;
	panxdim = 1024L;
	animspeed = 4;
	drawmainscreen();
	while (ch != 27)
	{
		if (kbhit() != 0)
		{
			ch = getch();
			if ((ch == 't') || (ch == 'T'))
			{
				buf[c][d] = col, asksave = 1;
				trailstatus = 1-trailstatus;
				if (trailstatus == 0)
					printmessage("Trail OFF");
				else
					printmessage("Trail ON");
			}
			if ((ch == 32) || (trailstatus == 1))
				buf[c][d] = col, asksave = 1;
			if (ch == 92)                             // It'a a \!
			{
				drawdot(buf[c][d]);
				c = (xdim>>1);
				d = (ydim>>1);
				drawdot((buf[c][d]+16)&255);
			}
			if (ch == '|')
			{
				sprintf(&printbuf,"Coordinates: (%d,%d)",c,d);
				printmessage(&printbuf);
			}
			if (ch == 8)
			{
				drawcolordot(col);
				col = 255;
				drawcolordot((col+16)&255);
			}
			if ((ch == ',') || (ch == '.') || (ch == '<') || (ch == '>'))
			{
				xstep = 0;
				ystep = 0;
				if (markx > c) xstep = 1;
				if (markx < c) xstep = -1;
				if (marky > d) ystep = 1;
				if (marky < d) ystep = -1;
				i = c-xstep;
				do
				{
					i += xstep;
					j = d-ystep;
					do
					{
						j += ystep;
						if ((buf[i][j]&31) > 0)
							if (ch == ',') buf[i][j]--;
						if ((buf[i][j]&31) < 31)
							if (ch == '.') buf[i][j]++;
						if (ch == '<')
						{
							buf[i][j] += 224;
							buf[i][j] &= 255;
						}
						if (ch == '>')
						{
							buf[i][j] += 32;
							buf[i][j] &= 255;
						}
					}
					while (j != marky);
				}
				while (i != markx);
				showall(buf);
				asksave = 1;
			}
			if ((ch == 'M') || (ch == 'm'))
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						buf3[i][j] = buf[i][j];
				printmessage("Tile in memory (P - restore)");
			}
			if ((ch == 'P') || (ch == 'p'))
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						buf[i][j] = buf3[i][j];
				showall(buf);
				asksave = 1;
				printmessage("Tile restored from memory");
			}
			if ((ch == 'J') || (ch == 'j'))
			{
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if (buf[i][j] == buf[c][d])
							if ((rand()&15) == 0)
								buf[i][j] = col;
				showall(buf);
				asksave = 1;
			}
			if ((ch == ']') && (xdim > 0) && (ydim > 0))
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						buf2[i][j] = buf[i][j];
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = buf2[(i+0)%xdim][(j+0)%ydim]*2, n = 2;
							tempchar = buf2[(i+1)%xdim][(j+0)%ydim];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;
							tempchar = buf2[(i-1)%xdim][(j+0)%ydim];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;
							tempchar = buf2[(i+0)%xdim][(j+1)%ydim];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;
							tempchar = buf2[(i+0)%xdim][(j-1)%ydim];
							if ((tempchar>>5) == k)
								m += tempchar, n += 1;

							buf[i][j] = (buf[i][j]&0xe0)+(((m+(n>>1))/n)&31);
						}
				showall(buf);
				asksave = 1;
			}
			if ((ch == '[') && (xdim > 0) && (ydim > 0))
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						buf2[i][j] = buf[i][j];
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = buf2[(i+0)%xdim][(j+0)%ydim]*2, n = 2;

							l = rand();
							tempchar = buf2[(i+1)%xdim][(j+0)%ydim];
							if (((tempchar>>5) == k) && ((l&0x03) == 0))
								m += tempchar, n++;
							tempchar = buf2[(i-1)%xdim][(j+0)%ydim];
							if (((tempchar>>5) == k) && ((l&0x0c) == 0))
								m += tempchar, n++;
							tempchar = buf2[(i+0)%xdim][(j+1)%ydim];
							if (((tempchar>>5) == k) && ((l&0x30) == 0))
								m += tempchar, n++;
							tempchar = buf2[(i+0)%xdim][(j-1)%ydim];
							if (((tempchar>>5) == k) && ((l&0xc0) == 0))
								m += tempchar, n++;

							buf[i][j] = (buf[i][j]&0xe0)+(((m+(n>>1))/n)&31);
						}
				showall(buf);
				asksave = 1;
			}
			if ((ch == 39) && (xdim > 0) && (ydim > 0))    // It's a '
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = (buf[i][j]&31);
							tempchar = buf[(i+1)%xdim][(j+0)%ydim];
							if ((tempchar>>5) != k)
								m--;
							tempchar = buf[(i-1)%xdim][(j+0)%ydim];
							if ((tempchar>>5) != k)
								m++;
							tempchar = buf[(i+0)%xdim][(j+1)%ydim];
							if ((tempchar>>5) != k)
								m--;
							tempchar = buf[(i+0)%xdim][(j-1)%ydim];
							if ((tempchar>>5) != k)
								m++;

							if (m < 0) m = 0;
							if (m > 31) m = 31;
							buf[i][j] = (buf[i][j]&0xe0)+m;
						}
				showall(buf);
				asksave = 1;
			}
			if ((ch == ';') && (xdim > 0) && (ydim > 0))
			{
				k = (buf[c][d]>>5);
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if ((buf[i][j]>>5) == k)
						{
							m = (buf[i][j]&31);
							tempchar = buf[(i+1)%xdim][(j+0)%ydim];
							if ((tempchar>>5) != k)
								m++;
							tempchar = buf[(i-1)%xdim][(j+0)%ydim];
							if ((tempchar>>5) != k)
								m--;
							tempchar = buf[(i+0)%xdim][(j+1)%ydim];
							if ((tempchar>>5) != k)
								m++;
							tempchar = buf[(i+0)%xdim][(j-1)%ydim];
							if ((tempchar>>5) != k)
								m--;

							if (m < 0) m = 0;
							if (m > 31) m = 31;
							buf[i][j] = (buf[i][j]&0xe0)+m;
						}
				showall(buf);
				asksave = 1;
			}
			if (((ch == 'R') || (ch == 'r')) && (xdim > 0) && (ydim > 0))
			{
				printmessage("Rotate tile (Use arrows)");
				ch = getch();
				if (ch == 0)
				{
					ch = getch();
					if (ch == 75)
						for(i=xdim-1;i>=1;i--)
							for(j=0;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[(i+1)%xdim][j];
								buf[(i+1)%xdim][j] = tempchar;
							}
					if (ch == 77)
						for(i=1;i<xdim;i++)
							for(j=0;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[(i+1)%xdim][j];
								buf[(i+1)%xdim][j] = tempchar;
							}
					if (ch == 72)
						for(i=0;i<xdim;i++)
							for(j=ydim-1;j>=1;j--)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[i][(j+1)%ydim];
								buf[i][(j+1)%ydim] = tempchar;
							}
					if (ch == 80)
						for(i=0;i<xdim;i++)
							for(j=1;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[i][(j+1)%ydim];
								buf[i][(j+1)%ydim] = tempchar;
							}
					showall(buf);
				}
				asksave = 1;
				cleartext();
			}
			if ((ch == 'C') || (ch == 'c'))
			{
				tempchar = buf[c][d];
				for(i=0;i<xdim;i++)
					for(j=0;j<ydim;j++)
						if (buf[i][j] == tempchar)
							buf[i][j] = col;
				showall(buf);
				asksave = 1;
			}
			if (ch == '1')
			{
				markx = c;
				marky = d;
				printmessage("1st point set (2 - copy)");
			}
			if (ch == '2')
			{
				x = markx, y = marky, x2 = c, y2 = d;
				if (x > x2)
					templong = x, x = x2, x2 = templong;
				if (y > y2)
					templong = y, y = y2, y2 = templong;
				markxlen = x2-x+1;
				markylen = y2-y+1;
				for(i=0;i<markxlen;i++)
					for(j=0;j<markylen;j++)
						buf2[i][j] = buf[i+x][j+y];
				printmessage("Region copied (3 - paste)");
			}
			if (ch == '3')
			{
				for(i=0;i<markxlen;i++)
					for(j=0;j<markylen;j++)
						if ((i+c < xdim) && (j+d < ydim) && (buf2[i][j] != 255))
							buf[i+c][j+d] = buf2[i][j];
				showall(buf);
				asksave = 1;
			}
			if (ch == '4')
			{
				for(i=0;i<(markxlen>>1);i++)
					for(j=0;j<markylen;j++)
					{
						templong = buf2[i][j];
						buf2[i][j] = buf2[markxlen-1-i][j];
						buf2[markxlen-1-i][j] = templong;
					}
				printmessage("Region flipped x-wise");
			}
			if (ch == '5')
			{
				for(i=0;i<markxlen;i++)
					for(j=0;j<(markylen>>1);j++)
					{
						templong = buf2[i][j];
						buf2[i][j] = buf2[i][markylen-1-j];
						buf2[i][markylen-1-j] = templong;
					}
				printmessage("Region flipped y-wise");
			}
			if (ch == '6')
			{
				x2 = xdim;
				y2 = ydim;
				if (x2 > 240) x2 = 240;
				if (y2 > 240) y2 = 240;
				for(i=0;i<x2;i++)
					for(j=0;j<y2;j++)
						if (i > j)
						{
							templong = buf2[j][i];
							buf2[j][i] = buf2[i][j];
							buf2[i][j] = templong;
						}
				templong = markxlen;
				markxlen = markylen;
				markylen = templong;
				printmessage("X and Y swapped");
			}
			if (ch == '/')
			{
				markxlen = (markxlen>>1)+1, markylen = (markylen>>1)+1;
				for(i=0;i<markxlen;i++)
					for(j=0;j<markylen;j++)
						buf2[i][j] = buf2[i<<1][j<<1];
				printmessage("Region now half-size");
			}
			if (ch == '*')
			{
				markxlen <<= 1, markylen <<= 1;
				if (markxlen > 1024) markxlen = 1024;
				if (markylen > 240) markylen = 240;
				for(i=markxlen;i>=0;i--)
					for(j=markylen;j>=0;j--)
						if ((i < xdim) && (j < ydim))
							buf2[i][j] = buf2[i>>1][j>>1];
				printmessage("Region now double-size");
			}
			if ((ch == 'F') || (ch == 'f'))
			{
				fillregion(c,d,col,col);
				showall(buf);
				printmessage("Flood Fill");
				asksave = 1;
			}
			if (ch == 9)
			{
				drawcolordot(col);
				col = buf[c][d];
				drawcolordot((col+16)&255);
				printmessage("Current color updated");
			}
			if ((ch == '+') || (ch == '-'))
			{
				if ((ch == '+') && ((picanm[picnum]&63) < 63))
					picanm[picnum]++;
				if (ch == '-')
				{
					if ((picanm[picnum]&63) > 0)
						picanm[picnum]--;
					else
						picanm[picnum] = ((picanm[picnum]+64)&0x000000c0)+(picanm[picnum]&0xffffff3f);
				}
				showall(buf);
			}
			if ((ch == 's') || (ch == 'S'))
			{
				x = xdim;
				y = ydim;

				ch = 0;
				while ((ch != 13) && (ch != 27))
				{
					sprintf(&buffer,"Xdim: %d_ ",xdim);
					printmessage(buffer);

					ch = getch();
					if ((ch >= 48) && (ch <= 57))
					{
						i = (xdim*10)+(ch-48);
						if (i <= 1024)
							xdim = i;
					}
					if (ch == 8)
					{
						xdim /= 10;
					}
				}
				if (ch == 13)
				{
					ch = 0;
					while ((ch != 13) && (ch != 27))
					{
						sprintf(&buffer,"Ydim: %d_ ",ydim);
						printmessage(buffer);

						ch = getch();
						if ((ch >= 48) && (ch <= 57))
						{
							i = (ydim*10)+(ch-48);
							if (i <= 240)
								ydim = i;
						}
						if (ch == 8)
						{
							ydim /= 10;
						}
					}
				}
				if (ch == 13)
				{
					c = (xdim>>1);
					d = (ydim>>1);
					asksave = 1;
					drawmainscreen();
				}
				else
				{
					xdim = x;
					ydim = y;
					showall(buf);
					cleartext();
				}
				ch = 255;
			}
			if (((ch == 'o') || (ch == 'O')) && (xdim > 0) && (ydim > 0))
			{
				l = 0;
				m = xdim;
				while ((m > 0) && (l == 0))
				{
					l = 0;
					for(k=0;k<ydim;k++)
						if (buf[0][k] != 255)
						{
							l = 1;
							break;
						}
					if (l == 0)
						for(i=1;i<xdim;i++)
							for(j=0;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[(i+1)%xdim][j];
								buf[(i+1)%xdim][j] = tempchar;
							}
					m--;
				}

				l = 0;
				m = ydim;
				while ((m > 0) && (l == 0))
				{
					l = 0;
					for(k=0;k<xdim;k++)
						if (buf[k][0] != 255)
						{
							l = 1;
							break;
						}
					if (l == 0)
						for(i=0;i<xdim;i++)
							for(j=1;j<ydim;j++)
							{
								tempchar = buf[i][j];
								buf[i][j] = buf[i][(j+1)%ydim];
								buf[i][(j+1)%ydim] = tempchar;
							}
					m--;
				}

				l = 0;
				while ((xdim > 0) && (l == 0))
				{
					l = 0;
					for(k=0;k<ydim;k++)
						if (buf[xdim-1][k] != 255)
						{
							l = 1;
							break;
						}
					if (l == 0)
						xdim--;
				}

				l = 0;
				while ((ydim > 0) && (l == 0))
				{
					l = 0;
					for(k=0;k<xdim;k++)
						if (buf[k][ydim-1] != 255)
						{
							l = 1;
							break;
						}
					if (l == 0)
						ydim--;
				}

				c = (xdim>>1);
				d = (ydim>>1);
				asksave = 1;
				drawmainscreen();
				ch = 255;
			}

			if ((ch == 'u') || (ch == 'U'))
			{
				k = 0;
				do
				{
					i = menuselect();
					if (i < 0)
					{
						chdir(curpath);
						showall(buf);
						if (i == -2)
							printmessage("No files found.");
						break;
					}
					else
					{
						menuhighlight = i;

						j = 0;
						while (menuname[menuhighlight][j] != '.')
							j++;

						if (menuname[menuhighlight][j+1] == 'B')
							loadbmp(menuname[menuhighlight],&frame);
						if (menuname[menuhighlight][j+1] == 'P')
							loadpcx(menuname[menuhighlight],&frame);
						if (menuname[menuhighlight][j+1] == 'G')
							loadgif(menuname[menuhighlight],&frame);
						chdir(curpath);
						k = selectbox();
					}
				}
				while (k == 0);
				ch = 255;
			}
			if ((ch == 'v') || (ch == 'V'))
			{
				savewall(buf,picnum);
				savepics();
				picnum = gettile(picnum);
				loadpics(picnum);
				loadwall(buf,picnum);
				drawmainscreen();
				ch = 255;
			}
			if (((ch == 'a') || (ch == 'A')) && ((picanm[picnum]&192) > 0) && ((picanm[picnum]&63) > 0))
			{
				savewall(buf,picnum);
				sprintf(&printbuf,"Use +/- to change speed",animspeed);
				printmessage(&printbuf);
				i = 1;
				ch = 0;
				while ((ch != 13) && (ch != 27))
				{
					templong = picnum;
					switch(picanm[templong]&192)
					{
						case 64:
							k = (i%((picanm[templong]&63)<<1));
							if (k < (picanm[templong]&63))
								templong += k;
							else
								templong += (((picanm[templong]&63)<<1)-k);
							break;
						case 128:
							templong += (i%((picanm[templong]&63)+1));
							break;
						case 192:
							templong -= (i%((picanm[templong]&63)+1));
					}
					if ((templong >= 0) && (templong < MAXTILES))
						loadwall(buf,templong);
					showall(buf);
					for(j=0;j<animspeed;j++)
						limitrate();
					i = ((i+1)&65535);
					if (kbhit() != 0)
					{
						ch = getch();
						if ((ch == '+') && (animspeed > 0))
							animspeed--;
						if ((ch == '-') && (animspeed < 16))
							animspeed++;
					}
				}
				cleartext();
				loadwall(buf,picnum);
				showall(buf);
				ch = 255;
			}
			if ((ch == 'n') || (ch == 'N'))
			{
				strcpy(&buffer,&names[picnum][0]);
				i = 0;
				while (buffer[i] != 0)
					i++;
				buffer[i] = '_';
				buffer[i+1] = 0;
				strcpy(&buffer2,"Name: ");
				strcat(&buffer2,buffer);
				printmessage(&buffer2[0]);
				ch = 0;
				while ((ch != 13) && (ch != 27))
				{
					ch = getch();
					if ((ch > 32) && (i < 16))
					{
						buffer[i] = ch;
						buffer[i+1] = '_';
						buffer[i+2] = 32;
						buffer[i+3] = 0;
						i++;
						strcpy(&buffer2,"Name: ");
						strcat(&buffer2,buffer);
						printmessage(&buffer2[0]);
					}
					if ((ch == 8) && (i > 0))
					{
						i--;
						buffer[i] = '_';
						buffer[i+1] = 32;
						buffer[i+2] = 0;
						strcpy(&buffer2,"Name: ");
						strcat(&buffer2,buffer);
						printmessage(&buffer2[0]);
					}
				}
				if (ch == 13)
				{
					buffer[i] = 0;
					strcpy(&names[picnum][0],&buffer[0]);
					asksave = 1;
				}
				cleartext();
				if (names[picnum][0] != 0)
				{
					strcpy(&buffer2,"Name: ");
					strcat(&buffer2,&names[picnum][0]);
					printmessage(&buffer2[0]);
				}
			}
			if (ch == 0)
			{
				ch = getch();
				keystate = *keystateptr;
				if ((keystate&3) == 0)
				{
					drawdot(buf[c][d]);
					if ((ch == 75) && (c > 0)) c--;
					if ((ch == 77) && (c < xdim-1)) c++;
					if ((ch == 72) && (d > 0)) d--;
					if ((ch == 80) && (d < ydim-1)) d++;
					drawdot((buf[c][d]+16)&255);
				}
				else
				{
					drawcolordot(col);
					if ((ch == 75) && (col > 0)) col--;
					if ((ch == 77) && (col < 255)) col++;
					if ((ch == 72) && (col > 31)) col -= 32;
					if ((ch == 80) && (col < 224)) col += 32;
					drawcolordot((col+16)&255);
				}
				if ((ch == 73) && (picnum > 0))
				{
					savewall(buf,picnum);
					picnum--;
					loadpics(picnum);
					loadwall(buf,picnum);
					showall(buf);
					drawdot((buf[c][d]+16)&255);
				}
				if ((ch == 81) && (picnum < MAXTILES-1))
				{
					savewall(buf,picnum);
					picnum++;
					loadpics(picnum);
					loadwall(buf,picnum);
					showall(buf);
					drawdot((buf[c][d]+16)&255);
				}
				if (ch == 83)
				{
					xdim = 0;
					ydim = 0;
					c = (xdim>>1);
					d = (ydim>>1);
					asksave = 1;
					drawmainscreen();
				}
				if (ch == 134)   //F12
				{
					drawdot(buf[c][d]);
					screencapture();
					drawdot((buf[c][d]+16)&255);
				}
				ch = 0;
			}
		}
		if (moustat == 1)
		{
			readmouse();
			if ((mousx != 0) || (mousy != 0))
			{
				drawdot(buf[c][d]);

				xstep = c;
				ystep = d;
				c += mousx;
				d += mousy;
				if (c < 0) c = 0;
				if (c >= xdim) c = xdim-1;
				if (d < 0) d = 0;
				if (d >= ydim) d = ydim-1;
				drawdot((buf[c][d]+16)&255);
			}
			if (bstatus > 0)
			{
				x = c;
				y = d;
				j = labs(xstep-x)+labs(ystep-y);
				for(i=0;i<j;i++)
				{
					c = xstep + ((x-xstep)*i)/j;
					d = ystep + ((y-ystep)*i)/j;
					buf[c][d] = col;
					drawdot(col);
				}
				asksave = 1;
				c = x;
				d = y;
			}
		}
		if (ch == 27)
		{
			printmessage("Quit? (Y/N)");
			do
			{
				ch = getch();
			}
			while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N') && (ch != 27));
			if ((ch == 'y') || (ch == 'Y'))
				ch = 27;
			else
			{
				cleartext();
				ch = 0;
			}
		}
	}
	savewall(buf,picnum);
	savepics();

	savenames();
	setvmode(0x3);
	return(0);
}

loadtables()
{
	short int fil;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		lseek(fil,4096L+4096L+640L,SEEK_SET);
		read(fil,&textfont[0],1024);
		close(fil);
	}
	return(0);
}

loadpics(long dapicnum)
{
	long i, offscount, siz, danum;
	short int fil;

	i = curtilefile;
	if (i < 0)
		i = 0;
	while (dapicnum < localtilestart[i])
		i--;
	while ((dapicnum > localtileend[i]) && (i < numtilefiles-1))
		i++;

	if ((i == curtilefile) && (dapicnum <= localtileend[i]))
		return(-1);

	if (curtilefile == -1)
		allasksave = 0;
	else
		savepics();

	if ((dapicnum > localtileend[i]) && (i == numtilefiles-1))
	{
		localtilestart[numtilefiles] = localtileend[i]+1;
		localtileend[numtilefiles] = localtilestart[numtilefiles];
		localtileend[numtilefiles] += (localtileend[i]-localtilestart[i]);
		for(i=localtilestart[numtilefiles];i<=localtileend[numtilefiles];i++)
		{
			tilesizx[i] = 0;
			tilesizy[i] = 0;
			picanm[i] = 0L;
			waloff[i] = FP_OFF(pic);
		}
		numtilefiles++;
		curtilefile = numtilefiles-1;
		totpicsiz = 0L;
		return(0);
	}

	curtilefile = i;
	danum = curtilefile;

	artfilename[7] = (danum%10)+48;
	artfilename[6] = ((danum/10)%10)+48;
	artfilename[5] = ((danum/100)%10)+48;
	if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	read(fil,&artversion,4);
	if (artversion != 1) return(-1);
	read(fil,&numtiles,4);
	read(fil,&localtilestart[danum],4);
	read(fil,&localtileend[danum],4);
	read(fil,&tilesizx[localtilestart[danum]],(localtileend[danum]-localtilestart[danum]+1)<<1);
	read(fil,&tilesizy[localtilestart[danum]],(localtileend[danum]-localtilestart[danum]+1)<<1);
	read(fil,&picanm[localtilestart[danum]],(localtileend[danum]-localtilestart[danum]+1)<<2);

	totpicsiz = 0L;
	for(i=localtilestart[danum];i<=localtileend[danum];i++)
		totpicsiz += (long)(tilesizx[i]*tilesizy[i]);

	if (totpicsiz >= totpicmem)
	{
		printf("Not enough memory to fit artwork data.\n");
		exit(0);
	}

	offscount = 0L;
	for(i=localtilestart[danum];i<=localtileend[danum];i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		siz = tilesizx[i]*tilesizy[i];
		if (siz > 0)
		{
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

savepics()
{
	char ch, dabuffer[80];
	long i, templong, offscount, siz, danum;
	short int fil;

	if (allasksave == 0)
		return(0);
	allasksave = 0;

	danum = curtilefile;

	artfilename[7] = (danum%10)+48;
	artfilename[6] = ((danum/10)%10)+48;
	artfilename[5] = ((danum/100)%10)+48;

	sprintf(dabuffer,"Updating %s...",artfilename);
	printmessage(dabuffer);

	if (localtilestart[danum] > localtileend[danum])
		return(0);

	numtiles = 4095L;
	while ((tilesizx[numtiles] < 2) && (tilesizy[numtiles] < 2) && (numtiles > 0))
		numtiles--;
	numtiles++;

	if (localtilestart[danum] >= MAXTILES)
		return(0);
	if (localtileend[danum] >= MAXTILES)
		localtileend[danum] = MAXTILES-1;

	if ((fil = open(artfilename,O_BINARY|O_CREAT|O_TRUNC|O_WRONLY,S_IWRITE))==-1)
		return(-1);
	write(fil,&artversion,4);
	write(fil,&numtiles,4);
	write(fil,&localtilestart[danum],4);
	write(fil,&localtileend[danum],4);
	write(fil,&tilesizx[localtilestart[danum]],(localtileend[danum]-localtilestart[danum]+1)<<1);
	write(fil,&tilesizy[localtilestart[danum]],(localtileend[danum]-localtilestart[danum]+1)<<1);
	write(fil,&picanm[localtilestart[danum]],(localtileend[danum]-localtilestart[danum]+1)<<2);

	offscount = 0L;
	for(i=localtilestart[danum];i<=localtileend[danum];i++)
	{
		siz = tilesizx[i]*tilesizy[i];
		if (siz > 0)
		{
			if (write(fil,&pic[offscount],siz) < siz)
				printf("SAVE UNSUCCESSFUL!\n");
			offscount += siz;
		}
	}
	close(fil);

	sprintf(dabuffer,"%s updated.",artfilename);
	printmessage(dabuffer);

	return(0);
}

loadwall(char *bufptr, long wallnum)
{
	long i, j, vidpos, dat;
	char *picptr;

	picptr = (char *)(waloff[wallnum]);
	xdim = tilesizx[wallnum];
	ydim = tilesizy[wallnum];

	vidpos = 0;
	for(i=0;i<xdim;i++)
		for(j=0;j<ydim;j++)
		{
			dat = *picptr++;
			*(bufptr+(i<<8)+j) = dat;
		}
	asksave = 0;
	if (c < 0) c = 0;
	if (d < 0) d = 0;
	if (c >= xdim) c = xdim-1;
	if (d >= ydim) d = ydim-1;
	return(0);
}

savewall(char *bufptr, long wallnum)
{
	long i, j, vidpos, dat;
	char *picptr, ch;

	if (asksave != 0)
	{
		if (asksave == 1)
		{
			asksave = 0;
			printmessage("Save current tile?");
			do
			{
				ch = getch();
			}
			while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
			if ((ch == 'n') || (ch == 'N'))
				return(-1);
		}

		allasksave = 1;

		if ((xdim != tilesizx[wallnum]) || (ydim != tilesizy[wallnum]))
		{
			if (resizetile(picnum,(long)tilesizx[wallnum],(long)tilesizy[wallnum],xdim,ydim) == -1)
			{
				printmessage("OUT OF MEMORY! (cancelled)");
			}
			else
			{
				tilesizx[wallnum] = xdim;
				tilesizy[wallnum] = ydim;
			}
		}

		picptr = (char *)(waloff[wallnum]);
		xdim = tilesizx[wallnum];
		ydim = tilesizy[wallnum];

		vidpos = 0;
		for(i=0;i<xdim;i++)
			for(j=0;j<ydim;j++)
			{
				dat = *(bufptr+(i<<8)+j);
				*picptr++ = dat;
			}
	}
	return(0);
}

showall(char *bufptr)
{
	long i, j, vidpos, totsiz, dat, dat1, dat2, dat3, dat4;
	char *picptr;

	cleartopbox();
	cleartext();
	switch(picanm[picnum]&192)
	{
		case 0: printext256(152L,0L,whitetext,blacktext,"NoAnm:"); break;
		case 64: printext256(152L,0L,whitetext,blacktext,"Oscil:"); break;
		case 128: printext256(152L,0L,whitetext,blacktext,"AnmFD:"); break;
		case 192: printext256(152L,0L,whitetext,blacktext,"AnmBK:"); break;
	}
	printbuf[0] = ((picanm[picnum]&63)/10)+48;
	printbuf[1] = ((picanm[picnum]&63)%10)+48;
	if ((picanm[picnum]&63) < 10)
	{
		printbuf[0] = ((picanm[picnum]&63)%10)+48;
		printbuf[1] = 32;
	}
	printbuf[2] = 0;
	printext256(200L,0L,whitetext,blacktext,&printbuf);
	if ((xdim == 0) && (ydim == 0))
	{
		printext256(80L,0L,whitetext,blacktext," -blank-");
	}
	else
	{
		if (xdim >= 1000)
			printbuf[0] = ((xdim/1000)%10)+48;
		else
			printbuf[0] = 32;
		if (xdim >= 100)
			printbuf[1] = ((xdim/100)%10)+48;
		else
			printbuf[1] = 32;
		if (xdim >= 10)
			printbuf[2] = ((xdim/10)%10)+48;
		else
			printbuf[2] = 32;
		printbuf[3] = (xdim%10)+48;
		printbuf[4] = '*';
		printbuf[5] = 32;
		printbuf[6] = 32;
		printbuf[7] = 32;
		printbuf[8] = 0;
		if (ydim >= 100)
		{
			printbuf[5] = ((ydim/100)%10)+48;
			printbuf[6] = ((ydim/10)%10)+48;
			printbuf[7] = (ydim%10)+48;
		}
		else if (ydim >= 10)
		{
			printbuf[5] = ((ydim/10)%10)+48;
			printbuf[6] = (ydim%10)+48;
		}
		else if (ydim >= 1)
		{
			printbuf[5] = (ydim%10)+48;
		}
		else
		{
			printbuf[5] = '0';
		}
		printext256(80L,0L,whitetext,blacktext,&printbuf);
	}

	sprintf(&printbuf,"Tile:");
	printbuf[5] = 32;
	printbuf[6] = 32;
	printbuf[7] = 32;
	printbuf[9] = 32;
	printbuf[8] = 0;
	if (picnum >= 1000)
	{
		printbuf[5] = ((picnum/1000)%10)+48;
		printbuf[6] = ((picnum/100)%10)+48;
		printbuf[7] = ((picnum/10)%10)+48;
		printbuf[8] = (picnum%10)+48;
	}
	else if (picnum >= 100)
	{
		printbuf[5] = ((picnum/100)%10)+48;
		printbuf[6] = ((picnum/10)%10)+48;
		printbuf[7] = (picnum%10)+48;
	}
	else if (picnum >= 10)
	{
		printbuf[5] = ((picnum/10)%10)+48;
		printbuf[6] = (picnum%10)+48;
	}
	else if (picnum >= 1)
	{
		printbuf[5] = (picnum%10)+48;
	}
	else
	{
		printbuf[5] = '0';
	}
	printext256(0L,0L,whitetext,blacktext,&printbuf);

	if (names[picnum][0] != 0)
		printmessage(&names[picnum][0]);

	for(i=0;i<xdim;i++)
	{
		outp(0x3c4,2); outp(0x3c5,1<<(i&3));
		vidpos = (((16*panxdim)+i)>>2);
		for(j=0;j<ydim;j++)
		{
			dat = *(bufptr+(i<<8)+j);
			drawpixel(vidpos+0xa0000,dat);
			vidpos += (panxdim>>2);
		}
	}
	return(0);
}

drawdot(char col)
{
	long vidpos, dat, num;

	panx = 0;
	pany = 0;
	if (xdim > 320)
	{
		panx = c-160;
		if (panx < 0) panx = 0;
		if (panx > xdim-320)
			panx = xdim-320;
	}
	if (ydim > 184)
	{
		pany = d-92;
		if (pany < 0) pany = 0;
		if (pany > ydim-184)
			pany = ydim-184;
	}
	num = (pany+16)*panxdim+panx;
	outp(0x3d4,0xc); outp(0x3d5,num>>10);
	outp(0x3d4,0xd); outp(0x3d5,(num>>2)&255);
	outp(0x3c0,inp(0x3c0)|0x13); outp(0x3c0,(num&3)<<1);

	dat = col;
	if ((xdim|ydim) == 0)
		return(-1);
	outp(0x3c4,2); outp(0x3c5,1<<(c&3));
	vidpos = ((((d+16)*panxdim)+c)>>2)+0xa0000;
	drawpixel(vidpos,dat);

	return(0);
}

drawcolordot(char thecol)
{
	long vidpos, dat;

	outp(0x3c4,2); outp(0x3c5,1<<(((col&31)*3+1)&3));
	vidpos = ((((col>>5)*2)*panxdim+((col&31)*3+225))>>2)+0xa0000;
	drawpixel(vidpos,(long)thecol);
	drawpixel(vidpos+(panxdim>>2),(long)thecol);
}

loadbmp(char filename[20],char *ptr)
{
	short int fil, i;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
		return(-1);
	read(fil,&tempbuf[0],4);
	if ((tempbuf[0] == 'B') && (tempbuf[1] == 'M') && (tempbuf[2] == 'Z') && (tempbuf[3] == 34))
	{
		read(fil,&tempbuf[0],22);
		read(fil,&tempbuf[0],768);
		outp(0x3c8,0);
		for(i=0;i<256;i++)
		{
			outp(0x3c9,tempbuf[i+i+i+2]>>2);
			outp(0x3c9,tempbuf[i+i+i+1]>>2);
			outp(0x3c9,tempbuf[i+i+i+0]>>2);
		}
	}
	else
	{
		read(fil,&tempbuf[0],50);
		read(fil,&tempbuf[0],1024);
		outp(0x3c8,0);
		for(i=0;i<1024;i++)
			if ((i&3) != 0)
				outp(0x3c9,tempbuf[i^3]>>2);
	}
	pplc = ((long)ptr)+64000L-320L;
	for(i=0;i<200;i++)
	{
		read(fil,&tempbuf[0],320);
		drawrow(pplc);
		pplc -= 320L;
	}
	close(fil);
	return(0);
}

loadpcx(char filename[20],char *ptr)
{
	unsigned char dat;
	long fil, i, p, datcnt, leng;

	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
		return(-1);
	read(fil,&tempbuf[0],128);
	p = 64000;
	read(fil,&tempbuf[0],4096), datcnt = 0;
	while (p > 0)
	{
		dat = tempbuf[datcnt++];
		if (datcnt == 4096)
			read(fil,&tempbuf[0],4096), datcnt = 0;
		if ((dat&0xc0) == 0xc0)
		{
			leng = (dat&0x3f);
			dat = tempbuf[datcnt++];
			if (datcnt == 4096)
				read(fil,&tempbuf[0],4096), datcnt = 0;
			for(i=0;i<leng;i++)
			{
				*ptr = dat;
				ptr++;
			}
			p -= leng;
		}
		else
		{
			*ptr = dat;
			ptr++;
			p--;
		}
	}
	dat = tempbuf[datcnt++];
	if (datcnt == 4096)
		read(fil,&tempbuf[0],4096), datcnt = 0;
	if (dat == 0xc)
	{
		outp(0x3c8,0);
		for(i=0;i<768;i++)
		{
			dat = tempbuf[datcnt++];
			if (datcnt == 4096)
				read(fil,&tempbuf[0],4096), datcnt = 0;
			outp(0x3c9,dat>>2);
		}
	}
	close(fil);
	return(0);
}

loadgif(char filename[20], char *ptr)
{
	unsigned char header[13], imagestat[10], bitcnt, numbits;
	unsigned char globalflag, chunkind;
	short i, j, k, m, y, xspan, yspan, yend;
	short currstr, bytecnt, numbitgoal;
	short numcols, numpals, dat, fil, blocklen, firstring;
	short unsigned int bytesperline, numlines, gifdatacnt;
	long p, pend;

	if ((strstr(filename,".gif") == 0) && (strstr(filename,".GIF") == 0))
		strcat(filename,".gif");
	if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	gifdatacnt = 0;
	read(fil,&gifdata[0],(unsigned)GIFBUFLEN);
	for(j=0;j<13;j++)
		header[j] = gifdata[j+gifdatacnt];
	gifdatacnt += 13;
	if ((header[0] != 'G') || (header[1] != 'I') || (header[2] != 'F'))
		return(-1);
	globalflag = header[10];
	numcols = (1<<((globalflag&7)+1));
	firstring = numcols+2;
	if (header[12] != 0)
		return(-1);
	if ((globalflag&128) > 0)
	{
		numpals = numcols+numcols+numcols;
		for(j=0;j<numpals;j++)
			giffilbuffer[j] = gifdata[j+gifdatacnt];
		gifdatacnt += numpals;
	}
	chunkind = gifdata[gifdatacnt], gifdatacnt++;
	while (chunkind == '!')
	{
		gifdatacnt++;
		do
		{
			chunkind = gifdata[gifdatacnt], gifdatacnt++;
			if (chunkind > 0)
				gifdatacnt += chunkind;
		}
		while (chunkind > 0);
		chunkind = gifdata[gifdatacnt], gifdatacnt++;
	}
	if (chunkind == ',')
	{
		for(j=0;j<9;j++)
			imagestat[j] = gifdata[j+gifdatacnt];
		gifdatacnt += 9;
		xspan = imagestat[4]+(imagestat[5]<<8);
		yspan = imagestat[6]+(imagestat[7]<<8);
		if ((imagestat[8]&128) > 0)        //localflag
		{
			numpals = numcols+numcols+numcols;
			for(j=0;j<numpals;j++)
				giffilbuffer[j] = gifdata[j+gifdatacnt];
			gifdatacnt += numpals;
		}
		gifdatacnt++;

		bytesperline = 320, numlines = 200;
		setvmode(0x13);
		outp(0x3c8,0);
		for(i=0;i<numpals;i++)
			outp(0x3c9,giffilbuffer[i]>>2);

		y = ((numlines-yspan)>>1);
		if (y < 0) y = 0;
		yend = y+yspan;
		if (yend > 768) yend = 768;

		p = (long)y*(long)bytesperline+(long)((bytesperline-xspan)>>1);
		pend = p+xspan;

		bitcnt = 0;
		for(i=0;i<numcols;i++)
		{
			gifsuffix[i] = i;
			gifprefix[i] = i;
		}
		currstr = firstring;
		numbits = (globalflag&7)+2;
		numbitgoal = (numcols<<1);
		blocklen = 0;
		blocklen = gifdata[gifdatacnt], gifdatacnt++;
		for(j=0;j<blocklen;j++)
			giffilbuffer[j] = gifdata[j+gifdatacnt];
		gifdatacnt += blocklen;
		bytecnt = 0;
		while (y < yend)
		{
			dat = gifgetdat(bytecnt,numbits,bitcnt);
			bytecnt += ((bitcnt+numbits)>>3);
			bitcnt = ((bitcnt+numbits)&7);
			if (bytecnt > blocklen-3)
			{
				giffilbuffer[0] = giffilbuffer[bytecnt];
				giffilbuffer[1] = giffilbuffer[bytecnt+1];
				i = blocklen-bytecnt;
				blocklen = (short)gifdata[gifdatacnt++];
				if (gifdatacnt+blocklen < GIFBUFLEN)
				{
					for(m=0;m<blocklen;m++)
						giffilbuffer[i+m] = gifdata[gifdatacnt+m];
					gifdatacnt += blocklen;
				}
				else
				{
					k = GIFBUFLEN-gifdatacnt;
					for(m=0;m<k;m++)
						giffilbuffer[i+m] = gifdata[gifdatacnt+m];
					read(fil,&gifdata[0],(unsigned)GIFBUFLEN);
					for(m=k;m<blocklen;m++)
						giffilbuffer[i+m] = gifdata[m-k];
					gifdatacnt = blocklen-k;
				}
				bytecnt = 0;
				blocklen += i;
			}
			if (currstr == numbitgoal)
				if (numbits < 12)
				{
					numbits++;
					numbitgoal <<= 1;
				}
			if (dat == numcols)
			{
				currstr = firstring;
				numbits = (globalflag&7)+2;
				numbitgoal = (numcols<<1);
			}
			else
			{
				gifprefix[currstr] = dat;
				k = 0;
				while (dat > numcols+1)
				{
					giftempstack[k++] = gifsuffix[dat];
					dat = gifprefix[dat];
				}
				giftempstack[k++] = gifprefix[dat];
				gifsuffix[currstr-1] = dat;
				gifsuffix[currstr] = dat;
				for(i=k-1;i>=0;i--)
				{
					*ptr = giftempstack[i];
					ptr++;
					p++;
					if (p >= pend)
					{
						y++;
						p += bytesperline-xspan;
						pend += bytesperline;
					}
				}
				currstr++;
			}
		}
	}
	close(fil);
	return(0);
}

drawmainscreen()
{
	long i, j, lin, templong, dat;

	setvmode(0x13);
	outp(0x3c4,0x4); outp(0x3c5,0x6);
	outp(0x3d4,0x14); outp(0x3d5,0x0);
	outp(0x3d4,0x17); outp(0x3d5,0xe3);

	outp(0x3c4,2); outp(0x3c5,15);
	clearbuf(0xa0000,16384,0L);

	outp(0x3d4,0x13); outp(0x3d5,panxdim>>3);

	inp(0x3da); outp(0x3c0,0x30); outp(0x3c0,113);  //FIX FOR LINE COMPARE
	outp(0x3d4,0x11); outp(0x3d5,inp(0x3d5)&(255-128)); //Unlock indeces 0-7
	outp(0x3d4,21); outp(0x3d5,142);

	lin = 399 - 32;
	outp(0x3d4,0x18); outp(0x3d5,lin&255);
	outp(0x3d4,0x7); outp(0x3d5,(inp(0x3d5)&239)|((lin&256)>>4));
	outp(0x3d4,0x9); outp(0x3d5,(inp(0x3d5)&191)|((lin&512)>>3));

	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	for(i=0;i<32;i++)
		for(j=0;j<8;j++)
		{
			templong = (j*2*panxdim)+(i*3+224);
			dat = (j<<5)+i;
			drawchainpixel(templong,dat);
			drawchainpixel(templong+1,dat);
			drawchainpixel(templong+2,dat);
			drawchainpixel(templong+panxdim,dat);
			drawchainpixel(templong+panxdim+1,dat);
			drawchainpixel(templong+panxdim+2,dat);
		}

	showall(buf);
	drawdot((buf[c][d]+16)&255);
	drawcolordot((col+16)&255);
}

drawopenbox(long x1, long y1, long x2, long y2, char col)
{
	long i, vidpos1, vidpos2, dat, temp;

	dat = (long)col;
	dat += (dat<<8);
	if (x1 > x2)
		temp = x1, x1 = x2, x2 = temp;
	if (y1 > y2)
		temp = y1, y1 = y2, y2 = temp;
	vidpos1 = y1*320+x1;
	vidpos2 = y1*320+x2;
	for(i=y1;i<y2;i+=2)
	{
		drawchainpixel(vidpos1,dat);
		drawchainpixel(vidpos2,dat);
		vidpos1 += (320<<1);
		vidpos2 += (320<<1);
	}
	vidpos1 = y1*320+x1;
	vidpos2 = y2*320+x1;
	for(i=x1;i<x2;i+=2)
	{
		drawchainpixel(vidpos1,dat);
		drawchainpixel(vidpos2,dat);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

getpaletteconversion()
{
	long i, j, totintens1, totintens2, brichang, c1, c2, c3, bestcol, dadist;
	long zx;

	totintens1 = 0;
	totintens2 = 0;
	for(i=0;i<768;i++)
	{
		totintens1 += palette[i];
		totintens2 += palette2[i];
	}
	brichang = (totintens1-totintens2)/768;
	for(i=0;i<768;i+=3)
	{
		c1 = palette2[i]+brichang;
		c2 = palette2[i+1]+brichang;
		c3 = palette2[i+2]+brichang;
		bestcol = 0;
		dadist = 65536;
		for(j=0;j<768;j+=3)
		{
			zx = 30*(c1-palette[j])*(c1-palette[j]);
			zx += 59*(c2-palette[j+1])*(c2-palette[j+1]);
			zx += 11*(c3-palette[j+2])*(c3-palette[j+2]);
			if (zx < dadist)
				dadist = zx, bestcol = j/3;
		}
		palookupe[i/3] = bestcol;
	}
	palookupe[255] = 255;
}

fillregion(long x, long y, char col, char bound)
{
	unsigned char tstat, bstat, tlast, blast;
	int i, leftz, z, zz, c;

	c = 1;
	xfillbuf[c] = x;
	yfillbuf[c] = y;
	if (buf[x][y] == bound)
		return(-1);
	while (c > 0)
	{
		z = xfillbuf[c];
		zz = yfillbuf[c];
		c--;
		while ((buf[z-1][zz] != bound) && (z > 0))
			z--;
		leftz = z;
		tlast = 0;
		blast = 0;
		while ((buf[z][zz] != bound) && (z < xdim))
		{
			if (zz > 0)
			{
				tstat = buf[z][zz-1];
				if ((tstat != bound) && (tstat != col))
				{
					if (tlast == 0)
					{
						c++;
						xfillbuf[c] = z;
						yfillbuf[c] = zz-1;
						tlast = 1;
					}
				}
				else
					tlast = 0;
			}
			if (zz < ydim-1)
			{
				bstat = buf[z][zz+1];
				if ((bstat != bound) && (bstat != col))
				{
					if (blast == 0)
					{
						c++;
						xfillbuf[c] = z;
						yfillbuf[c] = zz+1;
						blast = 1;
					}
				}
				else
					blast = 0;
			}
			z++;
		}
		z--;
		while (z >= leftz)
		{
			if ((z >= 0) && (z < xdim))
				buf[z][zz] = col;
			z--;
		}
	}
	return(0);
}

getpalookup()
{
	long i, j, k, dist, mindist, c1, c2, c3, closest;

	for(i=0;i<NUMPALOOKUPS;i++)
	{
		for(j=0;j<256;j++)
		{
			c1 = (palette[j+j+j+0]*((NUMPALOOKUPS-1)-i))/NUMPALOOKUPS;
			c2 = (palette[j+j+j+1]*((NUMPALOOKUPS-1)-i))/NUMPALOOKUPS;
			c3 = (palette[j+j+j+2]*((NUMPALOOKUPS-1)-i))/NUMPALOOKUPS;

			mindist = 32767, closest = -1;
			for(k=0;k<256;k++)
			{
				dist = (c1-palette[k+k+k+0])*(c1-palette[k+k+k+0]);
				dist += (c2-palette[k+k+k+1])*(c2-palette[k+k+k+1]);
				dist += (c3-palette[k+k+k+2])*(c3-palette[k+k+k+2]);
				if (dist < mindist)
				{
					mindist = dist;
					closest = k;
				}
			}

			palookup[i][j] = closest;
		}
	}
}

gettile(long tilenum)
{
	char ch;
	long i, j, lin, num, otilenum, topleft;

	outp(0x3d4,0x13); outp(0x3d5,320>>3);

	lin = 400;
	outp(0x3d4,0x18); outp(0x3d5,lin&255);
	outp(0x3d4,0x7); outp(0x3d5,(inp(0x3d5)&239)|((lin&256)>>4));
	outp(0x3d4,0x9); outp(0x3d5,(inp(0x3d5)&191)|((lin&512)>>3));
	num = 0;
	outp(0x3d4,0xc); outp(0x3d5,num>>10);
	outp(0x3d4,0xd); outp(0x3d5,(num>>2)&255);
	outp(0x3c0,inp(0x3c0)|0x13); outp(0x3c0,(num&3)<<1);


	otilenum = tilenum;

	topleft = ((tilenum/5)*5)-5;
	if (topleft < 0) topleft = 0;
	if (topleft > MAXTILES-15) topleft = MAXTILES-15;
	ch = 0;
	while ((ch != 27) && (ch != 13))
	{
		drawtilescreen(topleft,tilenum);
		copytovideo();

		ch = getch();
		if (ch == 0)
		{
			ch = getch();
			{
				if ((ch == 75) && (tilenum > 0)) tilenum--;
				if ((ch == 77) && (tilenum < MAXTILES-1)) tilenum++;
				if ((ch == 72) && (tilenum >= 5)) tilenum-=5;
				if ((ch == 80) && (tilenum < MAXTILES-5)) tilenum+=5;
				if ((ch == 73) && (tilenum >= 5))
				{
					tilenum-=15;
					if (tilenum < 0) tilenum = 0;
				}
				if ((ch == 81) && (tilenum < MAXTILES-5))
				{
					tilenum+=15;
					if (tilenum >= MAXTILES) tilenum = MAXTILES;
				}
				while (tilenum < topleft) topleft -= 5;
				while (tilenum >= topleft+15) topleft += 5;
			}
		}
	}

	if (ch != 13) tilenum = otilenum;
	return(tilenum);
}

drawtilescreen(long pictopleft, long picbox)
{
	long i, j, vidpos, vidpos2, dat, wallnum, xdime, ydime, cnt, scaledown;
	char *picptr;

	clearbuf(frameplace,16000L,0L); //clear frame first

	loadpics(pictopleft);

	for(cnt=0;cnt<15;cnt++)         //draw the 5*3 grid of tiles
	{
		wallnum = cnt+pictopleft;

		loadpics(wallnum);

		if ((tilesizx[wallnum]|tilesizy[wallnum]) != 0)
		{
			picptr = (char *)(waloff[wallnum]);
			xdime = tilesizx[wallnum];
			ydime = tilesizy[wallnum];

			vidpos = (cnt/5)*(320*64)+(cnt%5)*64+frameplace;
			if ((xdime <= 64) && (ydime <= 64))
			{
				for(i=0;i<xdime;i++)
				{
					vidpos2 = vidpos;
					for(j=0;j<ydime;j++)
					{
						dat = *picptr++;
						drawpixel(vidpos2, dat);
						vidpos2 += 320L;
					}
					vidpos++;
				}
			}
			else                          //if 1 dimension > 64
			{
				if (xdime > ydime)
					scaledown = ((xdime+63)>>6);
				else
					scaledown = ((ydime+63)>>6);

				for(i=0;i<xdime;i+=scaledown)
				{
					picptr = (char *)(waloff[wallnum]) + ydime*i;
					vidpos2 = vidpos;
					for(j=0;j<ydime;j+=scaledown)
					{
						dat = *picptr;
						picptr += scaledown;
						drawpixel(vidpos2, dat);
						vidpos2 += 320L;
					}
					vidpos++;
				}
			}
		}
	}

	cnt = picbox-pictopleft;    //draw open white box
	vidpos = (cnt/5)*(320*64)+(cnt%5)*64+frameplace;
	vidpos2 = vidpos+(63*320);
	j = 0;
	for(i=0;i<64;i++)
	{
		drawpixel(vidpos+i,31);
		drawpixel(vidpos2+i,31);
		drawpixel(vidpos+j,31);
		drawpixel(vidpos+j+63,31);
		j += 320;
	}
	return(0);
}

loadnames()
{
	char buffer[80], firstch, ch;
	short int fil, i, num, buffercnt;

	if ((fil = open("names.h",O_BINARY|O_RDWR,S_IREAD)) == -1)
		return(-1);
	do
	{
		i = read(fil,&firstch,1);
	}
	while ((firstch != '#') && (i > 0));

	while ((firstch == '#') || (firstch == '/'))
	{
		do
		{
			read(fil,&ch,1);
		}
		while (ch > 32);

		buffercnt = 0;
		do
		{
			read(fil,&ch,1);
			if (ch > 32)
				buffer[buffercnt++] = ch;
		}
		while (ch > 32);

		num = 0;
		do
		{
			read(fil,&ch,1);
			if ((ch >= 48) && (ch <= 57))
				num = num*10+(ch-48);
		}
		while (ch != 13);
		for(i=0;i<buffercnt;i++)
			names[num][i] = buffer[i];
		names[num][buffercnt] = 0;

		if (read(fil,&firstch,1) <= 0)
			firstch = 0;
		if (firstch == 10)
			read(fil,&firstch,1);
	}
	close(fil);
	return(0);
}

savenames()
{
	char buffer[80];
	short int fil, i, j;

	if ((fil = open("names.h",O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) == -1)
		return(-1);
	strcpy(&buffer,"//PLEASE DO NOT MODIFY THIS FILE!");
	buffer[33] = 13, buffer[34] = 10, buffer[35] = 0;
	write(fil,&buffer[0],35);
	strcpy(&buffer,"//pics.art");
	buffer[10] = 13, buffer[11] = 10, buffer[12] = 0;
	write(fil,&buffer[0],12);

	strcpy(&buffer,"#define ");
	for(i=0;i<MAXTILES;i++)
		if (names[i][0] != 0)
		{
			j = 8;
			while (names[i][j-8] != 0)
			{
				buffer[j] = names[i][j-8];
				j++;
			}
			buffer[j++] = 32;

			if (i >= 10000) buffer[j++] = ((i/10000)%10)+48;
			if (i >= 1000) buffer[j++] = ((i/1000)%10)+48;
			if (i >= 100) buffer[j++] = ((i/100)%10)+48;
			if (i >= 10) buffer[j++] = ((i/10)%10)+48;
			buffer[j++] = (i%10)+48;

			buffer[j++] = 13;
			buffer[j++] = 10;
			write(fil,&buffer[0],j);
		}

	close(fil);
	return(0);
}

initmenupaths(char filename[80])
{
	long i;

	strcpy(&curpath,filename);
	i = 0;
	while ((i < 80) && (curpath[i] != 0)) i++;
	while ((i > 0) && (curpath[i] != 92)) i--;
	curpath[i] = 0;
	strcpy(&menupath,curpath);
}

getfilenames(char kind[6])
{
	short type;
	struct find_t fileinfo;

	if (strcmp(kind,"SUBD") == 0)
	{
		strcpy(kind,"*.*");
		if (_dos_findfirst(kind,_A_SUBDIR,&fileinfo) != 0)
			return(-1);
		type = 1;
	}
	else
	{
		if (_dos_findfirst(kind,_A_NORMAL,&fileinfo) != 0)
			return(-1);
		type = 0;
	}
	do
	{
		if ((type == 0) || ((fileinfo.attrib&16) > 0))
			if ((fileinfo.name[0] != '.') || (fileinfo.name[1] != 0))
			{
				strcpy(menuname[menunamecnt],fileinfo.name);
				menuname[menunamecnt][16] = type;
				menunamecnt++;
			}
	}
	while (_dos_findnext(&fileinfo) == 0);

	return(0);
}

sortfilenames()
{
	char sortbuffer[17];
	long i, j, k, m;

	for(i=1;i<menunamecnt;i++)
		for(j=0;j<i;j++)
		{
			 k = 0;
			 while ((menuname[i][k] == menuname[j][k]) && (menuname[i][k] != 0) && (menuname[j][k] != 0))
				 k++;
			if (menuname[i][k] < menuname[j][k])
			{
				memcpy(&sortbuffer[0],&menuname[i][0],sizeof(menuname[0]));
				memcpy(&menuname[i][0],&menuname[j][0],sizeof(menuname[0]));
				memcpy(&menuname[j][0],&sortbuffer[0],sizeof(menuname[0]));
			}
		}
}

menuselect()
{
	long newhighlight, i, j, topplc;
	char ch, buffer[42];

	chdir(menupath);
	menunamecnt = 0;
	getfilenames("SUBD");
	getfilenames("*.BMP");
	getfilenames("*.PCX");
	getfilenames("*.GIF");
	sortfilenames();
	if (menunamecnt == 0)
		return(-2);

	printmessage("Select with arrows&enter.");
	cleartopbox();
	if (menuhighlight < 0) menuhighlight = 0;
	if (menuhighlight >= menunamecnt) menuhighlight = menunamecnt-1;

	newhighlight = menuhighlight;
	do
	{
		if (menunamecnt <= 22)
		{
			topplc = 0;
		}
		else
		{
			topplc = newhighlight-11;
			if (topplc < 0) topplc = 0;
			if (topplc > menunamecnt-23) topplc = menunamecnt-23;
		}

		for(i=0;i<menunamecnt;i++)
		{
			for(j=0;j<24;j++)
				buffer[j] = 32;
			buffer[24] = 0;
			if (i == newhighlight)
			{
				buffer[0] = '-';
				buffer[1] = '-';
				buffer[2] = '>';
			}
			j = 0;
			while (menuname[i][j] != 0)
			{
				buffer[j+4] = menuname[i][j];
				j++;
			}
			if ((i-topplc >= 0) && (i-topplc <= 22))
			{
				if (menuname[i][16] == 1)
				{
					printext256(panx,((i-topplc)<<3)+16L+pany,pinktext,blacktext,buffer);
				}
				else
				{
					printext256(panx,((i-topplc)<<3)+16L+pany,whitetext,blacktext,buffer);
				}
			}
		}
		ch = getch();
		if (ch == 0)
		{
			ch = getch();
			if ((ch == 75) || (ch == 72))
			{
				newhighlight--;
				if (newhighlight < 0)
					newhighlight = menunamecnt-1;
			}
			if ((ch == 77) || (ch == 80))
			{
				newhighlight++;
				if (newhighlight >= menunamecnt)
					newhighlight = 0;
			}
		}
		if ((ch == 13) && (menuname[newhighlight][16] == 1))
		{
			if ((menuname[newhighlight][0] == '.') && (menuname[newhighlight][1] == '.'))
			{
				i = 0;
				while ((i < 80) && (menupath[i] != 0)) i++;
				while ((i > 0) && (menupath[i] != 92)) i--;
				menupath[i] = 0;
			}
			else
			{
				strcat(&menupath,"\\");
				strcat(&menupath,menuname[newhighlight]);
			}
			chdir(menuname[newhighlight]);
			menunamecnt = 0;
			getfilenames("SUBD");
			getfilenames("*.BMP");
			getfilenames("*.PCX");
			getfilenames("*.GIF");
			sortfilenames();
			newhighlight = 0;
			ch = 0;
			cleartopbox();
		}
	}
	while ((ch != 13) && (ch != 27));
	if (ch == 13)
	{
		menuhighlight = newhighlight;
		return(newhighlight);
	}
	return(-1);
}

printext256(long xpos, long ypos, short col, short backcol, char name[82])
{
	char ch;
	short shift;
	long p, startp, z, zz;

	outp(0x3c4,2);
	startp = ((ypos*panxdim+xpos)>>2)+0xa0000;

	z = 0;
	while (name[z] != 0)
	{
		ch = name[z];
		z++;

		if ((xpos&3) == 0)
		{
			p = startp;
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3c5,15-reversemask[textfont[ch][zz]>>4]);
					drawpixel(p,backcol);
					outp(0x3c5,15-reversemask[textfont[ch][zz]&15]);
					drawpixel(p+1,backcol);
				}
				outp(0x3c5,reversemask[textfont[ch][zz]>>4]);
				drawpixel(p,col);
				outp(0x3c5,reversemask[textfont[ch][zz]&15]);
				drawpixel(p+1,col);
				p += (panxdim>>2);
			}
		}
		else
		{
			shift = (xpos&3);

			p = startp;
			for(zz=0;zz<8;zz++)
			{
				if (backcol >= 0)
				{
					outp(0x3c5,(16-(1<<shift)) - (reversemask[(textfont[ch][zz]>>(shift+4))&reversemask[16-(1<<shift)]]));
					drawpixel(p,backcol);
					outp(0x3c5,15-reversemask[(textfont[ch][zz]>>shift)&15]);
					drawpixel(p+1,backcol);
					outp(0x3c5,((1<<shift)-1) - (reversemask[(textfont[ch][zz]<<(4-shift))&reversemask[(1<<shift)-1]]));
					drawpixel(p+2,backcol);
				}
				outp(0x3c5,reversemask[(textfont[ch][zz]>>(shift+4))&reversemask[16-(1<<shift)]]);
				drawpixel(p,col);
				outp(0x3c5,reversemask[(textfont[ch][zz]>>shift)&15]);
				drawpixel(p+1,col);
				outp(0x3c5,reversemask[(textfont[ch][zz]<<(4-shift))&reversemask[(1<<shift)-1]]);
				drawpixel(p+2,col);
				p += (panxdim>>2);
			}
		}

		startp += 2;
	}
	return(0);
}

printmessage(char name[82])
{
	cleartext();
	printext256(0L,8L,yellowtext,browntext,name);
}

screencapture()
{
	char filename[15];
	short fil;
	long i, j, k, bufplc, vidpos;

	strcpy(filename,"capturxx.bmp");
	filename[6] = (capturecount/10)+48;
	filename[7] = (capturecount%10)+48;
	capturecount++;
	if ((fil=open(filename,O_BINARY|O_CREAT|O_WRONLY,S_IWRITE))==-1)
	{
		capturecount--;
		return(-1);
	}
	tempbuf[0] = 66, tempbuf[1] = 77, tempbuf[2] = 90, tempbuf[3] = 34;
	tempbuf[4] = 0, tempbuf[5] = 0, tempbuf[6] = 0, tempbuf[7] = 0;
	tempbuf[8] = 0, tempbuf[9] = 0, tempbuf[10] = 26, tempbuf[11] = 3;
	tempbuf[12] = 0, tempbuf[13] = 0, tempbuf[14] = 12, tempbuf[15] = 0;
	tempbuf[16] = 0, tempbuf[17] = 0, tempbuf[18] = 64, tempbuf[19] = 1;
	tempbuf[20] = 200, tempbuf[21] = 0, tempbuf[22] = 1, tempbuf[23] = 0;
	tempbuf[24] = 8, tempbuf[25] = 0;
	write(fil,&tempbuf[0],26);
	outp(0x3c7,0);
	for(i=0;i<768;i++)
		tempbuf[i] = (inp(0x3c9)<<2);
	for(i=0;i<768;i+=3)
	{
		j = tempbuf[i];
		tempbuf[i] = tempbuf[i+2];
		tempbuf[i+2] = j;
	}
	if (write(fil,&tempbuf[0],768) < 768)
	{
		close(fil);
		capturecount--;
		return(-1);
	}

	bufplc = 0L;
	for(j=199;j>=0;j--)
	{
		outp(97,inp(97)|3);

		vidpos = (j+pany+16)*panxdim+panx;
		for(i=0;i<320;i++)
		{
			outp(0x3ce,4); outp(0x3cf,(i+panx)&3);
			tempbuf[bufplc+i] = getpixel((vidpos>>2)+0xa0000);
			vidpos++;
		}
		//readrow(frameplace+j*320,bufplc);

		bufplc += 320L;
		if (bufplc >= 3200L)
		{
			if (write(fil,&tempbuf[0],3200) < 3200)
			{
				close(fil);
				capturecount--;
				return(-1);
			}
			bufplc = 0L;
		}
		outp(97,inp(97)&252);
	}
	close(fil);
	return(0);
}

resizetile(long picnume, long oldx, long oldy, long newx, long newy)
{
	char *charptr1, *charptr2;
	long *longptr1, *longptr2;
	long i, j, dat, templong;

	if (totpicsiz+templong > totpicmem)
		return(-1);

	templong = newx*newy-oldx*oldy;
	j = 0L;
	for(i=localtilestart[curtilefile];i<picnume;i++)
		j += tilesizx[i]*tilesizy[i];
	if (templong < 0)
	{
		longptr1 = (long *)(FP_OFF(pic)+j-templong);
		longptr2 = (long *)(FP_OFF(pic)+j);
		i = j-templong;
		while (i < totpicsiz-3)
		{
			dat = *longptr1++;
			*longptr2++ = dat;
			i += 4;
		}
		charptr1 = (char *)(longptr1);
		charptr2 = (char *)(longptr2);
		while (i < totpicsiz)
		{
			dat = *charptr1++;
			*charptr2++ = dat;
			i++;
		}
	}
	else if (templong > 0)
	{
		longptr1 = (long *)(FP_OFF(pic)+totpicsiz-1);
		longptr2 = (long *)(FP_OFF(pic)+totpicsiz-1+templong);
		i = j;
		while (i < totpicsiz-3)
		{
			dat = *longptr1--;
			*longptr2-- = dat;
			i += 4;
		}
		charptr1 = (char *)(longptr1);
		charptr2 = (char *)(longptr2);
		while (i < totpicsiz)
		{
			dat = *charptr1++;
			*charptr2++ = dat;
			i++;
		}
	}
	for(j=picnume+1;j<localtileend[curtilefile];j++)
		waloff[j] += templong;
	totpicsiz += templong;
	return(0);
}

selectbox()
{
	char ch, *ptr;
	long i, j, k, x, y, x2, y2, fil, templong, dat, vidpos;
	long xstep, ystep, lin, num, oxdim, oydim;

	outp(0x3d4,0x13); outp(0x3d5,320>>3);

	lin = 400;
	outp(0x3d4,0x18); outp(0x3d5,lin&255);
	outp(0x3d4,0x7); outp(0x3d5,(inp(0x3d5)&239)|((lin&256)>>4));
	outp(0x3d4,0x9); outp(0x3d5,(inp(0x3d5)&191)|((lin&512)>>3));
	num = 0;
	outp(0x3d4,0xc); outp(0x3d5,num>>10);
	outp(0x3d4,0xd); outp(0x3d5,(num>>2)&255);
	outp(0x3c0,inp(0x3c0)|0x13); outp(0x3c0,(num&3)<<1);

	outp(0x3c7,0);
	for(i=0;i<768;i++)
		palette2[i] = inp(0x3c9);
	ch = 0;

	oxdim = xdim;
	oydim = ydim;
	if (oxdim > 320) oxdim = 320;
	if (oydim > 200) oydim = 200;
	x = 160-(oxdim>>1);
	y = 100-(oydim>>1);

	copytovideo(), drawopenbox(x,y,x+oxdim-1,y+oydim-1,31);
	while ((ch != 13) && (ch != ' ') && (ch != 27))
	{
		if (kbhit() != 0)
		{
			ch = getch();
			if ((ch == 'p') || (ch == 'P'))
			{
				panxdim = 320;
				printext256(0L,0L,15,-1,"Make this the new build palette?");
				panxdim = 1024;
				do
				{
					ch = getch();
				}
				while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
				if ((ch == 'y') || (ch == 'Y'))
				{
					for(i=0;i<768;i++)          //Swap palette and palette2
					{
						j = palette[i];
						palette[i] = palette2[i];
						palette2[i] = j;
					}
					getpaletteconversion();

					getpalookup();
					if ((fil = open("palette.dat",O_BINARY|O_CREAT|O_WRONLY,S_IWRITE)) != -1)
					{
						write(fil,&palette[0],768);
						write(fil,&palookup[0][0],NUMPALOOKUPS*256);
						gettextcolors();
						close(fil);
					}

					for(i=0;i<MAXTILES;i++)
					{
						if ((tilesizx[i] > 0) && (tilesizy[i] > 0))
						{
							loadwall(buf,i);
							k = tilesizx[i]*tilesizy[i];
							ptr = (char *)waloff[i];
							for(j=0;j<k;j++)
							{
								ch = *ptr;
								*ptr = palookupe[ch];
								ptr++;
							}
							savewall(buf,i);
						}
					}
					for(i=0;i<768;i++)
						palette2[i] = palette[i];
				}
				ch = 'p';
				copytovideo(), drawopenbox(x,y,x+oxdim-1,y+oydim-1,31);
			}
			if (ch == 0)
			{
				ch = getch();
				if (bstatus == 0)
				{
					if ((ch == 75) && (x > 0)) x--;
					if ((ch == 77) && (x < 320-oxdim)) x++;
					if ((ch == 72) && (y > 0)) y--;
					if ((ch == 80) && (y < 200-oydim)) y++;
				}
				else
				{
					if (ch == 75) oxdim--;
					if (ch == 77) oxdim++;
					if (ch == 72) oydim--;
					if (ch == 80) oydim++;
					if (oxdim < 1) oxdim = 1;
					if (oydim < 1) oydim = 1;
					if (oxdim+x-1 < 0) oxdim = 1-x;
					if (oxdim+x-1 >= 320) oxdim = 320-x;
					if (oydim+y-1 < 0) oydim = 1-y;
					if (oydim+y-1 >= 200) oydim = 200-y;
				}
				copytovideo(), drawopenbox(x,y,x+oxdim-1,y+oydim-1,31);
			}
		}
		if (moustat == 1)
		{
			readmouse();
			if ((mousx != 0) || (mousy != 0))
			{
				if (bstatus > 0)
				{
					oxdim += mousx;
					oydim += mousy;
					if (oxdim < 1) oxdim = 1;
					if (oydim < 1) oydim = 1;
					if (oxdim+x-1 < 0) oxdim = 1-x;
					if (oxdim+x-1 >= 320) oxdim = 320-x;
					if (oydim+y-1 < 0) oydim = 1-y;
					if (oydim+y-1 >= 200) oydim = 200-y;
				}
				else
				{
					x += mousx;
					y += mousy;
					if (x < 0) x = 0;
					if (x >= 320-oxdim) x = 320-oxdim;
					if (y < 0) y = 0;
					if (y >= 200-oydim) y = 200-oydim;
				}
				copytovideo(), drawopenbox(x,y,x+oxdim-1,y+oydim-1,31);
			}
		}
	}
	if ((ch == 13) || (ch == ' '))
	{
		x2 = xdim;
		y2 = ydim;
		if (x2 > 320) x2 = 320;
		if (y2 > 200) y2 = 200;
		if ((oxdim != x2) || (oydim != y2))
		{
			xdim = oxdim;
			ydim = oydim;
			c = (xdim>>1);
			d = (ydim>>1);
		}

		copytovideo();
		getpaletteconversion();
		if (ch == ' ')
			for(i=0;i<256;i++)
				palookupe[i] = i;
		asksave = 1;
		vidpos = y*320+x;
		x2 = 0;
		y2 = 0;
		if (xdim > 320) x2 = panx;
		if (ydim > 184) y2 = pany;
		for(j=0;j<oydim;j++)
		{
			xstep = x;
			vidpos = (y+j)*320+x;
			for(i=0;i<oxdim;i++)
			{
				outp(0x3ce,4); outp(0x3cf,xstep&3);
				buf[i+x2][j+y2] = palookupe[getpixel((vidpos>>2)+0xa0000)];
				vidpos++;
				xstep++;
			}
		}
		drawmainscreen();
		return(1);
	}
	drawmainscreen();
	return(0);
}

gettextcolors()
{
	long i, whitedist, browndist, yellowdist, pinkdist, blackdist, dist;
	char whiteval[3], brownval[3], yellowval[3], pinkval[3], blackval[3];

	whiteval[0] = 48, whiteval[1] = 48, whiteval[2] = 48;
	brownval[0] = 32, brownval[1] = 16, brownval[2] = 12;
	yellowval[0] = 48, yellowval[1] = 48, yellowval[2] = 50;
	pinkval[0] = 63, pinkval[1] = 32, pinkval[2] = 63;
	blackval[0] = 0, blackval[1] = 0, blackval[2] = 0;

	whitedist = 0x7fffffff; whitetext = 0;
	browndist = 0x7fffffff; browntext = 0;
	yellowdist = 0x7fffffff; yellowtext = 0;
	pinkdist = 0x7fffffff; pinktext = 0;
	blackdist = 0x7fffffff; blacktext = 0;
	for(i=0;i<256;i++)
	{
		dist = (whiteval[0]-palette[i+i+i+0])*(whiteval[0]-palette[i+i+i+0]);
		dist += (whiteval[1]-palette[i+i+i+1])*(whiteval[1]-palette[i+i+i+1]);
		dist += (whiteval[2]-palette[i+i+i+2])*(whiteval[2]-palette[i+i+i+2]);
		if (dist < whitedist)
		{
			whitedist = dist;
			whitetext = i;
		}
		dist = (brownval[0]-palette[i+i+i+0])*(brownval[0]-palette[i+i+i+0]);
		dist += (brownval[1]-palette[i+i+i+1])*(brownval[1]-palette[i+i+i+1]);
		dist += (brownval[2]-palette[i+i+i+2])*(brownval[2]-palette[i+i+i+2]);
		if (dist < browndist)
		{
			browndist = dist;
			browntext = i;
		}
		dist = (yellowval[0]-palette[i+i+i+0])*(yellowval[0]-palette[i+i+i+0]);
		dist += (yellowval[1]-palette[i+i+i+1])*(yellowval[1]-palette[i+i+i+1]);
		dist += (yellowval[2]-palette[i+i+i+2])*(yellowval[2]-palette[i+i+i+2]);
		if (dist < yellowdist)
		{
			yellowdist = dist;
			yellowtext = i;
		}
		dist = (pinkval[0]-palette[i+i+i+0])*(pinkval[0]-palette[i+i+i+0]);
		dist += (pinkval[1]-palette[i+i+i+1])*(pinkval[1]-palette[i+i+i+1]);
		dist += (pinkval[2]-palette[i+i+i+2])*(pinkval[2]-palette[i+i+i+2]);
		if (dist < pinkdist)
		{
			pinkdist = dist;
			pinktext = i;
		}
		dist = (blackval[0]-palette[i+i+i+0])*(blackval[0]-palette[i+i+i+0]);
		dist += (blackval[1]-palette[i+i+i+1])*(blackval[1]-palette[i+i+i+1]);
		dist += (blackval[2]-palette[i+i+i+2])*(blackval[2]-palette[i+i+i+2]);
		if (dist < blackdist)
		{
			blackdist = dist;
			blacktext = i;
		}
	}
}
