// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#define ENGINE
#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#include "build.h"
#include "names.h"

#define NUMTIMECOUNTS 8
#define COMBUFSIZ 32768
#define MAXCLIPNUM 512
#define MAXSNDLEN 16384
#define MAXTILEFILES 256
#define ADPCMMIN -4
#define ADPCMMAX 3

static char timenames[NUMTIMECOUNTS][20] =
{
	"Main program       ",
	"Wall calculations  ",
	"Scansector         ",
	"Vline calculations ",
	"Hscanning          ",
	"Vline drawing      ",
	"Hline drawing      ",
	"Screen copying     ",
};

static unsigned char tempbuf[MAXWALLS];

char picsiz[MAXTILES];
long artversion, mapversion;
static char *pic[MAXTILEFILES];

static short radarang[320];
static long tantable[1024];
char textfont[128][8];

static long xb1[MAXWALLS], yb1[MAXWALLS], xb2[MAXWALLS], yb2[MAXWALLS];
static short p2[MAXWALLS];
static short thesector[MAXWALLS], thewall[MAXWALLS];
static long llinum[MAXWALLS], rlinum[MAXWALLS];

static short bunchfirst[MAXWALLS], bunchlast[MAXWALLS];

static short maskwall[MAXWALLS], maskwallcnt;

static short edgex[XDIM+2], edgesect[XDIM+2], edgecnt;

static unsigned char splc[XDIM][32], scnt[XDIM];
static long sdist[XDIM][32];

static short umost[XDIM], dmost[XDIM];
static long uplc[XDIM], dplc[XDIM];
static long uwall[XDIM], dwall[XDIM], swall[XDIM], lwall[XDIM];

static short sectorborder[256], sectorbordercnt;
static char got[MAXSECTORS], screen[65536], tablesloaded = 0;
long frameplace;
static long lastx[YDIM+2];
char palette[768], paletteloaded;
char palookup[NUMPALOOKUPS][256];

static short clipnum, hitwalls[4], cliplist[MAXCLIPNUM];
static long clipx1[MAXCLIPNUM], clipy1[MAXCLIPNUM];
static long clipx2[MAXCLIPNUM], clipy2[MAXCLIPNUM];
static short clipsectorlist[MAXCLIPNUM], clipsectnum;

short numscans, numhits, numbunches;
static short posfil, capturecount, hitcnt;
static long poscapture = 0L;

short editstatus;
short searchit;
long searchx, searchy;                          //search input
short searchsector, searchwall, searchstat;     //search output

short page;

short neartagsector, neartagwall, neartagsprite;
long *animateptr[MAXANIMATES], animategoal[MAXANIMATES];
long animatevel[MAXANIMATES], animatecnt;

short tilesizx[MAXTILES], tilesizy[MAXTILES];
long numtiles, picanm[MAXTILES], waloff[MAXTILES];
static char artfilename[20];
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles;

volatile long timetakercount[NUMTIMECOUNTS], takernum;
volatile unsigned char readch, oldreadch, extended;

static char sndspeed, sndvolumetable[256], *sndptr, sndlastfil[13];
static unsigned short sndselector, sndseg = -1, sndportaddr;
static long sndoffs, sndrightaddr, sndwrongaddr, sndleng;

long asm1, asm2, asm3, asm4;
unsigned char globalyrepeat, globalorientation, globalpanning;
signed char globalshade;
short globalpicnum, globalshiftval;
long globalzd, globalbufplc;

static long note[8192], chanage[18], musicstatus, adlibcount, countstop;
static short nownote, numnotes, numchans, firstime = 1, drumstat;
static char inst[256][11], databuf[2048], chanfreq[18], chantrack[18];
static char trinst[16], trquant[16], trchan[16], trprio[16], trvol[16];
static char adlibchanoffs[9] = {0,1,2,8,9,10,16,17,18};
static short adlibfreq[63] =
{
	0,
	2390,2411,2434,2456,2480,2506,2533,2562,2592,2625,2659,2695,
	3414,3435,3458,3480,3504,3530,3557,3586,3616,3649,3683,3719,
	4438,4459,4482,4504,4528,4554,4581,4610,4640,4673,4707,4743,
	5462,5483,5506,5528,5552,5578,5605,5634,5664,5697,5731,5767,
	6486,6507,6530,6552,6576,6602,6629,6658,6688,6721,6755,6791,
	7510
};
static short musici, musicj, musicquanter, musicbufnum, musicchan;
static short musicdrumnum, musicfreq, musictrack, musicvolevel, musicvolval;
static long musictemp, musictemplong;

volatile long comnum, comport, comvect, comspeed;
volatile char inbuf[COMBUFSIZ], outbuf[COMBUFSIZ], mstat, lstat;
volatile long inbufplc, inbufend, outbufplc, outbufend;
static void (interrupt far *oldcomhandler)(void);
static void interrupt far comhandler(void);

static unsigned char sndorig[MAXSNDLEN], sndcomp[MAXSNDLEN];
static long sndbytelen, sndbitlen;
static unsigned char astart0, astart1, astart2;
static unsigned char hufflen[8] = {5,5,4,3,1,3,4,4};
static unsigned char huffval[8] = {0xf,0x1f,3,1,0,5,0xb,7};

void (__interrupt __far *oldtimerhandler)();
void __interrupt __far timerhandler(void);
static void (__interrupt __far *oldkeyhandler)();
static void __interrupt __far keyhandler(void);
static void (__interrupt __far *oldzerohandler)();
static void __interrupt __far zerohandler(void);

extern long sethlinesizes(long,long);
#pragma aux sethlinesizes parm [eax][ebx];
extern long hlineasm64(long,long,long,long,long,long);
#pragma aux hlineasm64 parm [eax][ebx][ecx][edx][esi][edi];
extern long hchainasm64(long,long,long,long,long,long);
#pragma aux hchainasm64 parm [eax][ebx][ecx][edx][esi][edi];
extern long fixvlinesforchain();
extern long vlineasm1(long,long,long,long,long,long);
#pragma aux vlineasm1 parm [eax][ebx][ecx][edx][esi][edi];
extern long mvlineasm1(long,long,long,long,long,long);
#pragma aux mvlineasm1 parm [eax][ebx][ecx][edx][esi][edi];
extern long vlineasm4(long,long,long,long,long,long);
#pragma aux vlineasm4 parm [eax][ebx][ecx][edx][esi][edi];

#pragma aux scale =\
	"imul ebx",\
	"idiv ecx",\
	parm [eax][ebx][ecx]\
	modify [eax edx]\

#pragma aux mulscale =\
	"imul ebx",\
	"shrd eax, edx, cl",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux divscale =\
	"cdq",\
	"shld edx, eax, cl",\
	"sal eax, cl",\
	"idiv ebx",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux int5 =\
	"int 0x5",\

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux setupmouse =\
	"mov ax, 0",\
	"int 33h",\
	"mov moustat,1",\
	modify [eax]\

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov bx, bstatus",\
	"mov obstatus, bx",\
	"mov bstatus, ax",\
	modify [eax ecx edx]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi]",\
	parm [edi]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov word ptr [edi], ax",\
	parm [edi][eax]\

#pragma aux drawpixeles =\
	"mov dword ptr [edi], eax",\
	parm [edi][eax]\

#pragma aux copytovideo =\
	"cld",\
	"mov esi, frameplace",\
	"mov edi, 0xa0000",\
	"mov ecx, 16000",\
	"rep movsd",\
	modify [esi edi ecx]\

#pragma aux videomove =\
	"cld",\
	"mov esi, 0xa0000",\
	"mov edi, 0xa0000",\
	"mov ecx, 16000",\
	"rep movsd",\
	modify [esi edi ecx]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\
	modify [eax]\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\
	modify [eax]\

#pragma aux clearbuf =\
	"rep stosd",\
	parm [edi][ecx][eax]\

#pragma aux copybuf =\
	"rep movsd",\
	parm [esi][edi][ecx]\

#pragma aux memcopybyte =\
	"mov al, byte ptr [ecx]",\
	"add al, dl",\
	"mov byte ptr [ebx], al",\
	parm [ebx][ecx][edx]\

#pragma aux readrow =\
	"mov ecx, 80d",\
	"add edi, offset tempbuf",\
	"rep movsd",\
	parm [esi][edi]\
	modify [ecx edi]\

#pragma aux drawrow =\
	"cld",\
	"mov ecx, 80d",\
	"mov esi, offset tempbuf",\
	"rep movsd",\
	parm [edi]\
	modify [edi esi ecx]\

#pragma aux convallocate =\
	"mov ax, 0x100",\
	"int 0x31",\
	"jnc skiperror",\
	"mov ax, -1",\
	"skiperror:",\
	"mov sndselector, dx",\
	parm [bx]\

#pragma aux convdeallocate =\
	"mov ax, 0x101",\
	"mov dx, sndselector",\
	"int 0x31",\
	parm [dx]\

#pragma aux resetsb =\
	"mov al, 1",\
	"mov dx, sndportaddr",\
	"add dx, 0x6",\
	"out dx, al",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"xor al, al",\
	"out dx, al",\
	"add dx, 4",\
	"mov cx, 100",\
	"resetsb1: in al, dx",\
	"cmp al, 0xaa",\
	"je resetsb2",\
	"loop resetsb1",\
	"mov ax, 1",\
	"jmp resetsb3",\
	"resetsb2: xor ax, ax",\
	"resetsb3:",\
	modify [eax ecx edx]\

#pragma aux sbwait =\
	"mov dx, sndportaddr",\
	"add dx, 0xc",\
	"sbwait1: in al, dx",\
	"test al, 0x80",\
	"jnz sbwait1",\
	modify [eax edx]\

#pragma aux sndvolumeadjust =\
	"xor eax, eax",\
	"begadjustvolume: lodsb",\
	"mov al, byte ptr [edx+eax]",\
	"stosb",\
	"loop begadjustvolume",\
	parm [ecx][edx][esi][edi]\
	modify [eax]\

#pragma aux portwait =\
	"beginwait: in al, dx",\
	"xor al, cl",\
	"test al, bl",\
	"jz beginwait",\
	parm [edx][ebx][ecx]\

#pragma aux huffputbits =\
	"xor edx, edx",\
	"mov dl, byte ptr huffval[eax]",\
	"mov ecx, sndbitlen",\
	"and ecx, 7",\
	"shl edx, cl",\
	"mov ecx, sndbitlen",\
	"shr ecx, 3",\
	"or dword ptr sndcomp[ecx], edx",\
	"xor ebx, ebx",\
	"mov bl, byte ptr hufflen[eax]",\
	"add dword ptr sndbitlen, ebx",\
	parm [eax]\
	modify [ebx ecx edx]\

#pragma aux qinterpolate =\
	"inc ecx",\
	"mov ebx, ecx",\
	"shr ecx, 1",\
	"jecxz skipbegcalc",\
	"begqcalc: mov dword ptr [eax], edx",\
	"add edx, esi",\
	"mov dword ptr [eax+4], edx",\
	"add edx, esi",\
	"add eax, 8",\
	"loop begqcalc",\
	"test ebx, 1",\
	"jz skipbegqcalc2",\
	"skipbegcalc: mov dword ptr [eax], edx",\
	"skipbegqcalc2:",\
	parm [eax][ecx][edx][esi]\
	modify [ebx]\

#pragma aux outdata =\
	"mov dx, 0x388",\
	"add dl, al",\
	"add dl, al",\
	"mov al, bl",\
	"out dx, al",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"in al, dx",\
	"inc dx",\
	"mov al, cl",\
	"out dx, al",\
	"mov ecx, 33",\
	"outdatawait: in al, dx",\
	"loop outdatawait",\
	parm [eax][ebx][ecx]\
	modify [eax ebx ecx edx]\

#pragma aux groudat =\
	"shl eax, 6",\
	"or eax, ebx",\
	"mov al, byte ptr [eax+ecx]",\
	"and eax, 0x000000ff",\
	parm [eax][ebx][ecx]\

#pragma aux drawslab =\
	"startdraw: mov [edi], al",\
	"sub edi, ebx",\
	"loop startdraw",\
	"mov eax, edi",\
	parm [edi][ecx][eax][ebx]\

void __interrupt __far timerhandler()
{
	if (keystatus[0x9d] == 0)                   //KEYBOARD STUFF
	{
		if (keystatus[0xcb] > 0)
		{
			angvel -= 32;
			if (angvel < -256) angvel = -256;
		}
		if (keystatus[0xcd] > 0)
		{
			angvel += 32;
			if (angvel > 256) angvel = 256;
		}
	}
	else
	{
		if (keystatus[0xcb] > 0)
		{
			svel += 16;
			if (svel > 256) svel = 256;
		}
		if (keystatus[0xcd] > 0)
		{
			svel -= 16;
			if (svel < -256) svel = -256;
		}
	}
	if (keystatus[0xc8] > 0)
	{
		vel += 16;
		if (vel > 256) vel = 256;
	}
	if (keystatus[0xd0] > 0)
	{
		vel -= 16;
		if (vel < -256) vel = -256;
	}

	if (angvel < 0)
	{
		angvel += 24;
		if (angvel > 0) angvel = 0;
	}
	if (angvel > 0)
	{
		angvel -= 24;
		if (angvel < 0) angvel = 0;
	}
	if (svel < 0)
	{
		svel += 4;
		if (svel > 0) svel = 0;
	}
	if (svel > 0)
	{
		svel -= 4;
		if (svel < 0) svel = 0;
	}
	if (vel < 0)
	{
		vel += 4;
		if (vel > 0) vel = 0;
	}
	if (vel > 0)
	{
		vel -= 4;
		if (vel < 0) vel = 0;
	}

	clockspeed++;
	totalclock++;
	timetakercount[takernum]++;

	if (musicstatus > 0)                               //MUSIC STUFF
	{
		adlibcount+=2;
		if (adlibcount >= countstop)
		{
			musicbufnum = 0;
			while (adlibcount >= countstop)
			{
				musictemplong = note[nownote];
				musictrack = (int)((musictemplong>>8)&15);
				if ((musictemplong&192) == 0)
				{
					musici = 0;
					while (((chanfreq[musici] != (musictemplong&63)) || (chantrack[musici] != ((musictemplong>>8)&15))) && (musici < numchans))
						musici++;
					if (musici < numchans)
					{
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xb0+musici); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)((adlibfreq[musictemplong&63]>>8)&223); musicbufnum++;
						chanfreq[musici] = 0;
						chanage[musici] = 0;
					}
				}
				else
				{
					musicvolevel = trvol[musictrack];
					if ((musictemplong&192) == 128)
					{
						musicvolevel -= 4;
						if (musicvolevel < 0)
							musicvolevel = 0;
					}
					if ((musictemplong&192) == 192)
					{
						musicvolevel += 4;
						if (musicvolevel > 63)
							musicvolevel = 63;
					}
					if (musictrack < 11)
					{
						musictemp = 0;
						musici = numchans;
						for(musicj=0;musicj<numchans;musicj++)
							if ((countstop - chanage[musicj] >= musictemp) && (chantrack[musicj] == musictrack))
							{
								musictemp = countstop - chanage[musicj];
								musici = musicj;
							}
						if (musici < numchans)
						{
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0xb0+musici); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)0; musicbufnum++;
							musicvolval = (inst[trinst[musictrack]][1]&192)+(musicvolevel^63);
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0x40+adlibchanoffs[musici]+3); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)musicvolval; musicbufnum++;
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0xa0+musici); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(adlibfreq[musictemplong&63]&255); musicbufnum++;
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0xb0+musici); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)((adlibfreq[musictemplong&63]>>8)|32); musicbufnum++;
							chanfreq[musici] = musictemplong&63;
							chanage[musici] = countstop;
						}
					}
					else if ((drumstat&32) > 0)
					{
						musicfreq = adlibfreq[musictemplong&63];
						switch(musictrack)
						{
							case 11: musicdrumnum = 16; musicchan = 6; musicfreq -= 2048; break;
							case 12: musicdrumnum = 8; musicchan = 7; musicfreq -= 2048; break;
							case 13: musicdrumnum = 4; musicchan = 8; break;
							case 14: musicdrumnum = 2; musicchan = 8; break;
							case 15: musicdrumnum = 1; musicchan = 7; musicfreq -= 2048; break;
						}
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xa0+musicchan); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(musicfreq&255); musicbufnum++;
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xb0+musicchan); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)((musicfreq>>8)&223); musicbufnum++;
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xbd); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(drumstat&(255-musicdrumnum)); musicbufnum++;
						drumstat |= musicdrumnum;
						if ((musictrack == 11) || (musictrack == 12) || (musictrack == 14))
						{
							musicvolval = (inst[trinst[musictrack]][1]&192)+(musicvolevel^63);
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0x40+adlibchanoffs[musicchan]+3); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(musicvolval); musicbufnum++;
						}
						else
						{
							musicvolval = (inst[trinst[musictrack]][6]&192)+(musicvolevel^63);
							databuf[musicbufnum] = (char)0, musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(0x40+adlibchanoffs[musicchan]); musicbufnum++;
							databuf[musicbufnum] = (unsigned char)(musicvolval); musicbufnum++;
						}
						databuf[musicbufnum] = (char)0, musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(0xbd); musicbufnum++;
						databuf[musicbufnum] = (unsigned char)(drumstat); musicbufnum++;
					}
				}
				nownote++;
				if (nownote >= numnotes)
					nownote = 0;
				musictemplong = note[nownote];
				if (nownote == 0)
					adlibcount = (musictemplong>>12)-1;
				musicquanter = (240/trquant[(musictemplong>>8)&15]);
				countstop = (((musictemplong>>12)+(musicquanter>>1)) / musicquanter) * musicquanter;
			}
			for(musici=0;musici<musicbufnum;musici+=3)
				outdata((long)databuf[musici],(long)databuf[musici+1],(long)databuf[musici+2]);
		}
	}

	interruptend();
}

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	interruptend();
}

drawrooms()
{
	short tempshort, closest, wallnum, sectnum;
	long i, j, k, m, n, xs, ys, gap, temp, templong, animval;

	takernum = 1;
	clearbuf((long)(&got[0]),(long)((numsectors+3)>>2),0L);
	copybuf((long)(&startumost[0]),(long)(&umost[0]),XDIM>>1);
	copybuf((long)(&startdmost[0]),(long)(&dmost[0]),XDIM>>1);
	clearbuf((long)(&swall[0]),(long)XDIM,0x7fffffff);
	clearbuf((long)(&scnt[0]),(long)(XDIM>>2),0L);

	edgex[0] = 0, edgesect[0] = -1, edgex[1] = 320, edgecnt = 2;

	getsector();

	numhits = XDIM;
	numscans = 0;
	numbunches = 0;
	maskwallcnt = 0;
	neartagsector = -1;
	neartagwall = -1;
	neartagsprite = -1;
	takernum = 2, scansector(cursectnum), takernum = 1;

	while ((numbunches > 0) && (numhits > 0))
	{
		clearbuf((long)(&tempbuf[0]),(long)((numbunches+3)>>2),0L);
		tempbuf[0] = 1;

		closest = 0;
		for(i=0;i<numbunches;i++)
			if (tempbuf[i] == 0)
			{
				j = bunchfront((short)i,closest);
				if (j >= 0) tempbuf[i] = 1;
				if (j == i) closest = i, i = 0;
			}

		//closest = 0;              //Almost works, but not quite :(
		//for(i=1;i<numbunches;i++)
		//   if (bunchfront(i,closest) == i)
		//      closest = i;

		calcwalls(closest);

		sectnum = thesector[bunchfirst[closest]];
		if ((sector[sectnum].ceilingstat&3) == 0)
			ceilscan(xb1[bunchfirst[closest]],xb2[bunchlast[closest]],sectnum);
		if ((sector[sectnum].floorstat&3) == 0)
			florscan(xb1[bunchfirst[closest]],xb2[bunchlast[closest]],sectnum);

		drawalls(closest);

		numbunches--;
		bunchfirst[closest] = bunchfirst[numbunches];
		bunchlast[closest] = bunchlast[numbunches];

		/*sectnum = thesector[closest];
		wallnum = thewall[closest];
		if (wall[wallnum].nextwall1 == -1)
			mergewall((short)xb1[closest], (short)xb2[closest], sectnum, 16384);
		else
			mergewall((short)xb1[closest], (short)xb2[closest], sectnum, 0);*/

	}

	takernum = 0;

	spritesortcnt = 0;     //Make sprite list from sectors that were drawn
	for(i=0;i<numsectors;i++)
		if (got[i] != 0)
		{
			j = headspritesect[i];
			while (j != -1)
			{
				xs = sprite[j].x - posx;
				ys = sprite[j].y - posy;
				spritey[spritesortcnt] = ((xs*sintable[(ang+512)&2047]+ys*sintable[(ang+0)&2047])>>14);
				if (spritey[spritesortcnt] > 4)
				{
					spritex[spritesortcnt] = ((ys*sintable[(ang+512)&2047]-xs*sintable[(ang+0)&2047])>>14);
					thesprite[spritesortcnt] = j;
					spritesortcnt++;
				}
				j = nextspritesect[j];
			}
		}

	gap = (spritesortcnt>>1);  //Sort sprite list
	do
	{
		for(i=0;i<spritesortcnt-gap;i++)
		{
			temp = i;
			while ((spritey[temp] > spritey[temp+gap]) && (temp >= 0))
			{
				templong = spritex[temp]; spritex[temp] = spritex[temp+gap]; spritex[temp+gap] = templong;
				templong = spritey[temp]; spritey[temp] = spritey[temp+gap]; spritey[temp+gap] = templong;
				tempshort = thesprite[temp]; thesprite[temp] = thesprite[temp+gap]; thesprite[temp+gap] = tempshort;
				temp -= gap;
			}
		}
		gap >>= 1;
	}
	while (gap > 0);


	for(i=animatecnt-1;i>=0;i--)
	{
		animval = *animateptr[i];
		if (animval < animategoal[i])
		{
			animval += (lockspeed*animatevel[i]);
			if (animval > animategoal[i])
				animval = animategoal[i];
		}
		if (animval > animategoal[i])
		{
			animval -= (lockspeed*animatevel[i]);
			if (animval < animategoal[i])
				animval = animategoal[i];
		}
		*animateptr[i] = animval;
		if (animval == animategoal[i])
		{
			animatecnt--;
			animateptr[i] = animateptr[animatecnt];
			animategoal[i] = animategoal[animatecnt];
			animatevel[i] = animatevel[animatecnt];
		}
	}

	return(0);
}

scansector (short sectnum)
{
	short z, startwall, endwall;
	short numscansbefore, scanfirst, bunchfrst, zx, ozx;

	if (sectnum == -1) return(0);

	sectorborder[0] = sectnum, sectorbordercnt = 1;

	while (sectorbordercnt > 0)
	{
		sectnum = sectorborder[--sectorbordercnt];

		got[sectnum] = 1;
		startwall = sector[sectnum].wallptr;
		endwall = startwall + sector[sectnum].wallnum - 1;

		numscansbefore = numscans;
		scanfirst = numscans;
		for(z=startwall;z<=endwall;z++)
		{
			if (addboxlinum(sectnum, z) == 1)
				p2[numscans-1] = numscans;
			if (wall[z].point2 < z)
			{
				if (scanfirst < numscans)
					p2[numscans-1] = scanfirst;
				scanfirst = numscans;
			}
		}

		bunchfrst = numbunches;
		for(z=numscansbefore;z<numscans;z++)
			if ((wall[thewall[z]].point2 != thewall[p2[z]]) || (xb2[z] >= xb1[p2[z]]))
				bunchfirst[numbunches++] = p2[z], p2[z] = -1;
		for(z=bunchfrst;z<numbunches;z++)
		{
			zx = bunchfirst[z];
			while (p2[zx] != -1)
				zx = p2[zx];
			bunchlast[z] = zx;
		}
	}

	return(0);
}

wallfront (short l1, short l2)
{
	long x1l1, y1l1, x2l1, y2l1, x1l2, y1l2, x2l2, y2l2;
	long templong0, templong1, templong2, templong3, templong4;

	x1l1 = wall[thewall[l1]].x;
	y1l1 = wall[thewall[l1]].y;
	x2l1 = wall[wall[thewall[l1]].point2].x;
	y2l1 = wall[wall[thewall[l1]].point2].y;
	x1l2 = wall[thewall[l2]].x;
	y1l2 = wall[thewall[l2]].y;
	x2l2 = wall[wall[thewall[l2]].point2].x;
	y2l2 = wall[wall[thewall[l2]].point2].y;

	templong1 = (x1l2-x1l1)*(y2l1-y1l1) - (x2l1-x1l1)*(y1l2-y1l1); //p1(l2) vs. l1
	templong2 = (x2l2-x1l1)*(y2l1-y1l1) - (x2l1-x1l1)*(y2l2-y1l1); //p2(l2) vs. l1
	if ((templong1|templong2) == 0) return(-1);
	if (templong1 == 0) templong1 = templong2;
	if (templong2 == 0) templong2 = templong1;
	if ((templong1 < 0) == (templong2 < 0))
	{
		templong0 = (posx-x1l1)*(y2l1-y1l1) - (x2l1-x1l1)*(posy-y1l1);  //pos vs. l1
		if ((templong1<0) == (templong0<0))
			return(l2);
		else
			return(l1);
	}

	templong1 = (x1l1-x1l2)*(y2l2-y1l2) - (x2l2-x1l2)*(y1l1-y1l2); //p1(l1) vs. l2
	templong2 = (x2l1-x1l2)*(y2l2-y1l2) - (x2l2-x1l2)*(y2l1-y1l2); //p2(l1) vs. l2
	if ((templong1|templong2) == 0) return(-1);
	if (templong1 == 0) templong1 = templong2;
	if (templong2 == 0) templong2 = templong1;
	if ((templong1 < 0) == (templong2 < 0))
	{
		templong0 = (posx-x1l2)*(y2l2-y1l2) - (x2l2-x1l2)*(posy-y1l2);  //pos vs. l2
		if ((templong1<0) == (templong0<0))
			return(l1);
		else
			return(l2);
	}
	return(-2);
}

bunchfront (short b1, short b2)
{
	long x1b1, x2b1, x1b2, x2b2, y1, y2, they;
	short z;

	x1b1 = xb1[bunchfirst[b1]];
	x2b1 = xb2[bunchlast[b1]]+1;
	x1b2 = xb1[bunchfirst[b2]];
	x2b2 = xb2[bunchlast[b2]]+1;
	if ((x1b1 >= x2b2) || (x1b2 >= x2b1))
		return(-1);

	if ((x1b1 >= x1b2) && (x1b1 <= x2b2))
	{
		z = bunchfirst[b2];
		while (xb2[z] < x1b1)
			z = p2[z];

		if (wallfront(z,bunchfirst[b1]) == z)
			return(b2);
		else
			return(b1);

		/*if ((yb1[z] != 0) && (yb2[z] != 0) && (yb1[bunchfirst[b1]] != 0))
		{
			y1 = (2097152*64)/yb1[z];
			y2 = (2097152*64)/yb2[z];
			if (y1 > 16777216) y1 = 16777216;
			if (y2 > 16777216) y2 = 16777216;
			they = y1 + ((x1b1-xb1[z])*(y2-y1))/(xb2[z]-xb1[z]+1);

			if (they > ((2097152*64)/yb1[bunchfirst[b1]]))
				return(b2);
			else
				return(b1);
		}*/
	}
	else if ((x1b2 >= x1b1) && (x1b2 <= x2b1))
	{
		z = bunchfirst[b1];
		while (xb2[z] < x1b2)
			z = p2[z];

		if (wallfront(z,bunchfirst[b2]) == z)
			return(b1);
		else
			return(b2);

		/*if ((yb1[z] != 0) && (yb2[z] != 0) && (yb1[bunchfirst[b2]] != 0))
		{
			y1 = (2097152*64)/yb1[z];
			y2 = (2097152*64)/yb2[z];
			if (y1 > 16777216) y1 = 16777216;
			if (y2 > 16777216) y2 = 16777216;
			they = y1 + ((x1b2-xb1[z])*(y2-y1))/(xb2[z]-xb1[z]+1);

			if (they > ((2097152*64)/yb1[bunchfirst[b2]]))
				return(b1);
			else
				return(b2);
		}*/
	}

	return(-1);
}

calcwalls (short bunch)
{
	char cstat1, cstat2, calclinums, theshade;
	short z, wallnum, sectnum, nextsectnum, thepicnum;
	long i, j, top, topinc, bot, botinc, x, y, templong, z1, z2, y1, y2;
	long hplc, hinc, uuplc, uuinc, ddplc, ddinc, daplc, llin, rlin;

	takernum = 1;
	z = bunchfirst[bunch];

	sectnum = thesector[z];
	z1 = sector[sectnum].ceilingz;
	z2 = sector[sectnum].floorz;
	cstat1 = sector[sectnum].ceilingstat;
	cstat2 = sector[sectnum].floorstat;

	do
	{
		wallnum = thewall[z];
		nextsectnum = wall[wallnum].nextsector1;

		calclinums = 0;
		if ((nextsectnum == -1) || (sector[nextsectnum].ceilingz > z1) || (sector[nextsectnum].floorz < z2) || ((wall[wallnum].cstat&32) > 0))
		{
			llin = mulscale(llinum[z],(long)wall[wallnum].xrepeat,7);
			rlin = mulscale(rlinum[z],(long)wall[wallnum].xrepeat,7);
			if ((wall[wallnum].cstat&8) > 0)
			{
				llin = (wall[wallnum].xrepeat<<9)-llin;
				rlin = (wall[wallnum].xrepeat<<9)-rlin;
			}
			top = 0; topinc = mulscale(rlin-llin,yb1[z],8);
			bot = (xb2[z]-xb1[z]+1)*yb2[z]; botinc = yb1[z]-yb2[z];
			calclinums = 1;
		}

		if (z == bunchfirst[bunch])
		{
			y1 = (2097152*64)/yb1[z];
			if (y1 > 16777216) y1 = 16777216;
			y2 = (2097152*64)/yb2[z];
			if (y2 > 16777216) y2 = 16777216;
		}
		else
		{
			y1 = y2;
			y2 = (2097152*64)/yb2[z];
			if (y2 > 16777216) y2 = 16777216;
		}
		hplc = y1;
		uuplc = (YDIM<<15)+mulscale(y1,z1-posz,8);
		ddplc = (YDIM<<15)+mulscale(y1,z2-posz,8);
		hinc = (y2-y1)/(xb2[z]-xb1[z]+1);
		uuinc = mulscale(z1-posz,hinc,8);
		ddinc = mulscale(z2-posz,hinc,8);

		if ((cstat2&2) > 0)  //Groudraw
		{
			daplc = hplc;
			for(x=xb1[z];x<=xb2[z];x++)
			{
				grouvline(x,swall[x],daplc,sectnum);
				daplc += hinc;

				sdist[x][scnt[x]] = -daplc;
				splc[x][scnt[x]] = (unsigned char)dmost[x];
				scnt[x]++;
			}
		}

		if ((cstat1&1) > 0)  //Parallaxing SKY
		{
			if ((nextsectnum == -1) || ((sector[nextsectnum].ceilingstat&1) == 0) || ((wall[wallnum].cstat&32) > 0))
			{
				globalyrepeat = 8;
				globalorientation = 0;
				globalpicnum = sector[sectnum].ceilingpicnum;
				globalshade = sector[sectnum].ceilingshade;
				globalpanning = sector[sectnum].ceilingpanning;
				if ((picanm[globalpicnum]&192) != 0)
					globalpicnum += animateoffs(globalpicnum);
				globalshiftval = (picsiz[globalpicnum]>>4);
				if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
				globalzd = (YDIM<<(31-globalshiftval));

				switch(parallaxtype)
				{
					case 0:
						daplc = uuplc;
						for(j=xb1[z];j<=xb2[z];j++)
						{
							uwall[j] = 0;
							dwall[j] = daplc;
							swall[j] = 65536;
							lwall[j] = (((((((j-(XDIM>>1))<<9)/XDIM)+(ang&2047))>>1)&1023)<<6);
							daplc += uuinc;
						}
						break;
					case 1:
						daplc = uuplc;
						for(j=xb1[z];j<=xb2[z];j++)
						{
							uwall[j] = 0;
							dwall[j] = daplc;
							swall[j] = 65536;
							lwall[j] = ((((radarang[j]+(ang&2047))>>1)&1023)<<6);
							daplc += uuinc;
						}
						break;
					case 2:
						daplc = uuplc;
						for(j=xb1[z];j<=xb2[z];j++)
						{
							uwall[j] = 0;
							dwall[j] = daplc;
							swall[j] = divscale(16384,(long)sintable[(radarang[j]+2560)&2047],16);
							lwall[j] = ((((radarang[j]+(ang&2047))>>1)&1023)<<6);
							daplc += uuinc;
						}
						break;
				}
				wallscan(xb1[z],xb2[z]);
			}
		}

		if (calclinums == 1)
		{
			top >>= 1;
			bot >>= 1;
			for(x=xb1[z];x<=xb2[z];x+=2)
			{
				if (bot != 0) lwall[x] = llin + divscale(top,bot,8);
				top += topinc, bot += botinc;
			}
			for(x=xb1[z]+1;x<xb2[z];x+=2)
				lwall[x] = ((lwall[x-1]+lwall[x+1])>>1);

			lwall[xb2[z]] = rlin;
		}

		qinterpolate((long)(&uplc[xb1[z]]),xb2[z]-xb1[z],uuplc,uuinc);
		qinterpolate((long)(&dplc[xb1[z]]),xb2[z]-xb1[z],ddplc,ddinc);
		qinterpolate((long)(&swall[xb1[z]]),xb2[z]-xb1[z],hplc,hinc);

		if (searchit == 2)
		{
			if ((searchx >= xb1[z]) && (searchx <= xb2[z]))
			{
				if (searchy <= (uplc[searchx]>>16))
				{
					searchsector = sectnum;
					searchwall = wallnum;
					searchstat = 1;  //ceiling
					searchit = 1;
				}
				else if (searchy >= (dplc[searchx]>>16))
				{
					searchsector = sectnum;
					searchwall = wallnum;
					searchstat = 2;  //floor
					searchit = 1;
				}
				else if (nextsectnum == -1)
				{
					searchsector = sectnum;
					searchwall = wallnum;
					searchstat = 0;  //wall
					searchit = 1;
				}
				else
				{
					if (sector[nextsectnum].ceilingz > z1)
					{
						y = (YDIM>>1) + mulscale(swall[searchx],sector[nextsectnum].ceilingz-posz,24);
						if (searchy <= y)
						{
							searchsector = sectnum;
							searchwall = wallnum;
							searchstat = 0;  //wall
							searchit = 1;
						}
					}
					if (sector[nextsectnum].floorz < z2)
					{
						y = (YDIM>>1) + mulscale(swall[searchx],sector[nextsectnum].floorz-posz,24);
						if (searchy >= y)
						{
							searchsector = sectnum;
							searchwall = wallnum;
							if ((wall[wallnum].cstat&2) > 0)
								searchwall = wall[wallnum].nextwall1;
							searchstat = 0;  //wall
							searchit = 1;
						}
					}
				}
			}
		}

		z = p2[z];
	}
	while (z != -1);

}

drawalls(short bunch)
{
	char cstat1, cstat2, theshade, theyrepeat;
	short z, wallnum, sectnum, nextsectnum, tempshort, dontbother, thepicnum;
	long x, y, templong, hplc, hinc, uuplc, uuinc, ddplc, ddinc, daplc;

	z = bunchfirst[bunch];

	sectnum = thesector[z];
	cstat1 = sector[sectnum].ceilingstat;
	cstat2 = sector[sectnum].floorstat;

	do
	{
		wallnum = thewall[z];
		nextsectnum = wall[wallnum].nextsector1;

		if (uplc[xb1[z]] > dplc[xb1[z]])
			goto avoidsectorlinebug;
		if (uplc[xb2[z]] > dplc[xb2[z]])
			goto avoidsectorlinebug;

		if (neartagwall == -1)
		{
			if (wall[wallnum].tag > 0)
				if ((xb1[z] <= (XDIM>>1)) && (xb2[z] >= (XDIM>>1)))
					if (swall[XDIM>>1] >= 131072)
						neartagwall = wallnum;
		}

		if ((nextsectnum == -1) || ((wall[wallnum].cstat&32) > 0))
		{
			globalyrepeat = wall[wallnum].yrepeat;
			globalorientation = wall[wallnum].cstat;
			globalpicnum = wall[wallnum].picnum;
			globalpanning = wall[wallnum].panning;
			if ((picanm[globalpicnum]&192) != 0)
				globalpicnum += animateoffs(globalpicnum);
			globalshade = wall[wallnum].shade;
			globalshiftval = (picsiz[globalpicnum]>>4);
			if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
			if ((globalorientation&4) == 0)
				globalzd = (((posz-sector[sectnum].ceilingz)*globalyrepeat)<<(21-globalshiftval));
			else
				globalzd = (((posz-sector[sectnum].floorz)*globalyrepeat)<<(21-globalshiftval));

			copybuf((long)(&uplc[xb1[z]]),(long)(&uwall[xb1[z]]),xb2[z]-xb1[z]+1);
			copybuf((long)(&dplc[xb1[z]]),(long)(&dwall[xb1[z]]),xb2[z]-xb1[z]+1);

			wallscan(xb1[z],xb2[z]);

			for(x=xb1[z];x<=xb2[z];x++)
				if (umost[x] <= dmost[x])
				{
					umost[x] = YDIM;
					dmost[x] = 0;

					sdist[x][scnt[x]] = swall[x];
					splc[x][scnt[x]] = 255;
					scnt[x]++;

					numhits--;
				}
		}
		else
		{
			if (neartagsector == -1)
			{
				if (sector[nextsectnum].tag > 0)
					if ((xb1[z] <= (XDIM>>1)) && (xb2[z] >= (XDIM>>1)))
						if (swall[XDIM>>1] >= 131072)
							neartagsector = nextsectnum;
			}

			if ((wall[wallnum].cstat&16) > 0)
				maskwall[maskwallcnt++] = z;

			if (((cstat1&1) == 0) || ((sector[nextsectnum].ceilingstat&1) == 0))
			{
				if (sector[nextsectnum].ceilingz <= sector[sectnum].ceilingz)
				{
					dontbother = 0;
					if (sector[nextsectnum].ceilingz == sector[sectnum].ceilingz) dontbother = 1;
					for(x=xb1[z];x<=xb2[z];x++)
						if (umost[x] <= dmost[x])
							if ((uplc[x]>>16) > umost[x])
							{
								umost[x] = (uplc[x]>>16);
								if (umost[x] > YDIM) umost[x] = YDIM;
								if (dontbother == 0)
								{
									sdist[x][scnt[x]] = swall[x];
									splc[x][scnt[x]] = (unsigned char)umost[x];
									scnt[x]++;
								}
								if (umost[x] > dmost[x]) numhits--;
							}
				}
				else
				{
					if (sector[sectnum].floorz < sector[nextsectnum].ceilingz)
						templong = (sector[sectnum].floorz-posz);
					else
						templong = (sector[nextsectnum].ceilingz-posz);
					ddplc = (YDIM<<15)+mulscale(swall[xb1[z]],templong,8);
					if (xb2[z] > xb1[z])
						ddinc = mulscale((swall[xb2[z]]-swall[xb1[z]])/(xb2[z]-xb1[z]),templong,8);

					copybuf((long)(&uplc[xb1[z]]),(long)(&uwall[xb1[z]]),xb2[z]-xb1[z]+1);
					qinterpolate((long)(&dwall[xb1[z]]),xb2[z]-xb1[z],ddplc,ddinc);

					globalyrepeat = wall[wallnum].yrepeat;
					globalorientation = wall[wallnum].cstat;
					globalpicnum = wall[wallnum].picnum;
					globalpanning = wall[wallnum].panning;
					globalshiftval = (picsiz[globalpicnum]>>4);
					if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
					if ((picanm[globalpicnum]&192) != 0)
						globalpicnum += animateoffs(globalpicnum);
					globalshade = wall[wallnum].shade;
					if ((globalorientation&4) == 0)
						globalzd = (((posz-sector[nextsectnum].ceilingz)*globalyrepeat)<<(21-globalshiftval));
					else
						globalzd = (((posz-sector[sectnum].ceilingz)*globalyrepeat)<<(21-globalshiftval));

					wallscan(xb1[z],xb2[z]);

					for(x=xb1[z];x<=xb2[z];x++)
					{
						if (umost[x] <= dmost[x])
						{
							if ((ddplc>>16) > umost[x])
							{
								umost[x] = (ddplc>>16);
								if (umost[x] > YDIM) umost[x] = YDIM;

								sdist[x][scnt[x]] = swall[x];
								splc[x][scnt[x]] = (unsigned char)umost[x];
								scnt[x]++;

								if (umost[x] > dmost[x]) numhits--;
							}
						}
						ddplc += ddinc;
					}
				}
			}
			if (sector[nextsectnum].floorz >= sector[sectnum].floorz)
			{
				dontbother = 0;
				if (sector[nextsectnum].floorz == sector[sectnum].floorz) dontbother = 1;
				for(x=xb1[z];x<=xb2[z];x++)
					if (umost[x] <= dmost[x])
						if ((dplc[x]>>16) < dmost[x])
						{
							dmost[x] = (dplc[x]>>16);
							if (dmost[x] < 0) dmost[x] = 0;
							if (dontbother == 0)
							{
								sdist[x][scnt[x]] = -swall[x];
								splc[x][scnt[x]] = (unsigned char)dmost[x];
								scnt[x]++;
							}
							if (umost[x] > dmost[x]) numhits--;
						}
			}
			else
			{
				if (sector[sectnum].ceilingz > sector[nextsectnum].floorz)
					templong = (sector[sectnum].ceilingz-posz);
				else
					templong = (sector[nextsectnum].floorz-posz);
				uuplc = (YDIM<<15)+mulscale(swall[xb1[z]],templong,8);
				if (xb2[z] > xb1[z])
					uuinc = mulscale((swall[xb2[z]]-swall[xb1[z]])/(xb2[z]-xb1[z]),templong,8);

				qinterpolate((long)(&uwall[xb1[z]]),xb2[z]-xb1[z],uuplc,uuinc);
				copybuf((long)(&dplc[xb1[z]]),(long)(&dwall[xb1[z]]),xb2[z]-xb1[z]+1);

				if ((wall[wallnum].cstat&2) > 0)
				{
					wallnum = wall[wallnum].nextwall1;
					globalyrepeat = wall[wallnum].yrepeat;
					globalorientation = wall[wallnum].cstat;
					globalpicnum = wall[wallnum].picnum;
					globalpanning = wall[wallnum].panning;
					if ((picanm[globalpicnum]&192) != 0)
						globalpicnum += animateoffs(globalpicnum);
					globalshade = wall[wallnum].shade;
					wallnum = thewall[z];
				}
				else
				{
					globalyrepeat = wall[wallnum].yrepeat;
					globalorientation = wall[wallnum].cstat;
					globalpicnum = wall[wallnum].picnum;
					globalpanning = wall[wallnum].panning;
					if ((picanm[globalpicnum]&192) != 0)
						globalpicnum += animateoffs(globalpicnum);
					globalshade = wall[wallnum].shade;
				}
				globalshiftval = (picsiz[globalpicnum]>>4);
				if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
				if ((globalorientation&4) == 0)
					globalzd = (((posz-sector[nextsectnum].floorz)*globalyrepeat)<<(21-globalshiftval));
				else
					globalzd = (((posz-sector[sectnum].ceilingz)*globalyrepeat)<<(21-globalshiftval));

				wallscan(xb1[z],xb2[z]);

				for(x=xb1[z];x<=xb2[z];x++)
				{
					if (umost[x] <= dmost[x])
					{
						if ((uuplc>>16) < dmost[x])
						{
							dmost[x] = (uuplc>>16);
							if (dmost[x] < 0) dmost[x] = 0;

							sdist[x][scnt[x]] = -swall[x];
							splc[x][scnt[x]] = (unsigned char)dmost[x];
							scnt[x]++;

							if (umost[x] > dmost[x]) numhits--;
						}
					}
					uuplc += uuinc;
				}
			}
		}
		if (numhits < 0)
			return(0);

		if ((nextsectnum != -1) && (got[nextsectnum] == 0))
			for(x=xb1[z];x<=xb2[z];x++)
				if (umost[x] < dmost[x])
				{
					takernum = 2, scansector(nextsectnum), takernum = 1;
					break;
				}

avoidsectorlinebug:

		z = p2[z];
	}
	while (z != -1);

	takernum = 1;
	return(0);
}

addboxlinum(short sectore, short walle)
{
	short good;
	long x1, y1, x2, y2, xp1, yp1, xp2, yp2, xc, yc, templong, templong1;

	x1 = wall[walle].x - posx;
	y1 = wall[walle].y - posy;
	x2 = wall[wall[walle].point2].x - posx;
	y2 = wall[wall[walle].point2].y - posy;

	xp1 = ((y1*sintable[(ang+512)&2047] - x1*sintable[(ang+0)&2047])>>14);
	yp1 = ((x1*sintable[(ang+512)&2047] + y1*sintable[(ang+0)&2047])>>14);
	xp2 = ((y2*sintable[(ang+512)&2047] - x2*sintable[(ang+0)&2047])>>14);
	yp2 = ((x2*sintable[(ang+512)&2047] + y2*sintable[(ang+0)&2047])>>14);
 
	if ((yp1 > 0) && (yp2 > 0) && (labs(xp1) <= yp1) && (labs(xp2) <= yp2))
	{
		good = 7;
	}
	else
	{
		good = 7;
		if ((yp1 > 0) || (yp2 > 0))
		{
			if (((yp1-yp2)*xp1) > ((xp1-xp2)*yp1))
			{
				if ((xp1 < -yp1) && (xp2 > -yp2)) good--;
				if ((xp1 < yp1) && (xp2 > yp2)) good -= 2;
			}
		}
		if (good == 7)
			good = 0;
	}

	if (wall[walle].nextsector1 >= 0)
		if (got[wall[walle].nextsector1] == 0)
		{
			templong = labs(xp1*(yp2-yp1)-yp1*(xp2-xp1));
			templong1 = ksqrt((xp2-xp1)*(xp2-xp1)+(yp2-yp1)*(yp2-yp1));
			if (templong1 != 0)
			{
				templong /= templong1;
				if (templong <= 32)
					sectorborder[sectorbordercnt++] = wall[walle].nextsector1;
			}
		}

	if (good > 0)
	{
		yb1[numscans] = -1;
		yb2[numscans] = -1;

		if (good < 7) templong = xp1*yp2 - xp2*yp1;
		if ((good&1) > 0)
		{
			if (yp1 == 0) return(0);
			xb1[numscans] = 160 + ((xp1*160) / yp1);
			yb1[numscans] = yp1;
			llinum[numscans] = 0L;
		}
		else
		{
			xb1[numscans] = 0;
			templong1 = yp1-yp2-xp2+xp1;
			if (templong1 == 0) return(0);
			yb1[numscans] = templong/templong1;
		  
			xc = ((160-xb1[numscans])*yb1[numscans]) / 160;
			yc = yb1[numscans];
			templong1 = (labs(xp2-xp1) + labs(yp2-yp1));
			if (templong1 != 0)
				llinum[numscans] = divscale(labs(xc+xp1)+labs(yc-yp1),templong1,16);
		}
		if ((good&2) > 0)
		{
			if (yp2 == 0) return(0);
			xb2[numscans] = 159 + ((xp2*160) / yp2);
			yb2[numscans] = yp2;
			rlinum[numscans] = 65535L;
		}
		else
		{
			xb2[numscans] = XDIM-1;
			templong1 = yp2-yp1-xp2+xp1;
			if (templong1 == 0) return(0);
			yb2[numscans] = templong/templong1;

			xc = ((160-xb2[numscans])*yb2[numscans]) / 160;
			yc = yb2[numscans];
			templong1 = (labs(xp2-xp1) + labs(yp2-yp1));
			if (templong1 != 0)
				rlinum[numscans] = divscale(labs(xc+xp1)+labs(yc-yp1),templong1,16);
		}

		if ((yb1[numscans] > 8) && (yb2[numscans] > 8))
		{
			if (xb1[numscans] <= xb2[numscans])
			{
				thesector[numscans] = sectore;
				thewall[numscans] = walle;
				numscans++;
				return(1);
			}
		}
	}

	return(0);
}

ceilscan (long x1, long x2, short sectnum)
{
	long i, x, y1, y2, twall, bwall;

	globalzd = sector[sectnum].ceilingz-posz;
	globalpicnum = sector[sectnum].ceilingpicnum;
	if ((picanm[globalpicnum]&192) != 0)
		globalpicnum += animateoffs((short)globalpicnum);
	globalbufplc = waloff[globalpicnum];
	globalshade = sector[sectnum].ceilingshade;
	globalorientation = sector[sectnum].ceilingstat;
	globalpanning = sector[sectnum].ceilingpanning;

	sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);

	takernum = 4;
	y1 = umost[x1]-1; y2 = y1;
	if (y1 < -1) y1 = -1;
	if (y1 > YDIM-1) y1 = YDIM-1;
	if (y2 < 0) y2 = 0;
	if (y2 > YDIM) y2 = YDIM;
	for(x=x1;x<=x2;x++)
	{
		twall = umost[x]-1;
		bwall = (uplc[x]>>16);
		if (bwall > dmost[x]) bwall = dmost[x];

		if (twall < bwall-1)
		{
			if (twall < -1) twall = -1;
			if (twall > YDIM-1) twall = YDIM-1;
			if (bwall < 0) bwall = 0;
			if (bwall > YDIM) bwall = YDIM;

			if (twall >= y2)
			{
				while (y1 < y2-1)
				{
					y1++;
					hline(lastx[y1],x-1,y1,sectnum);
				}
				y1 = twall;
			}
			else
			{
				while (y1 < twall)
				{
					y1++;
					hline(lastx[y1],x-1,y1,sectnum);
				}
				while (y1 > twall)
				{
					lastx[y1] = x;
					y1--;
				}
			}

			while (y2 > bwall)
			{
				y2--;
				hline(lastx[y2],x-1,y2,sectnum);
			}
			while (y2 < bwall)
			{
				lastx[y2] = x;
				y2++;
			}
		}
		else
		{
			while (y1 < y2-1)
			{
				y1++;
				hline(lastx[y1],x-1,y1,sectnum);
			}
			y1 = umost[x+1]-1;
			y2 = y1;

			if (y1 < -1) y1 = -1;
			if (y1 > YDIM-1) y1 = YDIM-1;
			if (y2 < 0) y2 = 0;
			if (y2 > YDIM) y2 = YDIM;
		}
	}
	while (y1 < y2-1)
	{
		y1++;
		hline(lastx[y1],x2,y1,sectnum);
	}
	takernum = 1;
	return(0);
}

florscan (long x1, long x2, short sectnum)
{
	long i, x, y1, y2, twall, bwall;

	globalzd = posz-sector[sectnum].floorz;
	globalpicnum = sector[sectnum].floorpicnum;
	if ((picanm[globalpicnum]&192) != 0)
		globalpicnum += animateoffs((short)globalpicnum);
	globalbufplc = waloff[globalpicnum];
	globalshade = sector[sectnum].floorshade;
	globalorientation = sector[sectnum].floorstat;
	globalpanning = sector[sectnum].floorpanning;

	sethlinesizes(picsiz[globalpicnum]&15,picsiz[globalpicnum]>>4);

	takernum = 4;
	y1 = (dplc[x1]>>16)-1;
	if (y1 < umost[x1]-1) y1 = umost[x1]-1;
	y2 = y1;
	if (y1 < -1) y1 = -1;
	if (y1 > YDIM-1) y1 = YDIM-1;
	if (y2 < 0) y2 = 0;
	if (y2 > YDIM) y2 = YDIM;
	for(x=x1;x<=x2;x++)
	{
		twall = (dplc[x]>>16)-1;
		if (twall < umost[x]-1) twall = umost[x]-1;
		bwall = dmost[x];

		if (twall < bwall-1)
		{
			if (twall < -1) twall = -1;
			if (twall > YDIM-1) twall = YDIM-1;
			if (bwall < 0) bwall = 0;
			if (bwall > YDIM) bwall = YDIM;

			if (twall >= y2)
			{
				while (y1 < y2-1)
				{
					y1++;
					hline(lastx[y1],x-1,y1,sectnum);
				}
				y1 = twall;
			}
			else
			{
				while (y1 < twall)
				{
					y1++;
					hline(lastx[y1],x-1,y1,sectnum);
				}
				while (y1 > twall)
				{
					lastx[y1] = x;
					y1--;
				}
			}

			while (y2 > bwall)
			{
				y2--;
				hline(lastx[y2],x-1,y2,sectnum);
			}
			while (y2 < bwall)
			{
				lastx[y2] = x;
				y2++;
			}
		}
		else
		{
			while (y1 < y2-1)
			{
				y1++;
				hline(lastx[y1],x-1,y1,sectnum);
			}
			y1 = (dplc[x+1]>>16)-1;
			if (y1 < umost[x+1]-1) twall = umost[x+1]-1;
			y2 = y1;

			if (y1 < -1) y1 = -1;
			if (y1 > YDIM-1) y1 = YDIM-1;
			if (y2 < 0) y2 = 0;
			if (y2 > YDIM) y2 = YDIM;
		}
	}
	while (y1 < y2-1)
	{
		y1++;
		hline(lastx[y1],x2,y1,sectnum);
	}
	takernum = 1;
	return(0);
}

wallscan(long x1, long x2)
{
	char startplane, plane;
	long x, startx;

	if (option[0] == 0)
	{
		plane = (1<<(x1&3));
		startplane = plane;
		if ((x2-x1) < 4) startplane = (1<<((x2+1)&3));
		startx = x1;
		do
		{
			outpw(0x3c4,2+(((short)plane)<<8));

			x = startx;
			while (x <= x2-12)
				vline4(x), x += 16;
			while (x <= x2)
				vline(x), x += 4;

			plane <<= 1; if (plane == 16) plane = 1;
			startx++;
		}
		while (plane != startplane);
	}
	else
	{
		x = x1;
		while (x <= x2-3)
			vline4(x), x += 4;
		while (x <= x2)
			vline(x), x++;
	}
}

maskwallscan(long x1, long x2)
{
	char startplane, plane;
	long x, startx;

	if (option[0] == 0)
	{
		plane = (1<<(x1&3));
		startplane = plane;
		if ((x2-x1) < 4) startplane = (1<<((x2+1)&3));
		startx = x1;
		do
		{
			outpw(0x3c4,2+(((short)plane)<<8));

			x = startx;
			while (x <= x2)
				maskvline(x), x += 4;

			plane <<= 1; if (plane == 16) plane = 1;
			startx++;
		}
		while (plane != startplane);
	}
	else
	{
		x = x1;
		while (x <= x2)
			maskvline(x), x++;
	}
}

loadboard(filename)
char filename[20];
{
	short int fil, i, numsprites;

	initspritelists();
	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
	{
		mapversion = 3L;
		return(-1);
	}

	read(fil,&mapversion,4);
	if (mapversion != 3L) return(-1);
	read(fil,&posx,4);
	read(fil,&posy,4);
	read(fil,&posz,4);
	read(fil,&ang,2);
	read(fil,&cursectnum,2);
	read(fil,&numsectors,2);
	read(fil,&numwalls,2);
	read(fil,&numsprites,2);
	for(i=0;i<numsectors;i++) read(fil,&sector[i],sizeof(struct sectortype));
	for(i=0;i<numwalls;i++) read(fil,&wall[i],sizeof(struct walltype));
	for(i=0;i<numsprites;i++)
	{
		read(fil,&sprite[i],sizeof(struct spritetype));
		insertsprite(sprite[i].sectnum,sprite[i].statnum);
	}
	close(fil);

	return(0);
}

saveboard(filename)
char filename[20];
{
	short int fil, i, j, numsprites;

	if ((fil = open(filename,O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) == -1)
		return(-1);
	write(fil,&mapversion,4);
	write(fil,&posx,4);
	write(fil,&posy,4);
	write(fil,&posz,4);
	write(fil,&ang,2);
	write(fil,&cursectnum,2);
	write(fil,&numsectors,2);
	write(fil,&numwalls,2);

	numsprites = 0;
	for(j=0;j<MAXSTATUS;j++)
	{
		i = headspritestat[j];
		while (i != -1)
		{
			numsprites++;
			i = nextspritestat[i];
		}
	}
	write(fil,&numsprites,2);

	for(i=0;i<numsectors;i++) write(fil,&sector[i],sizeof(struct sectortype));
	for(i=0;i<numwalls;i++) write(fil,&wall[i],sizeof(struct walltype));

	for(j=0;j<MAXSTATUS;j++)
	{
		i = headspritestat[j];
		while (i != -1)
		{
			write(fil,&sprite[i],sizeof(struct spritetype));
			i = nextspritestat[i];
		}
	}

	close(fil);
	return(0);
}

loadtables()
{
	short fil;

	if (tablesloaded == 0)
	{
		if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&sintable[0],4096);
			read(fil,&tantable[0],4096);
			read(fil,&radarang[0],640);
			read(fil,&textfont[0],1024);
			read(fil,&option[0],NUMOPTIONS);
			close(fil);
			tablesloaded = 1;
		}
	}
	return(0);
}

setgamemode()
{
	short i, fil;

	setvmode(0x13);
	if (paletteloaded == 0)
	{
		if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&palette[0],768);
			read(fil,&palookup[0][0],(NUMPALOOKUPS<<8));
			close(fil);
		}
		paletteloaded = 1;
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);

	if (option[0] == 0)
	{
		outp(0x3c4,0x4); outp(0x3c5,0x6);
		outp(0x3d4,0x14); outp(0x3d5,0x0);
		outp(0x3d4,0x17); outp(0x3d5,0xe3);

		outp(0x3c4,2); outp(0x3c5,15);
		clearbuf(0xa0000,4096L+4096L+4096L,0L);
	}
	if (option[0] == 2)
	{
		outp(0x3cd,1), clearbuf(0xa0000,16000L,0L);
		outp(0x3cd,2), clearbuf(0xa0000,16000L,0L);
	}
	if (option[0] == 3)
	{
		outp(0x3ce,0xf); outp(0x3cf,0x5);
		outp(0x3d4,0x29); outp(0x3d5,0x85);
		outp(0x3c4,0x6); outp(0x3c5,0x48);
		outp(0x3d4,0x2f); outp(0x3d5,0);   //set mod = 256k

		outp(0x3ce,0x9); outp(0x3cf,1<<4); clearbuf(0xa0000,16000L,0L);
		outp(0x3ce,0x9); outp(0x3cf,2<<4); clearbuf(0xa0000,16000L,0L);
	}
	if (option[0] == 4)
	{
		outp(0x3d4,0x38); outp(0x3d5,0x48);           //S3 Extensions enable #1
		outp(0x3d4,0x39); outp(0x3d5,0xa5);           //S3 Extensions enable #2
		outp(0x3d4,0x31); outp(0x3d5,inp(0x3d5)|9);   //Init for start address

		outp(0x3d4,0x35); outp(0x3d5,1); clearbuf(0xa0000,16000L,0L);
		outp(0x3d4,0x35); outp(0x3d5,2); clearbuf(0xa0000,16000L,0L);
	}

	return(0);
}

hline (long xl, long xr, long yp, short sectnum)
{
	char *ptr, shiftval;
	unsigned long dat;
	short shade, siz;
	long zx, x, y, xc, yc, hd, p;

	if ((xl < 0) || (xr >= XDIM) || (yp < 0) || (yp >= YDIM))
		return(0);

	if (xl > xr)
		zx = xl, xl = xr, xr = zx;
	siz = xr-xl+1;

	if (yp == (YDIM>>1)) yp++;
	hd = divscale(globalzd,XDIM*labs((YDIM>>1)-yp),14);
	xc = mulscale(hd,sintable[(2048+ang)&2047],4);
	yc = mulscale(hd,sintable[(2560+ang)&2047],4);
	x = xc*xl - (xc+yc)*(XDIM>>1) + (posx<<20);
	y = yc*xl + (xc-yc)*(XDIM>>1) - (posy<<20);
	if (yp > (YDIM>>1))
	{
		y ^= 0xffffffff;
		yc ^= 0xffffffff;
	}

	if ((globalorientation&4) == 0)
		x += (((long)globalpanning)<<24);
	else
		y += (((long)globalpanning)<<24);

	if ((globalorientation&8) == 0)
	{
		x >>= ((picsiz[globalpicnum]&15)-6);
		xc >>= ((picsiz[globalpicnum]&15)-6);
		y >>= ((picsiz[globalpicnum]>>4)-6);
		yc >>= ((picsiz[globalpicnum]>>4)-6);
	}
	x <<= 2;
	xc <<= 2;
	y <<= 2;
	yc <<= 2;

	shade = (labs(hd)>>visibility)+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= NUMPALOOKUPS) shade = NUMPALOOKUPS-1;

	takernum = 6;
	if (option[0] == 0)
	{
		p = yp*80+(xl>>2)+0xa0000+(((long)page)<<14);
		asm1 = xc;
		asm2 = yc;
		asm3 = siz-1;
		hchainasm64((long)(((xr+1)&3)<<8)+(xl&3),y,((long)shade)<<8,globalbufplc,x,p);
	}
	else
	{
		p = yp*320+xl+frameplace;
		asm1 = xc;
		asm2 = yc;
		asm3 = siz;
		hlineasm64(0L,globalbufplc,(long)shade,y,x,p);
	}
	takernum = 4;

	return(0);
}

vline (long x)
{
	short y1v, y2v, shade;
	long vplc, vinc, p, bufplc, palookupoffs, linum;

	if ((x < 0) || (x >= XDIM) || (swall[x] <= 4L))
		return(0);

	takernum = 3;
 
	y1v = ((short)(uwall[x]>>16));
	y2v = ((short)(dwall[x]>>16)-1);
	if (y1v < umost[x]) y1v = umost[x];
	if (y2v >= dmost[x]) y2v = dmost[x]-1;

	if (y2v < y1v)
	{
		takernum = 1;
		return(0);
	}

	vinc = divscale(65536,swall[x],16);

	shade = (vinc>>(visibility+2))+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= NUMPALOOKUPS) shade = NUMPALOOKUPS-1;
	palookupoffs = (long)(&palookup[0][0]) + (((long)shade)<<8);

	vinc = ((vinc*((long)globalyrepeat))<<(13-globalshiftval));
	vplc = globalzd + vinc*(y1v-(YDIM>>1)+1);

	linum = globalpanning;
	if ((globalorientation&64) > 0)
		linum = 0, vplc -= (((long)globalpanning)<<24);
	linum += (lwall[x]>>6);
	linum = (linum%tilesizx[globalpicnum])*tilesizy[globalpicnum];
	bufplc = waloff[globalpicnum]+linum;

	takernum = 5;
	if (option[0] == 0)
		p = y1v*80+(x>>2)+0xa0000+(((long)page)<<14);
	else
		p = y1v*320+x+frameplace;
	vlineasm1(vinc,palookupoffs,(((long)(y2v-y1v))<<8)+globalshiftval,vplc,bufplc,p);
	takernum = 1;
	return(0);
}

maskvline (long x)
{
	short y1v, y2v, shade;
	long vplc, vinc, p, bufplc, palookupoffs, linum;

	if ((x < 0) || (x >= XDIM) || (swall[x] <= 4L))
		return(0);

	takernum = 3;

	y1v = ((short)(uwall[x]>>16));
	y2v = ((short)(dwall[x]>>16)-1);
	if (y1v < umost[x]) y1v = umost[x];
	if (y2v >= dmost[x]) y2v = dmost[x]-1;

	if (y2v < y1v)
	{
		takernum = 1;
		return(0);
	}

	vinc = divscale(65536,swall[x],16);

	shade = (vinc>>(visibility+2))+globalshade;
	if (shade < 0) shade = 0;
	if (shade >= NUMPALOOKUPS) shade = NUMPALOOKUPS-1;
	palookupoffs = (long)(&palookup[0][0]) + (((long)shade)<<8);

	vinc = ((vinc*((long)globalyrepeat))<<(13-globalshiftval));
	vplc = globalzd + vinc*(y1v-(YDIM>>1)+1);

	linum = globalpanning;
	if ((globalorientation&64) > 0)
		linum = 0, vplc -= (((long)globalpanning)<<24);
	linum += (lwall[x]>>6);
	linum = (linum%tilesizx[globalpicnum])*tilesizy[globalpicnum];
	bufplc = waloff[globalpicnum]+linum;

	takernum = 5;
	if (option[0] == 0)
		p = y1v*80+(x>>2)+0xa0000+(((long)page)<<14);
	else
		p = y1v*320+x+frameplace;
	mvlineasm1(vinc,palookupoffs,(((long)(y2v-y1v))<<8)+globalshiftval,vplc,bufplc,p);
	takernum = 1;
	return(0);
}

vline4 (long xstart)
{
	short y1ve[4], y2ve[4], shade, bad;
	long vplce[4], vince[4], bufplce[4], palookupoffse[4], daglobalzd;
	long u1, u4, d4, d1, x, z, zx, oldp, p, dat, linum;

	if ((xstart+3 < 0L) || (xstart >= XDIM))
		return(0);

	takernum = 3;

	bad = 0;

	u1 = YDIM; u4 = 0; d4 = YDIM; d1 = 0;
	for(z=0;z<4;z++)
	{
		x = xstart+z;
		if (option[0] == 0)
			x += (z<<1)+z;

		y1ve[z] = ((short)(uwall[x]>>16));
		if (y1ve[z] < umost[x]) y1ve[z] = umost[x];
		y2ve[z] = ((short)(dwall[x]>>16)-1);
		if (y2ve[z] >= dmost[x]) y2ve[z] = dmost[x]-1;

		if ((y2ve[z] < y1ve[z]) || (swall[x] <= 4L))
		{
			bad += (1<<z);
			continue;
		}

		vince[z] = divscale(65536,swall[x],16);

		shade = (vince[z]>>(visibility+2))+globalshade;
		if (shade < 0) shade = 0;
		if (shade >= NUMPALOOKUPS) shade = NUMPALOOKUPS-1;
		palookupoffse[z] = (long)(&palookup[0][0]) + (((long)shade)<<8);

		vince[z] = ((vince[z]*((long)globalyrepeat))<<(13-globalshiftval));
		vplce[z] = globalzd + vince[z]*(y1ve[z]-(YDIM>>1)+1);

		linum = globalpanning;
		if ((globalorientation&64) > 0)
			linum = 0, vplce[z] -= (((long)globalpanning)<<24);
		linum += (lwall[x]>>6);
		linum = (linum%tilesizx[globalpicnum])*tilesizy[globalpicnum];
		bufplce[z] = waloff[globalpicnum]+linum;
	}
	if (bad == 15)
	{
		takernum = 1;
		return(0);
	}

	for(z=0;z<4;z++)
	{
		if (y1ve[z] < u1) u1 = y1ve[z];
		if (y1ve[z] > u4) u4 = y1ve[z];
		if (y2ve[z] < d4) d4 = y2ve[z];
		if (y2ve[z] > d1) d1 = y2ve[z];
	}

	if ((bad > 0) || (u4 >= d4))
	{
		for(z=0;z<4;z++)
			if ((bad&(1<<z)) == 0)
			{
				if (option[0] == 0)
					p = y1ve[z]*80+(xstart>>2)+z+0xa0000+(((long)page)<<14);
				else
					p = y1ve[z]*320+xstart+z+frameplace;
				vlineasm1(vince[z],palookupoffse[z],(((long)(y2ve[z]-y1ve[z]))<<8)+globalshiftval,vplce[z],bufplce[z],p);
			}
	}
	else
	{
			//Draw 1 pixel at a time for top
		for(z=0;z<4;z++)
		{
			if (option[0] == 0)
				p = y1ve[z]*80+(xstart>>2)+z+0xa0000+(((long)page)<<14);
			else
				p = y1ve[z]*320+xstart+z+frameplace;
			vplce[z] = vlineasm1(vince[z],palookupoffse[z],(((long)(u4-y1ve[z]))<<8)+globalshiftval,vplce[z],bufplce[z],p);
		}

		//Draw 4 pixels at a time
		if (d4 > u4)
		{
			if (option[0] == 0)
				p = (u4+1)*80+(xstart>>2)+0xa0000+(((long)page)<<14);
			else
				p = (u4+1)*320+xstart+frameplace;
			takernum = 5;
			p = vlineasm4((long)(&vplce[0]),(long)(&vince[0]),((d4-u4-1)<<8)+globalshiftval,(long)(&bufplce[0]),(long)(&palookupoffse[0]),p);
			takernum = 3;
		}

			//Draw 1 pixel at a time for bottom
		oldp = p;
		for(z=0;z<4;z++)
			if (y2ve[z] > d4)
				vlineasm1(vince[z],palookupoffse[z],(((long)(y2ve[z]-d4-1))<<8)+globalshiftval,vplce[z],bufplce[z],oldp+z);
	}

	takernum = 1;
	return(0);
}

initengine()
{
	long i;

	parallaxtype = 2;
	paletteloaded = 0;
	searchx = 160;
	searchy = 100;
	searchit = 0;
	searchstat = -1;
	animatecnt = 0;
	neartagsector = -1;
	loadtables();
	for(i=0;i<XDIM;i++)
	{
		startumost[i] = 0;
		startdmost[i] = YDIM;
	}
	for(i=0;i<=YDIM+1;i++)
		lastx[i] = -1;
	oldzerohandler = _dos_getvect(0);
	_disable(); _dos_setvect(0, zerohandler); _enable();
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();
	if (option[4] > 0)
	{
		comnum = option[4];
		switch(option[5])
		{
			case 0: comspeed = 2400; break;
			case 1: comspeed = 4800; break;
			case 2: comspeed = 9600; break;
			case 3: comspeed = 14400; break;
			case 4: comspeed = 19200; break;
			case 5: comspeed = 28800; break;
		}
		comon();
	}
	resettiming();
	visibility = 13;
	capturecount = 0;
	clearbuf((long)(&keystatus[0]),64L,0L);
	takernum = 0;
	editstatus = 0;
	heightoffceiling = (32<<8);
	heightofffloor = (32<<8);
	gravity = 98;
	mousx = 0;
	mousy = 0;
	page = 0;
	if (option[3] == 1)
		setupmouse();
	//videocard = getcard();

	switch(option[0])
	{
		case 0:
			frameplace = 0xa0000;
			fixvlinesforchain();
			page = 0;
			break;
		case 1:
			frameplace = FP_OFF(screen);
			clearbuf(frameplace,16000L,0L);
			break;
		case 2:
			frameplace = 0xa0000;
			page = 0; outp(0x3cd,page+(page<<4));
			break;
		case 3:
			frameplace = 0xa0000;
			page = 0; outp(0x3ce,0x9); outp(0x3cf,page<<4);
			break;
		case 4:
			frameplace = 0xa0000;
			page = 0; outp(0x3d4,0x35); outp(0x3d5,page);
			break;
	}
	musicstatus = 0;
	oldtimerhandler = _dos_getvect(0x8);
	_dos_setvect(0x8, timerhandler);
	outp(0x43,54); outp(0x40,9942&255); outp(0x40,9942>>8);
	return(0);
}

uninitengine()
{
	long i;

	if (poscapture > 0)
	{
		lseek(posfil,0L,SEEK_SET);
		poscapture--;
		write(posfil,&poscapture,4);
		close(posfil);
	}
	_dos_setvect(0x8, oldtimerhandler);
	if (option[4] > 0)
		comoff();
	_dos_setvect(0x9, oldkeyhandler);
	_disable(); _dos_setvect(0, oldzerohandler); _enable();
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	for(i=0;i<MAXTILEFILES;i++)
		free(pic[i]);
}

nextpage()
{
	lockspeed = clockspeed;
	clockspeed -= lockspeed;

	switch(option[0])
	{
		case 0:
			outp(0x3d4,0xc); outp(0x3d5,page<<6);
			page++;
			if (page == 3) page = 0;
			break;
		case 1:
			takernum = 7;
			copytovideo();
			takernum = 0;
			break;
		case 2:
			outp(0x3d4,0xc); outp(0x3d5,page<<6);
			page++;
			if (page == 3) page = 0;
			outp(0x3cd,page+(page<<4));
			break;
		case 3:
			outp(0x3d4,0xc); outp(0x3d5,page<<6);
			page++;
			if (page == 3) page = 0;
			outp(0x3ce,0x9); outp(0x3cf,page<<4);
			break;
		case 4:
			outp(0x3d4,0xc); outp(0x3d5,page<<6);
			page++;
			if (page == 3) page = 0;
			outp(0x3d4,0x35); outp(0x3d5,page);
			break;
	}

	numframes++;
}

loadpics(char filename[20])
{
	long totpicsiz, offscount, siz;
	short int fil, i, j, k;

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1) return(-1);
			read(fil,&numtiles,4);
			read(fil,&localtilestart[k],4);
			read(fil,&localtileend[k],4);
			read(fil,&tilesizx[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&tilesizy[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			totpicsiz = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
				totpicsiz += (long)(tilesizx[i]*tilesizy[i]);
			pic[k] = (char *)malloc(totpicsiz);

			offscount = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				waloff[i] = offscount+FP_OFF(pic[k]);
				siz = tilesizx[i]*tilesizy[i];
				if (siz > 0)
				{
					read(fil,&(pic[k])[offscount],siz);
					offscount += siz;
				}
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i]))
			j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i]))
			j--;
		picsiz[i] += ((char)(j<<4));
	}

	return(0);
}

showengineinfo()
{
	short i, j, k;
	long templong, templong1, templong2;

	templong = 0;
	for(i=0;i<NUMTIMECOUNTS;i++)
		templong += timetakercount[i];
	if ((templong != 0) && (numframes != 0))
		for(i=0;i<NUMTIMECOUNTS;i++)
		{
			templong1 = (10000L*timetakercount[i])/templong;
			printf("%d - %2d.%1d%1d%% - %s",i,(short)(templong1/100),(short)((templong1/10)%10),(short)(templong1%10),timenames[i]);
			templong2 = (templong1*(totalclock/12))/numframes;
			printf("(%3d.%1d%1dms) ",(unsigned short)(templong2/100),(unsigned short)((templong2/10)%10),(unsigned short)(templong2%10));

			j = (short)((templong1+50)/100);
			for(k=0;k<(j>>1);k++)
				printf("");
			if ((j&1) > 0)
				printf("");
			printf("\n");
		}
	if (totalclock != 0)
	{
		templong1 = (numframes*12000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(short)(templong1/100),(short)((templong1/10)%10),(short)(templong1%10));
	}
}

resettiming()
{
	long i;

	for(i=0;i<NUMTIMECOUNTS;i++)
		timetakercount[i] = 0L;
	numframes = 0L;
	clockspeed = 0L;
	lockspeed = 0L;
	totalclock = 0L;
	takernum = 0;
}

clipinsidebox (long x1, long y1, long x2, long y2, long boxsiz)
{
	long templong1, templong2, templong3, templong4;

	if ((x1 < 0) && (x2 < 0)) return(0);
	if ((x1 >= boxsiz) && (x2 >= boxsiz)) return(0);
	if ((y1 < 0) && (y2 < 0)) return(0);
	if ((y1 >= boxsiz) && (y2 >= boxsiz)) return(0);

	templong1 = (x2-x1)*(-y1)-(-x1)*(y2-y1);
	templong2 = (x2-x1)*(boxsiz-y1)-(-x1)*(y2-y1);
	if ((templong1<=0) != (templong2<=0)) return(1);
	templong3 = (x2-x1)*(-y1)-(boxsiz-x1)*(y2-y1);
	if ((templong2<=0) != (templong3<=0)) return(1);
	templong4 = (x2-x1)*(boxsiz-y1)-(boxsiz-x1)*(y2-y1);
	if ((templong3<=0) != (templong4<=0)) return(1);

	return(0);
}

engineinput()
{
	char *ptr;
	short i, j, k, startwall, endwall, doubvel;
	long oldposx, oldposy;
	long topz, botz, daheightoffceiling, daheightofffloor;

	if (keystatus[0xb7] > 0)
	{
		keystatus[0xb7] = 0;
		int5();
	}
	if (keystatus[0x14] > 0)  //T
		resettiming();
	if (keystatus[0x19] > 0)  //P
	{
		keystatus[0x19] = 0;
		while ((keystatus[0x19] == 0) && (keystatus[1] == 0));
		keystatus[0x19] = 0;
	}
	if (keystatus[88] > 0)   //F12
	{
		screencapture();
		keystatus[88] = 0;
	}
	if ((keystatus[0x2e] > 0) && (poscapture == 0)) //C
	{
		poscapture = 1L;
		posfil = open("poscapt.dat",O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE);
		write(posfil,&poscapture,4);
	}
	if ((keystatus[0x13] > 0) && (poscapture == 0)) //R
	{
		if (playposcapt("poscapt.dat") == 0)
		{
			uninitengine();
			setvmode(0x3);
			showengineinfo();
			exit(0);
		}
	}

	if (editstatus == 0)
	{
		if (moustat == 1)
		{
			readmouse();
			angvel += (mousx<<3);
			vel -= (mousy<<2);
			if (angvel < -512) angvel = -512;
			if (angvel > 512) angvel = 512;
			if (vel < -512) vel = -512;
			if (vel > 512) vel = 512;
		}
	}

	if (cursectnum >= 0)
	{
		daheightoffceiling = heightoffceiling;
		daheightofffloor = heightofffloor;
		if ((sector[cursectnum].floorstat&2) > 0) //Groudraw
		{
			ptr = (char *)(waloff[sector[cursectnum].floorheinum]+(((posx>>4)&63)<<6)+((posy>>4)&63));
			daheightofffloor += ((*ptr)<<8);
		}
		if (daheightoffceiling < (4<<8)) daheightoffceiling = (4<<8);
		if (daheightofffloor < (4<<8)) daheightofffloor = (4<<8);
		if ((sector[cursectnum].ceilingstat&1) > 0)   //is psky
			topz = 0x80000000;
		else
			topz = sector[cursectnum].ceilingz + daheightoffceiling;
		botz = sector[cursectnum].floorz - daheightofffloor;
		if (topz > botz)
		{
			topz = (sector[cursectnum].ceilingz*daheightofffloor+sector[cursectnum].floorz*daheightoffceiling);
			topz /= (daheightofffloor+daheightoffceiling);
			botz = topz;
		}

		doubvel = lockspeed;
		if (keystatus[0x2a] > 0)
			doubvel += lockspeed;

		if (gravity > 0)
		{
			if (posz < botz)
			{
				hvel += ((gravity*doubvel)>>6);
				posz += (hvel*doubvel);
				if (posz > botz) posz = botz;
			}
			else if (posz > botz)
			{
				hvel -= ((gravity*doubvel)>>6);
				posz += (hvel*doubvel);
				if (posz < topz) hvel = 0;
				if (posz < botz) posz = botz;
			}
			else
			{
				hvel = 0;
			}
		}
		else if (gravity < 0)
		{
			if (posz > topz)
			{
				hvel += ((gravity*doubvel)>>6);
				posz += (hvel*doubvel);
				if (posz < topz) posz = topz;
			}
			else if (posz < topz)
			{
				hvel -= ((gravity*doubvel)>>6);
				posz += (hvel*doubvel);
				if (posz > botz) hvel = 0;
				if (posz > topz) posz = topz;
			}
			else
			{
				hvel = 0;
			}
		}
		else
		{
			if (posz > botz) hvel -= ((98*doubvel)>>6);
			if (posz < topz) hvel += ((98*doubvel)>>6);
			posz += (hvel*doubvel);
		}
	}
	if ((sector[cursectnum].ceilingstat&1) == 0)   //Not psky
	{
		if (posz < sector[cursectnum].ceilingz+(2<<8))
		{
			posz = sector[cursectnum].ceilingz+(2<<8);
			hvel = 0;
		}
	}
	if (posz > sector[cursectnum].floorz-(2<<8))
	{
		posz = sector[cursectnum].floorz-(2<<8);
		hvel = 0;
	}

	if (poscapture > 0)
	{
		write(posfil,&posx,4);
		write(posfil,&posy,4);
		write(posfil,&posz,4);
		write(posfil,&ang,2);
		poscapture++;
	}
}

screencapture()
{
	char filename[15];
	short fil;
	long i, j, k, bufplc;

	strcpy(filename,"capturxx.bmp");
	filename[6] = (capturecount/10)+48;
	filename[7] = (capturecount%10)+48;
	capturecount++;
	if ((fil=open(filename,O_BINARY|O_CREAT|O_WRONLY,S_IWRITE))==-1)
	{
		capturecount--;
		return(-1);
	}
	tempbuf[0] = 66, tempbuf[1] = 77, tempbuf[2] = 90, tempbuf[3] = 34;
	tempbuf[4] = 0, tempbuf[5] = 0, tempbuf[6] = 0, tempbuf[7] = 0;
	tempbuf[8] = 0, tempbuf[9] = 0, tempbuf[10] = 26, tempbuf[11] = 3;
	tempbuf[12] = 0, tempbuf[13] = 0, tempbuf[14] = 12, tempbuf[15] = 0;
	tempbuf[16] = 0, tempbuf[17] = 0, tempbuf[18] = 64, tempbuf[19] = 1;
	tempbuf[20] = 200, tempbuf[21] = 0, tempbuf[22] = 1, tempbuf[23] = 0;
	tempbuf[24] = 8, tempbuf[25] = 0;
	write(fil,&tempbuf[0],26);
	outp(0x3c7,0);
	for(i=0;i<768;i++)
		tempbuf[i] = (inp(0x3c9)<<2);
	for(i=0;i<768;i+=3)
	{
		j = tempbuf[i];
		tempbuf[i] = tempbuf[i+2];
		tempbuf[i+2] = j;
	}
	if (write(fil,&tempbuf[0],768) < 768)
	{
		close(fil);
		capturecount--;
		return(-1);
	}

	bufplc = 0L;
	for(j=199;j>=0;j--)
	{
		outp(97,inp(97)|3);
		readrow(frameplace+j*320,bufplc);
		bufplc += 320L;
		if (bufplc >= 3200L)
		{
			if (write(fil,&tempbuf[0],3200) < 3200)
			{
				close(fil);
				capturecount--;
				return(-1);
			}
			bufplc = 0L;
		}
		outp(97,inp(97)&252);
	}
	close(fil);
	return(0);
}

getsector()
{
	short i;

	if ((cursectnum == -1) || (cursectnum >= numsectors) || (inside(posx,posy,cursectnum) == 0))
	{
		for(i=0;i<numsectors;i++)
			if (inside(posx,posy,i) == 1)
			{
				cursectnum = i;
				return(0);
			}
		cursectnum = -1;
	}
	return(0);
}

inside(long x, long y, short sectnum)
{
	long x1, y1, x2, y2, templong;
	short i, startwall, endwall, cnt;

	if ((sectnum < 0) || (sectnum >= numsectors))
		return(-1);
	cnt = 0;
	startwall = sector[sectnum].wallptr;
	endwall = startwall + sector[sectnum].wallnum - 1;
	for(i=startwall;i<=endwall;i++)
	{
		x1 = wall[i].x; x2 = wall[wall[i].point2].x;
		if ((x1 >= x) || (x2 >= x))
		{
			y1 = wall[i].y; y2 = wall[wall[i].point2].y;
			if (y1 > y2)
			{
				templong = x1, x1 = x2, x2 = templong;
				templong = y1, y1 = y2, y2 = templong;
			}
			if ((y1 <= y) && (y2 > y))
				if (x1*(y-y2)+x2*(y1-y) <= x*(y1-y2))
					cnt ^= 1;
		}
	}
	return(cnt);
}

getangle(long xvect, long yvect)
{
	if ((xvect|yvect) == 0) return(0);
	if (xvect == yvect) return(256+((xvect<0)<<10));
	if (xvect == -yvect) return(768+((xvect>0)<<10));
	if (labs(xvect) > labs(yvect))
		return(radarang[((yvect*(XDIM>>1))/xvect)+(XDIM>>1)]+((xvect<0)<<10));
	return(radarang[(XDIM>>1)-((xvect*(XDIM>>1))/yvect)]+512+((yvect<0)<<10));
}

ksqrt(long num)
{
	long root, temp;

	root = 128;
	do
	{
		temp = root;
		root = ((root+(num/root))>>1);
	}
	while (labs(temp-root) > 1);
	return(root);
}

copytilepiece(walnume1,x1,y1,xsiz,ysiz,walnume2,x2,y2,shadeoffs)
long walnume1, x1, y1, xsiz, ysiz, walnume2, x2, y2;
char shadeoffs;
{
	long xsiz1, ysiz1, xsiz2, ysiz2, picplc1, picplc2, i, j, ptr1, ptr2;

	if ((tilesizx[walnume1] != 0) && (tilesizy[walnume2] != 0))
	{
		xsiz1 = tilesizx[walnume1];
		ysiz1 = tilesizy[walnume1];
		xsiz2 = tilesizx[walnume2];
		ysiz2 = tilesizy[walnume2];
		for(i=x1;i<x1+xsiz;i++)
			for(j=y1;j<y1+ysiz;j++)
				if ((i < xsiz1) && (j < ysiz1) && (i-x1+x2 < xsiz2) && (j-y1+y2 < ysiz2))
				{
					ptr1 = waloff[walnume1] + i * ysiz1 + j;
					ptr2 = waloff[walnume2] + (i-x1+x2) * ysiz2 + (j-y1+y2);
					memcopybyte(ptr2,ptr1,shadeoffs);
				}
	}
}

printext(long x, long y, char buffer[42], short tilenum, char invisiblecol)
{
	long p, startp, bufplc;
	char *ptr, ch, plane;
	unsigned char dat;
	short i, dax, day, theyinc;

	bufplc = waloff[tilenum];

	if (option[0] == 0)
	{
		startp = y*80+(x>>2)+0xa0000+(((long)page)<<14);
		plane = (x&3);
		theyinc = 80;
	}
	else
	{
		startp = y*320+x+frameplace;
		theyinc = 320;
	}

	i = 0;
	while (buffer[i] != 0)
	{
		ch = buffer[i];
		ptr = (char *)(bufplc+(((long)ch&15)<<9)+(((long)ch>>4)<<3));
		for(dax=0;dax<8;dax++)
		{
			p = startp;
			if (option[0] == 0) outpw(0x3c4,2+(256<<(plane&3)));

			if (invisiblecol == 255)
			{
				for(day=0;day<8;day++)
				{
					dat = *ptr;
					if (dat != 255) drawpixel(p,(long)dat);
					p += theyinc;
					ptr++;
				}
			}
			else
			{
				for(day=0;day<8;day++)
				{
					dat = *ptr;
					if (dat == 255) dat = invisiblecol;
					drawpixel(p,dat);
					p += theyinc;
					ptr++;
				}
			}
			if (option[0] == 0)
			{
				plane++;
				if ((plane&3) == 0) startp++;
			}
			else
				startp++;

			ptr += (64-8);
		}
		i++;
	}
	return(0);
}

printnum(long x, long y, long num, short tilenum, char invisiblecol)
{
	char snotbuf[12];
	short i, j, sign;

	if (num == 0)
	{
		sign = 0;
		snotbuf[0] = 48;
	}
	else if (num < 0)
	{
		sign = -1;
		snotbuf[0] = '-';
		num = -num;
	}
	else
	{
		sign = 1;
		snotbuf[0] = '+';
	}

	snotbuf[1] = ((char)((num/1000000000)%10))+48;
	snotbuf[2] = ((char)((num/100000000)%10))+48;
	snotbuf[3] = ((char)((num/10000000)%10))+48;
	snotbuf[4] = ((char)((num/1000000)%10))+48;
	snotbuf[5] = ((char)((num/100000)%10))+48;
	snotbuf[6] = ((char)((num/10000)%10))+48;
	snotbuf[7] = ((char)((num/1000)%10))+48;
	snotbuf[8] = ((char)((num/100)%10))+48;
	snotbuf[9] = ((char)((num/10)%10))+48;
	snotbuf[10] = ((char)((num/1)%10))+48;
	snotbuf[11] = 0;
	i = 1;
	while (snotbuf[i] == 48)
		i++;
	for(j=i;j<12;j++)
		snotbuf[j-i+1] = snotbuf[j];

	printext(x,y,snotbuf,tilenum,invisiblecol);
}

drawmasks()
{
	long i, j, templong, templong1, templong2;
	long x1l1, y1l1, x2l1, y2l1, x1l2, y1l2;

	while ((maskwallcnt > 0) || (spritesortcnt > 0))
	{
		if ((maskwallcnt > 0) && (spritesortcnt > 0))
		{
			x1l1 = wall[thewall[maskwall[maskwallcnt-1]]].x;
			y1l1 = wall[thewall[maskwall[maskwallcnt-1]]].y;
			x2l1 = wall[wall[thewall[maskwall[maskwallcnt-1]]].point2].x;
			y2l1 = wall[wall[thewall[maskwall[maskwallcnt-1]]].point2].y;
			x1l2 = sprite[thesprite[spritesortcnt-1]].x;
			y1l2 = sprite[thesprite[spritesortcnt-1]].y;
			templong1 = (x1l1-posx)*(y2l1-posy) - (x2l1-posx)*(y1l1-posy);
			templong2 = (x1l1-x1l2)*(y2l1-y1l2) - (x2l1-x1l2)*(y1l1-y1l2);
			if ((templong1 < 0) == (templong2 < 0))
			{
				maskwallcnt--;
				drawmaskwall(maskwallcnt);
			}
			else
			{
				spritesortcnt--;
				drawfacesprite(spritex[spritesortcnt],spritey[spritesortcnt],thesprite[spritesortcnt]);
			}
		}
		else
		{
			if (spritesortcnt > 0)
			{
				spritesortcnt--;
				drawfacesprite(spritex[spritesortcnt],spritey[spritesortcnt],thesprite[spritesortcnt]);
			}
			if (maskwallcnt > 0)
			{
				maskwallcnt--;
				drawmaskwall(maskwallcnt);
			}
		}
	}
}

drawmaskwall(short damaskwallcnt)
{
	long i, x, z, wallnum, sectnum;
	long y1, y2, z1, z2, llin, rlin, top, topinc, bot, botinc;
	long hplc, hinc, uuplc, uuinc, ddplc, ddinc, um, dm, das;

	z = maskwall[damaskwallcnt];
	wallnum = wall[thewall[z]].nextwall1;
	sectnum = thesector[z];
	z1 = sector[wall[thewall[z]].nextsector1].ceilingz;
	if (sector[sectnum].ceilingz > z1)
		z1 = sector[sectnum].ceilingz;
	z2 = sector[wall[thewall[z]].nextsector1].floorz;
	if (sector[sectnum].floorz < z2)
		z2 = sector[sectnum].floorz;

	llin = mulscale(llinum[z],(long)wall[wallnum].xrepeat,7);
	rlin = mulscale(rlinum[z],(long)wall[wallnum].xrepeat,7);
	if ((wall[wallnum].cstat&8) > 0)
	{
		llin = (wall[wallnum].xrepeat<<9)-llin;
		rlin = (wall[wallnum].xrepeat<<9)-rlin;
	}
	top = 0; topinc = mulscale(rlin-llin,yb1[z],8);
	bot = (xb2[z]-xb1[z]+1)*yb2[z]; botinc = yb1[z]-yb2[z];

	y1 = (2097152*64)/yb1[z];
	if (y1 > 16777216) y1 = 16777216;
	y2 = (2097152*64)/yb2[z];
	if (y2 > 16777216) y2 = 16777216;
	hplc = y1;
	uuplc = (YDIM<<15)+(y1>>8)*(z1-posz);
	ddplc = (YDIM<<15)+(y1>>8)*(z2-posz);
	hinc = (y2-y1)/(xb2[z]-xb1[z]+1);
	uuinc = (((z1-posz)*hinc)>>8);
	ddinc = (((z2-posz)*hinc)>>8);

	top >>= 1;
	bot >>= 1;
	for(x=xb1[z];x<=xb2[z];x+=2)
	{
		if (bot != 0) lwall[x] = llin + divscale(top,bot,8);
		top += topinc, bot += botinc;
	}
	for(x=xb1[z]+1;x<xb2[z];x+=2)
		lwall[x] = ((lwall[x-1]+lwall[x+1])>>1);

	lwall[xb2[z]] = rlin;

	qinterpolate((long)(&uwall[xb1[z]]),xb2[z]-xb1[z],uuplc,uuinc);
	qinterpolate((long)(&dwall[xb1[z]]),xb2[z]-xb1[z],ddplc,ddinc);
	qinterpolate((long)(&swall[xb1[z]]),xb2[z]-xb1[z],hplc,hinc);

	globalyrepeat = wall[wallnum].yrepeat;
	globalorientation = wall[wallnum].cstat;
	globalpicnum = wall[wallnum].picnum;
	globalpanning = wall[wallnum].panning;
	if ((picanm[globalpicnum]&192) != 0)
		globalpicnum += animateoffs(globalpicnum);
	globalshade = wall[wallnum].shade;
	globalshiftval = (picsiz[globalpicnum]>>4);
	if ((1<<globalshiftval) != tilesizy[globalpicnum]) globalshiftval++;
	if ((globalorientation&4) == 0)
		globalzd = (((posz-sector[sectnum].ceilingz)*globalyrepeat)<<(21-globalshiftval));
	else
		globalzd = (((posz-sector[sectnum].floorz)*globalyrepeat)<<(21-globalshiftval));

	if (neartagwall == -1)
	{
		if (wall[wallnum].tag > 0)
			if ((xb1[z] <= (XDIM>>1)) && (xb2[z] >= (XDIM>>1)))
				if (swall[XDIM>>1] >= 131072)
					neartagwall = wallnum;
	}

	for(x=xb1[z];x<=xb2[z];x++)
	{
		um = startumost[x];
		dm = startdmost[x];

		das = 0;
		while ((swall[x] < labs(sdist[x][das])) && (das < scnt[x]))
		{
			if (sdist[x][das] > 0)
			{
				if (splc[x][das] > um) um = splc[x][das];
			}
			else
			{
				if (splc[x][das] <= dm) dm = splc[x][das]-1;
			}
			das++;
		}
		umost[x] = um;
		dmost[x] = dm;
	}

	if (searchit >= 1)
		if ((searchx >= xb1[z]) && (searchx <= xb2[z]))
			if ((searchy >= umost[searchx]) && (searchy <= dmost[searchx]))
				if ((searchy >= (uwall[searchx]>>16)) && (searchy <= (dwall[searchx]>>16)))
				{
					searchsector = sectnum;
					searchwall = wallnum;
					searchstat = 4;  //maskwall
					searchit = 1;
				}

	maskwallscan(xb1[z],xb2[z]);
}


drawfacesprite (long xp, long yp, short spritenum)
{
	char *ptr;
	unsigned char dat, cstat;
	signed short shade;
	short um, dm, das, linum, tilenum, sectnum;
	long xb, yb, siz, xsiz, ysiz, totsiz, testsiz, yspan, k;
	long x1, y1, x2, y2, lx, rx, x, y, secty1, secty2;
	long yplc, yinc, p, pinc, tileoffs, bufplc;

	tilenum = sprite[spritenum].picnum;
	if ((picanm[tilenum]&192) != 0)
		tilenum += animateoffs(tilenum);

	if ((yp <= 4) || (tilesizx[tilenum] <= 0) || (tilesizy[tilenum] <= 0))
		return(0);

	sectnum = sprite[spritenum].sectnum;
	cstat = sprite[spritenum].cstat;

	xb = (XDIM>>1) + ((xp*(XDIM>>1))/yp);
	siz = (131072 / yp);
	testsiz = (siz<<10);
	yspan = tilesizy[tilenum];

	xsiz = ((siz * sprite[spritenum].xrepeat * tilesizx[tilenum])>>12);
	ysiz = ((siz * sprite[spritenum].yrepeat * tilesizy[tilenum])>>12);
	totsiz = tilesizx[tilenum]*tilesizy[tilenum];

	yb = (sprite[spritenum].z-posz)-((yspan*sprite[spritenum].yrepeat)<<1);
	yb = (YDIM>>1) + ((siz*yb)>>14);
	x1 = xb-(xsiz>>1); x2 = x1+xsiz;
	y1 = yb-(ysiz>>1); y2 = y1+ysiz;

	if ((x2 < 0) || (x1 >= XDIM) || (x1 == x2) || (y1 == y2))
		return(0);

	lx = x1; if (lx < 0) lx = 0;
	rx = x2; if (rx >= XDIM) rx = XDIM-1;

	shade = (yp>>(visibility-4))+sprite[spritenum].shade+6;
	if ((sector[sprite[spritenum].sectnum].ceilingstat&1) > 0)
		shade += ((signed short)sector[sprite[spritenum].sectnum].ceilingshade);
	else
		shade += ((signed short)sector[sprite[spritenum].sectnum].floorshade);
	if (shade < 0) shade = 0;
	if (shade >= NUMPALOOKUPS) shade = NUMPALOOKUPS-1;

	tileoffs = waloff[tilenum];

	yinc = ((yspan-1)*4096) / (y2-y1);

	if ((sector[sectnum].ceilingstat&1) == 0)
		secty1 = (YDIM>>1)+((testsiz*(((sector[sectnum].ceilingz-posz)>>8)))>>16);
	else
		secty1 = 0;
	secty2 = (YDIM>>1)+((testsiz*(((sector[sectnum].floorz-posz)>>8)))>>16);

	if (option[0] == 0)
		pinc = 80;
	else
		pinc = 320;

	if (searchit >= 1)
		if ((searchx >= x1) && (searchx <= x2))
			if ((searchy >= y1) && (searchy <= y2))
			{
				um = y1; if (startumost[searchx] > um) um = startumost[searchx];
				dm = y2; if (startdmost[searchx] <= dm) dm = startdmost[searchx]-1;
				if (um < secty1) um = secty1;
				if (dm > secty2) dm = secty2;
				das = 0;
				while ((testsiz < labs(sdist[searchx][das])) && (das < scnt[searchx]))
				{
					if (sdist[searchx][das] > 0)
					{
						if (splc[searchx][das] > um) um = splc[searchx][das];
					}
					else
					{
						if (splc[searchx][das] <= dm) dm = splc[searchx][das]-1;
					}
					das++;
				}
				if ((searchy >= um) && (searchy <= dm))
				{
					searchsector = sectnum;
					searchwall = spritenum;
					searchstat = 3;  //facesprite
					searchit = 1;
				}
			}

	if (neartagsprite == -1)
	{
		if (sprite[spritenum].tag > 0)
			if ((lx <= (XDIM>>1)) && (rx >= (XDIM>>1)))
				if (testsiz >= 131072)
					neartagsprite = spritenum;
	}

	for(x=lx;x<=rx;x++)
	{
		um = y1; if (startumost[x] > um) um = startumost[x];
		dm = y2; if (startdmost[x] <= dm) dm = startdmost[x]-1;
		if (um < secty1) um = secty1;
		if (dm > secty2) dm = secty2;
		das = 0;
		while ((testsiz < labs(sdist[x][das])) && (das < scnt[x]))
		{
			if (sdist[x][das] > 0)
			{
				if (splc[x][das] > um) um = splc[x][das];
			}
			else
			{
				if (splc[x][das] <= dm) dm = splc[x][das]-1;
			}
			das++;
		}

		if (um < 0) um = 0;
		if (dm >= YDIM) dm = YDIM-1;
		if (um < dm)
		{
			if ((cstat&4) == 0)
				linum = ((x-x1)*(totsiz-1)) / (x2-x1);
			else
				linum = ((x2-x)*(totsiz-1)) / (x2-x1);

			linum -= (linum%tilesizy[tilenum]);
			bufplc = tileoffs+linum;

			yplc = ((um-y1)*(yspan-1)*4096) / (y2-y1);
			if (option[0] == 0)
			{
				p = um*80+(x>>2)+0xa0000+(((long)page)<<14);
				outpw(0x3c4,2+(256<<(x&3)));
			}
			else
				p = um*320 + x+frameplace;
			for(y=um;y<=dm;y++)
			{
				ptr = (char *)(bufplc+(yplc>>12));
				dat = *ptr;
				if (dat != 255)
					drawpixel(p,(long)palookup[shade][dat]);
				p += pinc;
				yplc += yinc;
			}
		}
	}
	return(0);
}

overwritesprite (long thex, long they, short tilenum, char shade, char orientation)
{
	char *ptr;
	unsigned char dat, drawmode;
	long xsiz, ysiz, x, y, x1, y1, x2, y2, p, pinc, tileoffs, bufplc;
	long x1temp, y1temp, x2temp, y2temp;

	if (option[0] == 0)
		pinc = 80;
	else
		pinc = 320;

	drawmode = 0;
	if (shade >= NUMPALOOKUPS) drawmode = 1;
	shade &= (NUMPALOOKUPS-1);

	tileoffs = waloff[tilenum];
	xsiz = tilesizx[tilenum];
	ysiz = tilesizy[tilenum];

	if ((orientation&1) == 0)
	{
		x1 = thex, y1 = they;
	}
	else
	{
		x1 = thex - (xsiz>>1), y1 = they - (ysiz>>1);
	}
	x2 = x1 + xsiz;
	y2 = y1 + ysiz;
	if ((x2 < 0) || (x1 >= XDIM) || (y2 < 0) || (y1 >= YDIM))
		return(0);

	x1temp = x1;
	x2temp = x2;
	if (x1temp < 0) x1temp = 0;
	if (x2temp > XDIM) x2temp = XDIM;

	for(x=x1temp;x<x2temp;x++)
	{
		ptr = (char *)(tileoffs+((x-x1)*ysiz));
		y1temp = y1;
		y2temp = y2;

		if (y1temp < startumost[x])
		{
			ptr += (startumost[x]-y1temp);
			y1temp = startumost[x];
		}
		if (y2temp > startdmost[x])
			y2temp = startdmost[x];

		if (option[0] == 0)
		{
			p = y1temp*80+(x>>2)+0xa0000+(((long)page)<<14);
			outpw(0x3c4,2+(256<<(x&3)));
		}
		else
			p = y1temp*320 + x+frameplace;

		if  (drawmode == 0)
		{
			for(y=y1temp;y<y2temp;y++)
			{
				dat = *ptr;
				if (dat != 255)
					drawpixel(p,(long)palookup[shade][dat]);
				p += pinc;
				ptr++;
			}
		}
		else
		{                          //Fake transluscence
			for(y=y1temp;y<y2temp;y++)
			{
				dat = *ptr;
				if (dat != 255)
					drawpixel(p,(long)palookup[dat>>3][getpixel(p)]);
				p += pinc;
				ptr++;
			}
		}
	}

	return(0);
}

permanentwritesprite (long thex, long they, short tilenum, char shade)
{
	char *ptr;
	unsigned char dat, drawmode;
	long xsiz, ysiz, x, y, x1, y1, x2, y2, p, pinc, tileoffs, bufplc;
	long dapage, danumpages;

	if (option[0] == 0)
		pinc = 80;
	else
		pinc = 320;

	drawmode = 0;
	if (shade >= NUMPALOOKUPS) drawmode = 1;
	shade &= (NUMPALOOKUPS-1);

	tileoffs = waloff[tilenum];
	xsiz = tilesizx[tilenum];
	ysiz = tilesizy[tilenum];

	x1 = thex;
	y1 = they;
	x2 = x1 + xsiz;
	y2 = y1 + ysiz;
	if ((x2 < 0) || (x1 >= XDIM) || (y2 < 0) || (y1 >= YDIM))
		return(0);

	danumpages = 3;
	if (option[0] == 1)
		danumpages = 1;

	for (dapage=0;dapage<danumpages;dapage++)
	{
		for(x=x1;x<x2;x++)
			if((x >= 0) && (x < XDIM))
			{
				ptr = (char *)(tileoffs+((x-x1)*ysiz));
				if (y1 < 0) ptr -= y1, y1 = 0;
				if (y2 > YDIM) y2 = YDIM;

				if (option[0] == 0)
				{
					p = y1*80+(x>>2)+0xa0000+(((long)dapage)<<14);
					outpw(0x3c4,2+(256<<(x&3)));
				}
				else
				{
					p = y1*320 + x+frameplace;
					if (option[0] == 2)
						outp(0x3cd,dapage+(dapage<<4));
					if (option[0] == 3)
						outp(0x3ce,0x9), outp(0x3cf,dapage<<4);
					if (option[0] == 4)
						outp(0x3d4,0x35), outp(0x3d5,dapage);
				}

				if (drawmode == 0)
				{
					for(y=y1;y<y2;y++)
					{
						dat = *ptr;
						if (dat != 255)
							drawpixel(p,(long)palookup[shade][dat]);
						p += pinc;
						ptr++;
					}
				}
				else
				{
					for(y=y1;y<y2;y++)
					{
						dat = *ptr;
						if (dat != 255)
							drawpixel(p,(long)palookup[dat>>3][getpixel(p)]);
						p += pinc;
						ptr++;
					}
				}
			}
	}
	if (option[0] == 2)
		outp(0x3cd,page+(page<<4));
	if (option[0] == 3)
		outp(0x3ce,0x9), outp(0x3cf,page<<4);
	if (option[0] == 4)
		outp(0x3d4,0x35), outp(0x3d5,page);

	return(0);
}

grouvline (long xscr, long d1, long d2, short sectnum)
{
	char *ptr;
	signed char shade;
	short dir[2], index;
	long dist[2], dinc[2], incr[2], p, pinc, cosval, sinval, lastdist;
	long grid[2], tempx, tempy, x1, y1, x2, y2, stx, sty, cnt, dend, temp;
	long tilebufoffs, heibufoffs, zoffs, they, um, dm, y, zx, dat, col;

	d1 >>= 6;
	d2 >>= 6;
	if ((d1 <= 0) || (d2 <= 0) || (umost[xscr] >= dmost[xscr]))
		return(0);
	d1 = (65536 * 2048) / d1;
	d2 = (65536 * 2048) / d2;
	d1++;
	d2--;
	if ((d2 <= d1) || (d1 <= 0) || (d2 <= 0))
		return(0);

	if (option[0] == 0)
	{
		p = (dmost[xscr]-1)*80+(xscr>>2)+0xa0000+(((long)page)<<14);
		outpw(0x3c4,2+(256<<(xscr&3)));
		pinc = 80;
	}
	else
	{
		p = (dmost[xscr]-1)*320+xscr+frameplace;
		pinc = 320;
	}

	cosval = sintable[(ang+2560)&2047];
	sinval = sintable[(ang+2048)&2047];
	tempx = (d1>>2); tempy = (d1*(xscr-(XDIM>>1))) / (XDIM<<1);
	x1 = (posx<<6) + ((tempx*cosval - tempy*sinval)>>12);
	y1 = (posy<<6) + ((tempy*cosval + tempx*sinval)>>12);
	tempx = (d2>>2); tempy = (d2*(xscr-(XDIM>>1))) / (XDIM<<1);
	x2 = (posx<<6) + ((tempx*cosval - tempy*sinval)>>12);
	y2 = (posy<<6) + ((tempy*cosval + tempx*sinval)>>12);

	incr[0] = ((tempx*cosval - tempy*sinval)>>12);
	incr[1] = ((tempy*cosval + tempx*sinval)>>12);

	if (incr[0] > 0)
		dir[0] = 1;
	else if (incr[0] < 0)
		dir[0] = -1, incr[0] = -incr[0];
	else
		dir[0] = 0;

	if (incr[1] > 0)
		dir[1] = 1;
	else if (incr[1] < 0)
		dir[1] = -1, incr[1] = -incr[1];
	else
		dir[1] = 0;

	stx = (x1&0xfffffc00); if (dir[0] == 1) stx += 1024;
	sty = (y1&0xfffffc00); if (dir[1] == 1) sty += 1024;
	cnt = ((labs(stx-x1)*incr[1] - labs(sty-y1)*incr[0])>>10);
	grid[0] = ((x1>>10)&63);
	grid[1] = ((y1>>10)&63);

	if ((labs(d2)>>16) < labs(x2-(posx<<6)))
	{
		dinc[0] = divscale(d2,labs(x2-(posx<<6)),16);
		dist[0] = mulscale(dinc[0],labs(stx-(posx<<6)),10);
	}
	if ((labs(d2)>>16) < labs(y2-(posy<<6)))
	{
		dinc[1] = divscale(d2,labs(y2-(posy<<6)),16);
		dist[1] = mulscale(dinc[1],labs(sty-(posy<<6)),10);
	}
	if (dinc[0] < 8) dinc[0] = 8;
	if (dinc[1] < 8) dinc[1] = 8;
	if (dist[0] < 1) dist[0] = 1;
	if (dist[1] < 1) dist[1] = 1;

	shade = (d1>>(visibility+2))+sector[sectnum].floorshade;
	if (shade < 0) shade = 0;
	if (shade >= NUMPALOOKUPS) shade = NUMPALOOKUPS-1;

	dend = (d2<<6);
	um = umost[xscr] - (YDIM>>1);
	dm = dmost[xscr] - (YDIM>>1);
	temp = incr[0]; incr[0] = incr[1]; incr[1] = temp;
	incr[1] = -incr[1];

	tilebufoffs = waloff[sector[sectnum].floorpicnum];
	heibufoffs = waloff[sector[sectnum].floorheinum];
	zoffs = sector[sectnum].floorz - posz;

	index = (cnt >= 0);
	lastdist = dist[index];
	while (dist[index] < dend)
	{
		dat = groudat(grid[0],grid[1],heibufoffs);
		y = divscale(zoffs-(dat<<8),dist[index],15);
		if (y < 0) goto restisabove;
		if (y <= dm)
		{
			col = palookup[shade][groudat(grid[0],grid[1],tilebufoffs)];
			if (y < um) goto finishgroudraw;
			p = drawslab(p,dm-y+1,col,pinc);
			dm = y-1;
		}
		grid[index] = ((grid[index]+dir[index])&63);
		lastdist = dist[index];
		dist[index] += dinc[index];
		cnt += incr[index];
		index = (cnt >= 0);
	}
	goto endgroudraw;

	while (dist[index] < dend)
	{
		dat = groudat(grid[0],grid[1],heibufoffs);
restisabove:
		y = divscale(zoffs-(dat<<8),lastdist,15);

		if (y <= dm)
		{
			col = palookup[shade][groudat(grid[0],grid[1],tilebufoffs)];
			if (y < um) goto finishgroudraw;
			p = drawslab(p,dm-y+1,col,pinc);
			dm = y-1;
		}
		grid[index] = ((grid[index]+dir[index])&63);
		lastdist = dist[index];
		dist[index] += dinc[index];
		cnt += incr[index];
		index = (cnt >= 0);
	}
	goto endgroudraw;

finishgroudraw:
	if (um <= dm)
	{
		p = drawslab(p,dm-um+1,col,pinc);
		dm = um-1;
	}

endgroudraw:
	dmost[xscr] = dm + (YDIM>>1);
	return(0);
}

playposcapt(char filename[20])
{
	long i, fil, framenumber;

	resettiming();
	if ((fil = open(filename,O_BINARY|O_RDWR,S_IREAD)) == -1)
		return(-1);
	read(fil,&framenumber,4);
	while ((framenumber > 0) && ((keystatus[0x1c]|keystatus[0x9c]|keystatus[1]|keystatus[0x39]) == 0))
	{
		read(fil,&posx,4);
		read(fil,&posy,4);
		read(fil,&posz,4);
		read(fil,&ang,2);

		drawrooms();
		drawmasks();
		nextpage();

		framenumber--;
	}
	close(fil);
	return(0);
}

initsb(char sndspeed)
{
	if (option[1] == 0)
		return(0);

	if (sndseg == -1)
	{
		if ((sndseg = convallocate(65536>>4)) == -1)
			return(-1);
		sndoffs = (((long)sndseg)<<4);

		if ((sndoffs&32768) == 0)
		{
			sndrightaddr = sndoffs;
			sndwrongaddr = sndoffs+32768;
		}
		else
		{
			sndrightaddr = sndoffs+32768;
			sndwrongaddr = sndoffs;
		}
		sndptr = (char *)sndwrongaddr;
	}

	sndportaddr = 0x220+(((short)option[1]-1)<<4);
	resetsb();
	sbwait(); outp(sndportaddr+0xc,0xd1);
	sbwait(); outp(sndportaddr+0xc,0x40);
	sbwait(); outp(sndportaddr+0xc,sndspeed);
	sndleng = 1;
	sndlastfil[0] = 0;
	return(0);
}

uninitsb()
{
	if (option[1] == 0)
		return(0);

	resetsb();
	if (sndseg != -1)
	{
		convdeallocate(sndseg);
		sndseg = -1;
	}
	return(0);
}

wsay(char filename[80], short volume)
{
	long i, sndfil;

	if (option[1] == 0)
		return(0);

	if (volume >= 0)
	{
		if (strchr(filename,'.') == 0)
			strcat(filename,".wav");

		i = 0;
		while ((sndlastfil[i] == filename[i]) && (filename[i] != 0))
			i++;

		if (sndlastfil[i] != filename[i])
		{
			for(i=0;i<13;i++)
				sndlastfil[i] = filename[i];

			if ((sndfil = open(filename, O_BINARY, S_IREAD)) == -1)
				return(-1);
			lseek(sndfil,44,SEEK_SET);
			sndleng = read(sndfil,sndptr,32768);
			close(sndfil);
		}
	}
	else
	{
		sndlastfil[0] = 0;
	}

	outp(0xa,0x5);

	if ((volume == 255) || (volume < 0))
		copybuf(sndwrongaddr,sndrightaddr,(sndleng+3)>>2);
	else
	{
		for(i=0;i<256;i++)
			sndvolumetable[i] = (char)((((i-128)*(volume+1))>>8)+128);
		sndvolumeadjust(sndleng,(long)(&sndvolumetable[0]),sndwrongaddr,sndrightaddr);
	}

	outp(0xc,0);
	outp(0xb,0x49);
	outp(0x2,(char)(sndrightaddr&255)); outp(0x2,(char)((sndrightaddr>>8)&255));
	outp(0x3,(char)(sndleng-1)&255); outp(0x3,(char)((sndleng-1)>>8)&255);
	outp(0x83,(char)((sndrightaddr>>16)&255));
	outp(0xa,0x1);
	sbwait(); outp(sndportaddr+0xc,0x14);
	sbwait(); outp(sndportaddr+0xc,(char)(sndleng-1)&255);
	sbwait(); outp(sndportaddr+0xc,(char)((sndleng-1)>>8)&255);
	return(0);
}

mergewall (short x1, short x2, short sectnum, short locking)
{
	short z, zx, z1, z2, secondsect, secondlock;

	z1 = 0;
	while ((edgex[z1+1]&16383) < x1)
		z1++;
	z2 = z1;
	while ((edgex[z2+1]&16383) < x2)
		z2++;

	secondsect = edgesect[z2];
	secondlock = (edgex[z2]&16384);

	if (z2 > z1)
	{
		for (z=z2;z>z1;z--)
		{
			if ((edgex[z]&16384) == 0)
			{
				if ((edgex[z-1]&16384) != 0)
				{
					edgesect[z] = sectnum;
					edgex[z] += 16384;
				}
				else
				{
					edgecnt--;
					for(zx=z;zx<edgecnt;zx++)              //delete z
					{
						edgex[zx] = edgex[zx+1];
						edgesect[zx] = edgesect[zx+1];
					}
					z2--;
				}
			}
		}
	}

	if ((edgex[z1]&16384) == 0)
	{
		for(z=edgecnt;z>z1+1;z--)          //insert z1+1
		{
			edgex[z] = edgex[z-1];
			edgesect[z] = edgesect[z-1];
		}
		edgecnt++;
		z2++;
		edgex[z1+1] = x1+locking;
		edgesect[z1+1] = sectnum;
	}
	if ((edgex[z2]&16384) == 0)
	{
		for(z=edgecnt;z>z2+1;z--)          //insert z2+1
		{
			edgex[z] = edgex[z-1];
			edgesect[z] = edgesect[z-1];
		}
		edgecnt++;
		edgex[z2+1] = x2+secondlock;
		edgesect[z2+1] = secondsect;
	}
	return(0);
}

loadmusic(filename)
char filename[80];
{
	char buffer[256], instbuf[11];
	int infile, i, j;

	if (option[2] == 0)
		return(0);

	if (firstime == 1)
	{
		if((infile=open("insts.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		{
			printf("I cannot load insts.dat!");
			exit(0);
		}
		for(i=0;i<256;i++)
		{
			read(infile,&buffer[0],33);
			for(j=0;j<11;j++)
				inst[i][j] = buffer[j+20];
		}
		close(infile);
		numchans = 9;
		outdata(0L,0x1L,32L);  //clear test stuff
		outdata(0L,0x4L,0L);   //reset
		outdata(0L,0x8L,0L);   //2-operator synthesis
		firstime = 0;
	}
	if ((strstr(filename,".KSM") == 0) && (strstr(filename,".ksm") == 0))
		strcat(filename,".KSM");
	if((infile=open(filename,O_BINARY|O_RDONLY,S_IREAD))==-1)
	{
		printf("I cannot load %s.",filename);
		exit(0);
	}
	read(infile,&trinst[0],16);
	read(infile,&trquant[0],16);
	read(infile,&trchan[0],16);
	read(infile,&trprio[0],16);
	read(infile,&trvol[0],16);
	read(infile,&numnotes,2);
	read(infile,&note[0],numnotes<<2);
	close(infile);
	if (trchan[11] == 0)
	{
		drumstat = 0;
		numchans = 9;
		outdata(0L,0xbdL,(long)drumstat);
	}
	if (trchan[11] == 1)
	{
		for(i=0;i<11;i++)
			instbuf[i] = inst[trinst[11]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[11])^63);
		setinst((char)0,6,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		for(i=0;i<5;i++)
			instbuf[i] = inst[trinst[12]][i];
		for(i=5;i<11;i++)
			instbuf[i] = inst[trinst[15]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[12])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[15])^63);
		setinst((char)0,7,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		for(i=0;i<5;i++)
			instbuf[i] = inst[trinst[14]][i];
		for(i=5;i<11;i++)
			instbuf[i] = inst[trinst[13]][i];
		instbuf[1] = ((instbuf[1]&192)|(trvol[14])^63);
		instbuf[6] = ((instbuf[6]&192)|(trvol[13])^63);
		setinst((char)0,8,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		drumstat = 32;
		numchans = 6;
		outdata(0L,0xbdL,(long)drumstat);
	}
	return(0);
}

musicon()
{
	char ch;
	unsigned int num;
	int i, j, k, offs;
	unsigned char instbuf[11];
	unsigned long templong;

	if (option[2] == 0)
		return(0);

	for(i=0;i<numchans;i++)
	{
		chantrack[i] = 0;
		chanage[i] = 0;
	}
	j = 0;
	for(i=0;i<16;i++)
		if ((trchan[i] > 0) && (j < numchans))
		{
			k = trchan[i];
			while ((j < numchans) && (k > 0))
			{
				chantrack[j] = i;
				k--;
				j++;
			}
		}
	for(i=0;i<numchans;i++)
	{
		for(j=0;j<11;j++)
			instbuf[j] = inst[trinst[chantrack[i]]][j];
		instbuf[1] = ((instbuf[1]&192)|(63-trvol[chantrack[i]]));
		setinst((char)0,i,instbuf[0],instbuf[1],instbuf[2],instbuf[3],instbuf[4],instbuf[5],instbuf[6],instbuf[7],instbuf[8],instbuf[9],instbuf[10]);
		chanfreq[i] = 0;
	}
	k = 0;
	musicstatus = 0;
	templong = note[0];
	adlibcount = (templong>>12)-1;
	countstop = (templong>>12)-1;
	nownote = 0;
	musicstatus = 1;
	return(0);
}

musicoff()
{
	int i;

	if (option[2] == 0)
		return(0);

	for(i=0;i<numchans;i++)
	{
		outdata(0L,0xa0L+(long)i,0L);
		outdata(0L,0xb0L+(long)i,0L);
	}
	musicstatus = 0;
	return(0);
}

setinst(synth,chan,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10)
int chan;
unsigned char synth,v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10;
{
	int offs;

	outdata((long)synth,0xa0L+(long)chan,0L);
	outdata((long)synth,0xb0L+(long)chan,0L);
	outdata((long)synth,0xc0L+(long)chan,(long)v10);
	offs = adlibchanoffs[chan];
	outdata((long)synth,0x20L+(long)offs,(long)v5);
	outdata((long)synth,0x40L+(long)offs,(long)v6);
	outdata((long)synth,0x60L+(long)offs,(long)v7);
	outdata((long)synth,0x80L+(long)offs,(long)v8);
	outdata((long)synth,0xe0L+(long)offs,(long)v9);
	offs+=3;
	outdata((long)synth,0x20L+(long)offs,(long)v0);
	outdata((long)synth,0x40L+(long)offs,(long)v1);
	outdata((long)synth,0x60L+(long)offs,(long)v2);
	outdata((long)synth,0x80L+(long)offs,(long)v3);
	outdata((long)synth,0xe0L+(long)offs,(long)v4);
}

setsprite(short spritenum, long newx, long newy, long newz)
{
	short bad, j, dasectnum;

	dasectnum = sprite[spritenum].sectnum;

	sprite[spritenum].x = newx;
	sprite[spritenum].y = newy;
	sprite[spritenum].z = newz;

	if (inside(newx,newy,dasectnum) == 1)
		return(1);

	for(j=0;j<numsectors;j++)
		if (inside(newx,newy,j) == 1)
		{
			changespritesect(spritenum,j);
			return(1);
		}

	return(-1);
}


movesprite(short spritenum, long xchange, long ychange, long zchange, long walldist)
{
	long daz, templong;
	short good, dasectnum;

	dasectnum = sprite[spritenum].sectnum;

	daz = sprite[spritenum].z;
	daz -= ((tilesizy[sprite[spritenum].picnum]*sprite[spritenum].yrepeat)<<1);
	good = clipmove(&sprite[spritenum].x,&sprite[spritenum].y,&daz,&dasectnum,((xchange*lockspeed)<<11),((ychange*lockspeed)<<11),walldist);
	if ((dasectnum != sprite[spritenum].sectnum) && (dasectnum >= 0))
		changespritesect(spritenum,dasectnum);

	daz = sprite[spritenum].z + ((zchange*lockspeed)>>3);
	if ((daz > sector[dasectnum].ceilingz) && (daz <= sector[dasectnum].floorz))
		sprite[spritenum].z = daz;
	else
		return(0);

	return(good);
}

animateoffs(short tilenum)
{
	long k, offs;

	offs = 0;
	if ((picanm[tilenum]&63) > 0)
	{
		switch(picanm[tilenum]&192)
		{
			case 64:
				k = (numframes%((picanm[tilenum]&63)<<1));
				if (k < (picanm[tilenum]&63))
					offs = k;
				else
					offs = (((picanm[tilenum]&63)<<1)-k);
				break;
			case 128:
				offs = (numframes%((picanm[tilenum]&63)+1));
					break;
			case 192:
				offs = -(numframes%((picanm[tilenum]&63)+1));
		}
	}
	return(offs);
}

/*intersect (long x1l1, long y1l1, long x2l1, long y2l1, short l)
{
	short value;
	long x1l2, y1l2, x2l2, y2l2, templong1, templong2;

	x1l2 = wall[l].x;
	y1l2 = wall[l].y;
	x2l2 = wall[wall[l].point2].x;
	y2l2 = wall[wall[l].point2].y;

	value = 0;

	if ((x1l1 < x2l1) == (x2l1 < x2l1))
		if ((x1l1 < x2l2) == (x2l1 < x2l2))
			if ((x1l1 < x2l1) == (x1l1 < x2l2))
				if ((y1l1 < y2l1) == (y2l1 < y2l1))
					if ((y1l1 < y2l2) == (y2l1 < y2l2))
						if ((y1l1 < y2l1) == (y1l1 < y2l2))
							value = -1;

	if (value == 0)
	{
		templong1 = (x1l2-x1l1)*(y2l1-y1l1) - (x2l1-x1l1)*(y1l2-y1l1);  //p1(l2) vs. l1
		templong2 = (x2l2-x1l1)*(y2l1-y1l1) - (x2l1-x1l1)*(y2l2-y1l1);  //p2(l2) vs. l1
		if ((templong1 < 0) == (templong2 < 0)) value = -1;
		if ((templong1 == 0) || (templong2 == 0)) value = 0;
	}

	if (value == 0)
	{
		templong1 = (x1l1-x1l2)*(y2l2-y1l2) - (x2l2-x1l2)*(y1l1-y1l2);  //p1(l1) vs. l2
		templong2 = (x2l1-x1l2)*(y2l2-y1l2) - (x2l2-x1l2)*(y2l1-y1l2);  //p2(l1) vs. l2
		if ((templong1 < 0) == (templong2 < 0)) value = -1;
		if ((templong1 == 0) || (templong2 == 0)) value = 0;
	}

	if (value >= 0)
	{
		templong2 = (x2l1-x1l2)*(y2l2-y1l2) - (x2l2-x1l2) * (y2l1-y1l2);  //p2(l1) vs. l2
		if (templong2 >= 0)
		{
			value = 1;  //if l is wall of build board then 1 means you hit front
							//of wall, else 2 is back
							// -1 means the lines didn't intersect
		}
		else
		{
			value = 2;
		}
	}

	return(value);
}

intersectpoint (long x1, long y1, short daang, short l,
					long *intersectx, long *intersecty)
{
	long x3, y3, x4, y4, xp1, xp2, ratio;

	if (l < 4096)
	{
		x3 = wall[l].x;
		y3 = wall[l].y;
		x4 = wall[wall[l].point2].x;
		y4 = wall[wall[l].point2].y;

		xp1 = (((y3-y1)*sintable[(daang+512)&2047] - (x3-x1)*sintable[(daang+0)&2047])>>14);
		xp2 = (((y4-y1)*sintable[(daang+512)&2047] - (x4-x1)*sintable[(daang+0)&2047])>>14);

		if (xp1 == xp2)
		{
			*intersectx = x3;
			*intersecty = y3;
		}
		else
		{
			ratio = divscale(xp1,xp1-xp2,12);
			*intersectx = (((4096-ratio)*x3 + ratio*x4)>>12);
			*intersecty = (((4096-ratio)*y3 + ratio*y4)>>12);
		}
	}
	else
	{
		x3 = sprite[l&4095].x;
		y3 = sprite[l&4095].y;
		xp1 = (((y3-y1)*sintable[(daang+512)&2047] - (x3-x1)*sintable[(daang+0)&2047])>>14);
		*intersectx = x3 + ((xp1*sintable[daang&2047])>>14);
		*intersecty = y3 - ((xp1*sintable[(512+daang)&2047])>>14);
	}
} */

initspritelists()
{
	long i;

	for (i=0;i<MAXSECTORS;i++)     //Init doubly-linked sprite sector lists
		headspritesect[i] = -1;
	headspritesect[MAXSECTORS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevspritesect[i] = i-1;
		nextspritesect[i] = i+1;
		sprite[i].sectnum = MAXSECTORS;
	}
	prevspritesect[0] = -1;
	nextspritesect[MAXSPRITES-1] = -1;


	for(i=0;i<MAXSTATUS;i++)      //Init doubly-linked sprite status lists
		headspritestat[i] = -1;
	headspritestat[MAXSTATUS] = 0;
	for(i=0;i<MAXSPRITES;i++)
	{
		prevspritestat[i] = i-1;
		nextspritestat[i] = i+1;
		sprite[i].statnum = MAXSTATUS;
	}
	prevspritestat[0] = -1;
	nextspritestat[MAXSPRITES-1] = -1;
}

insertsprite(short sectnum, short statnum)
{
	insertspritestat(statnum);
	return(insertspritesect(sectnum));
}

insertspritesect(short sectnum)
{
	short blanktouse;

	if ((sectnum >= MAXSECTORS) || (headspritesect[MAXSECTORS] == -1))
		return(-1);  //list full

	blanktouse = headspritesect[MAXSECTORS];

	headspritesect[MAXSECTORS] = nextspritesect[blanktouse];
	if (headspritesect[MAXSECTORS] >= 0)
		prevspritesect[headspritesect[MAXSECTORS]] = -1;

	prevspritesect[blanktouse] = -1;
	nextspritesect[blanktouse] = headspritesect[sectnum];
	if (headspritesect[sectnum] >= 0)
		prevspritesect[headspritesect[sectnum]] = blanktouse;
	headspritesect[sectnum] = blanktouse;

	sprite[blanktouse].sectnum = sectnum;

	return(blanktouse);
}

insertspritestat(short statnum)
{
	short blanktouse;

	if ((statnum >= MAXSTATUS) || (headspritestat[MAXSTATUS] == -1))
		return(-1);  //list full

	blanktouse = headspritestat[MAXSTATUS];

	headspritestat[MAXSTATUS] = nextspritestat[blanktouse];
	if (headspritestat[MAXSTATUS] >= 0)
		prevspritestat[headspritestat[MAXSTATUS]] = -1;

	prevspritestat[blanktouse] = -1;
	nextspritestat[blanktouse] = headspritestat[statnum];
	if (headspritestat[statnum] >= 0)
		prevspritestat[headspritestat[statnum]] = blanktouse;
	headspritestat[statnum] = blanktouse;

	sprite[blanktouse].statnum = statnum;

	return(blanktouse);
}

deletesprite(short spritenum)
{
	deletespritestat(spritenum);
	return(deletespritesect(spritenum));
}

deletespritesect(short deleteme)
{
	if (sprite[deleteme].sectnum == MAXSECTORS)
		return(-1);

	if (headspritesect[sprite[deleteme].sectnum] == deleteme)
		headspritesect[sprite[deleteme].sectnum] = nextspritesect[deleteme];

	if (prevspritesect[deleteme] >= 0) nextspritesect[prevspritesect[deleteme]] = nextspritesect[deleteme];
	if (nextspritesect[deleteme] >= 0) prevspritesect[nextspritesect[deleteme]] = prevspritesect[deleteme];

	if (headspritesect[MAXSECTORS] >= 0) prevspritesect[headspritesect[MAXSECTORS]] = deleteme;
	prevspritesect[deleteme] = -1;
	nextspritesect[deleteme] = headspritesect[MAXSECTORS];
	headspritesect[MAXSECTORS] = deleteme;

	sprite[deleteme].sectnum = MAXSECTORS;
	return(0);
}

deletespritestat (short deleteme)
{
	if (sprite[deleteme].statnum == MAXSTATUS)
		return(-1);

	if (headspritestat[sprite[deleteme].statnum] == deleteme)
		headspritestat[sprite[deleteme].statnum] = nextspritestat[deleteme];

	if (prevspritestat[deleteme] >= 0) nextspritestat[prevspritestat[deleteme]] = nextspritestat[deleteme];
	if (nextspritestat[deleteme] >= 0) prevspritestat[nextspritestat[deleteme]] = prevspritestat[deleteme];

	if (headspritestat[MAXSTATUS] >= 0) prevspritestat[headspritestat[MAXSTATUS]] = deleteme;
	prevspritestat[deleteme] = -1;
	nextspritestat[deleteme] = headspritestat[MAXSTATUS];
	headspritestat[MAXSTATUS] = deleteme;

	sprite[deleteme].statnum = MAXSTATUS;
	return(0);
}

changespritesect(short spritenum, short newsectnum)
{
	if ((newsectnum < 0) || (newsectnum > MAXSECTORS)) return(-1);
	if (sprite[spritenum].sectnum == newsectnum) return(-1);
	if (sprite[spritenum].sectnum == MAXSECTORS) return(-1);
	if (deletespritesect(spritenum) < 0) return(-1);
	insertspritesect(newsectnum);
	return(0);
}

changespritestat(short spritenum, short newstatnum)
{
	if ((newstatnum < 0) || (newstatnum > MAXSTATUS)) return(-1);
	if (sprite[spritenum].statnum == newstatnum) return(-1);
	if (sprite[spritenum].statnum == MAXSTATUS) return(-1);
	if (deletespritestat(spritenum) < 0) return(-1);
	insertspritestat(newstatnum);
	return(0);
}

getanimationgoal(long animptr)
{
	long i, j;

	j = -1;
	for(i=0;i<animatecnt;i++)
		if (animptr == animateptr[i])
		{
			j = i;
			break;
		}
	return(j);
}

setanimation(long *animptr, long thegoal, long thevel)
{
	long i, j;

	if (animatecnt >= MAXANIMATES-1)
		return(-1);

	j = animatecnt;
	for(i=0;i<animatecnt;i++)
		if (animptr == animateptr[i])
		{
			j = i;
			break;
		}

	animateptr[j] = animptr;
	animategoal[j] = thegoal;
	animatevel[j] = thevel;
	if (j == animatecnt)
		animatecnt++;
	return(animatecnt-1);
}

nextsectorneighborz(short sectnum, long thez, short topbottom, short direction)
{
	long testz, nextz;
	short i, startwall, endwall, sectortouse;

	if (direction == 1)
		nextz = 0x7fffffff;
	else
		nextz = 0x80000000;

	sectortouse = -1;

	startwall = sector[sectnum].wallptr;
	endwall = startwall + sector[sectnum].wallnum - 1;
	for(i=startwall;i<=endwall;i++)
		if (wall[i].nextsector1 >= 0)
		{
			if (topbottom == 1)
			{
				testz = sector[wall[i].nextsector1].floorz;
				if (direction == 1)
				{
					if ((testz > thez) && (testz < nextz))
					{
						nextz = testz;
						sectortouse = wall[i].nextsector1;
					}
				}
				else
				{
					if ((testz < thez) && (testz > nextz))
					{
						nextz = testz;
						sectortouse = wall[i].nextsector1;
					}
				}
			}
			else
			{
				testz = sector[wall[i].nextsector1].ceilingz;
				if (direction == 1)
				{
					if ((testz > thez) && (testz < nextz))
					{
						nextz = testz;
						sectortouse = wall[i].nextsector1;
					}
				}
				else
				{
					if ((testz < thez) && (testz > nextz))
					{
						nextz = testz;
						sectortouse = wall[i].nextsector1;
					}
				}
			}
		}

	return(sectortouse);
}

comon()
{
	long divisor;
	short *ptr;

	inbufplc = 0;
	inbufend = 0;
	outbufplc = 0;
	outbufend = 0;

	if ((comnum < 1) || (comnum > 4)) return(-1);
	comvect = 0xb+(comnum&1);
	ptr = (short *)(0x400L+(long)((comnum-1)<<1));
	comport = (long)(*ptr);
	if (comport == 0) return(-1);
	if ((comspeed <= 0) || (comspeed > 115200)) return(-1);

	  // Baud-Setting,?,?,Parity O/E,Parity Off/On, Stop-1/2,Bits-5/6/7/8
	  // 0x0b is odd parity,1 stop bit, 8 bits

	_disable();

	outp(comport+3,0x80);                  //enable latch registers
	divisor = 115200 / comspeed;
	outp(comport+0,divisor&255);           //# = 115200 / bps
	outp(comport+1,divisor>>8);
	outp(comport+3,0x03);                  //0x03 = n,8,1

	oldcomhandler = _dos_getvect(comvect);
	_dos_setvect(comvect, comhandler);

	outp(comport+4,0x0b);             //setup for interrupts (modem control)
	outp(comport+1,0);                //com interrupt disable
	outp(0x21,inp(0x21)&(255-(1<<(comvect&7))));          //Unmask vector
	mstat = inp(comport+6);
	lstat = inp(comport+5);
	inp(comport+0);
	inp(comport+2);
	outp(comport+1,0x03);             //com interrupt enable
	outp(0x20,0x20);

	_enable();

	return(0);
}

comoff()
{
	while ((outbufplc != outbufend) && (keystatus[0x1c] == 0));

	_disable();
	outp(0x21,inp(0x21)|(1<<(comvect&7)));          //Mask vector
	outp(comport+1,0);
	outp(comport+4,0);
	_dos_setvect(comvect, oldcomhandler);
	_enable();
}

comsend(long dat, long numbytes)
{
	long i;

	i = 0;
	while (numbytes > 0)
	{
		outbuf[outbufend] = (char)((dat>>i)&255);
		outbufend = ((outbufend+1)&(COMBUFSIZ-1));

		numbytes--;
		i += 8;
	}
	if ((inp(comport+5)&0x20) > 0)
	{
		if (outbufplc != outbufend)
		{
			outp(comport,outbuf[outbufplc]);
			outbufplc = ((outbufplc+1)&(COMBUFSIZ-1));
		}
	}

	/*i = 0;
	while (numbytes > 0)           //Enable for COM Testing mode.
	{
		inbuf[inbufend] = (char)((dat>>i)&255);
		inbufend = ((inbufend+1)&(COMBUFSIZ-1));

		numbytes--;
		i += 8;
	}*/

	return(0);
}

comgetchar()
{
	short i;

	i = -1;
	if (inbufplc != inbufend)
	{
		i = (short)inbuf[inbufplc];
		inbufplc = ((inbufplc+1)&(COMBUFSIZ-1));
	}
	return(i);
}

void __interrupt __far comhandler(void)
{
	while (1)
	{
		 switch(inp(comport+2)&7)
		 {
			 case 0:
				 mstat = inp(comport+6);
				 keystatus[1] = 1;
				 break;
			 case 2:
				 if (outbufplc != outbufend)
				 {
					 outp(comport,outbuf[outbufplc]);
					 outbufplc = ((outbufplc+1)&(COMBUFSIZ-1));
				 }
				 break;
			 case 4:
				 inbuf[inbufend] = inp(comport);
				 inbufend = ((inbufend+1)&(COMBUFSIZ-1));
				 break;
			 case 6:
				 lstat = inp(comport+5);
				 keystatus[1] = 1;
				 break;
			 default:
				 outp(0x20, 0x20);
				 return;
		}
	}
	outp(0x20,0x20);
}

void __interrupt __far zerohandler(void)
{
	long i;

	setvmode(0x3);
	for(i=0;i<4000;i+=4)
	{
		drawpixel(0xb8000+i,'/');
		drawpixel(0xb8000+i+2,'0');
	}
	exit(0);
}

lopassfilter()
{
	long z;

	for(z=0;z<sndbytelen;z++)
		sndcomp[z] = sndorig[z];
	for(z=2;z<sndbytelen-2;z++)
		sndorig[z] = (sndcomp[z-1] + sndcomp[z]*3 + sndcomp[z+1])/5;
}

record()
{
	long i, j;

	outp(0x43,0x94);  //Initializes timer (IMPORTANT for this POLLING method)
	outp(97,inp(97)|1);
	outp(0x42,216);

	sndbytelen = 0;
	portwait(0x42,128L,0L);
	portwait(0x42,128L,255L);
	while ((sndbytelen < MAXSNDLEN) && (keystatus[0x1c] != 0))
	{
		portwait(0x42,128L,0L);
		outp(0x22c,0x20);
		portwait(0x42,128L,255L);
		sndorig[sndbytelen++] = inp(0x22a);
	}
	lopassfilter();
	adpcmencode();

	comsend(254L,1L);
	comsend(sndbytelen,4L);
	comsend(sndbitlen,4L);
	comsend((long)astart0,1L);
	comsend((long)astart1,1L);
	comsend((long)astart2,1L);
	j = ((sndbitlen+7)>>3);
	for(i=0;i<j;i++)
		comsend((long)sndcomp[i],1L);
}

adpcmencode()
{
	long z, pred, dat, scale, a0, a1, a2;

	for(z=0;z<sndbytelen;z++)
		sndcomp[z] = 0;
	sndbitlen = 0;
	astart0 = sndorig[0]; astart1 = sndorig[1]; astart2 = sndorig[1];
	a0 = astart0; a1 = astart1; a2 = astart2;
	scale = 2;
	for(z=3;z<sndbytelen;z++)
	{
		pred = a2 + (((a2-a1) + ((a2-a1) - (a1-a0)))>>1);
		if (pred < 0) pred = 0;
		if (pred > 255) pred = 255;
		dat = (sndorig[z] - pred) / scale;
		if (dat > ADPCMMAX) dat = ADPCMMAX;
		if (dat < ADPCMMIN) dat = ADPCMMIN;
		a0 = a1; a1 = a2; a2 = pred + dat * scale;
		huffputbits((long)(dat-ADPCMMIN));
		if ((dat == ADPCMMIN) || (dat == ADPCMMAX)) scale <<= 1;
		if ((dat == 0) && (scale > 2)) scale >>= 1;
	}
}

adpcmdecode()
{
	long z, pred, dat, scale, a0, a1, a2;

	sndbitlen = 0;
	sndorig[0] = astart0; sndorig[1] = astart1; sndorig[2] = astart2; scale = 2;
	for(z=3;z<sndbytelen;z++)
	{
		dat = huffgetbits();
		dat += ADPCMMIN;
		a0 = sndorig[z-3]; a1 = sndorig[z-2]; a2 = sndorig[z-1];
		pred = a2 + (((a2-a1) + ((a2-a1) - (a1-a0)))>>1);
		if (pred < 0) pred = 0;
		if (pred > 255) pred = 255;
		sndorig[z] = pred + dat * scale;
		if ((dat == ADPCMMIN) || (dat == ADPCMMAX)) scale <<= 1;
		if ((dat == 0) && (scale > 2)) scale >>= 1;
	}
}

huffgetbits()
{
	long i, j, dat;

	dat = (long)sndcomp[sndbitlen>>3]+((long)sndcomp[(sndbitlen>>3)+1]<<8);
	dat >>= (sndbitlen&7);
	for(i=0;i<8;i++)
	{
		if ((dat&((1<<hufflen[i])-1)) == ((long)huffval[i]))
		{
			j = i;
			break;
		}
	}

	sndbitlen += hufflen[j];
	return(j);
}

playback()
{
	char *ptr;
	short dat;
	long i, j;

	i = 0;
	while (i < 11)
	{
		if ((dat = comgetchar()) >= 0)
		{
			if (i == 0) sndbytelen = (long)dat;
			if (i == 1) sndbytelen += ((long)dat<<8);
			if (i == 2) sndbytelen += ((long)dat<<16);
			if (i == 3) sndbytelen += ((long)dat<<24);
			if (i == 4) sndbitlen = (long)dat;
			if (i == 5) sndbitlen += ((long)dat<<8);
			if (i == 6) sndbitlen += ((long)dat<<16);
			if (i == 7) sndbitlen += ((long)dat<<24);
			if (i == 8) astart0 = (char)dat;
			if (i == 9) astart1 = (char)dat;
			if (i == 10) astart2 = (char)dat;
			i++;
		}
	}
	j = ((sndbitlen+7)>>3);
	i = 0;
	while (i < j)
	{
		if ((dat = comgetchar()) >= 0)
		{
			sndcomp[i] = (char)dat;
			i++;
		}
	}

	adpcmdecode();
	lopassfilter();

	ptr = sndptr;
	for(i=0;i<sndbytelen;i++)
	{
		*ptr++ = sndorig[i];
		*ptr++ = ((sndorig[i]+sndorig[i+1])>>1);
	}
	sndleng = (sndbytelen<<1);
	wsay("",-1);                      //Use Special no-load Wsay mode
}

cansee(long xs, long ys, long zs, short sectnums, long xe, long ye, long ze, short sectnume)
{
	long x1, y1, x2, y2, intx, inty, intz;
	short z, zz, tempshortcnt, tempshortnum, dasector, startwall, endwall;
	short nextsector, bad;

	clipsectorlist[0] = sectnums;
	clipsectorlist[1] = sectnume;
	tempshortcnt = 0;
	tempshortnum = 2;
	while (tempshortcnt < tempshortnum)
	{
		dasector = clipsectorlist[tempshortcnt];

		startwall = sector[dasector].wallptr;
		endwall = startwall + sector[dasector].wallnum - 1;
		for(z=startwall;z<=endwall;z++)
		{
			x1 = wall[z].x;
			y1 = wall[z].y;
			x2 = wall[wall[z].point2].x;
			y2 = wall[wall[z].point2].y;
			if (lintersect(xs,ys,zs,xe,ye,ze,x1,y1,x2,y2,&intx,&inty,&intz,0) == 1)
			{
				nextsector = wall[z].nextsector1;
				if (nextsector == -1)
				{
					return(0);
				}
				else
				{
					if (intz <= sector[dasector].ceilingz) return(0);
					if (intz >= sector[dasector].floorz) return(0);
					if (intz <= sector[nextsector].ceilingz) return(0);
					if (intz >= sector[nextsector].floorz) return(0);

					bad = 0;
					for(zz=0;zz<tempshortnum;zz++)
						if (clipsectorlist[zz] == nextsector)
						{
							bad = 1;
							break;
						}
					if (bad == 0)
						clipsectorlist[tempshortnum++] = nextsector;
				}
			}
		}

		tempshortcnt++;
	}
	return(1);
}

hitscan(long xs, long ys, long zs, short sectnum, long vx, long vy, long vz,
	short *hitsect, short *hitwall, short *hitsprite, long *hitx, long *hity, long *hitz)
{
	long z, zz, xe, ye, ze, x1, y1, z1, x2, y2, z2, intx, inty, intz;
	long topt, topu, bot, daxsiz, daysiz, dist, offx, offy;
	short tempshortcnt, tempshortnum, dasector, startwall, endwall;
	short nextsector, bad;

	if (sectnum == -1) return(-1);
	xe = xs+vx;
	ye = ys+vy;
	ze = zs+vz;
	*hitsect = -1;
	clipsectorlist[0] = sectnum;
	tempshortcnt = 0;
	tempshortnum = 1;
	while (tempshortcnt < tempshortnum)
	{
		dasector = clipsectorlist[tempshortcnt];

		startwall = sector[dasector].wallptr;
		endwall = startwall + sector[dasector].wallnum - 1;
		for(z=startwall;z<=endwall;z++)
		{
			x1 = wall[z].x;
			y1 = wall[z].y;
			x2 = wall[wall[z].point2].x;
			y2 = wall[wall[z].point2].y;
			if (lintersect(xs,ys,zs,xe,ye,ze,x1,y1,x2,y2,&intx,&inty,&intz,1) == 1)
			{
				nextsector = wall[z].nextsector1;

				bad = 0;
				if (vz != 0)
					if ((intz <= sector[dasector].ceilingz) || (intz >= sector[dasector].floorz))
						if ((*hitsect == -1) || (labs(intx-xs)+labs(inty-ys) < labs(*hitx-xs)+labs(*hity-ys)))
							{
								*hitsect = dasector;
								*hitwall = -1;
								*hitsprite = -1;
								if (vz > 0)
									*hitz = sector[dasector].floorz;
								else
									*hitz = sector[dasector].ceilingz;
								*hitx = xs + (vx*(*hitz-zs)) / vz;
								*hity = ys + (vy*(*hitz-zs)) / vz;
								bad = 1;
							}

				if (bad == 0)
				{
					if (nextsector == -1)
					{
						if ((*hitsect == -1) || (labs(intx-xs)+labs(inty-ys) < labs(*hitx-xs)+labs(*hity-ys)))
						{
							*hitsect = dasector;
							*hitwall = z;
							*hitsprite = -1;
							*hitx = intx;
							*hity = inty;
							*hitz = intz;
						}
					}
					else
					{
						if ((intz <= sector[nextsector].ceilingz) || (intz >= sector[nextsector].floorz))
							if ((*hitsect == -1) || (labs(intx-xs)+labs(inty-ys) < labs(*hitx-xs)+labs(*hity-ys)))
							{
								*hitsect = dasector;
								*hitwall = z;
								*hitsprite = -1;
								*hitx = intx;
								*hity = inty;
								*hitz = intz;
								bad = 1;
							}

						if (bad == 0)
						{
							for (zz=0;zz<tempshortnum;zz++)
								if (clipsectorlist[zz] == nextsector)
								{
									bad = 1;
									break;
								}

							if (bad == 0)
								clipsectorlist[tempshortnum++] = nextsector;
						}
					}
				}
			}
		}

		z = headspritesect[dasector];
		while (z != -1)
		{
			if ((sprite[z].cstat&1) > 0)
			{
				x1 = sprite[z].x;
				y1 = sprite[z].y;
				z1 = sprite[z].z;

				topt = vx*(x1-xs) + vy*(y1-ys);
				if (topt > 0)
				{
					bot = vx*vx + vy*vy;
					if (bot != 0)
					{
						intz = zs+scale(vz,topt,bot);
						daysiz = (tilesizy[sprite[z].picnum]*sprite[z].yrepeat);
						if ((intz <= z1) && (intz >= z1-((daysiz<<8)>>6)))
						{
							topu = vx*(y1-ys) - vy*(x1-xs);

							offx = scale(vx,topu,bot);
							offy = scale(vy,topu,bot);
							dist = offx*offx + offy*offy;
							daxsiz = (tilesizx[sprite[z].picnum]*sprite[z].xrepeat);
							daxsiz *= daxsiz;
							if (dist <= (daxsiz>>7))
							{
								intx = xs + scale(vx,topt,bot);
								inty = ys + scale(vy,topt,bot);

								if ((*hitsect == -1) || (labs(intx-xs)+labs(inty-ys) < labs(*hitx-xs)+labs(*hity-ys)))
								{
									*hitsect = dasector;
									*hitwall = -1;
									*hitsprite = z;
									*hitx = intx;
									*hity = inty;
									*hitz = intz;
								}
							}
						}
					}
				}
			}

			z = nextspritesect[z];
		}

		tempshortcnt++;
	}
	return(0);
}

lintersect(long x1, long y1, long z1, long x2, long y2, long z2, long x3,
			  long y3, long x4, long y4, long *intx, long *inty, long *intz,
			  short datype)
{
	long templong1, templong2, bot, topt;
	short intersect;

	//if datype == 0 then p1 to p2 is a line segment
	//if datype == 1 then p1 towards p2 is a ray

	if (datype == 0)
	{
		if ((x1 < x3) && (x1 < x4) && (x2 < x3) && (x2 < x4)) return(0);
		if ((x1 > x3) && (x1 > x4) && (x2 > x3) && (x2 > x4)) return(0);
		if ((y1 < y3) && (y1 < y4) && (y2 < y3) && (y2 < y4)) return(0);
		if ((y1 > y3) && (y1 > y4) && (y2 > y3) && (y2 > y4)) return(0);
	}

	intersect = 0;
	templong1 = (x3-x1)*(y2-y1) - (y3-y1)*(x2-x1);
	templong2 = (x4-x1)*(y2-y1) - (y4-y1)*(x2-x1);
	if (((templong1<=0) && (templong2>=0)) || ((templong1>=0) && (templong2<=0)))
	{
		templong1 = (x1-x3)*(y4-y3) - (y1-y3)*(x4-x3);
		templong2 = (x2-x3)*(y4-y3) - (y2-y3)*(x4-x3);
		if (((templong1<=0) && (templong2>=0)) || ((templong1>=0) && (templong2<=0)))
			intersect = 1;
		if (datype == 1)
			if (labs(templong2) < labs(templong1))
				intersect = 1;
	}

	if (intersect == 1)
	{
		bot = (x2-x1)*(y3-y4) - (x3-x4)*(y2-y1);
		topt = (x3-x1)*(y3-y4) - (x3-x4)*(y3-y1);
		//topu = (x2-x1)*(y3-y1) - (x3-x1)*(y2-y1);

		if (bot == 0)
		{
			*intx = x1;                    //If parallel
			*inty = y1;
			*intz = z1;
		}
		else
		{
			*intx = x1 + scale(x2-x1,topt,bot);
			*inty = y1 + scale(y2-y1,topt,bot);
			*intz = z1 + scale(z2-z1,topt,bot);
		}
		return(1);
	}
	return(0);
}

dragpoint(short pointhighlight, long dax, long day)
{
	short cnt, tempshort;

	wall[pointhighlight].x = dax;
	wall[pointhighlight].y = day;

	cnt = MAXWALLS;
	tempshort = pointhighlight;    //search points CCW
	do
	{
		if (wall[tempshort].nextwall1 >= 0)
		{
			tempshort = wall[wall[tempshort].nextwall1].point2;
			wall[tempshort].x = dax;
			wall[tempshort].y = day;
		}
		else
		{
			tempshort = pointhighlight;    //search points CW if not searched all the way around
			do
			{
				if (wall[lastwall(tempshort)].nextwall1 >= 0)
				{
					tempshort = wall[lastwall(tempshort)].nextwall1;
					wall[tempshort].x = dax;
					wall[tempshort].y = day;
				}
				else
				{
					break;
				}
				cnt--;
			}
			while ((tempshort != pointhighlight) && (cnt > 0));
			break;
		}
		cnt--;
	}
	while ((tempshort != pointhighlight) && (cnt > 0));
}

lastwall(short point)
{
	long cnt, tempshort;

	tempshort = point;
	cnt = MAXWALLS;
	while ((wall[tempshort].point2 != point) && (cnt > 0))
	{
		tempshort = wall[tempshort].point2;
		cnt--;
	}
	if (cnt <= 0)
		tempshort = point;
	return(tempshort);
}

clipmove (long *x, long *y, long *z, short *sectnum, long xvect, long yvect, long walldist)
{
	short hitwall, cnt, bad;
	long i, j, templong1, templong2, dist, slidex, slidey, slidevel;
	long oxvect, oyvect, goalx, goaly, intx, inty, lx, ly;

	if ((xvect|yvect) == 0)
		return(0);

	oxvect = xvect;
	oyvect = yvect;

	goalx = *x + (xvect>>14);
	goaly = *y + (yvect>>14);

	getcliplines(*x, *y, *z, goalx, goaly, *sectnum, walldist);

	hitwall = 0;
	cnt = 3;
	while (((xvect|yvect) != 0) && (hitwall >= 0) && (cnt > 0))
	{
		if ((hitwall = raytrace(*x, *y, xvect, yvect, &intx, &inty)) >= 0)
		{
			if (keepaway(&intx, &inty, hitwall) == 1)
				intx = *x, inty = *y;

			lx = clipx2[hitwall]-clipx1[hitwall];
			ly = clipy2[hitwall]-clipy1[hitwall];
			dist = ksqrt(lx*lx + ly*ly);
			slidex = (lx<<14) / dist;
			slidey = (ly<<14) / dist;
			slidevel = (((goalx-intx)*slidex + (goaly-inty)*slidey)>>7);
			xvect = ((slidex*slidevel)>>7);
			yvect = ((slidey*slidevel)>>7);

			templong1 = lx*(oxvect>>6)+ly*(oyvect>>6);
			for(i=cnt+1;i<=3;i++)
			{
				templong2 = (clipx2[hitwalls[i]]-clipx1[hitwalls[i]])*(oxvect>>6) + (clipy2[hitwalls[i]]-clipy1[hitwalls[i]])*(oyvect>>6);
				if ((templong1<0) != (templong2<0))
				  return(0);
			}

			goalx = intx + (xvect>>14);
			goaly = inty + (yvect>>14);
			keepaway(&goalx, &goaly, hitwall);
			xvect = ((goalx-intx)<<14);
			yvect = ((goaly-inty)<<14);

			hitwalls[cnt] = hitwall;
		}
		cnt--;

		*x = intx;
		*y = inty;
	}

	bad = 1;
	for(j=0;j<clipsectnum;j++)
		if (inside(*x,*y,clipsectorlist[j]) == 1)
		{
			*sectnum = clipsectorlist[j];
			bad = 0;
			break;
		}
	if (bad == 1)
		for(j=0;j<numsectors;j++)
			if (inside(*x,*y,j) == 1)
			{
				*sectnum = j;
				bad = 0;
				break;
			}
	if (bad == 1)
		*sectnum = -1;

	if ((cnt == 2) && (hitwall == -1))
		return(1);
	else
		return(0);
}

getcliplines(long x, long y, long z, long goalx, long goaly, short sectnum, long walldist)
{
	short bad, i, j, k, theclipnum, clipsectcnt, startwall, endwall;
	long x1, y1, x2, y2, cx, cy, rad, xmin, ymin, xmax, ymax;

	clipnum = 0;

	cx = ((x+goalx)>>1);
	cy = ((y+goaly)>>1);
	rad = ksqrt((goalx-x)*(goalx-x) + (goaly-y)*(goaly-y)) + walldist + 8;
	xmin = cx-rad; ymin = cy-rad;
	xmax = cx+rad; ymax = cy+rad;

	clipsectcnt = 0;
	clipsectnum = 0;
	clipsectorlist[clipsectnum++] = sectnum;

	while (clipsectcnt < clipsectnum)
	{
		startwall = sector[clipsectorlist[clipsectcnt]].wallptr;
		endwall = startwall + sector[clipsectorlist[clipsectcnt]].wallnum - 1;
		for(j=startwall;j<=endwall;j++)
		{
			x1 = wall[j].x; y1 = wall[j].y;
			x2 = wall[wall[j].point2].x; y2 = wall[wall[j].point2].y;

			bad = 0;
			if ((x1 < xmin) && (x2 < xmin)) bad = 1;
			if ((x1 > xmax) && (x2 > xmax)) bad = 1;
			if ((y1 < ymin) && (y2 < ymin)) bad = 1;
			if ((y1 > ymax) && (y2 > ymax)) bad = 1;

			if (y2 > y1)
			{
				if (x2 > x1)
				{
					if ((x2-x1)*(ymin-y1) - (xmax-x1)*(y2-y1) >= 0) bad = 1;
				}
				else
				{
					if ((x2-x1)*(ymax-y1) - (xmax-x1)*(y2-y1) >= 0) bad = 1;
				}
			}
			else
			{
				if (x2 > x1)
				{
					if ((x2-x1)*(ymin-y1) - (xmin-x1)*(y2-y1) >= 0) bad = 1;
				}
				else
				{
					if ((x2-x1)*(ymax-y1) - (xmin-x1)*(y2-y1) >= 0) bad = 1;
				}
			}


			if (bad == 0)
			{
				if ((wall[j].nextsector1 == -1) || ((wall[j].cstat&1) > 0))
				{
					if (x2 > x1)
					{
						y1 += walldist, y2 += walldist;
					}
					else
					{
						y1 -= walldist, y2 -= walldist;
					}
					if (y2 > y1)
					{
						x1 -= walldist, x2 -= walldist;
					}
					else
					{
						x1 += walldist, x2 += walldist;
					}

					clipx1[clipnum] = x1; clipy1[clipnum] = y1;
					clipx2[clipnum] = x2; clipy2[clipnum] = y2;
					cliplist[clipnum] = j;
					clipnum++;
				}
				else
				{
					if (((z >= sector[wall[j].nextsector1].floorz-(3<<8)) || ((z <= sector[wall[j].nextsector1].ceilingz+(3<<8))) && ((sector[wall[j].nextsector1].ceilingstat&1) == 0)) && (editstatus == 0))
					{
						if (x2 > x1)
						{
							y1 += walldist, y2 += walldist;
						}
						else
						{
							y1 -= walldist, y2 -= walldist;
						}
						if (y2 > y1)
						{
							x1 -= walldist, x2 -= walldist;
						}
						else
						{
							x1 += walldist, x2 += walldist;
						}

						clipx1[clipnum] = x1; clipy1[clipnum] = y1;
						clipx2[clipnum] = x2; clipy2[clipnum] = y2;
						cliplist[clipnum] = j;
						clipnum++;
					}
					else
					{
						bad = 0;
						for(i=0;i<clipsectnum;i++)
						{
							if (wall[j].nextsector1 == clipsectorlist[i])
							{
								bad = 1;
								break;
							}
						}
						if (bad == 0)
							clipsectorlist[clipsectnum++] = wall[j].nextsector1;
					}
				}
			}
		}
		clipsectcnt++;
	}

	theclipnum = clipnum;

	for(j=0;j<theclipnum;j++)
	{
		k = cliplist[j];
		x1 = wall[k].x; y1 = wall[k].y;
		x2 = wall[wall[k].point2].x; y2 = wall[wall[k].point2].y;

		if (goalx > x)
		{
			clipx1[clipnum] = x1-walldist;
			clipy1[clipnum] = y1-walldist;
			clipx2[clipnum] = x1-walldist;
			clipy2[clipnum] = y1+walldist;
		}
		else
		{
			clipx1[clipnum] = x1+walldist;
			clipy1[clipnum] = y1+walldist;
			clipx2[clipnum] = x1+walldist;
			clipy2[clipnum] = y1-walldist;
		}
		clipnum++;
		if (goaly > y)
		{
			clipx1[clipnum] = x1+walldist;
			clipy1[clipnum] = y1-walldist;
			clipx2[clipnum] = x1-walldist;
			clipy2[clipnum] = y1-walldist;
		}
		else
		{
			clipx1[clipnum] = x1-walldist;
			clipy1[clipnum] = y1+walldist;
			clipx2[clipnum] = x1+walldist;
			clipy2[clipnum] = y1+walldist;
		}
		clipnum++;

		if (goalx > x)
		{
			clipx1[clipnum] = x2-walldist;
			clipy1[clipnum] = y2-walldist;
			clipx2[clipnum] = x2-walldist;
			clipy2[clipnum] = y2+walldist;
		}
		else
		{
			clipx1[clipnum] = x2+walldist;
			clipy1[clipnum] = y2+walldist;
			clipx2[clipnum] = x2+walldist;
			clipy2[clipnum] = y2-walldist;
		}
		clipnum++;
		if (goaly > y)
		{
			clipx1[clipnum] = x2+walldist;
			clipy1[clipnum] = y2-walldist;
			clipx2[clipnum] = x2-walldist;
			clipy2[clipnum] = y2-walldist;
		}
		else
		{
			clipx1[clipnum] = x2-walldist;
			clipy1[clipnum] = y2+walldist;
			clipx2[clipnum] = x2+walldist;
			clipy2[clipnum] = y2+walldist;
		}
		clipnum++;
	}

	for(i=0;i<clipsectnum;i++)
	{
		j = headspritesect[clipsectorlist[i]];
		while (j != -1)
		{
			if ((sprite[j].cstat&1) > 0)
				if ((sprite[j].x >= xmin-rad) && (sprite[j].x <= xmax+rad))
					if ((sprite[j].y >= ymin-rad) && (sprite[j].y <= ymax+rad))
					{
						x1 = sprite[j].x; y1 = sprite[j].y;

						if (goalx > x)
						{
							clipx1[clipnum] = x1-(walldist<<1);
							clipy1[clipnum] = y1-(walldist<<1);
							clipx2[clipnum] = x1-(walldist<<1);
							clipy2[clipnum] = y1+(walldist<<1);
						}
						else
						{
							clipx1[clipnum] = x1+(walldist<<1);
							clipy1[clipnum] = y1+(walldist<<1);
							clipx2[clipnum] = x1+(walldist<<1);
							clipy2[clipnum] = y1-(walldist<<1);
						}
						clipnum++;
						if (goaly > y)
						{
							clipx1[clipnum] = x1+(walldist<<1);
							clipy1[clipnum] = y1-(walldist<<1);
							clipx2[clipnum] = x1-(walldist<<1);
							clipy2[clipnum] = y1-(walldist<<1);
						}
						else
						{
							clipx1[clipnum] = x1-(walldist<<1);
							clipy1[clipnum] = y1+(walldist<<1);
							clipx2[clipnum] = x1+(walldist<<1);
							clipy2[clipnum] = y1+(walldist<<1);
						}
						clipnum++;
					}
			j = nextspritesect[j];
		}
	}

	if ((x != posx) || (y != posy))
	{
		x1 = posx; y1 = posy;

		if (goalx > x)
		{
			clipx1[clipnum] = x1-(walldist<<1);
			clipy1[clipnum] = y1-(walldist<<1);
			clipx2[clipnum] = x1-(walldist<<1);
			clipy2[clipnum] = y1+(walldist<<1);
		}
		else
		{
			clipx1[clipnum] = x1+(walldist<<1);
			clipy1[clipnum] = y1+(walldist<<1);
			clipx2[clipnum] = x1+(walldist<<1);
			clipy2[clipnum] = y1-(walldist<<1);
		}
		clipnum++;
		if (goaly > y)
		{
			clipx1[clipnum] = x1+(walldist<<1);
			clipy1[clipnum] = y1-(walldist<<1);
			clipx2[clipnum] = x1-(walldist<<1);
			clipy2[clipnum] = y1-(walldist<<1);
		}
		else
		{
			clipx1[clipnum] = x1-(walldist<<1);
			clipy1[clipnum] = y1+(walldist<<1);
			clipx2[clipnum] = x1+(walldist<<1);
			clipy2[clipnum] = y1+(walldist<<1);
		}
		clipnum++;
	}
}

keepaway (long *x, long *y, short clipwall)
{
	short first, bad, z, zz;
	long bakx, baky, daside;

	bakx = 0; baky = 0;
	if (clipx2[clipwall] > clipx1[clipwall]) baky = 1;
	if (clipx2[clipwall] < clipx1[clipwall]) baky = -1;
	if (clipy2[clipwall] > clipy1[clipwall]) bakx = -1;
	if (clipy2[clipwall] < clipy1[clipwall]) bakx = 1;

	if (labs(clipx2[clipwall]-clipx1[clipwall]) > labs(clipy2[clipwall]-clipy1[clipwall]))
		first = 0;
	else
		first = 1;

	daside = (clipx2[clipwall]-clipx1[clipwall])*(*y-clipy1[clipwall])-(*x-clipx1[clipwall])*(clipy2[clipwall]-clipy1[clipwall]);
	while (daside <= 0)
	{
	  if (first == 0)
		  *x += bakx;
	  else
		  *y += baky;
	  first ^= 1;
	  daside = (clipx2[clipwall]-clipx1[clipwall])*(*y-clipy1[clipwall])-(*x-clipx1[clipwall])*(clipy2[clipwall]-clipy1[clipwall]);
	}

	/*bad = 0;
	z = clipwall+1; if (z >= clipnum) z -= clipnum;
	zz = clipwall+clipnum-1; if (zz >= clipnum) zz -= clipnum;
	if ((clipx1[z] != clipx2[clipwall]) || (clipy1[z] != clipy2[clipwall]))
	{
		daside = (clipx2[z]-clipx1[z])*(*y-clipy1[z])-(*x-clipx1[z])*(clipy2[z]-clipy1[z]);
		if (daside < 0) return(1);
	}
	if ((clipx2[zz] != clipx1[clipwall]) || (clipy2[zz] != clipy1[clipwall]))
	{
		daside = (clipx2[zz]-clipx1[zz])*(*y-clipy1[zz])-(*x-clipx1[zz])*(clipy2[zz]-clipy1[zz]);
		if (daside < 0) return(1);
	}*/
	return(0);
}

raytrace (long x, long y, long xvect, long yvect, long *intx, long *inty)
{
	short z, hitwall;
	long x1, y1, x2, y2, x3, y3, x4, y4, bot, topu, nintx, ninty;
	long templong1, templong2, templong3, templong4;

	x3 = x; y3 = y;
	x4 = x3+(xvect>>14); y4 = y3+(yvect>>14);
	*intx = x4; *inty = y4;
	hitwall = -1;

	for (z=0;z<clipnum;z++)
	{
		x1 = clipx1[z]; y1 = clipy1[z];
		x2 = clipx2[z]; y2 = clipy2[z];

		templong1 = (x2-x1)*(y3-y1) - (x3-x1)*(y2-y1);
		templong2 = (x2-x1)*(y4-y1) - (x4-x1)*(y2-y1);
		if ((templong1 >= 0) && (templong2 < 0))
		{
			templong3 = (x4-x3)*(y1-y3) - (x1-x3)*(y4-y3);
			templong4 = (x4-x3)*(y2-y3) - (x2-x3)*(y4-y3);
			if ((templong3 <= 0) && (templong4 > 0))
			{
				bot = (x2-x1)*(y3-y4) - (x3-x4)*(y2-y1);
				if (bot != 0)
				{
					topu = (x2-x1)*(y3-y1) - (x3-x1)*(y2-y1);
					nintx = x3 + scale(x4-x3,topu,bot);
					ninty = y3 + scale(y4-y3,topu,bot);
					if (labs(x3-nintx)+labs(y3-ninty) < labs(x3 - *intx)+labs(y3 - *inty))
					{
						*intx = nintx;
						*inty = ninty;
						hitwall = z;
					}
				}
			}
		}
	}

	return(hitwall);
}
