#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXTILES 4096
#define XDIM 320
#define YDIM 200

static char palette[768];
static short sintable[2048], radarang[320];
static long tantable[1024];

char picsiz[MAXTILES];
long artversion;
static char *pic;
short tilesizx[MAXTILES], tilesizy[MAXTILES];
long numtiles, picanm[MAXTILES], waloff[MAXTILES];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

main()
{
	char *ptr;
	short ang;
	long x, y, p, startx, picnume, fil, i;

	setvmode(0x13);
	loadtables();
	loadpics("tiles.art");
	if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		outp(0x3c8,0);
		for(i=0;i<768;i++)
			outp(0x3c9,palette[i]);
		close(fil);
	}

	picnume = 122;
	ang = 0;
	while (kbhit() == 0)
	{
		for(x=0;x<XDIM;x++)
		{
			startx = ((radarang[x]+2048+ang)&((1<<(picsiz[picnume]&15))-1))*200;
			startx += 100 + waloff[picnume];
			p = 0xa0000 + x;
			for(y=60;y<260;y++)
			{
				ptr = (char *)(radarang[y]+startx);
				drawpixel(p,*ptr);
				p += 320;
			}
		}
		ang++;
	}

	free(pic);
	setvmode(0x3);
}

loadtables()
{
	short fil, i;

	//if (tablesloaded == 0)
	//{
		if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&sintable[0],4096);
			read(fil,&tantable[0],4096);
			read(fil,&radarang[0],640);
			for(i=0;i<320;i++)
				radarang[i] >>= 1;
	//      read(fil,&textfont[0],1024);
	//      read(fil,&option[0],NUMOPTIONS);
			close(fil);
	//      tablesloaded = 1;
		}
	//}
	return(0);
}

loadpics(char filename[20])
{
	long totpicsiz, offscount, siz;
	short int fil, i, j;

	if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	read(fil,&artversion,4);
	if (artversion != 0L) return(-1);
	read(fil,&numtiles,4);
	read(fil,&tilesizx[0],numtiles<<1);
	read(fil,&tilesizy[0],numtiles<<1);
	read(fil,&picanm[0],numtiles<<2);

	for(i=numtiles;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i]))
			j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i]))
			j--;
		picsiz[i] += ((char)(j<<4));
	}

	totpicsiz = 0L;
	for(i=0;i<numtiles;i++)
		totpicsiz += (long)(tilesizx[i]*tilesizy[i]);

	pic = (char *)malloc(totpicsiz);
	offscount = 0L;
	for(i=0;i<MAXTILES;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		siz = tilesizx[i]*tilesizy[i];
		if (siz > 0)
		{
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}
