DECLARE FUNCTION getminrank& (dacol%, bestmove&)
DECLARE FUNCTION getmaxrank& (dacol%, bestmove&)
DECLARE SUB copyboard (daboard1%, daboard2%)
DECLARE FUNCTION getabsboardrank& (daboard%)
DECLARE FUNCTION checkboard& (dacol%)
DECLARE SUB getpiecelist (dacol%, daboard%)
DECLARE SUB movepiece (x1%, y1%, x2%, y2%, daboard%)
DECLARE SUB playermove (dacol%)
DECLARE SUB computermove (dacol%)
DECLARE SUB getvalidmoves (x%, y%, daboard%)
DECLARE SUB initboard ()
DECLARE SUB drawboard (daboard%)
DECLARE SUB initchesspictures ()
DECLARE SUB drawchesspicture (dax%, day%, siz&, picnum%)
DECLARE SUB loadnewall (bufplc&, wallnum%)

CONST MAXTILES = 4096 \ 16
CONST NUMRECURSION = 2

SCREEN 13

DIM SHARED board%(NUMRECURSION, 8, 8), recursecnt%
DIM SHARED piecelist%(NUMRECURSION, 16), piecenum%(NUMRECURSION)
DIM SHARED validmove%(NUMRECURSION, 64), validmovecnt%(NUMRECURSION)
DIM SHARED rank&(7)
DIM SHARED c%, d%

DIM SHARED buf%(24576)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)

CALL initchesspictures
CALL initboard

turn% = 0: c% = 4: d% = 4

DO
   CALL drawboard(0): CALL playermove(0)
   CALL drawboard(0): CALL computermove(1)
LOOP WHILE z$ <> CHR$(27)

SUB computermove (dacol%)
   recursecnt% = 0
   bestrank& = getmaxrank&(dacol% + 0, bestmove&)
  
   bestx1% = ((bestmove& \ 16777216) AND 7)
   besty1% = ((bestmove& \ 65536) AND 7)
   bestx2% = ((bestmove& \ 256) AND 7)
   besty2% = (bestmove& AND 7)

   FOR zx% = 0 TO 31
	 LINE (bestx1% * 25 + 72, besty1% * 25 + 12)-(bestx2% * 25 + 72, besty2% * 25 + 12), INT(256 * RND)
	 WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
   NEXT zx%

   CALL movepiece(bestx1%, besty1%, bestx2%, besty2%, 0)
END SUB

SUB copyboard (daboard1%, daboard2%)
   FOR x% = 0 TO 7
	 FOR y% = 0 TO 7
	    board%(daboard2%, x%, y%) = board%(daboard1%, x%, y%)
	 NEXT y%
   NEXT x%
END SUB

SUB drawboard (daboard%)
   FOR x% = 0 TO 7
	 FOR y% = 0 TO 7
	    LINE (x% * 25 + 60, y% * 25)-(x% * 25 + 24 + 60, y% * 25 + 24), ((x% XOR y%) AND 1 XOR 1) * 2 + 12, BF
	    dat% = board%(daboard%, x%, y%)
	    IF dat% > 0 THEN
		  CALL drawchesspicture(x% * 25 + 60 + 12, y% * 25 + 12, 128, dat% - 1)
	    END IF
	 NEXT y%
   NEXT x%
END SUB

SUB drawchesspicture (dax%, day%, siz&, picnum%)
   dapicnum% = picnum%
   dashade% = 0
   IF dapicnum% >= 8 THEN dashade% = -14: dapicnum% = dapicnum% - 8
  
   xdim% = tilesizx%(dapicnum% + 140)
   ydim% = tilesizy%(dapicnum% + 140)
   IF dax% < 0 OR dax% + xdim% > 320 THEN EXIT SUB
   nxdim% = (xdim% * siz&) \ 256
   nydim% = (ydim% * siz&) \ 256
   dax% = dax% - nxdim% \ 2
   day% = day% - nydim% \ 2

   DEF SEG = &HA000
   bufinc& = 65536 \ siz&
   FOR x% = 0 TO nxdim% - 1
	 bufoffs& = ((x% * 256 \ siz&) * ydim% + dapicnum% * 4096) * 256&
	 p& = day% * 320& + (x% + dax%)
	 FOR y% = 0 TO nydim% - 1
	    dat% = buf%(bufoffs& \ 256)
	    IF dat% <> 255 THEN
		  IF (p& OR 65535) = 65535 THEN POKE p&, dat% + dashade%
	    END IF
	    p& = p& + 320: bufoffs& = bufoffs& + bufinc&
	 NEXT y%
   NEXT x%
END SUB

FUNCTION getabsboardrank& (daboard%)
   absrank& = 0
   FOR x% = 0 TO 7
	 FOR y% = 0 TO 7
	    dat% = board%(daboard%, x%, y%)
	    IF dat% > 0 THEN
		  IF dat% < 8 THEN
			absrank& = absrank& - rank&(dat%)
		  ELSE
			absrank& = absrank& + rank&(dat% - 8)
		  END IF
	    END IF
	 NEXT y%
   NEXT x%
   getabsboardrank& = absrank&
END FUNCTION

FUNCTION getmaxrank& (dacol%, bestmove&)
   recursecnt% = recursecnt% + 1

   bestrank& = &H80000000
  
   CALL getpiecelist(dacol%, recursecnt% - 1)
   FOR zz% = piecenum%(recursecnt% - 1) - 1 TO 0 STEP -1
	 zx% = piecelist%(recursecnt% - 1, zz%): x1% = zx% \ 256: y1% = zx% AND 255
	 CALL getvalidmoves(x1%, y1%, recursecnt% - 1)
	 FOR z% = validmovecnt%(recursecnt% - 1) - 1 TO 0 STEP -1
	    zx% = validmove%(recursecnt% - 1, z%): x2% = zx% \ 256: y2% = zx% AND 255
		 
		  'x1,y1,x2,y2 is the next possibility
	    CALL copyboard(recursecnt% - 1, recursecnt%)
	    CALL movepiece(x1%, y1%, x2%, y2%, recursecnt%)
	   
	    darank& = getabsboardrank&(recursecnt%)
	    IF recursecnt% < NUMRECURSION THEN
		  darank& = darank& + getminrank&(1 - dacol%, damove&)
	    END IF
	    
	    IF recursecnt% = 1 THEN
		  LINE (x1% * 25 + 72, y1% * 25 + 12)-(x2% * 25 + 72, y2% * 25 + 12), 16
	    END IF
	   
	    IF darank& > bestrank& THEN
		  bestrank& = darank&
		  x1& = x1%: y1& = y1%: x2& = x2%: y2& = y2%
		  bestmove& = x1& * 16777216 + y1& * 65536 + x2& * 256 + y2&
	    END IF

	 NEXT z%
   NEXT zz%
  
   recursecnt% = recursecnt% - 1
   getmaxrank& = bestrank&
END FUNCTION

FUNCTION getminrank& (dacol%, bestmove&)
   recursecnt% = recursecnt% + 1

   bestrank& = &H7FFFFFFF
 
   CALL getpiecelist(dacol%, recursecnt% - 1)
   FOR zz% = piecenum%(recursecnt% - 1) - 1 TO 0 STEP -1
	 zx% = piecelist%(recursecnt% - 1, zz%): x1% = zx% \ 256: y1% = zx% AND 255
	 CALL getvalidmoves(x1%, y1%, recursecnt% - 1)
	 FOR z% = validmovecnt%(recursecnt% - 1) - 1 TO 0 STEP -1
	    zx% = validmove%(recursecnt% - 1, z%): x2% = zx% \ 256: y2% = zx% AND 255
		 
		  'x1,y1,x2,y2 is the next possibility
	    CALL copyboard(recursecnt% - 1, recursecnt%)
	    CALL movepiece(x1%, y1%, x2%, y2%, recursecnt%)
	  
	    darank& = getabsboardrank&(recursecnt%)
	    IF recursecnt% < NUMRECURSION THEN
		  darank& = darank& + getmaxrank&(1 - dacol%, damove&)
	    END IF
		
	    IF darank& < bestrank& THEN
		  bestrank& = darank&
		  x1& = x1%: y1& = y1%: x2& = x2%: y2& = y2%
		  bestmove& = x1& * 16777216 + y1& * 65536 + x2& * 256 + y2&
	    END IF

	 NEXT z%
   NEXT zz%
 
   recursecnt% = recursecnt% - 1
   getminrank& = bestrank&
END FUNCTION

SUB getpiecelist (dacol%, daboard%)
   piecenum%(daboard%) = 0
   FOR x% = 0 TO 7
	 FOR y% = 0 TO 7
	    dat% = board%(daboard%, x%, y%)
	    IF dat% > 0 THEN
		  z% = dat% \ 8
		  IF z% = dacol% THEN
			piecelist%(daboard%, piecenum%(daboard%)) = x% * 256 + y%
			piecenum%(daboard%) = piecenum%(daboard%) + 1
		  END IF
	    END IF
	 NEXT y%
   NEXT x%
END SUB

SUB getvalidmoves (x%, y%, daboard%)
   validmovecnt%(daboard%) = 0
   piece% = board%(daboard%, x%, y%)
   IF piece% = 0 THEN EXIT SUB
  
   playeroffs% = 0
   IF piece% >= 8 THEN playeroffs% = 8: piece% = piece% - 8

   IF piece% = 1 THEN             'pawn
	 IF playeroffs% >= 8 THEN dir% = 1 ELSE dir% = -1
	
	 IF board%(daboard%, x%, y% + dir%) = 0 THEN
	    validmove%(daboard%, validmovecnt%(daboard%)) = x% * 256 + y% + dir%
	    validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
	    IF (y% = 1 AND dir% > 0) OR (y% = 6 AND dir% < 0) THEN
		  IF board%(daboard%, x%, y% + dir% + dir%) = 0 THEN
			validmove%(daboard%, validmovecnt%(daboard%)) = x% * 256 + (y% + dir% + dir%)
			validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
		  END IF
	    END IF
	 END IF
	 FOR dax% = x% - 1 TO x% + 1 STEP 2
	    IF (dax% OR 7) = 7 THEN
		  IF board%(daboard%, dax%, y% + dir%) > 0 THEN
			IF (board%(daboard%, dax%, y% + dir%) OR 7) = (8 - playeroffs%) + 7 THEN
			   validmove%(daboard%, validmovecnt%(daboard%)) = dax% * 256 + y% + dir%
			   validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
			END IF
		  END IF
	    END IF
	 NEXT dax%
   END IF
  
   IF piece% = 2 THEN              'horse
	 FOR z% = 0 TO 7
	    IF z% = 0 THEN dax% = x% + 2: day% = y% + 1
	    IF z% = 1 THEN dax% = x% - 2: day% = y% + 1
	    IF z% = 2 THEN dax% = x% + 2: day% = y% - 1
	    IF z% = 3 THEN dax% = x% - 2: day% = y% - 1
	    IF z% = 4 THEN dax% = x% + 1: day% = y% + 2
	    IF z% = 5 THEN dax% = x% - 1: day% = y% + 2
	    IF z% = 6 THEN dax% = x% + 1: day% = y% - 2
	    IF z% = 7 THEN dax% = x% - 1: day% = y% - 2
	    IF (dax% OR day% OR 7) = 7 THEN
		  IF board%(daboard%, dax%, day%) = 0 THEN
			validmove%(daboard%, validmovecnt%(daboard%)) = dax% * 256 + day%
			validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
		  ELSEIF (board%(daboard%, dax%, day%) OR 7) <> playeroffs% + 7 THEN
			validmove%(daboard%, validmovecnt%(daboard%)) = dax% * 256 + day%
			validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
		  END IF
	    END IF
	 NEXT z%
   END IF
  
   IF piece% = 3 OR piece% = 5 THEN          'bishop/queen
	 FOR z% = 0 TO 3
	    dax% = x%: day% = y%
	    IF (z% AND 1) = 0 THEN xdir% = 1 ELSE xdir% = -1
	    IF (z% AND 2) = 0 THEN ydir% = 1 ELSE ydir% = -1
	    DO
		  dax% = dax% + xdir%: day% = day% + ydir%
		 
		  IF (dax% OR day% OR 7) <> 7 THEN EXIT DO
		  IF board%(daboard%, dax%, day%) > 0 THEN
			IF (board%(daboard%, dax%, day%) OR 7) = playeroffs% + 7 THEN EXIT DO
		  END IF

		  validmove%(daboard%, validmovecnt%(daboard%)) = dax% * 256 + day%
		  validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
		 
		  IF board%(daboard%, dax%, day%) > 0 THEN
			IF (board%(daboard%, dax%, day%) OR 7) <> playeroffs% + 7 THEN EXIT DO
		  END IF
	    LOOP
	 NEXT z%
   END IF
  
   IF piece% = 4 OR piece% = 5 THEN          'rook/queen
	 FOR z% = 0 TO 3
	    dax% = x%: day% = y%
	    xdir% = 0: ydir% = 0
	    IF z% = 0 THEN xdir% = 1
	    IF z% = 1 THEN xdir% = -1
	    IF z% = 2 THEN ydir% = 1
	    IF z% = 3 THEN ydir% = -1
	    DO
		  dax% = dax% + xdir%: day% = day% + ydir%
		
		  IF (dax% OR day% OR 7) <> 7 THEN EXIT DO
		  IF board%(daboard%, dax%, day%) > 0 THEN
			IF (board%(daboard%, dax%, day%) OR 7) = playeroffs% + 7 THEN EXIT DO
		  END IF

		  validmove%(daboard%, validmovecnt%(daboard%)) = dax% * 256 + day%
		  validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
		 
		  IF board%(daboard%, dax%, day%) > 0 THEN
			IF (board%(daboard%, dax%, day%) OR 7) <> playeroffs% + 7 THEN EXIT DO
		  END IF
	    LOOP
	 NEXT z%
   END IF
  
   IF piece% = 6 THEN                        'king
	 FOR z% = 0 TO 7
	    IF z% = 0 THEN dax% = x% - 1: day% = y% - 1
	    IF z% = 1 THEN dax% = x%: day% = y% - 1
	    IF z% = 2 THEN dax% = x% + 1: day% = y% - 1
	    IF z% = 3 THEN dax% = x% - 1: day% = y%
	    IF z% = 4 THEN dax% = x% + 1: day% = y%
	    IF z% = 5 THEN dax% = x% - 1: day% = y% + 1
	    IF z% = 6 THEN dax% = x%: day% = y% + 1
	    IF z% = 7 THEN dax% = x% + 1: day% = y% + 1
	   
	    IF (dax% OR day% OR 7) = 7 THEN
		  bad% = 0
		  IF board%(daboard%, dax%, day%) > 0 THEN
			IF (board%(daboard%, dax%, day%) OR 7) = playeroffs% + 7 THEN bad% = 1
		  END IF
		  IF bad% = 0 THEN
			validmove%(daboard%, validmovecnt%(daboard%)) = dax% * 256 + day%
			validmovecnt%(daboard%) = validmovecnt%(daboard%) + 1
		  END IF
	    END IF
	 NEXT z%
 
   END IF

END SUB

SUB initboard
   FOR x% = 0 TO 7
	 FOR y% = 0 TO 7
	    board%(0, x%, y%) = 0
	 NEXT y%
   NEXT x%
   board%(0, 0, 0) = 12: board%(0, 1, 0) = 10
   board%(0, 2, 0) = 11: board%(0, 3, 0) = 13
   board%(0, 4, 0) = 14: board%(0, 5, 0) = 11
   board%(0, 6, 0) = 10: board%(0, 7, 0) = 12
   board%(0, 0, 1) = 9: board%(0, 1, 1) = 9
   board%(0, 2, 1) = 9: board%(0, 3, 1) = 9
   board%(0, 4, 1) = 9: board%(0, 5, 1) = 9
   board%(0, 6, 1) = 9: board%(0, 7, 1) = 9
   board%(0, 0, 6) = 1: board%(0, 1, 6) = 1
   board%(0, 2, 6) = 1: board%(0, 3, 6) = 1
   board%(0, 4, 6) = 1: board%(0, 5, 6) = 1
   board%(0, 6, 6) = 1: board%(0, 7, 6) = 1
   board%(0, 0, 7) = 4: board%(0, 1, 7) = 2
   board%(0, 2, 7) = 3: board%(0, 3, 7) = 5
   board%(0, 4, 7) = 6: board%(0, 5, 7) = 3
   board%(0, 6, 7) = 2: board%(0, 7, 7) = 4

    rank&(0) = 0
    rank&(1) = 1       'pawn
    rank&(2) = 3       'horse
    rank&(3) = 3       'bishop
    rank&(4) = 5       'rook
    rank&(5) = 10      'queen
    rank&(6) = 256     'king
END SUB

SUB initchesspictures
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0): GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 0 TO 767
	OUT &H3C9, ASC(MID$(pal$, z% + 1, 1))
   NEXT z%
   CLOSE #1
  
   FOR z% = 0 TO 5
	 CALL loadnewall(z% * 4096, z% + 140)
   NEXT z%
END SUB

SUB loadnewall (bufplc&, wallnum%)
   OPEN "tiles000.art" FOR BINARY AS #1

   SEEK #1, 1
   GET #1, , version&
   GET #1, , numtiles&
   GET #1, , localtilestart&
   GET #1, , localtileend&
   FOR z% = 0 TO localtileend& - localtilestart&
	 GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
	 GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
	 GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
	 dasiz& = tilesizx%(z%): dasiz& = dasiz& * tilesizy%(z%)
	 totsiz& = totsiz& + dasiz&
   NEXT z%
   SEEK #1, totsiz& + 16 + (localtileend& - localtilestart& + 1) * 8 + 1

   buf$ = STRING$(tilesizx%(wallnum%) * tilesizy%(wallnum%), 0): GET #1, , buf$
   DEF SEG = VARSEG(buf$): offs& = SADD(buf$)
   FOR z% = 0 TO tilesizx%(wallnum%) - 1
	 FOR zz% = 0 TO tilesizy%(wallnum%) - 1
	    buf%(bufplc& + z% * tilesizy%(wallnum%) + zz%) = PEEK(offs&)
	    offs& = offs& + 1
	 NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB movepiece (x1%, y1%, x2%, y2%, daboard%)
   oboard% = board%(daboard%, x2%, y2%)
   board%(daboard%, x2%, y2%) = board%(daboard%, x1%, y1%)
   board%(daboard%, x1%, y1%) = 0
   IF (board%(daboard%, x2%, y2%) AND 7) = 1 AND (y2% = 0 OR y2% = 7) THEN
	 board%(daboard%, x2%, y2%) = (board%(daboard%, x2%, y2%) AND 8) + 5
   END IF
  
   IF daboard% = 0 THEN
	 IF (oboard% AND 7) = 6 THEN
	    CALL drawboard(0)
	    LOCATE 12, 15
	    IF oboard% < 8 THEN
		  PRINT "Black wins!";
	    ELSE
		  PRINT "White wins!";
	    END IF
	    END
	 END IF
   END IF
END SUB

SUB playermove (dacol%)
   spaceset% = 0: bakc% = -1: bakd% = -1
   DO
	 LINE (c% * 25 + 60, d% * 25)-(c% * 25 + 24 + 60, d% * 25 + 24), 95, B
	
	 DO
	    z$ = INKEY$
	 LOOP WHILE z$ = ""

	 LINE (c% * 25 + 60, d% * 25)-(c% * 25 + 24 + 60, d% * 25 + 24), ((c% XOR d%) AND 1) * 2 + 12, B
	
	 IF z$ = CHR$(0) + CHR$(75) AND c% > 0 THEN c% = c% - 1
	 IF z$ = CHR$(0) + CHR$(77) AND c% < 7 THEN c% = c% + 1
	 IF z$ = CHR$(0) + CHR$(72) AND d% > 0 THEN d% = d% - 1
	 IF z$ = CHR$(0) + CHR$(80) AND d% < 7 THEN d% = d% + 1

	 IF z$ = " " THEN
	    IF board%(0, c%, d%) > 0 THEN
		  IF (board%(0, c%, d%) OR 7) = dacol% * 8 + 7 THEN
			spaceset% = 1: bakc% = c%: bakd% = d%
		  END IF
	    END IF
	 END IF
	
	 IF z$ = CHR$(13) THEN
	    IF (bakc% OR bakd% OR 7) <> 7 THEN
		  z$ = "": SOUND 60, 1
	    ELSE
		  CALL getvalidmoves(bakc%, bakd%, 0)
		  good% = 0
		  FOR z% = 0 TO validmovecnt%(0) - 1
			IF validmove%(0, z%) = c% * 256 + d% THEN good% = 1: EXIT FOR
		  NEXT z%
		  IF good% = 0 THEN z$ = "": SOUND 60, 1
	    END IF
	 END IF
  
   LOOP WHILE z$ <> CHR$(27) AND (z$ <> CHR$(13) OR spaceset% = 0)

   IF z$ = CHR$(13) THEN CALL movepiece(bakc%, bakd%, c%, d%, 0)
END SUB

