' "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
' Ken Silverman's official web site: "http://www.advsys.net/ken"
' See the included license file "BUILDLIC.TXT" for license info.

DECLARE SUB saveboard (fil$)
DECLARE SUB loadboard (fil$)
CONST maxsector = 1024 \ 4
CONST maxwalls = 4096 \ 4
CONST maxsprites = 4096 \ 4

TYPE sectortype
   wallptr AS INTEGER
   wallnum AS INTEGER
   ceilingstat AS STRING * 1
   ceilingosc AS STRING * 1
   ceilingshade AS STRING * 1
   ceilingz AS LONG
   ceilingpicnum AS INTEGER
   ceilingheinum AS INTEGER
   floorstat AS STRING * 1
   floorosc AS STRING * 1
   floorshade AS STRING * 1
   floorz AS LONG
   floorpicnum AS INTEGER
   floorheinum AS INTEGER
END TYPE

TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
   cstat AS STRING * 1
   shade AS STRING * 1
   xrepeat AS STRING * 1
   yrepeat AS STRING * 1
   picnum AS INTEGER
   nextsector1 AS INTEGER
   nextwall1 AS INTEGER
   nextsector2 AS INTEGER
   nextwall2 AS INTEGER
END TYPE

TYPE spritetype
   x AS LONG
   y AS LONG
   z AS LONG
   x2offs AS INTEGER
   y2offs AS INTEGER
   point2 AS INTEGER
   cstat AS STRING * 1
   shade AS STRING * 1
   xrepeat AS STRING * 1
   yrepeat AS STRING * 1
   picnum AS INTEGER
   ang AS INTEGER
   vel AS INTEGER
   zvel AS INTEGER
   owner AS INTEGER
END TYPE

DIM SHARED sector(maxsector) AS sectortype
DIM SHARED wall(maxwalls) AS walltype
DIM SHARED sprite(maxsprites) AS spritetype
DIM SHARED firstsprite%(maxsector), spritesectnum%(maxsprites)
COMMON SHARED posx&, posy&, posz&, ang%
COMMON SHARED numsectors%, numwalls%, cursectnum%, numsprites%

loadfil$ = "boards.dat": savefil$ = "convbord.dat"

'SHELL "del " + savefil$

CALL loadboard(loadfil$)
'CALL saveboard(savefil$)

CLS
FOR z% = 0 TO numsectors% - 1
   startwall% = sector(z%).wallptr
   endwall% = startwall% + sector(z%).wallnum - 1
   FOR zz% = startwall% TO endwall%
      PRINT zz%; wall(zz%).point2,
   NEXT zz%
   PRINT : PRINT
NEXT z%

SUB loadboard (fil$)
   OPEN fil$ FOR BINARY AS #1
   GET #1, , posx&
   GET #1, , posy&
   GET #1, , posz&
   GET #1, , ang%
   GET #1, , numsectors%
   GET #1, , numwalls%
   GET #1, , numsprites%
   GET #1, , cursectnum%
   FOR z% = 0 TO numsectors% - 1: GET #1, , firstsprite%(z%): NEXT z%
   FOR z% = 0 TO numsprites% - 1: GET #1, , spritesectnum%(z%): NEXT z%
   FOR z% = 0 TO numsectors% - 1: GET #1, , sector(z%): NEXT z%
   FOR z% = 0 TO numwalls% - 1: GET #1, , wall(z%): NEXT z%
   FOR z% = 0 TO numsprites% - 1: GET #1, , sprite(z%): NEXT z%
   CLOSE #1
END SUB

SUB saveboard (fil$)
   OPEN fil$ FOR BINARY AS #1
   PUT #1, , posx&
   PUT #1, , posy&
   PUT #1, , posz&
   PUT #1, , ang%
   PUT #1, , numsectors%
   PUT #1, , numwalls%
   PUT #1, , numsprites%
   PUT #1, , cursectnum%
   FOR z% = 0 TO numsectors% - 1: PUT #1, , firstsprite%(z%): NEXT z%
   FOR z% = 0 TO numsprites% - 1: PUT #1, , spritesectnum%(z%): NEXT z%
   FOR z% = 0 TO numsectors% - 1: PUT #1, , sector(z%): NEXT z%
   FOR z% = 0 TO numwalls% - 1: PUT #1, , wall(z%): NEXT z%
   FOR z% = 0 TO numsprites% - 1: PUT #1, , sprite(z%): NEXT z%
   CLOSE #1
END SUB

