DECLARE SUB loadnewall (bufplc&, wallnum%)
DECLARE SUB setupscreen ()
DECLARE SUB fillpolygon (px&(), py&(), point2%(), numpoints%)
DECLARE SUB hline (x1&, x2&, y&)
DECLARE SUB loadtables ()
DECLARE SUB loadboard (fil$)
DECLARE SUB draw2dboard (dax&, day&, ang%, zoome&)
DECLARE FUNCTION changespritesect% (spritenum%, newsectnum%)
DECLARE FUNCTION changespritestat% (spritenum%, newstatnum%)
DECLARE FUNCTION deletesprite% (spritenum%)
DECLARE FUNCTION deletespritesect% (deleteme%)
DECLARE FUNCTION deletespritestat% (deleteme%)
DECLARE SUB initspritelists ()
DECLARE FUNCTION insertsprite% (sectnum%, statnum%)
DECLARE FUNCTION insertspritesect% (sectnum%)
DECLARE FUNCTION insertspritestat% (statnum%)

CONST MAXSECTORS = 1024 \ 3
CONST MAXWALLS = 4096 \ 3
CONST MAXSPRITES = 4096 \ 3
CONST MAXSTATUS = 1024 \ 3

CONST NUMPALOOKUPS = 32
CONST MAXTILES = 4096

CONST XDIM = 320
CONST YDIM = 200
CONST MAXPOINTS = 1024
CONST MAXPOLYS = 16
CONST MAXBUNCHES = 256

TYPE sectortype
   wallptr AS INTEGER
   wallnum AS INTEGER
   ceilingpicnum AS INTEGER
   floorpicnum AS INTEGER
   ceilingheinum AS INTEGER
   floorheinum AS INTEGER
   ceilingz AS LONG
   floorz AS LONG
   ceilingshade AS STRING * 1
   floorshade AS STRING * 1
   ceilingxpanning AS STRING * 1
   floorxpanning AS STRING * 1
   ceilingypanning AS STRING * 1
   floorypanning AS STRING * 1
   ceilingstat AS STRING * 1
   floorstat AS STRING * 1
   ceilingpal AS STRING * 1
   floorpal AS STRING * 1
   visibility AS STRING * 1
   lotag AS INTEGER
   hitag AS INTEGER
   extra AS INTEGER
END TYPE
    
TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
   nextsector AS INTEGER
   nextwall AS INTEGER
   picnum AS INTEGER
   overpicnum AS INTEGER
   shade AS STRING * 1
   pal AS STRING * 1
   cstat AS INTEGER
   xrepeat AS STRING * 1
   yrepeat AS STRING * 1
   xpanning AS STRING * 1
   ypanning AS STRING * 1
   lotag AS INTEGER
   hitag AS INTEGER
   extra AS INTEGER
END TYPE
    
TYPE spritetype
   x AS LONG
   y AS LONG
   z AS LONG
   cstat AS INTEGER
   shade AS STRING * 1
   pal AS STRING * 1
   clipdist AS STRING * 1
   xrepeat AS STRING * 1
   yrepeat AS STRING * 1
   xoffset AS STRING * 1
   yoffset AS STRING * 1
   picnum AS INTEGER
   ang AS INTEGER
   xvel AS INTEGER
   yvel AS INTEGER
   zvel AS INTEGER
   owner AS INTEGER
   sectnum AS INTEGER
   statnum AS INTEGER
   lotag AS INTEGER
   hitag AS INTEGER
   extra AS INTEGER
END TYPE

DIM SHARED sector(MAXSECTORS) AS sectortype
DIM SHARED wall(MAXWALLS) AS walltype
DIM SHARED sprite(MAXSPRITES) AS spritetype

DIM SHARED headspritesect%(MAXSECTORS), headspritestat%(MAXSTATUS)
DIM SHARED prevspritesect%(MAXSPRITES), prevspritestat%(MAXSPRITES)
DIM SHARED nextspritesect%(MAXSPRITES), nextspritestat%(MAXSPRITES)

DIM SHARED sintable&(2048), regs%(7), tempshort%(4096)

DIM SHARED mapversion&, posx&, posy&, posz&, ang%, zoom&
DIM SHARED cursectnum%, numsectors%, numwalls%, numsprites%

DIM SHARED px&(MAXPOINTS), py&(MAXPOINTS), point2%(MAXPOINTS), numpoints%

DIM SHARED dalastx&(YDIM)
DIM SHARED bunchstart%(MAXBUNCHES), bunchend%(MAXBUNCHES), numbunches%
DIM SHARED sortlist%(MAXBUNCHES), sortlistnum%

DIM SHARED buf%(20480), palookup%(NUMPALOOKUPS, 256)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)

DIM SHARED globx&, globy&, gxvect&, gyvect&, globtextoffs%

CALL setupscreen
regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
CALL loadtables
CALL loadboard("ascboar2.map")
CALL loadnewall(0&, 18)
CALL loadnewall(4096&, 20)
CALL loadnewall(8192&, 31)
CALL loadnewall(12288&, 36)
CALL loadnewall(16384&, 22)
zoom& = 512
DO
   CLS
  
   CALL draw2dboard(posx&, posy&, ang%, zoom&)

   DO
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      ang% = ((ang% + regs%(2)) AND 2047)
      posx& = posx& - sintable&((ang% + 2560) AND 2047) * regs%(3) \ 1024
      posy& = posy& - sintable&((ang% + 2048) AND 2047) * regs%(3) \ 1024
     
      z$ = UCASE$(INKEY$)
   LOOP WHILE z$ = "" AND ((regs%(2) OR regs%(3)) = 0)
   DO
      IF z$ = CHR$(0) + CHR$(75) THEN ang% = ((ang% + 2016) AND 2047)
      IF z$ = CHR$(0) + CHR$(77) THEN ang% = ((ang% + 32) AND 2047)
      IF z$ = CHR$(0) + CHR$(72) THEN
         posx& = posx& + sintable&((ang% + 2560) AND 2047) \ 32
         posy& = posy& + sintable&((ang% + 2048) AND 2047) \ 32
      END IF
      IF z$ = CHR$(0) + CHR$(80) THEN
         posx& = posx& - sintable&((ang% + 2560) AND 2047) \ 32
         posy& = posy& - sintable&((ang% + 2048) AND 2047) \ 32
      END IF
      IF UCASE$(z$) = "A" AND zoom& < 1024 THEN zoom& = zoom& + zoom& \ 4
      IF UCASE$(z$) = "Z" AND zoom& > 4 THEN zoom& = zoom& - zoom& \ 4
      z$ = UCASE$(INKEY$)
   LOOP WHILE z$ <> ""
LOOP WHILE z$ <> CHR$(27)
END

FUNCTION changespritesect% (spritenum%, newsectnum%)
   IF sprite(spritenum%).sectnum = newsectnum% OR sprite(spritenum%).sectnum = MAXSECTORS THEN
      changespritesect% = -1
      EXIT FUNCTION
   END IF
   zx% = deletespritesect%(spritenum%)
   IF zx% >= 0 THEN
      zx% = insertspritesect%(newsectnum%)
      changespritesect% = 0
   ELSE
      changespritesect% = -1
   END IF
END FUNCTION

FUNCTION changespritestat% (spritenum%, newstatnum%)
   IF sprite(spritenum%).statnum = newstatnum% OR sprite(spritenum%).statnum = MAXSTATUS THEN
      changespritestat% = -1
      EXIT FUNCTION
   END IF
   zx% = deletespritestat%(spritenum%)
   IF zx% >= 0 THEN
      zx% = insertspritestat%(newstatnum%)
      changespritestat% = 0
   ELSE
      changespritestat% = -1
   END IF
END FUNCTION

FUNCTION deletesprite% (spritenum%)
   spritenum1% = deletespritestat(spritenum%)
   spritenum2% = deletespritesect(spritenum%)
   IF spritenum1% <> spritenum2% THEN SOUND 131, 1
   deletesprite% = spritenum2%
END FUNCTION

FUNCTION deletespritesect% (deleteme%)
   IF sprite(deleteme%).sectnum = MAXSECTORS THEN
      deletespritesect% = -1
      EXIT FUNCTION
   END IF

   IF headspritesect%(sprite(deleteme%).sectnum) = deleteme% THEN headspritesect%(sprite(deleteme%).sectnum) = nextspritesect%(deleteme%)

   IF prevspritesect%(deleteme%) >= 0 THEN nextspritesect%(prevspritesect%(deleteme%)) = nextspritesect%(deleteme%)
   IF nextspritesect%(deleteme%) >= 0 THEN prevspritesect%(nextspritesect%(deleteme%)) = prevspritesect%(deleteme%)

   IF headspritesect%(MAXSECTORS) >= 0 THEN prevspritesect%(headspritesect%(MAXSECTORS)) = deleteme%
   prevspritesect%(deleteme%) = -1
   nextspritesect%(deleteme%) = headspritesect%(MAXSECTORS)
   headspritesect%(MAXSECTORS) = deleteme%

   sprite(deleteme%).sectnum = MAXSECTORS
   deletespritesect% = 0
END FUNCTION

FUNCTION deletespritestat% (deleteme%)
   IF sprite(deleteme%).statnum = MAXSTATUS THEN
      deletespritestat% = -1
      EXIT FUNCTION
   END IF
 
   IF headspritestat%(sprite(deleteme%).statnum) = deleteme% THEN headspritestat%(sprite(deleteme%).statnum) = nextspritestat%(deleteme%)

   IF prevspritestat%(deleteme%) >= 0 THEN nextspritestat%(prevspritestat%(deleteme%)) = nextspritestat%(deleteme%)
   IF nextspritestat%(deleteme%) >= 0 THEN prevspritestat%(nextspritestat%(deleteme%)) = prevspritestat%(deleteme%)
 
   IF headspritestat%(MAXSTATUS) >= 0 THEN prevspritestat%(headspritestat%(MAXSTATUS)) = deleteme%
   prevspritestat%(deleteme%) = -1
   nextspritestat%(deleteme%) = headspritestat%(MAXSTATUS)
   headspritestat%(MAXSTATUS) = deleteme%
 
   sprite(deleteme%).statnum = MAXSTATUS
   deletespritestat% = 0
END FUNCTION

SUB draw2dboard (dax&, day&, ang%, zoome&)
   bakgxvect& = ((sintable&((1536 - ang%) AND 2047)) * 16&) \ zoome&
   bakgyvect& = ((sintable&((2048 - ang%) AND 2047)) * 16&) \ zoome&
  
   xvect& = (sintable&((2048 - ang%) AND 2047) * zoome&) \ 16384
   yvect& = (sintable&((1536 - ang%) AND 2047) * zoome&) \ 16384
  
   FOR s% = 0 TO numsectors% - 1
      startwall% = sector(s%).wallptr
      endwall% = startwall% + sector(s%).wallnum - 1
     
      numpoints% = 0
      FOR w% = startwall% TO endwall%
         ox& = wall(w%).x - dax&: oy& = wall(w%).y - day&
         px&(numpoints%) = (ox& * xvect& - oy& * yvect&) \ 16384 + XDIM \ 2
         py&(numpoints%) = (oy& * xvect& + ox& * yvect&) \ 16384 + YDIM \ 2
         point2%(numpoints%) = wall(w%).point2 - startwall%
         numpoints% = numpoints% + 1
      NEXT w%

      IF (ASC(sector(s%).floorstat) AND 64) = 0 THEN
         globx& = dax&
         globy& = day&
         gxvect& = bakgxvect&
         gyvect& = bakgyvect&
      ELSE
         x1& = wall(startwall%).x
         y1& = wall(startwall%).y
         x2& = wall(wall(startwall%).point2).x - x1&
         y2& = wall(wall(startwall%).point2).y - y1&
         gxvect& = (y2& * bakgxvect& - x2& * bakgyvect&) \ 4096
         gyvect& = (x2& * bakgxvect& + y2& * bakgyvect&) \ 4096
         ox& = px&(0) - XDIM \ 2: oy& = py&(0) - YDIM \ 2
         globx& = -(oy& * gxvect& + ox& * gyvect&) \ 16
         globy& = (ox& * gxvect& - oy& * gyvect&) \ 16
      END IF

      globtextoffs% = (s% MOD 5) * 4096
      CALL fillpolygon(px&(), py&(), point2%(), numpoints%)
   NEXT s%
END SUB

SUB fillpolygon (px&(), py&(), point2%(), numpoints%)
    
      'Get bunchstart and numbunches
   numbunches% = 0
   FOR z% = 0 TO numpoints% - 1
      zz% = point2%(z%)
      IF (py&(zz%) > py&(z%)) <> (py&(point2%(zz%)) > py&(zz%)) THEN
         bunchstart%(numbunches%) = zz%
         numbunches% = numbunches% + 1
      END IF
   NEXT z%
 
      'Sort bunches by y's
   gap% = numbunches% \ 2
   DO
      FOR z% = 0 TO numbunches% - gap% - 1
         zz% = z%
         DO WHILE py&(bunchstart%(zz%)) > py&(bunchstart%(zz% + gap%))
            SWAP bunchstart%(zz%), bunchstart%(zz% + gap%)
            zz% = zz% - gap%: IF zz% < 0 THEN EXIT DO
         LOOP
      NEXT z%
      gap% = gap% \ 2
   LOOP WHILE gap% > 0

      'Get bunchends
   FOR zx% = 0 TO numbunches% - 1
      zz% = bunchstart%(zx%)
      DO
         z% = zz%: zz% = point2%(z%)
      LOOP WHILE (py&(zz%) > py&(z%)) = (py&(point2%(zz%)) > py&(zz%))
      bunchend%(zx%) = zz%
   NEXT zx%
 
      'Sort bunches
   sortlistnum% = 0
   FOR z% = 0 TO numbunches% - 1
      IF py&(bunchend%(z%)) > py&(bunchstart%(z%)) THEN
       
         splitnum% = sortlistnum%: bad% = 0
         DO WHILE splitnum% > 0 AND bad% = 0
            splitnum% = splitnum% - 1
            zx% = sortlist%(splitnum%): sortlist%(splitnum% + 2) = zx%
            b1% = bunchstart%(zx%): b2% = bunchend%(zx%)
            zx% = bunchstart%(z%): x& = px&(zx%): y& = py&(zx%)
            IF (py&(b1%) <= y&) = (y& < py&(b2%)) THEN
               i% = b1%: ny2& = py&(i%)
               DO WHILE i% <> b2%
                  ii% = point2%(i%)
                  ny1& = ny2&: ny2& = py&(ii%)
                  IF (py&(i%) <= y&) = (y& < py&(ii%)) THEN
                     nx1& = px&(i%): nx2& = px&(ii%)  'compare line(i%,ii%) with point(x&,y&)
                     IF ny2& > ny1& THEN
                        IF (nx2& - nx1&) * (y& - ny1&) <= (x& - nx1&) * (ny2& - ny1&) THEN splitnum% = splitnum% + 1: bad% = 1: EXIT DO
                     ELSE
                        IF (nx1& - nx2&) * (y& - ny2&) <= (x& - nx2&) * (ny1& - ny2&) THEN splitnum% = splitnum% + 1: bad% = 1: EXIT DO
                     END IF
                  END IF
                  i% = ii%
               LOOP
            END IF
         LOOP
         sortlistnum% = sortlistnum% + 2
       
         lastz% = 0
         WHILE bunchend%(lastz%) <> bunchstart%(z%)
            lastz% = lastz% + 1
         WEND

         ii% = bunchstart%(z%)
         i% = bunchstart%(lastz%)
         WHILE point2%(i%) <> ii%
            i% = point2%(i%)
         WEND
         iii% = point2%(ii%)
         IF (px&(iii%) - px&(ii%)) * (py&(i%) - py&(ii%)) <= (px&(i%) - px&(ii%)) * (py&(iii%) - py&(ii%)) THEN
            sortlist%(splitnum% + 0) = z%
            sortlist%(splitnum% + 1) = lastz%
         ELSE
            sortlist%(splitnum% + 0) = lastz%
            sortlist%(splitnum% + 1) = z%
         END IF
      END IF
   NEXT z%
    
      'Draw bunches
   FOR zx% = 0 TO sortlistnum% - 1
      z% = bunchstart%(sortlist%(zx%)): zend% = bunchend%(sortlist%(zx%))
      WHILE z% <> zend%
         zz% = point2%(z%)

         y1& = py&(z%): y2& = py&(zz%)
         IF y1& <> y2& THEN
            x1& = px&(z%): x2& = px&(zz%)

            xinc& = ((x2& - x1&) * 65536) \ (y2& - y1&)
            IF y2& < y1& THEN
               x& = x2& * 65536 + 65535
               FOR y& = y2& TO y1& - 1
                  IF y& >= 0 AND y& < YDIM THEN dalastx&(y&) = x& \ 65536
                   x& = x& + xinc&
               NEXT y&
            ELSE
               x& = x1& * 65536 - 1
               FOR y& = y1& TO y2& - 1
                  IF y& >= 0 AND y& < YDIM THEN
                     dax1& = dalastx&(y&): dax2& = x& \ 65536
                     IF dax2& > dax1& THEN
                        IF dax1& < 0 THEN dax1& = 0
                        IF dax2& >= XDIM THEN dax2& = XDIM - 1
                        IF dax2& >= dax1& THEN CALL hline(dax1&, dax2&, y&)
                     END IF
                  END IF
                  x& = x& + xinc&
               NEXT y&
            END IF
         END IF

         z% = zz%
      WEND
   NEXT zx%

END SUB

SUB hline (x1&, x2&, y&)
   DEF SEG = &HA000: p& = y& * 320 + x1&
  
   ox& = x1& - XDIM \ 2: oy& = y& - YDIM \ 2
   bx& = (ox& * gxvect& - oy& * gyvect&) - globy& * 16&
   by& = (oy& * gxvect& + ox& * gyvect&) + globx& * 16&
  
   FOR x& = x1& TO x2&
      POKE p&, buf%(((bx& \ 4) AND &HFC0) + ((by& \ 256) AND 63) + globtextoffs%)
      p& = p& + 1
      bx& = bx& + gxvect&
      by& = by& + gyvect&
   NEXT x&
END SUB

SUB initspritelists
   FOR z% = 0 TO MAXSECTORS - 1     'Init doubly-linked sprite sector lists
      headspritesect%(z%) = -1
   NEXT z%
   headspritesect%(MAXSECTORS) = 0
   FOR z% = 0 TO MAXSPRITES - 1
      prevspritesect%(z%) = z% - 1
      nextspritesect%(z%) = z% + 1
      sprite(z%).sectnum = MAXSECTORS
   NEXT z%
   prevspritesect%(0) = -1
   nextspritesect%(MAXSPRITES - 1) = -1

 
   FOR z% = 0 TO MAXSTATUS - 1      'Init doubly-linked sprite status lists
      headspritestat%(z%) = -1
   NEXT z%
   headspritestat%(MAXSTATUS) = 0
   FOR z% = 0 TO MAXSPRITES - 1
      prevspritestat%(z%) = z% - 1
      nextspritestat%(z%) = z% + 1
      sprite(z%).statnum = MAXSTATUS
   NEXT z%
   prevspritestat%(0) = -1
   nextspritestat%(MAXSPRITES - 1) = -1
END SUB

FUNCTION insertsprite% (sectnum%, statnum%)
   spritenum1% = insertspritestat%(statnum%)
   spritenum2% = insertspritesect%(sectnum%)
   IF spritenum1% <> spritenum2% THEN SOUND 131, 1
   insertsprite% = spritenum2%
END FUNCTION

FUNCTION insertspritesect% (sectnum%)
   IF sectnum% >= MAXSECTORS OR headspritesect%(MAXSECTORS) = -1 THEN
      insertspritesect% = -1: EXIT FUNCTION   'list full
   END IF

   blanktouse% = headspritesect%(MAXSECTORS)

   headspritesect%(MAXSECTORS) = nextspritesect%(blanktouse%)
   IF headspritesect%(MAXSECTORS) >= 0 THEN prevspritesect%(headspritesect%(MAXSECTORS)) = -1

   prevspritesect%(blanktouse%) = -1
   nextspritesect%(blanktouse%) = headspritesect%(sectnum%)
   IF headspritesect%(sectnum%) >= 0 THEN prevspritesect%(headspritesect%(sectnum%)) = blanktouse%
   headspritesect%(sectnum%) = blanktouse%

   sprite(blanktouse%).sectnum = sectnum%

   insertspritesect% = blanktouse%
END FUNCTION

FUNCTION insertspritestat% (statnum%)
   IF statnum% >= MAXSTATUS OR headspritestat%(MAXSTATUS) = -1 THEN
      insertspritestat% = -1: EXIT FUNCTION   'list full
   END IF
 
   blanktouse% = headspritestat%(MAXSTATUS)
 
   headspritestat%(MAXSTATUS) = nextspritestat%(blanktouse%)
   IF headspritestat%(MAXSTATUS) >= 0 THEN prevspritestat%(headspritestat%(MAXSTATUS)) = -1
 
   prevspritestat%(blanktouse%) = -1
   nextspritestat%(blanktouse%) = headspritestat%(statnum%)
   IF headspritestat%(statnum%) >= 0 THEN prevspritestat%(headspritestat%(statnum%)) = blanktouse%
   headspritestat%(statnum%) = blanktouse%
 
   sprite(blanktouse%).statnum = statnum%
 
   insertspritestat% = blanktouse%
END FUNCTION

SUB loadboard (fil$)
   CALL initspritelists
  
   OPEN fil$ FOR BINARY AS #1
  
   GET #1, , mapversion&
   IF mapversion& <> 6 THEN PRINT "NOT MAP VERSION 6": END
  
   GET #1, , posx&
   GET #1, , posy&
   GET #1, , posz&
   GET #1, , ang%
   GET #1, , cursectnum%
  
   GET #1, , numsectors%
   FOR z% = 0 TO numsectors% - 1: GET #1, , sector(z%): NEXT z%
   GET #1, , numwalls%
   FOR z% = 0 TO numwalls% - 1: GET #1, , wall(z%): NEXT z%
   GET #1, , numsprites%
   FOR z% = 0 TO numsprites% - 1
      GET #1, , sprite(z%)
      snot% = insertsprite%(sprite(z%).sectnum, sprite(z%).statnum)
   NEXT z%

   CLOSE #1
END SUB

SUB loadnewall (bufplc&, wallnum%)
   OPEN "tiles000.art" FOR BINARY AS #1

   SEEK #1, 1
   GET #1, , version&
   GET #1, , numtiles&
   GET #1, , localtilestart&
   GET #1, , localtileend&
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      zx& = tilesizx%(z%)
      totsiz& = totsiz& + zx& * tilesizy%(z%)
   NEXT z%
   SEEK #1, totsiz& + 16 + (localtileend& - localtilestart& + 1) * 8 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO tilesizx%(wallnum%) - 1
      FOR zz% = 0 TO tilesizy%(wallnum%) - 1
         buf%(bufplc& + z% * tilesizy%(wallnum%) + zz%) = PEEK(offs&)
         offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB setupscreen
   SCREEN 13
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   pal$ = STRING$(256, 0)
   FOR z% = 0 TO NUMPALOOKUPS
      GET #1, , pal$
      FOR zz% = 0 TO 255
         palookup%(z%, zz%) = ASC(MID$(pal$, zz% + 1, 1))
      NEXT zz%
   NEXT z%
   CLOSE #1
END SUB

