DECLARE FUNCTION trans% (dat1%, dat2%)
DECLARE SUB inittrans ()
DECLARE FUNCTION gettrans% (dat1%, dat2%)
DECLARE SUB loadnewall (bufplc&, wallnum%)
DECLARE SUB loadtables ()
DECLARE SUB setupscreen ()

CONST NUMPALOOKUPS = 32
CONST MAXTILES = 4096
CONST XDIM = 320, YDIM = 200

COMMON SHARED numwalls%, transcnt&
DIM SHARED buf%(20480), palookup%(NUMPALOOKUPS, 256)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)

DIM SHARED r%(256), g%(256), b%(256)
DIM SHARED transluc0%(90, 256), transluc1%(90, 256), transluc2%(90, 256)

RANDOMIZE TIMER
CALL setupscreen
CALL inittrans

transcnt& = 0

CALL loadnewall(0&, 0)  'Fake loadwall

z$ = " "
DO
   IF z$ <> "2" THEN
      DO
         tile1% = INT(256 * RND)
      LOOP WHILE tilesizx%(tile1%) <> 64 OR tilesizy%(tile1%) <> 64
   END IF
   IF z$ <> "1" THEN
      DO
         tile2% = INT(256 * RND)
      LOOP WHILE tilesizx%(tile2%) <> 64 OR tilesizy%(tile2%) <> 64
   END IF

   CALL loadnewall(0&, tile1%)
   CALL loadnewall(4096&, tile2%)

   DEF SEG = &HA000
 
   FOR z% = 0 TO 4095
      p& = (z% AND 63) * 320 + (z% \ 64)
      POKE p&, buf%(z%)
      POKE p& + 64, buf%(z% + 4096)
   NEXT z%

   FOR z% = 0 TO 4095
      p& = ((z% AND 63) + 64) * 320& + (z% \ 64)
      POKE p&, trans%(buf%(z%), buf%(z% + 4096))
   NEXT z%
  
   LOCATE 20, 1: PRINT transcnt&; "/ 65536";
   DO
      z$ = INKEY$
   LOOP WHILE z$ = ""

LOOP WHILE z$ <> CHR$(27)

FUNCTION gettrans% (dat1%, dat2%)
   r& = (r%(dat1%) + r%(dat2%)) \ 2
   g& = (g%(dat1%) + g%(dat2%)) \ 2
   b& = (b%(dat1%) + b%(dat2%)) \ 2
 
   col% = 0
   closest& = &H7FFFFFFF
   FOR zx% = 0 TO 255
      dar& = (r%(zx%) - r&) * 30
      dag& = (g%(zx%) - g&) * 59
      dab& = (b%(zx%) - b&) * 11
      dist& = dar& * dar& + dag& * dag& + dab& * dab&
      IF dist& < closest& THEN
         closest& = dist&
         col% = zx%
      END IF
   NEXT zx%

   gettrans% = col%
END FUNCTION

SUB inittrans
   FOR z% = 0 TO 89
      FOR zz% = 0 TO 255
         transluc0%(z%, zz%) = -1
         transluc1%(z%, zz%) = -1
         transluc2%(z%, zz%) = -1
      NEXT zz%
   NEXT z%

   OUT &H3C7, 0
   FOR z% = 0 TO 255
      r%(z%) = INP(&H3C9): g%(z%) = INP(&H3C9): b%(z%) = INP(&H3C9)
   NEXT z%

END SUB

SUB loadnewall (bufplc&, wallnum%)
   OPEN "tiles000.art" FOR BINARY AS #1

   SEEK #1, 1
   GET #1, , version&
   GET #1, , numtiles&
   GET #1, , localtilestart&
   GET #1, , localtileend&
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart&
      GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      zx& = tilesizx%(z%)
      totsiz& = totsiz& + zx& * tilesizy%(z%)
   NEXT z%
   SEEK #1, totsiz& + 16 + (localtileend& - localtilestart& + 1) * 8 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO tilesizx%(wallnum%) - 1
      FOR zz% = 0 TO tilesizy%(wallnum%) - 1
         buf%(bufplc& + z% * tilesizy%(wallnum%) + zz%) = PEEK(offs&)
         offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB setupscreen
   SCREEN 13
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   pal$ = STRING$(256, 0)
   FOR z% = 0 TO NUMPALOOKUPS
      GET #1, , pal$
      FOR zz% = 0 TO 255
         palookup%(z%, zz%) = ASC(MID$(pal$, zz% + 1, 1))
      NEXT zz%
   NEXT z%
   CLOSE #1

END SUB

FUNCTION trans% (dat1%, dat2%)
   bad% = 0
   IF dat1% < 90 THEN
      IF transluc0%(dat1%, dat2%) >= 0 THEN
         col% = transluc0%(dat1%, dat2%)
      ELSE
         col% = gettrans%(dat1%, dat2%)
         transluc0%(dat1%, dat2%) = col%
         bad% = 1
      END IF
   ELSEIF dat1% < 180 THEN
      IF transluc1%(dat1% - 90, dat2%) >= 0 THEN
         col% = transluc1%(dat1% - 90, dat2%)
      ELSE
         col% = gettrans%(dat1%, dat2%)
         transluc1%(dat1% - 90, dat2%) = col%
         bad% = 1
      END IF
   ELSE
      IF transluc2%(dat1% - 180, dat2%) >= 0 THEN
         col% = transluc2%(dat1% - 180, dat2%)
      ELSE
         col% = gettrans%(dat1%, dat2%)
         transluc2%(dat1% - 180, dat2%) = col%
         bad% = 1
      END IF
   END IF
  
   IF bad% = 1 THEN
      transcnt& = transcnt& + 1
      IF dat1% <> dat2% THEN
         IF dat2% < 90 THEN
            transluc0%(dat2%, dat1%) = col%
         ELSEIF dat2% < 180 THEN
            transluc1%(dat2% - 90, dat1%) = col%
         ELSE
            transluc2%(dat2% - 180, dat1%) = col%
         END IF
         transcnt& = transcnt& + 1
      END IF
   END IF

   trans% = col%

END FUNCTION

