DECLARE SUB makeboxbsp ()
DECLARE SUB reduceedges (lnum%)
DECLARE FUNCTION rayscan% (x&, y&, z&, xv&, yv&, zv&)
DECLARE SUB clipmove (x&, y&, z&, xv&, yv&, zv&)
DECLARE SUB drawcubes ()
DECLARE SUB setuprotate3d (a1%, a2%, a3%)
DECLARE SUB backrotate3d (nx!, ny!, nz!)
DECLARE SUB loadboard ()
DECLARE SUB rotate3d (nx!, ny!, nz!)
DECLARE SUB add2bsp (meshnum%)
DECLARE SUB addmesh ()
DECLARE SUB drawfasttextureplane (pstart%, pend%)
DECLARE SUB splitmesh1 (splitval%, meshnum%, nx!, ny!, nz!)
DECLARE SUB initmesh ()

CONST XDIM = 640&, YDIM = 350&, SCRMODE = 9
CONST BSIZ = 16
CONST MAXPOINTS = 2048
CONST MAXMESHS = 1024
CONST MAXSPLITCNT = 1024
CONST WALLDIST = 128
CONST MAXSECTORS = (BSIZ * BSIZ * BSIZ) \ 4

TYPE point2d
   x AS LONG
   y AS LONG
END TYPE

TYPE point3d
   x AS SINGLE
   y AS SINGLE
   z AS SINGLE
END TYPE

TYPE edgetype
   p1 AS INTEGER
   p2 AS INTEGER
   a1 AS INTEGER
   a2 AS INTEGER
END TYPE

DIM SHARED board%(BSIZ * BSIZ * BSIZ)  'Board layout

DIM SHARED tempshort%(BSIZ * BSIZ * BSIZ)
DIM SHARED numsectors%
DIM SHARED cubesect%(BSIZ * BSIZ * BSIZ)
DIM SHARED sectx1%(MAXSECTORS), secty1%(MAXSECTORS), sectz1%(MAXSECTORS)
DIM SHARED sectx2%(MAXSECTORS), secty2%(MAXSECTORS), sectz2%(MAXSECTORS)

DIM SHARED facetag%(6)                  'Cube definition variables
DIM SHARED edgeoffacemask&(6)
edgeoffacemask&(0) = &H410140: edgeoffacemask&(1) = &H280820
edgeoffacemask&(2) = &H104201: edgeoffacemask&(3) = &H802408
edgeoffacemask&(4) = &H21012: edgeoffacemask&(5) = &H48084
DIM SHARED coordofpoint&(3, 8)
coordofpoint&(0, 0) = -512: coordofpoint&(0, 1) = 512
coordofpoint&(0, 2) = -512: coordofpoint&(0, 3) = 512
coordofpoint&(0, 4) = -512: coordofpoint&(0, 5) = 512
coordofpoint&(0, 6) = -512: coordofpoint&(0, 7) = 512
coordofpoint&(1, 0) = -512: coordofpoint&(1, 1) = -512
coordofpoint&(1, 2) = 512: coordofpoint&(1, 3) = 512
coordofpoint&(1, 4) = -512: coordofpoint&(1, 5) = -512
coordofpoint&(1, 6) = 512: coordofpoint&(1, 7) = 512
coordofpoint&(2, 0) = -512: coordofpoint&(2, 1) = -512
coordofpoint&(2, 2) = -512: coordofpoint&(2, 3) = -512
coordofpoint&(2, 4) = 512: coordofpoint&(2, 5) = 512
coordofpoint&(2, 6) = 512: coordofpoint&(2, 7) = 512
DIM SHARED pointofface%(6, 4)
pointofface%(0, 0) = 0: pointofface%(0, 1) = 4
pointofface%(0, 2) = 6: pointofface%(0, 3) = 2
pointofface%(1, 0) = 5: pointofface%(1, 1) = 1
pointofface%(1, 2) = 3: pointofface%(1, 3) = 7
pointofface%(2, 0) = 0: pointofface%(2, 1) = 1
pointofface%(2, 2) = 5: pointofface%(2, 3) = 4
pointofface%(3, 0) = 6: pointofface%(3, 1) = 7
pointofface%(3, 2) = 3: pointofface%(3, 3) = 2
pointofface%(4, 0) = 1: pointofface%(4, 1) = 0
pointofface%(4, 2) = 2: pointofface%(4, 3) = 3
pointofface%(5, 0) = 4: pointofface%(5, 1) = 5
pointofface%(5, 2) = 7: pointofface%(5, 3) = 6
DIM SHARED pointofedge%(12, 2)
pointofedge%(0, 0) = 0: pointofedge%(0, 1) = 1
pointofedge%(1, 0) = 2: pointofedge%(1, 1) = 3
pointofedge%(2, 0) = 4: pointofedge%(2, 1) = 5
pointofedge%(3, 0) = 6: pointofedge%(3, 1) = 7
pointofedge%(4, 0) = 0: pointofedge%(4, 1) = 2
pointofedge%(5, 0) = 1: pointofedge%(5, 1) = 3
pointofedge%(6, 0) = 4: pointofedge%(6, 1) = 6
pointofedge%(7, 0) = 5: pointofedge%(7, 1) = 7
pointofedge%(8, 0) = 0: pointofedge%(8, 1) = 4
pointofedge%(9, 0) = 1: pointofedge%(9, 1) = 5
pointofedge%(10, 0) = 2: pointofedge%(10, 1) = 6
pointofedge%(11, 0) = 3: pointofedge%(11, 1) = 7
DIM SHARED faceofedge%(2, 12)
faceofedge%(0, 0) = 2: faceofedge%(0, 1) = 4
faceofedge%(0, 2) = 5: faceofedge%(0, 3) = 3
faceofedge%(0, 4) = 4: faceofedge%(0, 5) = 1
faceofedge%(0, 6) = 0: faceofedge%(0, 7) = 5
faceofedge%(0, 8) = 0: faceofedge%(0, 9) = 2
faceofedge%(0, 10) = 3: faceofedge%(0, 11) = 1
faceofedge%(1, 0) = 4: faceofedge%(1, 1) = 3
faceofedge%(1, 2) = 2: faceofedge%(1, 3) = 5
faceofedge%(1, 4) = 0: faceofedge%(1, 5) = 4
faceofedge%(1, 6) = 5: faceofedge%(1, 7) = 1
faceofedge%(1, 8) = 2: faceofedge%(1, 9) = 1
faceofedge%(1, 10) = 0: faceofedge%(1, 11) = 3

	'New polygon variables
DIM SHARED r(MAXPOINTS) AS point3d
DIM SHARED sc(MAXPOINTS) AS point2d
DIM SHARED plist%(MAXPOINTS), elist%(MAXPOINTS), ecnt%
DIM SHARED got%(MAXPOINTS)

DIM SHARED mesh%(MAXMESHS), nummeshs%, numedges%, numpoints%, endopoints%
DIM SHARED tval(MAXPOINTS)
DIM SHARED edge(MAXPOINTS) AS edgetype

DIM SHARED split1%(MAXSPLITCNT), splitag1%(MAXSPLITCNT)

DIM SHARED fillist&(XDIM)

   'beam tree variables
DIM SHARED bn(MAXPOINTS) AS point3d
DIM SHARED front%(MAXPOINTS), back%(MAXPOINTS), parent%(MAXPOINTS), pnum%
DIM SHARED pt%(MAXPOINTS), meshtag%(MAXMESHS), edgetag%(MAXPOINTS)
DIM SHARED bak%(MAXMESHS)

   'edge reduction variables
DIM SHARED ssx&(MAXPOINTS), ssy&(MAXPOINTS), ltag%(MAXPOINTS)

DIM SHARED cubelist%(BSIZ * BSIZ * BSIZ)
DIM SHARED arealeft, gcube%, gface%
DIM SHARED xdimup15&, ydimup15&, xreszoom, ydimscale

DIM SHARED posx&, posy&, posz&, a1%, a2%, a3%
DIM SHARED gxx, gxy, gxz, gyx, gyy, gyz, gzx, gzy, gzz

DIM SHARED regs%(7)

SCREEN SCRMODE: RANDOMIZE TIMER
regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())

xdimup15& = (XDIM + 1) * 32768
ydimup15& = (YDIM + 1) * 32768
xreszoom = 32768 * XDIM
ydimscale = YDIM / XDIM

DO
   CALL loadboard
   CALL makeboxbsp

   pag% = 1
   DO
      xvect& = 0: yvect& = 0: zvect& = 0

      regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
      obstatus% = bstatus%: bstatus% = regs%(0)
     
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      xvect& = 0: yvect& = 0: zvect& = 0
      IF (bstatus% AND 1) = 0 THEN
	 xvect& = xvect& - gxz * regs%(3) * 16
	 yvect& = yvect& - gyz * regs%(3) * 16
	 zvect& = zvect& - gzz * regs%(3) * 16
      ELSE
	 a2% = a2% - regs%(3)
      END IF
      IF (bstatus% AND 2) = 0 THEN
	 a3% = a3% + regs%(2)
      ELSE
	 xvect& = xvect& + gxx * regs%(2) * 16
	 yvect& = yvect& + gyx * regs%(2) * 16
	 zvect& = zvect& + gzx * regs%(2) * 16
      END IF
     
      CLS
      CALL setuprotate3d(a1%, a2%, a3%)
      CALL drawcubes

      SCREEN , , pag%, 1 - pag%: pag% = 1 - pag%
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8

      DO
	 z$ = INKEY$
	 IF UCASE$(z$) = "A" THEN xvect& = xvect& - gxy * 256: yvect& = yvect& - gyy * 256: zvect& = zvect& - gzy * 256
	 IF UCASE$(z$) = "Z" THEN xvect& = xvect& + gxy * 256: yvect& = yvect& + gyy * 256: zvect& = zvect& + gzy * 256
	 IF z$ = CHR$(0) + CHR$(72) THEN xvect& = xvect& + gxz * 256: yvect& = yvect& + gyz * 256: zvect& = zvect& + gzz * 256
	 IF z$ = CHR$(0) + CHR$(80) THEN xvect& = xvect& - gxz * 256: yvect& = yvect& - gyz * 256: zvect& = zvect& - gzz * 256
      LOOP WHILE z$ <> "" AND z$ <> CHR$(13) AND z$ <> CHR$(27)

      IF xvect& OR yvect& OR zvect& <> 0 THEN
	 CALL clipmove(posx&, posy&, posz&, xvect&, yvect&, zvect&)
      END IF
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27)
LOOP WHILE z$ <> CHR$(27)

SUB add2bsp (meshnum%)
   plistnum% = 0
   i% = mesh%(meshnum% + 1) - 1
   FOR z% = mesh%(meshnum%) TO i%
      IF (edgetag%(z%) AND &H8000) <> 0 THEN
	 IF edge(z%).a2 >= 0 THEN
	    IF (facetag%(edge(z%).a1) XOR facetag%(edge(z%).a2)) < 0 THEN
	       plist%(plistnum%) = (edgetag%(z%) AND &H3FFF)
	       IF facetag%(edge(z%).a2) >= 0 THEN plist%(plistnum%) = plist%(plistnum%) OR &H4000
	       plistnum% = plistnum% + 1
	    END IF
	 ELSEIF facetag%(edge(z%).a1) >= 0 THEN
	    plist%(plistnum%) = (edgetag%(z%) AND &H3FFF)
	    plistnum% = plistnum% + 1
	 END IF
      END IF
   NEXT z%

   IF plistnum% = 0 THEN
      FOR z% = mesh%(meshnum%) TO i%
	 IF facetag%(edge(z%).a1) >= 0 THEN back%(bak%(meshnum%)) = -1: EXIT SUB
      NEXT z%
      EXIT SUB
   END IF

   daparent% = pnum%: p% = pnum% + 1

   FOR dap% = plistnum% - 1 TO 0 STEP -1
      i% = dap% 'mulscale16(krand(),dap+1);
      j% = plist%(i%)
      IF (j% AND &H4000) = 0 THEN
	 rp1% = edge(j%).p1: rp2% = edge(j%).p2
      ELSE
	 j% = j% AND &H3FFF: rp1% = edge(j%).p2: rp2% = edge(j%).p1
      END IF

      plist%(i%) = plist%(dap%)

      bn(pnum%).x = r(rp1%).y * r(rp2%).z - r(rp2%).y * r(rp1%).z
      bn(pnum%).y = r(rp2%).x * r(rp1%).z - r(rp1%).x * r(rp2%).z
      bn(pnum%).z = r(rp1%).x * r(rp2%).y - r(rp2%).x * r(rp1%).y

      i% = bak%(meshnum%)
      DO WHILE i% >= 0
	 IF ((bn(pnum%).x = bn(i%).x) AND (bn(pnum%).y = bn(i%).y) AND (bn(pnum%).z = bn(i%).z)) THEN GOTO add2bspcont
	 IF ((bn(pnum%).x = -bn(i%).x) AND (bn(pnum%).y = -bn(i%).y) AND (bn(pnum%).z = -bn(i%).z)) THEN GOTO add2bspcont
	 i% = parent%(i%)
      LOOP

      front%(pnum%) = -1: back%(pnum%) = -2: pt%(pnum%) = daparent%
      pnum% = pnum% + 1

      DO WHILE p% < pnum%
	 z% = pt%(p%)
	 DO WHILE z% >= 0
	    oz% = z%
	    t1 = bn(z%).x * r(rp1%).x + bn(z%).y * r(rp1%).y + bn(z%).z * r(rp1%).z
	    t2 = bn(z%).x * r(rp2%).x + bn(z%).y * r(rp2%).y + bn(z%).z * r(rp2%).z

	    IF t1 >= 0 AND t2 >= 0 THEN
	       z% = front%(z%)
	       IF z% < 0 THEN front%(oz%) = p%: parent%(p%) = oz%
	    ELSEIF t1 <= 0 AND t2 <= 0 THEN
	       z% = back%(z%)
	       IF z% < 0 THEN back%(oz%) = p%: parent%(p%) = oz%
	    ELSE
	       bn(pnum%).x = bn(p%).x
	       bn(pnum%).y = bn(p%).y
	       bn(pnum%).z = bn(p%).z
	       front%(pnum%) = -1: back%(pnum%) = -2

	       pt%(pnum%) = back%(z%)
	       IF back%(z%) < 0 THEN back%(z%) = pnum%: parent%(pnum%) = z%
	       pnum% = pnum% + 1
	       z% = front%(z%)
	       IF z% < 0 THEN front%(oz%) = p%: parent%(p%) = oz%
	    END IF
	 LOOP
	 p% = p% + 1
      LOOP
add2bspcont:
   NEXT dap%
   back%(bak%(meshnum%)) = daparent%: parent%(daparent%) = bak%(meshnum%)
END SUB

SUB addmesh
   FOR i% = numedges% - 1 TO 0 STEP -1: edgetag%(i%) = (i% OR &H8000): NEXT i%

			'Get bounding box
   x0 = r(0).x: x1 = r(0).x
   y0 = r(0).y: y1 = r(0).y
   z0 = r(0).z: z1 = r(0).z
   FOR i% = numpoints% - 1 TO 1 STEP -1
      IF r(i%).x < x0 THEN x0 = r(i%).x
      IF r(i%).y < y0 THEN y0 = r(i%).y
      IF r(i%).z < z0 THEN z0 = r(i%).z
      IF r(i%).x > x1 THEN x1 = r(i%).x
      IF r(i%).y > y1 THEN y1 = r(i%).y
      IF r(i%).z > z1 THEN z1 = r(i%).z
   NEXT i%

   ecnt% = 0
   meshtag%(0) = 0: pcnt% = 0
   DO WHILE pcnt% < nummeshs%
      p% = meshtag%(pcnt%)

      IF p% < 0 THEN
	 IF p% = -2 THEN elist%(ecnt%) = pcnt%: ecnt% = ecnt% + 1
	 GOTO addmeshcont
      END IF
			'Oops!  Dead branch
      IF front%(p%) < 0 AND back%(p%) = -1 THEN GOTO addmeshcont

			'Bounding box code
      x = bn(p%).x: y = bn(p%).y: z = bn(p%).z
     
      ft = 0
      IF bn(p%).x < 0 THEN
	 ft = ft + x * x1
      ELSEIF bn(p%).x <> 0 THEN
	 ft = ft + x * x0
      END IF
      IF bn(p%).y < 0 THEN
	 ft = ft + y * y1
      ELSEIF bn(p%).y <> 0 THEN
	 ft = ft + y * y0
      END IF
      IF bn(p%).z < 0 THEN
	 ft = ft + z * z1
      ELSEIF bn(p%).z <> 0 THEN
	 ft = ft + z * z0
      END IF
      IF ft >= 0 THEN meshtag%(pcnt%) = front%(p%): bak%(pcnt%) = p%: pcnt% = pcnt% - 1: GOTO addmeshcont
     
      ft = 0
      IF bn(p%).x < 0 THEN
	 ft = ft + x * x0
      ELSEIF bn(p%).x <> 0 THEN
	 ft = ft + x * x1
      END IF
      IF bn(p%).y < 0 THEN
	 ft = ft + y * y0
      ELSEIF bn(p%).y <> 0 THEN
	 ft = ft + y * y1
      END IF
      IF bn(p%).z < 0 THEN
	 ft = ft + z * z0
      ELSEIF bn(p%).z <> 0 THEN
	 ft = ft + z * z1
      END IF
      IF ft <= 0 THEN meshtag%(pcnt%) = back%(p%): bak%(pcnt%) = p%: pcnt% = pcnt% - 1: GOTO addmeshcont

			'Bounding box fails
      IF front%(p%) < 0 THEN
	 meshtag%(nummeshs%) = back%(p%): bak%(nummeshs%) = p%
	 CALL splitmesh1(p%, pcnt%, -x, -y, -z)
      ELSEIF back%(p%) = -1 THEN    'Already filled region
	 meshtag%(nummeshs%) = front%(p%): bak%(nummeshs%) = p%
	 CALL splitmesh1(p%, pcnt%, x, y, z)
      ELSE
	 meshtag%(nummeshs%) = front%(p%): bak%(nummeshs%) = p%
	 CALL splitmesh1(p%, pcnt%, x, y, z)
	 IF mesh%(nummeshs%) = mesh%(nummeshs% - 1) THEN nummeshs% = nummeshs% - 1
	 meshtag%(nummeshs%) = back%(p%): bak%(nummeshs%) = p%
	 CALL splitmesh1(p%, pcnt%, -x, -y, -z)
      END IF
      IF mesh%(nummeshs%) = mesh%(nummeshs% - 1) THEN nummeshs% = nummeshs% - 1
addmeshcont:
      pcnt% = pcnt% + 1
   LOOP
END SUB

SUB backrotate3d (nx, ny, nz)
   x = nx: y = ny: z = nz
   nx = x * gxx + y * gxy + z * gxz
   ny = x * gyx + y * gyy + z * gyz
   nz = x * gzx + y * gzy + z * gzz
END SUB

SUB clipmove (x&, y&, z&, xv&, yv&, zv&)
   IF rayscan%(x&, y&, z&, xv&, yv&, zv&) <> 255 THEN
      IF rayscan%(x&, y&, z&, xv&, yv&, zv&) <> 255 THEN
	 zx% = rayscan%(x&, y&, z&, xv&, yv&, zv&)
      END IF
   END IF
END SUB

SUB drawcubes
   CALL initmesh

   cubelist%(0) = (posx& \ 1024) * BSIZ * BSIZ + (posy& \ 1024) * BSIZ + (posz& \ 1024)
   cubelistplc% = 0: cubelistnum% = 1
   DO
      gcube% = cubelist%(cubelistplc%): cubelistplc% = cubelistplc% + 1
      cx& = ((gcube% \ (BSIZ * BSIZ)) * 1024) + 512 - posx&
      cy& = (((gcube% \ BSIZ) MOD BSIZ) * 1024) + 512 - posy&
      cz& = ((gcube% MOD BSIZ) * 1024) + 512 - posz&
     
      edgexor& = 0
      FOR gface% = 5 TO 0 STEP -1
	 facetag%(gface%) = -1
	 SELECT CASE gface%
	    CASE 0:
	       IF cx& > 512 THEN GOTO endofgface
	       daindex% = gcube% - BSIZ * BSIZ
	    CASE 1:
	       IF cx& < -512 THEN GOTO endofgface
	       daindex% = gcube% + BSIZ * BSIZ
	    CASE 2:
	       IF cy& > 512 THEN GOTO endofgface
	       daindex% = gcube% - BSIZ
	    CASE 3:
	       IF cy& < -512 THEN GOTO endofgface
	       daindex% = gcube% + BSIZ
	    CASE 4:
	       IF cz& > 512 THEN GOTO endofgface
	       daindex% = gcube% - 1
	    CASE 5:
	       IF cz& < -512 THEN GOTO endofgface
	       daindex% = gcube% + 1
	 END SELECT
	 IF board%(daindex%) >= 0 THEN
	    facetag%(gface%) = board%(daindex%)
	    'SELECT CASE gface%
	    '   CASE 0: facetag%(gface%) = board%(daindex% + 3 * BSIZ * BSIZ * BSIZ)
	    '   CASE 1: facetag%(gface%) = board%(daindex% + 0 * BSIZ * BSIZ * BSIZ)
	    '   CASE 2: facetag%(gface%) = board%(daindex% + 4 * BSIZ * BSIZ * BSIZ)
	    '   CASE 3: facetag%(gface%) = board%(daindex% + 1 * BSIZ * BSIZ * BSIZ)
	    '   CASE 4: facetag%(gface%) = board%(daindex% + 5 * BSIZ * BSIZ * BSIZ)
	    '   CASE 5: facetag%(gface%) = board%(daindex% + 2 * BSIZ * BSIZ * BSIZ)
	    'END SELECT
	 ELSE
	    facetag%(gface%) = -2
	 END IF
	 edgexor& = edgexor& XOR edgeoffacemask&(gface%)
endofgface:
      NEXT gface%

      FOR i% = 7 TO 0 STEP -1
	 r(i%).x = coordofpoint&(0, i%) + cx&
	 r(i%).y = coordofpoint&(1, i%) + cy&
	 r(i%).z = coordofpoint&(2, i%) + cz&
      NEXT i%
      numpoints% = 8

      numedges% = 0
      FOR i% = 11 TO 0 STEP -1        'i is edge counter
	 j& = 4097& * (2& ^ i%)
	 IF (edgexor& AND j&) <> 0 THEN
	    IF (edgexor& AND j&) = j& THEN  'Double sided edge
	       edge(numedges%).p1 = pointofedge%(i%, 0)
	       edge(numedges%).p2 = pointofedge%(i%, 1)
	       edge(numedges%).a1 = faceofedge%(0, i%)
	       edge(numedges%).a2 = faceofedge%(1, i%)
	    ELSEIF (edgexor& AND (2& ^ i%)) <> 0 THEN
	       edge(numedges%).p1 = pointofedge%(i%, 0)
	       edge(numedges%).p2 = pointofedge%(i%, 1)
	       edge(numedges%).a1 = faceofedge%(0, i%)
	       edge(numedges%).a2 = -1
	    ELSE
	       edge(numedges%).p1 = pointofedge%(i%, 1)
	       edge(numedges%).p2 = pointofedge%(i%, 0)
	       edge(numedges%).a1 = faceofedge%(1, i%)
	       edge(numedges%).a2 = -1
	    END IF
	    numedges% = numedges% + 1
	 END IF
      NEXT i%
      mesh%(0) = 0: mesh%(1) = numedges%: nummeshs% = 1

      CALL addmesh
     
      FOR gface% = 5 TO 0 STEP -1
	 IF facetag%(gface%) >= 0 THEN
	    lnum% = 0
	   
	    endopoints% = numpoints%

	    FOR j% = ecnt% - 1 TO 0 STEP -1
	       p% = elist%(j%)

	       FOR z% = 0 TO numpoints% - 1: got%(z%) = 0: NEXT z%
	       FOR i% = mesh%(p%) TO mesh%(p% + 1) - 1
		  IF edge(i%).a1 = gface% OR edge(i%).a2 = gface% THEN
		     IF edge(i%).a1 = gface% THEN
			k% = edge(i%).p1: l% = edge(i%).p2
		     ELSE
			l% = edge(i%).p1: k% = edge(i%).p2
		     END IF
		     IF got%(k%) = 0 THEN
			fx = r(k%).x: fy = r(k%).y: fz = r(k%).z
			CALL rotate3d(fx, fy, fz)
			ftemp = xreszoom / fz
			got%(k%) = 1
			sc(k%).x = fx * ftemp + xdimup15&
			sc(k%).y = fy * ftemp + ydimup15&
		     END IF
		     IF got%(l%) = 0 THEN
			fx = r(l%).x: fy = r(l%).y: fz = r(l%).z
			CALL rotate3d(fx, fy, fz)
			ftemp = xreszoom / fz
			got%(l%) = 1
			sc(l%).x = fx * ftemp + xdimup15&
			sc(l%).y = fy * ftemp + ydimup15&
		     END IF
		     IF ((edgetag%(i%) AND &HC000) <> 0) THEN
			sc(endopoints%).x = sc(k%).x
			sc(endopoints%).y = sc(k%).y
			sc(endopoints% + 1).x = sc(l%).x
			sc(endopoints% + 1).y = sc(l%).y
			endopoints% = endopoints% + 2
		     ELSE
			ssx&(lnum%) = sc(k%).x: ssx&(lnum% + 1) = sc(l%).x
			ssy&(lnum%) = sc(k%).y: ssy&(lnum% + 1) = sc(l%).y
			ltag%(lnum%) = edgetag%(i%) AND &H3FFF
			lnum% = lnum% + 2
		     END IF
		  END IF
	       NEXT i%
	    NEXT j%

	    IF lnum% > 0 THEN CALL reduceedges(lnum%)
	   
	    k = 0
	    FOR i% = numpoints% TO endopoints% - 1 STEP 2
	       k1 = sc(i%).x + sc(i% + 1).x
	       k2 = sc(i% + 1).y - sc(i%).y
	       k = k + k1 * k2
	    NEXT i%

	    IF k > 0 THEN
	       'gtext = facetag[gface];
	       CALL drawfasttextureplane(numpoints%, endopoints%)
	       arealeft = arealeft - k / 268435456
	       IF arealeft <= 0 THEN EXIT SUB
	    END IF
	 ELSEIF facetag%(gface%) = -2 THEN
	    SELECT CASE gface%
	       CASE 0: daindex% = gcube% - BSIZ * BSIZ
	       CASE 1: daindex% = gcube% + BSIZ * BSIZ
	       CASE 2: daindex% = gcube% - BSIZ
	       CASE 3: daindex% = gcube% + BSIZ
	       CASE 4: daindex% = gcube% - 1
	       CASE 5: daindex% = gcube% + 1
	    END SELECT
		 
	       '0 was cubelistplc
	    FOR i% = cubelistnum% - 1 TO 0 STEP -1
	       IF cubelist%(i%) = daindex% THEN GOTO endforloopindrawcubes
	    NEXT i%
	    FOR j% = ecnt% - 1 TO 0 STEP -1
	       p% = elist%(j%)
	       FOR i% = mesh%(p%) TO mesh%(p% + 1) - 1
		  IF edge(i%).a1 = gface% OR edge(i%).a2 = gface% THEN
		     cubelist%(cubelistnum%) = daindex%
		     cubelistnum% = cubelistnum% + 1
		     GOTO endforloopindrawcubes
		  END IF
	       NEXT i%
	    NEXT j%
endforloopindrawcubes:
	 END IF
      NEXT gface%

      EXIT SUB

      FOR i% = ecnt% - 1 TO 0 STEP -1
	 CALL add2bsp(elist%(i%))
      NEXT i%

   LOOP WHILE cubelistplc% < cubelistnum%
END SUB

SUB drawfasttextureplane (pstart%, pend%)
   miny& = YDIM: maxy& = 0
   FOR z% = pstart% TO pend% - 1 STEP 2
      sc(z%).x = sc(z%).x \ 65536: sc(z% + 1).x = sc(z% + 1).x \ 65536
      sc(z%).y = sc(z%).y \ 65536: sc(z% + 1).y = sc(z% + 1).y \ 65536
      IF sc(z%).y <> sc(z% + 1).y THEN
	 tval(z%) = (sc(z% + 1).x - sc(z%).x) / (sc(z% + 1).y - sc(z%).y)
      END IF
      y& = sc(z%).y
      IF y& < miny& THEN miny& = y&
      IF y& > maxy& THEN maxy& = y&
   NEXT z%

   col% = (cubesect%(gcube%) AND 15)

   FOR y& = miny& TO maxy&
      fillist&(0) = 0: fillcnt% = 1
      FOR z% = pend% - 2 TO pstart% STEP -2
	 y1& = sc(z%).y - y&: y2& = sc(z% + 1).y - y&
	 IF (y1& XOR y2&) < 0 THEN
	    IF y1& < y2& THEN
	       x& = sc(z%).x - y1& * tval(z%)
	    ELSE
	       x& = sc(z% + 1).x - y2& * tval(z%)
	    END IF
	    IF x& >= 0 THEN fillist&(fillcnt%) = x&: fillcnt% = fillcnt% + 1
	 END IF
      NEXT z%
      IF fillcnt% > 0 THEN
	 FOR z% = fillcnt% - 1 TO 1 STEP -1
	    FOR zz% = z% - 1 TO 0 STEP -1
	       IF fillist&(z%) < fillist&(zz%) THEN SWAP fillist&(z%), fillist&(zz%)
	    NEXT zz%
	 NEXT z%
       
	 FOR z% = fillcnt% - 2 TO 0 STEP -2
	    LINE (fillist&(z%), y&)-(fillist&(z% + 1), y&), col%
	 NEXT z%
      END IF
   NEXT y&

   FOR z% = pstart% TO pend% - 1 STEP 2
      x1& = sc(z%).x: y1& = sc(z%).y
      x2& = sc(z% + 1).x: y2& = sc(z% + 1).y
      LINE (x1& - 1, y1&)-(x2& - 1, y2&), 8
      LINE (x1& + 1, y1&)-(x2& + 1, y2&), 8
      LINE (x1&, y1& - 1)-(x2&, y2& - 1), 8
      LINE (x1&, y1& + 1)-(x2&, y2& + 1), 8
      LINE (x1&, y1&)-(x2&, y2&), 4
   NEXT z%
  
   FOR z% = pstart% TO pend% - 1 STEP 2
      x1& = sc(z%).x: y1& = sc(z%).y
      LINE (x1& - 1, y1& - 1)-(x1& + 1, y1& + 1), 12, BF
      PSET (x1&, y1&), 15
   NEXT z%
END SUB

SUB initmesh
   arealeft = XDIM * YDIM * 4095 / 128
  
   pnum% = 4
   bn(0).x = -1: bn(0).y = 0: bn(0).z = -1           'left
   bn(1).x = 1: bn(1).y = 0: bn(1).z = -1            'right
   bn(2).x = 0: bn(2).y = -1: bn(2).z = -ydimscale   'top
   bn(3).x = 0: bn(3).y = 1: bn(3).z = -ydimscale    'bottom

   FOR i% = 0 TO pnum% - 1
      CALL backrotate3d(bn(i%).x, bn(i%).y, bn(i%).z)
      front%(i%) = -1: back%(i%) = i% + 1: parent%(i% + 1) = i%
   NEXT i%
  
   back%(pnum% - 1) = -2
   parent%(0) = -1
END SUB

SUB loadboard
   OPEN "board.cub" FOR BINARY AS #1
   GET #1, , versionum&: IF versionum& <> &HCBE THEN PRINT "Wrong cube version": END
   GET #1, , posx&
   GET #1, , posy&
   GET #1, , posz&
   GET #1, , a1&: a1% = a1&
   GET #1, , a2&: a2% = a2&
   GET #1, , a3&: a3% = a3&
   FOR z% = 0 TO BSIZ * BSIZ * BSIZ - 1: GET #1, , board%(z%): NEXT z%
   CLOSE #1
END SUB

SUB makeboxbsp
   a% = 0
   FOR i% = BSIZ * BSIZ * BSIZ - 1 TO 0 STEP -1
      IF board%(i%) < 0 THEN cubesect%(i%) = -2: tempshort%(a%) = i%: a% = a% + 1
   NEXT i%
 
   numsectors% = 0
   DO
      i% = INT(a% * RND)
      x% = tempshort%(i%) \ (BSIZ * BSIZ)
      y% = (tempshort%(i%) \ BSIZ) MOD BSIZ
      z% = tempshort%(i%) MOD BSIZ
      IF cubesect%(tempshort%(i%)) = -2 THEN
	 x1% = x%: y1% = y%: z1% = z%: x2% = x%: y2% = y%: z2% = z%: bad% = 0
	 DO
	    IF (bad% AND 1) = 0 THEN
	       x2% = x2% + 1
	       FOR yy% = y1% TO y2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(x2% * BSIZ * BSIZ + yy% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 1: x2% = x2% - 1: EXIT FOR
		  NEXT zz%
	       NEXT yy%
	    END IF
	    IF (bad% AND 2) = 0 THEN
	       y2% = y2% + 1
	       FOR xx% = x1% TO x2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(xx% * BSIZ * BSIZ + y2% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 2: y2% = y2% - 1: EXIT FOR
		  NEXT zz%
	       NEXT xx%
	    END IF
	    IF (bad% AND 4) = 0 THEN
	       z2% = z2% + 1
	       FOR xx% = x1% TO x2%
		  FOR yy% = y1% TO y2%
		     IF cubesect%(xx% * BSIZ * BSIZ + yy% * BSIZ + z2%) <> -2 THEN bad% = bad% OR 4: z2% = z2% - 1: EXIT FOR
		  NEXT yy%
	       NEXT xx%
	    END IF
	    IF (bad% AND 8) = 0 THEN
	       x1% = x1% - 1
	       FOR yy% = y1% TO y2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(x1% * BSIZ * BSIZ + yy% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 8: x1% = x1% + 1: EXIT FOR
		  NEXT zz%
	       NEXT yy%
	    END IF
	    IF (bad% AND 16) = 0 THEN
	       y1% = y1% - 1
	       FOR xx% = x1% TO x2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(xx% * BSIZ * BSIZ + y1% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 16: y1% = y1% + 1: EXIT FOR
		  NEXT zz%
	       NEXT xx%
	    END IF
	    IF (bad% AND 32) = 0 THEN
	       z1% = z1% - 1
	       FOR xx% = x1% TO x2%
		  FOR yy% = y1% TO y2%
		     IF cubesect%(xx% * BSIZ * BSIZ + yy% * BSIZ + z1%) <> -2 THEN bad% = bad% OR 32: z1% = z1% + 1: EXIT FOR
		  NEXT yy%
	       NEXT xx%
	    END IF
	 LOOP WHILE bad% <> 63

	 FOR x% = x1% TO x2%
	    FOR y% = y1% TO y2%
	       FOR z% = z1% TO z2%
		  cubesect%(x% * BSIZ * BSIZ + y% * BSIZ + z%) = numsectors%
	       NEXT z%
	    NEXT y%
	 NEXT x%
	 sectx1%(numsectors%) = x1%: sectx2%(numsectors%) = x2%
	 secty1%(numsectors%) = y1%: secty2%(numsectors%) = y2%
	 sectz1%(numsectors%) = z1%: sectz2%(numsectors%) = z2%
	 numsectors% = numsectors% + 1
      ELSE
	 a% = a% - 1: IF a% <= 0 THEN EXIT SUB
	 tempshort%(i%) = tempshort%(a%)
      END IF
   LOOP
END SUB

FUNCTION rayscan% (x&, y&, z&, xv&, yv&, zv&)
   lasthit% = 255
   intx& = x& + xv&
   inty& = y& + yv&
   intz& = z& + zv&

   IF xv& <> 0 THEN
      xdir& = SGN(xv&)
      IF xdir& < 0 THEN
	 gridx& = (x& - WALLDIST) \ 1024 - 1: nintx& = gridx& * 1024& + 1024 + WALLDIST
      ELSE
	 gridx& = (x& + WALLDIST - 1) \ 1024 + 1: nintx& = gridx& * 1024& - WALLDIST
      END IF
    
      j& = xdir& * BSIZ * BSIZ
      DO WHILE ABS(nintx& - x&) < ABS(intx& - x&)
	 ninty& = y& + yv& * (nintx& - x&) \ xv&
	 nintz& = z& + zv& * (nintx& - x&) \ xv&

	 bad% = 0
	 i& = gridx& * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = gridx& * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = gridx& * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = gridx& * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 IF bad% <> 0 THEN
	    lasthit% = 0: intx& = nintx&: inty& = ninty&: intz& = nintz&
	    EXIT DO
	 END IF
	 gridx& = gridx& + xdir&
	 nintx& = nintx& + xdir& * 1024&
      LOOP
   END IF
 
   IF yv& <> 0 THEN
      ydir& = SGN(yv&)
      IF ydir& < 0 THEN
	 gridy& = (y& - WALLDIST) \ 1024 - 1: ninty& = gridy& * 1024& + 1024 + WALLDIST
      ELSE
	 gridy& = (y& + WALLDIST - 1) \ 1024 + 1: ninty& = gridy& * 1024& - WALLDIST
      END IF
   
      j& = ydir& * BSIZ
      DO WHILE ABS(ninty& - y&) < ABS(inty& - y&)
	 nintx& = x& + xv& * (ninty& - y&) \ yv&
	 nintz& = z& + zv& * (ninty& - y&) \ yv&

	 bad% = 0
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 IF bad% <> 0 THEN
	    lasthit% = 1: intx& = nintx&: inty& = ninty&: intz& = nintz&
	    EXIT DO
	 END IF
	 gridy& = gridy& + ydir&
	 ninty& = ninty& + ydir& * 1024&
      LOOP
   END IF
 
   IF zv& <> 0 THEN
      zdir& = SGN(zv&)
      IF zdir& < 0 THEN
	 gridz& = (z& - WALLDIST) \ 1024 - 1: nintz& = gridz& * 1024& + 1024 + WALLDIST
      ELSE
	 gridz& = (z& + WALLDIST - 1) \ 1024 + 1: nintz& = gridz& * 1024& - WALLDIST
      END IF
  
      j& = zdir&
      DO WHILE ABS(nintz& - z&) < ABS(intz& - z&)
	 nintx& = x& + xv& * (nintz& - z&) \ zv&
	 ninty& = y& + yv& * (nintz& - z&) \ zv&

	 bad% = 0
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 IF bad% <> 0 THEN
	    lasthit% = 2: intx& = nintx&: inty& = ninty&: intz& = nintz&
	    EXIT DO
	 END IF
	 gridz& = gridz& + zdir&
	 nintz& = nintz& + zdir& * 1024&
      LOOP
   END IF
   IF lasthit% = 0 THEN xv& = 0 ELSE xv& = x& + xv& - intx&
   IF lasthit% = 1 THEN yv& = 0 ELSE yv& = y& + yv& - inty&
   IF lasthit% = 2 THEN zv& = 0 ELSE zv& = z& + zv& - intz&
   x& = intx&: y& = inty&: z& = intz&
   rayscan% = lasthit%
END FUNCTION

SUB reduceedges (lnum%)
   lnum% = lnum% \ 2
  
   gap& = lnum% \ 2
   WHILE gap& > 0
      FOR z& = 0 TO lnum% - gap& - 1
	 FOR zz& = z& TO 0 STEP -gap&
	    i1& = zz& * 2: i2& = (zz& + gap&) * 2
	    IF ltag%(i1&) >= ltag%(i2&) THEN EXIT FOR
	    SWAP ssx&(i1&), ssx&(i2&): SWAP ssx&(i1& + 1), ssx&(i2& + 1)
	    SWAP ssy&(i1&), ssy&(i2&): SWAP ssy&(i1& + 1), ssy&(i2& + 1)
	    SWAP ltag%(i1&), ltag%(i2&)
	 NEXT zz&
      NEXT z&
      gap& = gap& \ 2
   WEND

   lnum% = lnum% + lnum%

   z& = 0
   WHILE z& < lnum%
      lt& = ltag%(z&): zz& = z&
      DO
	 ltag%(zz&) = 1: ltag%(zz& + 1) = -1: zz& = zz& + 2
      LOOP WHILE ltag%(zz&) = lt& AND zz& < lnum%
     
      pcnt& = zz& - z&
      IF (ABS(ssx&(z& + 1) - ssx&(z&)) >= ABS(ssy&(z& + 1) - ssy&(z&))) THEN
	 gap& = pcnt& \ 2
	 WHILE gap& > 0
	    FOR zx& = 0 TO pcnt& - gap& - 1
	       FOR zzx& = zx& TO 0 STEP -gap&
		  i1& = zzx& + z&: i2& = zzx& + gap& + z&
		  IF ssx&(i1&) <= ssx&(i2&) THEN EXIT FOR
		  SWAP ssx&(i1&), ssx&(i2&)
		  SWAP ssy&(i1&), ssy&(i2&)
		  SWAP ltag%(i1&), ltag%(i2&)
	       NEXT zzx&
	    NEXT zx&
	    gap& = gap& \ 2
	 WEND
      ELSE
	 gap& = pcnt& \ 2
	 WHILE gap& > 0
	    FOR zx& = 0 TO pcnt& - gap& - 1
	       FOR zzx& = zx& TO 0 STEP -gap&
		  i1& = zzx& + z&: i2& = zzx& + gap& + z&
		  IF ssy&(i1&) <= ssy&(i2&) THEN EXIT FOR
		  SWAP ssx&(i1&), ssx&(i2&)
		  SWAP ssy&(i1&), ssy&(i2&)
		  SWAP ltag%(i1&), ltag%(i2&)
	       NEXT zzx&
	    NEXT zx&
	    gap& = gap& \ 2
	 WEND
      END IF

      s& = 0: baks& = 0
      FOR dap& = z& TO zz& - 2
	 s& = s& + ltag%(dap&)
	 IF s& <> 0 THEN
	    x1& = ssx&(dap&): x2& = ssx&(dap& + 1)
	    y1& = ssy&(dap&): y2& = ssy&(dap& + 1)
	    IF x1& <> x2& OR y1& <> y2& THEN
	       IF baks& = s& AND bakx& = x1& AND baky& = y1& THEN
		  IF s& > 0 THEN
		     sc(endopoints% - 1).x = x2&: sc(endopoints% - 1).y = y2&
		  ELSE
		     sc(endopoints% - 2).x = x2&: sc(endopoints% - 2).y = y2&
		  END IF
	       ELSE
		  IF s& > 0 THEN
		     sc(endopoints%).x = x1&: sc(endopoints% + 1).x = x2&
		     sc(endopoints%).y = y1&: sc(endopoints% + 1).y = y2&
		  ELSE
		     sc(endopoints%).x = x2&: sc(endopoints% + 1).x = x1&
		     sc(endopoints%).y = y2&: sc(endopoints% + 1).y = y1&
		  END IF
		  endopoints% = endopoints% + 2
		  baks& = s&
	       END IF
	       bakx& = x2&: baky& = y2&
	    END IF
	 END IF
      NEXT dap&
    
      z& = zz&
   WEND
END SUB

SUB rotate3d (nx, ny, nz)
   x = nx: y = ny: z = nz
   nx = x * gxx + y * gyx + z * gzx
   ny = x * gxy + y * gyy + z * gzy
   nz = x * gxz + y * gyz + z * gzz
END SUB

SUB setuprotate3d (a1%, a2%, a3%)
   cosa1 = COS(a1% * 3.141592 / 1024): sina1 = SIN(a1% * 3.141592 / 1024)
   cosa2 = COS(a2% * 3.141592 / 1024): sina2 = SIN(a2% * 3.141592 / 1024)
   cosa3 = COS(a3% * 3.141592 / 1024): sina3 = SIN(a3% * 3.141592 / 1024)
   c1c3 = cosa1 * cosa3: c1s3 = cosa1 * sina3
   s1c3 = sina1 * cosa3: s1s3 = sina1 * sina3
   gxx = s1s3 * sina2 + c1c3: gyx = -sina1 * cosa2: gzx = s1c3 * sina2 - c1s3
   gxy = -c1s3 * sina2 + s1c3: gyy = cosa1 * cosa2: gzy = -c1c3 * sina2 - s1s3
   gxz = cosa2 * sina3: gyz = sina2: gzz = cosa2 * cosa3
END SUB

SUB splitmesh1 (splitval%, meshnum%, nx, ny, nz)
   pstart% = mesh%(meshnum%): pend% = mesh%(meshnum% + 1) - 1

   FOR z% = 0 TO numpoints% - 1: got%(z%) = 0: NEXT z%
       
   splitcnt1% = 0
   FOR z% = pstart% TO pend%
      p% = edge(z%).p1: pp% = edge(z%).p2
      a% = edge(z%).a1: aa% = edge(z%).a2
      IF got%(p%) = 0 THEN tval(p%) = r(p%).x * nx + r(p%).y * ny + r(p%).z * nz: got%(p%) = 1
      IF got%(pp%) = 0 THEN tval(pp%) = r(pp%).x * nx + r(pp%).y * ny + r(pp%).z * nz: got%(pp%) = 1
      t1 = tval(p%): t2 = tval(pp%)
      IF t1 > 0 THEN
	 IF t2 >= 0 THEN
	    edge(numedges%).p1 = p%: edge(numedges%).p2 = pp%
	    edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%
	    IF t2 = 0 THEN
	       split1%(splitcnt1%) = pp%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	       IF (aa% >= 0) THEN split1%(splitcnt1%) = pp%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1
	    END IF
	    edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1
	 ELSE
	    t = t1 / (t1 - t2)
	    edge(numedges%).p1 = p%: edge(numedges%).p2 = numpoints%
	    edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%

	    split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	    IF aa% >= 0 THEN split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1

	    edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1

	    r(numpoints%).x = r(p%).x + (r(pp%).x - r(p%).x) * t
	    r(numpoints%).y = r(p%).y + (r(pp%).y - r(p%).y) * t
	    r(numpoints%).z = r(p%).z + (r(pp%).z - r(p%).z) * t
	    numpoints% = numpoints% + 1
	 END IF
      ELSEIF t1 <> 0 THEN
	 IF t2 > 0 THEN
	    t = t1 / (t1 - t2)
	    edge(numedges%).p1 = numpoints%: edge(numedges%).p2 = pp%
	    edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%

	    split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	    IF aa% >= 0 THEN split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1
		 
	    edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1
	    r(numpoints%).x = r(p%).x + (r(pp%).x - r(p%).x) * t
	    r(numpoints%).y = r(p%).y + (r(pp%).y - r(p%).y) * t
	    r(numpoints%).z = r(p%).z + (r(pp%).z - r(p%).z) * t
	    numpoints% = numpoints% + 1
	 END IF
      ELSEIF t2 > 0 THEN
	 edge(numedges%).p1 = p%: edge(numedges%).p2 = pp%
	 edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%
	 
	 split1%(splitcnt1%) = p%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	 IF aa% >= 0 THEN split1%(splitcnt1%) = p%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1
	  
	 edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1
      END IF
   NEXT z%

   FOR z% = splitcnt1% - 1 TO 1 STEP -1
      sval% = splitag1%(z%)
      IF sval% >= 0 THEN
	 FOR zz% = z% - 1 TO 0 STEP -1
	    IF splitag1%(zz%) = sval% THEN EXIT FOR
	 NEXT zz%
	 
	 splitag1%(zz%) = -1

	 i1% = split1%(z%): i2% = split1%(zz%)
	 IF ABS(nx) >= ABS(ny) AND ABS(nx) > ABS(nz) THEN
	    i% = (r(i1%).y * r(i2%).z < r(i1%).z * r(i2%).y) = (nx > 0)
	 ELSEIF ABS(ny) > ABS(nz) THEN
	    i% = (r(i1%).z * r(i2%).x < r(i1%).x * r(i2%).z) = (ny > 0)
	 ELSE
	    i% = (r(i1%).x * r(i2%).y < r(i1%).y * r(i2%).x) = (nz > 0)
	 END IF

	 IF i% = 0 THEN
	    edge(numedges%).p1 = i1%: edge(numedges%).p2 = i2%
	 ELSE
	    edge(numedges%).p1 = i2%: edge(numedges%).p2 = i1%
	 END IF
	
	 edge(numedges%).a1 = sval%
	 edge(numedges%).a2 = -1
	 edgetag%(numedges%) = splitval%   'or &H4000?
	 numedges% = numedges% + 1
      END IF
   NEXT z%
  
   nummeshs% = nummeshs% + 1: mesh%(nummeshs%) = numedges%
END SUB

