DECLARE SUB addmesh (gbstart%)
DECLARE SUB draw3dclipline (bfx0!, bfy0!, bfz0!, bfx1!, bfy1!, bfz1!, col%)
DECLARE FUNCTION clip3dline% (x1!, y1!, z1!, x2!, y2!, z2!)
DECLARE SUB makeboxbsp ()
DECLARE SUB reduceedges (lnum%)
DECLARE FUNCTION rayscan% (x&, y&, z&, xv&, yv&, zv&)
DECLARE SUB clipmove (x&, y&, z&, xv&, yv&, zv&)
DECLARE SUB drawcubes ()
DECLARE SUB setuprotate3d (a1%, a2%, a3%)
DECLARE SUB backrotate3d (nx!, ny!, nz!)
DECLARE SUB loadboard ()
DECLARE SUB rotate3d (nx!, ny!, nz!)
DECLARE SUB add2bsp (meshnum%)
DECLARE SUB drawfasttextureplane (pstart%, pend%)
DECLARE SUB splitmesh1 (splitval%, meshnum%, nx!, ny!, nz!)
DECLARE SUB initmesh ()

CONST XDIM = 640&, YDIM = 350&, SCRMODE = 9
CONST HXDIM = XDIM \ 2, HYDIM = YDIM \ 2
CONST BSIZ = 16
CONST MAXPOINTS = 2500
CONST MAXMESHS = 1024
CONST MAXSPLITCNT = 1024
CONST WALLDIST = 128
CONST MAXSECTORS = (BSIZ * BSIZ * BSIZ) \ 4

TYPE point2d: x AS LONG: y AS LONG: END TYPE
TYPE point3d: x AS SINGLE: y AS SINGLE: z AS SINGLE: END TYPE
TYPE edgetype: p1 AS INTEGER: p2 AS INTEGER: a1 AS INTEGER: a2 AS INTEGER: END TYPE

DIM SHARED board%(BSIZ * BSIZ * BSIZ)  'Board layout

DIM SHARED tempshort%(BSIZ * BSIZ * BSIZ)
DIM SHARED numsectors%
DIM SHARED cubesect%(BSIZ * BSIZ * BSIZ)
DIM SHARED sectx1%(MAXSECTORS), secty1%(MAXSECTORS), sectz1%(MAXSECTORS)
DIM SHARED sectx2%(MAXSECTORS), secty2%(MAXSECTORS), sectz2%(MAXSECTORS)

DIM SHARED coordofpoint&(3, 8)
coordofpoint&(0, 0) = -512: coordofpoint&(0, 1) = 512
coordofpoint&(0, 2) = -512: coordofpoint&(0, 3) = 512
coordofpoint&(0, 4) = -512: coordofpoint&(0, 5) = 512
coordofpoint&(0, 6) = -512: coordofpoint&(0, 7) = 512
coordofpoint&(1, 0) = -512: coordofpoint&(1, 1) = -512
coordofpoint&(1, 2) = 512: coordofpoint&(1, 3) = 512
coordofpoint&(1, 4) = -512: coordofpoint&(1, 5) = -512
coordofpoint&(1, 6) = 512: coordofpoint&(1, 7) = 512
coordofpoint&(2, 0) = -512: coordofpoint&(2, 1) = -512
coordofpoint&(2, 2) = -512: coordofpoint&(2, 3) = -512
coordofpoint&(2, 4) = 512: coordofpoint&(2, 5) = 512
coordofpoint&(2, 6) = 512: coordofpoint&(2, 7) = 512
DIM SHARED pointofface%(6, 4)
pointofface%(0, 0) = 0: pointofface%(0, 1) = 4
pointofface%(0, 2) = 6: pointofface%(0, 3) = 2
pointofface%(1, 0) = 5: pointofface%(1, 1) = 1
pointofface%(1, 2) = 3: pointofface%(1, 3) = 7
pointofface%(2, 0) = 0: pointofface%(2, 1) = 1
pointofface%(2, 2) = 5: pointofface%(2, 3) = 4
pointofface%(3, 0) = 6: pointofface%(3, 1) = 7
pointofface%(3, 2) = 3: pointofface%(3, 3) = 2
pointofface%(4, 0) = 1: pointofface%(4, 1) = 0
pointofface%(4, 2) = 2: pointofface%(4, 3) = 3
pointofface%(5, 0) = 4: pointofface%(5, 1) = 5
pointofface%(5, 2) = 7: pointofface%(5, 3) = 6

	'New polygon variables
DIM SHARED r(MAXPOINTS) AS point3d
DIM SHARED sc(MAXPOINTS) AS point2d
DIM SHARED plist%(MAXPOINTS), elist%(MAXPOINTS), ecnt%
DIM SHARED got%(MAXPOINTS)

   'Mesh-splitting variables
DIM SHARED edge(MAXPOINTS) AS edgetype
DIM SHARED mesh%(MAXMESHS), nummeshs%, numedges%, numpoints%, endopoints%
DIM SHARED meshtag%(MAXMESHS), edgetag%(MAXPOINTS)
DIM SHARED tval(MAXPOINTS), split1%(MAXSPLITCNT), splitag1%(MAXSPLITCNT)

DIM SHARED fillist&(XDIM)

   'BSP variables
DIM SHARED bn(MAXPOINTS) AS point3d
DIM SHARED front%(MAXPOINTS), back%(MAXPOINTS), pt%(MAXPOINTS), pnum%

   'edge reduction variables
DIM SHARED ssx&(MAXPOINTS), ssy&(MAXPOINTS), ltag%(MAXPOINTS)

   'region definition variables
DIM SHARED facetag%(BSIZ * BSIZ)
DIM SHARED facesid%(BSIZ * BSIZ)
DIM SHARED gotsect%(BSIZ * BSIZ)

DIM SHARED sectlist%(BSIZ * BSIZ)
DIM SHARED bspstart%(BSIZ * BSIZ)
DIM SHARED gsect%, xdimup15&, ydimup15&, xreszoom, ydimscale

DIM SHARED posx&, posy&, posz&, a1%, a2%, a3%
DIM SHARED gxx, gxy, gxz, gyx, gyy, gyz, gzx, gzy, gzz

DIM SHARED regs%(7)

SCREEN SCRMODE: RANDOMIZE TIMER
regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())

xdimup15& = (XDIM + 1) * 32768
ydimup15& = (YDIM + 1) * 32768
xreszoom = 32768 * XDIM
ydimscale = YDIM / XDIM

DO
   CALL loadboard
   CALL makeboxbsp

   pag% = 1
   DO
      xvect& = 0: yvect& = 0: zvect& = 0

      regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
      obstatus% = bstatus%: bstatus% = regs%(0)
     
      regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
      xvect& = 0: yvect& = 0: zvect& = 0
      IF (bstatus% AND 1) = 0 THEN
	 xvect& = xvect& - gxz * regs%(3) * 16
	 yvect& = yvect& - gyz * regs%(3) * 16
	 zvect& = zvect& - gzz * regs%(3) * 16
      ELSE
	 a2% = a2% - regs%(3)
      END IF
      IF (bstatus% AND 2) = 0 THEN
	 a3% = a3% + regs%(2)
      ELSE
	 xvect& = xvect& + gxx * regs%(2) * 16
	 yvect& = yvect& + gyx * regs%(2) * 16
	 zvect& = zvect& + gzx * regs%(2) * 16
      END IF
     
      CLS
      CALL setuprotate3d(a1%, a2%, a3%)
      CALL drawcubes

      SCREEN , , pag%, 1 - pag%: pag% = 1 - pag%
      WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8

      DO
	 z$ = INKEY$
	 IF UCASE$(z$) = "A" THEN xvect& = xvect& - gxy * 256: yvect& = yvect& - gyy * 256: zvect& = zvect& - gzy * 256
	 IF UCASE$(z$) = "Z" THEN xvect& = xvect& + gxy * 256: yvect& = yvect& + gyy * 256: zvect& = zvect& + gzy * 256
	 IF z$ = CHR$(0) + CHR$(72) THEN xvect& = xvect& + gxz * 256: yvect& = yvect& + gyz * 256: zvect& = zvect& + gzz * 256
	 IF z$ = CHR$(0) + CHR$(80) THEN xvect& = xvect& - gxz * 256: yvect& = yvect& - gyz * 256: zvect& = zvect& - gzz * 256
      LOOP WHILE z$ <> "" AND z$ <> CHR$(13) AND z$ <> CHR$(27)

      IF xvect& OR yvect& OR zvect& <> 0 THEN
	 CALL clipmove(posx&, posy&, posz&, xvect&, yvect&, zvect&)
      END IF
   LOOP WHILE z$ <> CHR$(13) AND z$ <> CHR$(27)
LOOP WHILE z$ <> CHR$(27)

SUB add2bsp (plistnum%)
   FOR i% = plistnum% - 1 TO 0 STEP -1
      j% = plist%(i%): k% = j% AND 4095
      IF (j% AND &H8000) <> 0 THEN
	 IF (j% AND &H2000) <> 0 THEN
	    rp1% = edge(k%).p1: rp2% = edge(k%).p2
	 ELSE
	    rp1% = edge(k%).p2: rp2% = edge(k%).p1
	 END IF
	 bn(pnum%).x = r(rp1%).y * r(rp2%).z - r(rp2%).y * r(rp1%).z
	 bn(pnum%).y = r(rp2%).x * r(rp1%).z - r(rp1%).x * r(rp2%).z
	 bn(pnum%).z = r(rp1%).x * r(rp2%).y - r(rp2%).x * r(rp1%).y
      ELSE
	 bn(pnum%).x = bn(k%).x
	 bn(pnum%).y = bn(k%).y
	 bn(pnum%).z = bn(k%).z
      END IF
      front%(pnum%) = -1: back%(pnum%) = pnum% + 1
      pnum% = pnum% + 1
   NEXT i%
   back%(pnum% - 1) = -2
   EXIT SUB
  
  
   startpnum% = pnum%: p% = pnum% + 1

   FOR i% = plistnum% - 1 TO 0 STEP -1
      j% = plist%(i%): k% = j% AND 4095
      IF (j% AND &H8000) <> 0 THEN
	 IF (j% AND &H2000) <> 0 THEN
	    rp1% = edge(k%).p1: rp2% = edge(k%).p2
	 ELSE
	    rp1% = edge(k%).p2: rp2% = edge(k%).p1
	 END IF
	 bn(pnum%).x = r(rp1%).y * r(rp2%).z - r(rp2%).y * r(rp1%).z
	 bn(pnum%).y = r(rp2%).x * r(rp1%).z - r(rp1%).x * r(rp2%).z
	 bn(pnum%).z = r(rp1%).x * r(rp2%).y - r(rp2%).x * r(rp1%).y
      ELSE
	 bn(pnum%).x = bn(k%).x
	 bn(pnum%).y = bn(k%).y
	 bn(pnum%).z = bn(k%).z
	    'What about rp1% and rp2%!!
      END IF

      front%(pnum%) = -1: back%(pnum%) = -2: pt%(pnum%) = startpnum%
      pnum% = pnum% + 1

      DO WHILE p% < pnum%
	 z% = pt%(p%)
	 DO WHILE z% >= 0
	    oz% = z%
	    t1 = bn(z%).x * r(rp1%).x + bn(z%).y * r(rp1%).y + bn(z%).z * r(rp1%).z
	    t2 = bn(z%).x * r(rp2%).x + bn(z%).y * r(rp2%).y + bn(z%).z * r(rp2%).z

	    IF t1 >= 0 AND t2 >= 0 THEN
	       IF t1 = 0 AND t2 = 0 THEN pnum = pnum - 1: GOTO breakadd2bsploop
	       z% = front%(z%)
	       IF z% < 0 THEN front%(oz%) = p%
	    ELSEIF t1 <= 0 AND t2 <= 0 THEN
	       z% = back%(z%)
	       IF z% < 0 THEN back%(oz%) = p%
	    ELSE
	       bn(pnum%).x = bn(p%).x
	       bn(pnum%).y = bn(p%).y
	       bn(pnum%).z = bn(p%).z
	       front%(pnum%) = -1: back%(pnum%) = -2

	       pt%(pnum%) = back%(z%)
	       IF back%(z%) < 0 THEN back%(z%) = pnum%
	       pnum% = pnum% + 1
	       z% = front%(z%)
	       IF z% < 0 THEN front%(oz%) = p%
	    END IF
	 LOOP
	 p% = p% + 1
      LOOP
breakadd2bsploop:
   NEXT i%
END SUB

SUB addmesh (gbstart%)
   FOR i% = numedges% - 1 TO 0 STEP -1: edgetag%(i%) = (i% OR &H8000): NEXT i%

			'Get bounding box
   x0 = r(0).x: x1 = r(0).x
   y0 = r(0).y: y1 = r(0).y
   z0 = r(0).z: z1 = r(0).z
   FOR i% = numpoints% - 1 TO 1 STEP -1
      IF r(i%).x < x0 THEN x0 = r(i%).x
      IF r(i%).y < y0 THEN y0 = r(i%).y
      IF r(i%).z < z0 THEN z0 = r(i%).z
      IF r(i%).x > x1 THEN x1 = r(i%).x
      IF r(i%).y > y1 THEN y1 = r(i%).y
      IF r(i%).z > z1 THEN z1 = r(i%).z
   NEXT i%

   ecnt% = 0
   meshtag%(0) = gbstart%: pcnt% = 0
   DO WHILE pcnt% < nummeshs%
      p% = meshtag%(pcnt%)

      IF p% < 0 THEN
	 IF p% = -2 THEN elist%(ecnt%) = pcnt%: ecnt% = ecnt% + 1
	 GOTO addmeshcont
      END IF
			'Oops!  Dead branch
      IF front%(p%) < 0 AND back%(p%) = -1 THEN GOTO addmeshcont

			'Bounding box code
      x = bn(p%).x: y = bn(p%).y: z = bn(p%).z
     
      ft = 0
      IF bn(p%).x < 0 THEN
	 ft = ft + x * x1
      ELSEIF bn(p%).x <> 0 THEN
	 ft = ft + x * x0
      END IF
      IF bn(p%).y < 0 THEN
	 ft = ft + y * y1
      ELSEIF bn(p%).y <> 0 THEN
	 ft = ft + y * y0
      END IF
      IF bn(p%).z < 0 THEN
	 ft = ft + z * z1
      ELSEIF bn(p%).z <> 0 THEN
	 ft = ft + z * z0
      END IF
      IF ft >= 0 THEN meshtag%(pcnt%) = front%(p%): pcnt% = pcnt% - 1: GOTO addmeshcont
     
      ft = 0
      IF bn(p%).x < 0 THEN
	 ft = ft + x * x0
      ELSEIF bn(p%).x <> 0 THEN
	 ft = ft + x * x1
      END IF
      IF bn(p%).y < 0 THEN
	 ft = ft + y * y0
      ELSEIF bn(p%).y <> 0 THEN
	 ft = ft + y * y1
      END IF
      IF bn(p%).z < 0 THEN
	 ft = ft + z * z0
      ELSEIF bn(p%).z <> 0 THEN
	 ft = ft + z * z1
      END IF
      IF ft <= 0 THEN meshtag%(pcnt%) = back%(p%): pcnt% = pcnt% - 1: GOTO addmeshcont

			'Bounding box fails
      IF front%(p%) < 0 THEN
	 meshtag%(nummeshs%) = back%(p%)
	 CALL splitmesh1(p%, pcnt%, -x, -y, -z)
      ELSEIF back%(p%) = -1 THEN    'Already filled region
	 meshtag%(nummeshs%) = front%(p%)
	 CALL splitmesh1(p%, pcnt%, x, y, z)
      ELSE
	 meshtag%(nummeshs%) = front%(p%)
	 CALL splitmesh1(p%, pcnt%, x, y, z)
	 IF mesh%(nummeshs%) = mesh%(nummeshs% - 1) THEN nummeshs% = nummeshs% - 1
	 meshtag%(nummeshs%) = back%(p%)
	 CALL splitmesh1(p%, pcnt%, -x, -y, -z)
      END IF
      IF mesh%(nummeshs%) = mesh%(nummeshs% - 1) THEN nummeshs% = nummeshs% - 1
addmeshcont:
      pcnt% = pcnt% + 1
   LOOP
END SUB

SUB backrotate3d (nx, ny, nz)
   x = nx: y = ny: z = nz
   nx = x * gxx + y * gxy + z * gxz
   ny = x * gyx + y * gyy + z * gyz
   nz = x * gzx + y * gzy + z * gzz
END SUB

FUNCTION clip3dline% (x1, y1, z1, x2, y2, z2)
   a = 0: b = 1
 
   t1 = z1 + x1: t2 = z2 + x2
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF
 
   t1 = z1 - x1: t2 = z2 - x2
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF

   t1 = z1 * .625 + y1: t2 = z2 * .625 + y2
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF
 
   t1 = t1 - (y1 + y1): t2 = t2 - (y2 + y2)
   IF ((t1 AND t2) < 0) THEN clip3dline% = 0: EXIT FUNCTION
   IF ((t1 XOR t2) < 0) THEN
      t = t1 / (t1 - t2)
      IF t1 < 0 AND t > a THEN a = t
      IF t1 > 0 AND t < b THEN b = t
   END IF

   IF a <> 0 THEN x1 = (x2 - x1) * a + x1: y1 = (y2 - y1) * a + y1: z1 = (z2 - z1) * a + z1
   IF b <> 1 THEN x2 = (x2 - x1) * b + x1: y2 = (y2 - y1) * b + y1: z2 = (z2 - z1) * b + z1

   clip3dline% = 1
END FUNCTION

SUB clipmove (x&, y&, z&, xv&, yv&, zv&)
   IF rayscan%(x&, y&, z&, xv&, yv&, zv&) <> 255 THEN
      IF rayscan%(x&, y&, z&, xv&, yv&, zv&) <> 255 THEN
	 zx% = rayscan%(x&, y&, z&, xv&, yv&, zv&)
      END IF
   END IF
END SUB

SUB draw3dclipline (bfx0, bfy0, bfz0, bfx1, bfy1, bfz1, col%)
   fx0 = bfx0: fy0 = bfy0: fz0 = bfz0
   fx1 = bfx1: fy1 = bfy1: fz1 = bfz1
   CALL rotate3d(fx0, fy0, fz0)
   CALL rotate3d(fx1, fy1, fz1)
   IF ((fz0 <= 0) AND (fz1 <= 0)) THEN EXIT SUB
   IF (clip3dline(fx0, fy0, fz0, fx1, fy1, fz1) = 0) THEN EXIT SUB
   IF ((fz0 <= 0) OR (fz1 <= 0)) THEN EXIT SUB
   ft0 = HXDIM / fz0: ft1 = HXDIM / fz1
   LINE (fx0 * ft0 + HXDIM, fy0 * ft0 + HYDIM)-(fx1 * ft1 + HXDIM, fy1 * ft1 + HYDIM), col%
END SUB

SUB drawcubes
   DIM dapoint%(4)

   CALL initmesh

   sectlist%(0) = cubesect%((posx& \ 1024) * BSIZ * BSIZ + (posy& \ 1024) * BSIZ + (posz& \ 1024))
   bspstart%(0) = 0
   sectlistplc% = 0: sectlistnum% = 1
   DO
      gsect% = sectlist%(sectlistplc%)
      gotsectcnt% = 0

      numfaces% = 0
      IF (sectx1%(gsect%) * 1024) < posx& THEN
	 x& = sectx1%(gsect%) - 1
	 FOR y& = secty1%(gsect%) TO secty2%(gsect%)
	    FOR z& = sectz1%(gsect%) TO sectz2%(gsect%)
	       facetag%(numfaces%) = x& * BSIZ * BSIZ + y& * BSIZ + z&
	       facesid%(numfaces%) = 0
	       numfaces% = numfaces% + 1
	    NEXT z&
	 NEXT y&
      END IF
      IF ((sectx2%(gsect%) + 1) * 1024) > posx& THEN
	 x& = sectx2%(gsect%) + 1
	 FOR y& = secty1%(gsect%) TO secty2%(gsect%)
	    FOR z& = sectz1%(gsect%) TO sectz2%(gsect%)
	       facetag%(numfaces%) = x& * BSIZ * BSIZ + y& * BSIZ + z&
	       facesid%(numfaces%) = 1
	       numfaces% = numfaces% + 1
	    NEXT z&
	 NEXT y&
      END IF
      IF (secty1%(gsect%) * 1024) < posy& THEN
	 y& = secty1%(gsect%) - 1
	 FOR x& = sectx1%(gsect%) TO sectx2%(gsect%)
	    FOR z& = sectz1%(gsect%) TO sectz2%(gsect%)
	       facetag%(numfaces%) = x& * BSIZ * BSIZ + y& * BSIZ + z&
	       facesid%(numfaces%) = 2
	       numfaces% = numfaces% + 1
	    NEXT z&
	 NEXT x&
      END IF
      IF ((secty2%(gsect%) + 1) * 1024) > posy& THEN
	 y& = secty2%(gsect%) + 1
	 FOR x& = sectx1%(gsect%) TO sectx2%(gsect%)
	    FOR z& = sectz1%(gsect%) TO sectz2%(gsect%)
	       facetag%(numfaces%) = x& * BSIZ * BSIZ + y& * BSIZ + z&
	       facesid%(numfaces%) = 3
	       numfaces% = numfaces% + 1
	    NEXT z&
	 NEXT x&
      END IF
      IF (sectz1%(gsect%) * 1024) < posz& THEN
	 z& = sectz1%(gsect%) - 1
	 FOR x& = sectx1%(gsect%) TO sectx2%(gsect%)
	    FOR y& = secty1%(gsect%) TO secty2%(gsect%)
	       facetag%(numfaces%) = x& * BSIZ * BSIZ + y& * BSIZ + z&
	       facesid%(numfaces%) = 4
	       numfaces% = numfaces% + 1
	    NEXT y&
	 NEXT x&
      END IF
      IF ((sectz2%(gsect%) + 1) * 1024) > posz& THEN
	 z& = sectz2%(gsect%) + 1
	 FOR x& = sectx1%(gsect%) TO sectx2%(gsect%)
	    FOR y& = secty1%(gsect%) TO secty2%(gsect%)
	       facetag%(numfaces%) = x& * BSIZ * BSIZ + y& * BSIZ + z&
	       facesid%(numfaces%) = 5
	       numfaces% = numfaces% + 1
	    NEXT y&
	 NEXT x&
      END IF
      
      numedges% = 0: numpoints% = 0
      FOR f% = 0 TO numfaces% - 1
	 gcube% = facetag%(f%): dasid% = facesid%(f%)
	 x& = (gcube% \ (BSIZ * BSIZ)) * 1024 + 512 - posx&
	 y& = ((gcube% \ BSIZ) MOD BSIZ) * 1024 + 512 - posy&
	 z& = (gcube% MOD BSIZ) * 1024 + 512 - posz&
	 SELECT CASE dasid%
	    CASE 0: x& = x& + 1024
	    CASE 1: x& = x& - 1024
	    CASE 2: y& = y& + 1024
	    CASE 3: y& = y& - 1024
	    CASE 4: z& = z& + 1024
	    CASE 5: z& = z& - 1024
	 END SELECT
	 FOR e% = 0 TO 3
	    pe% = pointofface%(dasid%, e%)
	    px = coordofpoint&(0, pe%) + x&
	    py = coordofpoint&(1, pe%) + y&
	    pz = coordofpoint&(2, pe%) + z&
	    dapoint%(e%) = -1
	    FOR i% = numpoints% - 1 TO 0 STEP -1
	       IF px = r(i%).x AND py = r(i%).y AND pz = r(i%).z THEN
		  dapoint%(e%) = i%: EXIT FOR
	       END IF
	    NEXT i%
	    IF dapoint%(e%) < 0 THEN
	       r(numpoints%).x = px
	       r(numpoints%).y = py
	       r(numpoints%).z = pz
	       dapoint%(e%) = numpoints%
	       numpoints% = numpoints% + 1
	    END IF
	 NEXT e%
	 FOR e% = 0 TO 3
	    p1% = dapoint%(e%): p2% = dapoint%((e% + 1) AND 3)

	    bad% = 0
	    FOR i% = numedges% - 1 TO 0 STEP -1
	       IF edge(i%).p1 = p2% AND edge(i%).p2 = p1% THEN
		  edge(i%).a2 = gcube%: bad% = 1: EXIT FOR 'Double sided edge
	       END IF
	    NEXT i%
	    IF bad% = 0 THEN
	       edge(numedges%).p1 = p1%
	       edge(numedges%).p2 = p2%
	       edge(numedges%).a1 = gcube%
	       edge(numedges%).a2 = -1
	       numedges% = numedges% + 1
	    END IF
	 NEXT e%
      NEXT f%
     
      mesh%(0) = 0: mesh%(1) = numedges%: nummeshs% = 1

      CALL addmesh(bspstart%(sectlistplc%))
     
      FOR f% = 0 TO numfaces% - 1
	 gcube% = facetag%(f%)
	 IF board%(gcube%) >= 0 THEN
	    lnum% = 0
	   
	    endopoints% = numpoints%

	    FOR j% = ecnt% - 1 TO 0 STEP -1
	       p% = elist%(j%)

	       FOR z% = 0 TO numpoints% - 1: got%(z%) = 0: NEXT z%
	       FOR i% = mesh%(p%) TO mesh%(p% + 1) - 1
		  IF edge(i%).a1 = gcube% OR edge(i%).a2 = gcube% THEN

		     IF edge(i%).a1 = gcube% THEN
			p1% = edge(i%).p1: p2% = edge(i%).p2
		     ELSE
			p2% = edge(i%).p1: p1% = edge(i%).p2
		     END IF
		     IF got%(p1%) = 0 THEN
			fx = r(p1%).x: fy = r(p1%).y: fz = r(p1%).z
			CALL rotate3d(fx, fy, fz)
			ftemp = xreszoom / fz
			got%(p1%) = 1
			sc(p1%).x = fx * ftemp + xdimup15&
			sc(p1%).y = fy * ftemp + ydimup15&
		     END IF
		     IF got%(p2%) = 0 THEN
			fx = r(p2%).x: fy = r(p2%).y: fz = r(p2%).z
			CALL rotate3d(fx, fy, fz)
			ftemp = xreszoom / fz
			got%(p2%) = 1
			sc(p2%).x = fx * ftemp + xdimup15&
			sc(p2%).y = fy * ftemp + ydimup15&
		     END IF
		     'IF ((edgetag%(i%) AND &HC000) <> 0) THEN
			sc(endopoints%).x = sc(p1%).x
			sc(endopoints%).y = sc(p1%).y
			sc(endopoints% + 1).x = sc(p2%).x
			sc(endopoints% + 1).y = sc(p2%).y
			endopoints% = endopoints% + 2
		     'ELSE
		     '   ssx&(lnum%) = sc(p1%).x: ssx&(lnum% + 1) = sc(p2%).x
		     '   ssy&(lnum%) = sc(p1%).y: ssy&(lnum% + 1) = sc(p2%).y
		     '   ltag%(lnum%) = edgetag%(i%) AND &H3FFF
		     '   lnum% = lnum% + 2
		     'END IF
		  END IF
	       NEXT i%
	    NEXT j%

	    'IF lnum% > 0 THEN CALL reduceedges(lnum%)
	   
	    j = 0
	    FOR i% = numpoints% TO endopoints% - 1 STEP 2
	       j1 = sc(i%).x + sc(i% + 1).x
	       j2 = sc(i% + 1).y - sc(i%).y
	       j = j + j1 * j2
	    NEXT i%
	    IF j > 0 THEN CALL drawfasttextureplane(numpoints%, endopoints%)
	 ELSE
	    newsect% = cubesect%(gcube%)
	    bad% = 0
	    FOR i% = gotsectcnt% - 1 TO 0 STEP -1
	       IF gotsect%(i%) = newsect% THEN bad% = 1: EXIT FOR
	    NEXT i%
	    IF bad% = 0 THEN
	       gotsect%(gotsectcnt%) = newsect%: gotsectcnt% = gotsectcnt% + 1
	       plistnum% = 0
	       FOR j% = ecnt% - 1 TO 0 STEP -1
		  p% = elist%(j%): k% = mesh%(p% + 1) - 1
		  FOR i% = mesh%(p%) TO k%
		     IF edge(i%).a2 >= 0 THEN
			IF cubesect%(edge(i%).a1) = newsect% THEN
			   IF cubesect%(edge(i%).a2) <> newsect% THEN
			      plist%(plistnum%) = edgetag%(i%): plistnum% = plistnum% + 1
			   END IF
			ELSEIF cubesect%(edge(i%).a2) = newsect% THEN
			   plist%(plistnum%) = (edgetag%(i%) OR &H2000): plistnum% = plistnum% + 1
			END IF
		     ELSEIF cubesect%(edge(i%).a1) = newsect% THEN
			plist%(plistnum%) = edgetag%(i%): plistnum% = plistnum% + 1
		     END IF
		  NEXT i%
		  IF plistnum% >= 3 THEN
		     sectlist%(sectlistnum%) = newsect%
		     bspstart%(sectlistnum%) = pnum%
		     sectlistnum% = sectlistnum% + 1
		     CALL add2bsp(plistnum%)
		  END IF
	       NEXT j%
	    END IF
	 END IF
      NEXT f%
      sectlistplc% = sectlistplc% + 1
   LOOP WHILE sectlistplc% < sectlistnum%
END SUB

SUB drawfasttextureplane (pstart%, pend%)
   miny& = YDIM: maxy& = 0
   FOR z% = pstart% TO pend% - 1 STEP 2
      sc(z%).x = sc(z%).x \ 65536: sc(z% + 1).x = sc(z% + 1).x \ 65536
      sc(z%).y = sc(z%).y \ 65536: sc(z% + 1).y = sc(z% + 1).y \ 65536
      IF sc(z%).y <> sc(z% + 1).y THEN
	 tval(z%) = (sc(z% + 1).x - sc(z%).x) / (sc(z% + 1).y - sc(z%).y)
      END IF
      y& = sc(z%).y
      IF y& < miny& THEN miny& = y&
      IF y& > maxy& THEN maxy& = y&
   NEXT z%

   col% = (gsect% MOD 15) + 1

   FOR y& = miny& TO maxy&
      fillist&(0) = 0: fillcnt% = 1
      FOR z% = pend% - 2 TO pstart% STEP -2
	 y1& = sc(z%).y - y&: y2& = sc(z% + 1).y - y&
	 IF (y1& XOR y2&) < 0 THEN
	    IF y1& < y2& THEN
	       x& = sc(z%).x - y1& * tval(z%)
	    ELSE
	       x& = sc(z% + 1).x - y2& * tval(z%)
	    END IF
	    IF x& >= 0 THEN fillist&(fillcnt%) = x&: fillcnt% = fillcnt% + 1
	 END IF
      NEXT z%
      IF fillcnt% > 0 THEN
	 FOR z% = fillcnt% - 1 TO 1 STEP -1
	    FOR zz% = z% - 1 TO 0 STEP -1
	       IF fillist&(z%) < fillist&(zz%) THEN SWAP fillist&(z%), fillist&(zz%)
	    NEXT zz%
	 NEXT z%
       
	 FOR z% = fillcnt% - 2 TO 0 STEP -2
	    LINE (fillist&(z%), y&)-(fillist&(z% + 1), y&), col%
	 NEXT z%
      END IF
   NEXT y&

   FOR z% = pstart% TO pend% - 1 STEP 2
      x1& = sc(z%).x: y1& = sc(z%).y
      x2& = sc(z% + 1).x: y2& = sc(z% + 1).y
      LINE (x1& - 1, y1&)-(x2& - 1, y2&), 8
      LINE (x1& + 1, y1&)-(x2& + 1, y2&), 8
      LINE (x1&, y1& - 1)-(x2&, y2& - 1), 8
      LINE (x1&, y1& + 1)-(x2&, y2& + 1), 8
      LINE (x1&, y1&)-(x2&, y2&), 4
   NEXT z%
  
   FOR z% = pstart% TO pend% - 1 STEP 2
      x1& = sc(z%).x: y1& = sc(z%).y
      LINE (x1& - 1, y1& - 1)-(x1& + 1, y1& + 1), 12, BF
      PSET (x1&, y1&), 15
   NEXT z%
END SUB

SUB initmesh
   bn(0).x = -1: bn(0).y = 0: bn(0).z = -1           'left
   bn(1).x = 1: bn(1).y = 0: bn(1).z = -1            'right
   bn(2).x = 0: bn(2).y = -1: bn(2).z = -ydimscale   'top
   bn(3).x = 0: bn(3).y = 1: bn(3).z = -ydimscale    'bottom
   pnum% = 4

   FOR i% = 0 TO pnum% - 1
      CALL backrotate3d(bn(i%).x, bn(i%).y, bn(i%).z)
      front%(i%) = -1: back%(i%) = i% + 1
   NEXT i%
  
   back%(pnum% - 1) = -2
END SUB

SUB loadboard
   OPEN "board.cub" FOR BINARY AS #1
   GET #1, , versionum&: IF versionum& <> &HCBE THEN PRINT "Wrong cube version": END
   GET #1, , posx&
   GET #1, , posy&
   GET #1, , posz&
   GET #1, , a1&: a1% = a1&
   GET #1, , a2&: a2% = a2&
   GET #1, , a3&: a3% = a3&
   FOR z% = 0 TO BSIZ * BSIZ * BSIZ - 1: GET #1, , board%(z%): NEXT z%
   CLOSE #1
END SUB

SUB makeboxbsp
   a% = 0
   FOR i% = BSIZ * BSIZ * BSIZ - 1 TO 0 STEP -1
      IF board%(i%) < 0 THEN
	 cubesect%(i%) = -2: tempshort%(a%) = i%: a% = a% + 1
      ELSE
	 cubesect%(i%) = -1
      END IF
   NEXT i%
 
   numsectors% = 0
   DO
      i% = INT(a% * RND)
      x% = tempshort%(i%) \ (BSIZ * BSIZ)
      y% = (tempshort%(i%) \ BSIZ) MOD BSIZ
      z% = tempshort%(i%) MOD BSIZ
      IF cubesect%(tempshort%(i%)) = -2 THEN
	 x1% = x%: y1% = y%: z1% = z%: x2% = x%: y2% = y%: z2% = z%: bad% = 0
	 DO
	    IF (bad% AND 1) = 0 THEN
	       x2% = x2% + 1
	       FOR yy% = y1% TO y2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(x2% * BSIZ * BSIZ + yy% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 1: x2% = x2% - 1: EXIT FOR
		  NEXT zz%
	       NEXT yy%
	    END IF
	    IF (bad% AND 2) = 0 THEN
	       y2% = y2% + 1
	       FOR xx% = x1% TO x2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(xx% * BSIZ * BSIZ + y2% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 2: y2% = y2% - 1: EXIT FOR
		  NEXT zz%
	       NEXT xx%
	    END IF
	    IF (bad% AND 4) = 0 THEN
	       z2% = z2% + 1
	       FOR xx% = x1% TO x2%
		  FOR yy% = y1% TO y2%
		     IF cubesect%(xx% * BSIZ * BSIZ + yy% * BSIZ + z2%) <> -2 THEN bad% = bad% OR 4: z2% = z2% - 1: EXIT FOR
		  NEXT yy%
	       NEXT xx%
	    END IF
	    IF (bad% AND 8) = 0 THEN
	       x1% = x1% - 1
	       FOR yy% = y1% TO y2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(x1% * BSIZ * BSIZ + yy% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 8: x1% = x1% + 1: EXIT FOR
		  NEXT zz%
	       NEXT yy%
	    END IF
	    IF (bad% AND 16) = 0 THEN
	       y1% = y1% - 1
	       FOR xx% = x1% TO x2%
		  FOR zz% = z1% TO z2%
		     IF cubesect%(xx% * BSIZ * BSIZ + y1% * BSIZ + zz%) <> -2 THEN bad% = bad% OR 16: y1% = y1% + 1: EXIT FOR
		  NEXT zz%
	       NEXT xx%
	    END IF
	    IF (bad% AND 32) = 0 THEN
	       z1% = z1% - 1
	       FOR xx% = x1% TO x2%
		  FOR yy% = y1% TO y2%
		     IF cubesect%(xx% * BSIZ * BSIZ + yy% * BSIZ + z1%) <> -2 THEN bad% = bad% OR 32: z1% = z1% + 1: EXIT FOR
		  NEXT yy%
	       NEXT xx%
	    END IF
	 LOOP WHILE bad% <> 63

	 FOR x% = x1% TO x2%
	    FOR y% = y1% TO y2%
	       FOR z% = z1% TO z2%
		  cubesect%(x% * BSIZ * BSIZ + y% * BSIZ + z%) = numsectors%
	       NEXT z%
	    NEXT y%
	 NEXT x%
	 sectx1%(numsectors%) = x1%: sectx2%(numsectors%) = x2%
	 secty1%(numsectors%) = y1%: secty2%(numsectors%) = y2%
	 sectz1%(numsectors%) = z1%: sectz2%(numsectors%) = z2%
	 numsectors% = numsectors% + 1
      ELSE
	 a% = a% - 1: IF a% <= 0 THEN EXIT SUB
	 tempshort%(i%) = tempshort%(a%)
      END IF
   LOOP
END SUB

FUNCTION rayscan% (x&, y&, z&, xv&, yv&, zv&)
   lasthit% = 255
   intx& = x& + xv&
   inty& = y& + yv&
   intz& = z& + zv&

   IF xv& <> 0 THEN
      xdir& = SGN(xv&)
      IF xdir& < 0 THEN
	 gridx& = (x& - WALLDIST) \ 1024 - 1: nintx& = gridx& * 1024& + 1024 + WALLDIST
      ELSE
	 gridx& = (x& + WALLDIST - 1) \ 1024 + 1: nintx& = gridx& * 1024& - WALLDIST
      END IF
    
      j& = xdir& * BSIZ * BSIZ
      DO WHILE ABS(nintx& - x&) < ABS(intx& - x&)
	 ninty& = y& + yv& * (nintx& - x&) \ xv&
	 nintz& = z& + zv& * (nintx& - x&) \ xv&

	 bad% = 0
	 i& = gridx& * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = gridx& * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = gridx& * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = gridx& * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 IF bad% <> 0 THEN
	    lasthit% = 0: intx& = nintx&: inty& = ninty&: intz& = nintz&
	    EXIT DO
	 END IF
	 gridx& = gridx& + xdir&
	 nintx& = nintx& + xdir& * 1024&
      LOOP
   END IF
 
   IF yv& <> 0 THEN
      ydir& = SGN(yv&)
      IF ydir& < 0 THEN
	 gridy& = (y& - WALLDIST) \ 1024 - 1: ninty& = gridy& * 1024& + 1024 + WALLDIST
      ELSE
	 gridy& = (y& + WALLDIST - 1) \ 1024 + 1: ninty& = gridy& * 1024& - WALLDIST
      END IF
   
      j& = ydir& * BSIZ
      DO WHILE ABS(ninty& - y&) < ABS(inty& - y&)
	 nintx& = x& + xv& * (ninty& - y&) \ yv&
	 nintz& = z& + zv& * (ninty& - y&) \ yv&

	 bad% = 0
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& - WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + gridy& * BSIZ + ((nintz& + WALLDIST) \ 1024): IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 IF bad% <> 0 THEN
	    lasthit% = 1: intx& = nintx&: inty& = ninty&: intz& = nintz&
	    EXIT DO
	 END IF
	 gridy& = gridy& + ydir&
	 ninty& = ninty& + ydir& * 1024&
      LOOP
   END IF
 
   IF zv& <> 0 THEN
      zdir& = SGN(zv&)
      IF zdir& < 0 THEN
	 gridz& = (z& - WALLDIST) \ 1024 - 1: nintz& = gridz& * 1024& + 1024 + WALLDIST
      ELSE
	 gridz& = (z& + WALLDIST - 1) \ 1024 + 1: nintz& = gridz& * 1024& - WALLDIST
      END IF
  
      j& = zdir&
      DO WHILE ABS(nintz& - z&) < ABS(intz& - z&)
	 nintx& = x& + xv& * (nintz& - z&) \ zv&
	 ninty& = y& + yv& * (nintz& - z&) \ zv&

	 bad% = 0
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& - WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& - WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 i& = ((nintx& + WALLDIST) \ 1024) * BSIZ * BSIZ + ((ninty& + WALLDIST) \ 1024) * BSIZ + gridz&: IF ((board%(i&) >= 0) AND (board%(i& - j&) < 0)) THEN bad% = 1
	 IF bad% <> 0 THEN
	    lasthit% = 2: intx& = nintx&: inty& = ninty&: intz& = nintz&
	    EXIT DO
	 END IF
	 gridz& = gridz& + zdir&
	 nintz& = nintz& + zdir& * 1024&
      LOOP
   END IF
   IF lasthit% = 0 THEN xv& = 0 ELSE xv& = x& + xv& - intx&
   IF lasthit% = 1 THEN yv& = 0 ELSE yv& = y& + yv& - inty&
   IF lasthit% = 2 THEN zv& = 0 ELSE zv& = z& + zv& - intz&
   x& = intx&: y& = inty&: z& = intz&
   rayscan% = lasthit%
END FUNCTION

SUB reduceedges (lnum%)
   lnum% = lnum% \ 2
  
   gap& = lnum% \ 2
   WHILE gap& > 0
      FOR z& = 0 TO lnum% - gap& - 1
	 FOR zz& = z& TO 0 STEP -gap&
	    i1& = zz& * 2: i2& = (zz& + gap&) * 2
	    IF ltag%(i1&) >= ltag%(i2&) THEN EXIT FOR
	    SWAP ssx&(i1&), ssx&(i2&): SWAP ssx&(i1& + 1), ssx&(i2& + 1)
	    SWAP ssy&(i1&), ssy&(i2&): SWAP ssy&(i1& + 1), ssy&(i2& + 1)
	    SWAP ltag%(i1&), ltag%(i2&)
	 NEXT zz&
      NEXT z&
      gap& = gap& \ 2
   WEND

   lnum% = lnum% + lnum%

   z& = 0
   WHILE z& < lnum%
      lt& = ltag%(z&): zz& = z&
      DO
	 ltag%(zz&) = 1: ltag%(zz& + 1) = -1: zz& = zz& + 2
      LOOP WHILE ltag%(zz&) = lt& AND zz& < lnum%
     
      pcnt& = zz& - z&
      IF (ABS(ssx&(z& + 1) - ssx&(z&)) >= ABS(ssy&(z& + 1) - ssy&(z&))) THEN
	 gap& = pcnt& \ 2
	 WHILE gap& > 0
	    FOR zx& = 0 TO pcnt& - gap& - 1
	       FOR zzx& = zx& TO 0 STEP -gap&
		  i1& = zzx& + z&: i2& = zzx& + gap& + z&
		  IF ssx&(i1&) <= ssx&(i2&) THEN EXIT FOR
		  SWAP ssx&(i1&), ssx&(i2&)
		  SWAP ssy&(i1&), ssy&(i2&)
		  SWAP ltag%(i1&), ltag%(i2&)
	       NEXT zzx&
	    NEXT zx&
	    gap& = gap& \ 2
	 WEND
      ELSE
	 gap& = pcnt& \ 2
	 WHILE gap& > 0
	    FOR zx& = 0 TO pcnt& - gap& - 1
	       FOR zzx& = zx& TO 0 STEP -gap&
		  i1& = zzx& + z&: i2& = zzx& + gap& + z&
		  IF ssy&(i1&) <= ssy&(i2&) THEN EXIT FOR
		  SWAP ssx&(i1&), ssx&(i2&)
		  SWAP ssy&(i1&), ssy&(i2&)
		  SWAP ltag%(i1&), ltag%(i2&)
	       NEXT zzx&
	    NEXT zx&
	    gap& = gap& \ 2
	 WEND
      END IF

      s& = 0: baks& = 0
      FOR dap& = z& TO zz& - 2
	 s& = s& + ltag%(dap&)
	 IF s& <> 0 THEN
	    x1& = ssx&(dap&): x2& = ssx&(dap& + 1)
	    y1& = ssy&(dap&): y2& = ssy&(dap& + 1)
	    IF x1& <> x2& OR y1& <> y2& THEN
	       IF baks& = s& AND bakx& = x1& AND baky& = y1& THEN
		  IF s& > 0 THEN
		     sc(endopoints% - 1).x = x2&: sc(endopoints% - 1).y = y2&
		  ELSE
		     sc(endopoints% - 2).x = x2&: sc(endopoints% - 2).y = y2&
		  END IF
	       ELSE
		  IF s& > 0 THEN
		     sc(endopoints%).x = x1&: sc(endopoints% + 1).x = x2&
		     sc(endopoints%).y = y1&: sc(endopoints% + 1).y = y2&
		  ELSE
		     sc(endopoints%).x = x2&: sc(endopoints% + 1).x = x1&
		     sc(endopoints%).y = y2&: sc(endopoints% + 1).y = y1&
		  END IF
		  endopoints% = endopoints% + 2
		  baks& = s&
	       END IF
	       bakx& = x2&: baky& = y2&
	    END IF
	 END IF
      NEXT dap&
    
      z& = zz&
   WEND
END SUB

SUB rotate3d (nx, ny, nz)
   x = nx: y = ny: z = nz
   nx = x * gxx + y * gyx + z * gzx
   ny = x * gxy + y * gyy + z * gzy
   nz = x * gxz + y * gyz + z * gzz
END SUB

SUB setuprotate3d (a1%, a2%, a3%)
   cosa1 = COS(a1% * 3.141592 / 1024): sina1 = SIN(a1% * 3.141592 / 1024)
   cosa2 = COS(a2% * 3.141592 / 1024): sina2 = SIN(a2% * 3.141592 / 1024)
   cosa3 = COS(a3% * 3.141592 / 1024): sina3 = SIN(a3% * 3.141592 / 1024)
   c1c3 = cosa1 * cosa3: c1s3 = cosa1 * sina3
   s1c3 = sina1 * cosa3: s1s3 = sina1 * sina3
   gxx = s1s3 * sina2 + c1c3: gyx = -sina1 * cosa2: gzx = s1c3 * sina2 - c1s3
   gxy = -c1s3 * sina2 + s1c3: gyy = cosa1 * cosa2: gzy = -c1c3 * sina2 - s1s3
   gxz = cosa2 * sina3: gyz = sina2: gzz = cosa2 * cosa3
END SUB

SUB splitmesh1 (splitval%, meshnum%, nx, ny, nz)
   pstart% = mesh%(meshnum%): pend% = mesh%(meshnum% + 1) - 1

   FOR z% = 0 TO numpoints% - 1: got%(z%) = 0: NEXT z%
       
   splitcnt1% = 0
   FOR z% = pstart% TO pend%
      p% = edge(z%).p1: pp% = edge(z%).p2
      a% = edge(z%).a1: aa% = edge(z%).a2
      IF got%(p%) = 0 THEN tval(p%) = r(p%).x * nx + r(p%).y * ny + r(p%).z * nz: got%(p%) = 1
      IF got%(pp%) = 0 THEN tval(pp%) = r(pp%).x * nx + r(pp%).y * ny + r(pp%).z * nz: got%(pp%) = 1
      t1 = tval(p%): t2 = tval(pp%)
      IF t1 > 0 THEN
	 IF t2 >= 0 THEN
	    edge(numedges%).p1 = p%: edge(numedges%).p2 = pp%
	    edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%
	    IF t2 = 0 THEN
	       split1%(splitcnt1%) = pp%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	       IF aa% >= 0 THEN split1%(splitcnt1%) = pp%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1
	    END IF
	    edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1
	 ELSE
	    t = t1 / (t1 - t2)
	    edge(numedges%).p1 = p%: edge(numedges%).p2 = numpoints%
	    edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%

	    split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	    IF aa% >= 0 THEN split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1

	    edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1

	    r(numpoints%).x = r(p%).x + (r(pp%).x - r(p%).x) * t
	    r(numpoints%).y = r(p%).y + (r(pp%).y - r(p%).y) * t
	    r(numpoints%).z = r(p%).z + (r(pp%).z - r(p%).z) * t
	    numpoints% = numpoints% + 1
	 END IF
      ELSEIF t1 <> 0 THEN
	 IF t2 > 0 THEN
	    t = t1 / (t1 - t2)
	    edge(numedges%).p1 = numpoints%: edge(numedges%).p2 = pp%
	    edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%

	    split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	    IF aa% >= 0 THEN split1%(splitcnt1%) = numpoints%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1
		 
	    edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1
	    r(numpoints%).x = r(p%).x + (r(pp%).x - r(p%).x) * t
	    r(numpoints%).y = r(p%).y + (r(pp%).y - r(p%).y) * t
	    r(numpoints%).z = r(p%).z + (r(pp%).z - r(p%).z) * t
	    numpoints% = numpoints% + 1
	 END IF
      ELSEIF t2 > 0 THEN
	 edge(numedges%).p1 = p%: edge(numedges%).p2 = pp%
	 edge(numedges%).a1 = a%: edge(numedges%).a2 = aa%
	 
	 split1%(splitcnt1%) = p%: splitag1%(splitcnt1%) = a%: splitcnt1% = splitcnt1% + 1
	 IF aa% >= 0 THEN split1%(splitcnt1%) = p%: splitag1%(splitcnt1%) = aa%: splitcnt1% = splitcnt1% + 1
	  
	 edgetag%(numedges%) = edgetag%(z%): numedges% = numedges% + 1
      END IF
   NEXT z%

   FOR z% = splitcnt1% - 1 TO 1 STEP -1
      sval% = splitag1%(z%)
      IF sval% >= 0 THEN
	 FOR zz% = z% - 1 TO 0 STEP -1
	    IF splitag1%(zz%) = sval% THEN EXIT FOR
	 NEXT zz%
	 
	 splitag1%(zz%) = -1

	 i1% = split1%(z%): i2% = split1%(zz%)
	 IF ABS(nx) >= ABS(ny) AND ABS(nx) > ABS(nz) THEN
	    i% = (r(i1%).y * r(i2%).z < r(i1%).z * r(i2%).y) = (nx > 0)
	 ELSEIF ABS(ny) > ABS(nz) THEN
	    i% = (r(i1%).z * r(i2%).x < r(i1%).x * r(i2%).z) = (ny > 0)
	 ELSE
	    i% = (r(i1%).x * r(i2%).y < r(i1%).y * r(i2%).x) = (nz > 0)
	 END IF

	 IF i% = 0 THEN
	    edge(numedges%).p1 = i1%: edge(numedges%).p2 = i2%
	 ELSE
	    edge(numedges%).p1 = i2%: edge(numedges%).p2 = i1%
	 END IF
	
	 edge(numedges%).a1 = sval%
	 edge(numedges%).a2 = -1
	 edgetag%(numedges%) = splitval%   'or &H4000?
	 numedges% = numedges% + 1
      END IF
   NEXT z%
  
   nummeshs% = nummeshs% + 1: mesh%(nummeshs%) = numedges%
END SUB

