DECLARE SUB hline (xl&, xr&, yp&, zd&, walnume%, shadeoffs%)
DECLARE SUB hvline (x%, y1&, y2&, zd&, walnume%, shadeoffs%)
DECLARE SUB vline (x%, y1&, y2&, siz&, walnume%, picplc%, shadeoffs%)
DECLARE SUB setupscreen ()
DECLARE SUB loadnewall (wallnum%)
DECLARE SUB loadtables ()

CONST maxwalls% = 4096
CONST xdim = 320
CONST ydim = 200

DIM SHARED buf%(4096), sintable&(2048), umost%(xdim), dmost%(xdim)
DIM SHARED picsiz%(maxwalls%), picanm%(maxwalls%)
COMMON SHARED posx&, posy&, ang%

RANDOMIZE TIMER
CALL loadtables
CALL setupscreen
CALL loadnewall(7)

ang% = INT(2048 * RND)
posx& = INT(64 * RND): posy& = INT(64 * RND): posz& = INT(4096 * RND) + 6144

FOR z% = 0 TO 319
   CALL hvline(z%, 0, 99, posz&, 0, 0)
   CALL hvline(z%, 101, 199, posz&, 0, 0)
NEXT z%
FOR z& = 0 TO 199
   CALL hline(0, 319, z&, posz&, 0, 0)
NEXT z&
FOR z% = 0 TO 319
   umost%(z%) = 50 * SIN(z% / 30) + 40
   dmost%(z%) = 50 * COS(z% / 40) + 160
   CALL vline(z%, 0, 199& * 65536, 512& * 65536, 0, z% * 64&, 0)
NEXT z%

SUB hline (xl&, xr&, yp&, zd&, walnume%, shadeoffs%)
   IF ((yp& = ydim \ 2) OR (picsiz%(walnume%) = 0)) THEN EXIT SUB
   IF xl& > xr& THEN SWAP xl&, xr&
   siz& = xr& - xl& + 1
   hd& = (zd& * 16384&) \ (xdim * ABS(ydim \ 2 - yp&))
   IF ABS(hd&) > 131072 THEN EXIT SUB
   xc& = (hd& * sintable&((2048 + ang%) AND 2047)) \ 1024&
   yc& = (hd& * sintable&((2560 + ang%) AND 2047)) \ 1024&
   x& = xc& * xl& - (xc& + yc&) * (xdim \ 2) - (posx& * 16384&)
   y& = yc& * xl& + (xc& - yc&) * (xdim \ 2) + (posy& * 16384&)
   IF yp& > (ydim \ 2) THEN
      y& = y& XOR &HFFFFFFFF
      yc& = yc& XOR &HFFFFFFFF
   END IF

   shade% = hd& \ 8192&
     
   p& = yp& * 320& + xl&: DEF SEG = &HA000
       
   FOR zx& = 1 TO siz&
      POKE p&, buf%(((x& \ 262144) AND 63) * 64 + ((y& \ 262144) AND 63))
      p& = p& + 1
      x& = x& + xc&
      y& = y& + yc&
   NEXT zx&

END SUB

SUB hvline (x%, y1&, y2&, zd&, walnume%, shadeoffs%)
   p& = y1& * 320& + x%: DEF SEG = &HA000
   hd& = ABS(y1& - 100): hdir& = SGN(y1& - 100)
   t1& = (zd& * (sintable&((2048 + ang%) AND 2047))) \ 64&
   t2& = (zd& * (sintable&((2560 + ang%) AND 2047))) \ 64&
   t3& = (t1& + t2&) \ 2
   t4& = (t1& - t2&) \ 2
   t1& = (t1& * x%) \ 320 - t3&
   t2& = (t2& * x%) \ 320 + t4&
   FOR yp& = y1& TO y2&
      x& = (t1& \ hd& - posx&)
      y& = (t2& \ hd& + posy&)
      POKE p&, buf%(((x& \ 256) AND 63) * 64 + ((y& \ 256) AND 63))
      p& = p& + 320
      hd& = hd& + hdir&
   NEXT yp&
END SUB

SUB loadnewall (wallnum%)
   OPEN "pics.dat" FOR BINARY AS #1

   SEEK #1, 1
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
      picsiz%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%
   buf$ = STRING$(maxwalls%, 0)
   GET #1, , buf$
   FOR z% = 0 TO maxwalls% - 1
      picanm%(z%) = ASC(MID$(buf$, z% + 1, 1))
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      IF picsiz%(z%) > 0 THEN totsiz& = totsiz& + 2 ^ ((picsiz%(z%) AND 15) + (picsiz%(z%) \ 16))
   NEXT z%
   SEEK #1, totsiz& + maxwalls% * 2 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 63
      FOR zz% = 0 TO 63
         buf%(z% * 64 + zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB setupscreen
   SCREEN 13
   'OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) AND (255 - 8)    'CHAIN 4 OFF
   'OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) OR 64           'WORD MODE
   'OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) AND (255 - 64)  '2-WORD MODE
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   CLOSE #1
END SUB

SUB vline (x%, y1&, y2&, siz&, walnume%, picplc%, shadeoffs%)
   y1v% = y1& \ 65536
   y2v% = y2& \ 65536
   sizv% = siz& \ 65536
   thesiz% = y2v% - y1v%
  
   IF (y1v% > dmost%(x%)) OR (y2v% < umost%(x%)) OR (thesiz% <= 0) OR (sizv% <= 0) OR (x% < 0) OR (x% >= xdim) THEN EXIT SUB

   picplc% = picplc% AND &HFC0
   vinc& = (33554432 * 32) \ (siz& \ 2048)
   vplc& = ((((y1& AND 65535 XOR 65535) * (vinc& \ 256)) \ 256) AND 65535)
   IF (y1v% < umost%(x%)) THEN
      vplc& = vplc& + (umost%(x%) - y1v%) * vinc&
      y1v% = umost%(x%)
   END IF
   IF (y2v% >= dmost%(x%)) THEN y2v% = dmost%(x%) - 1
   thesiz% = y2v% - y1v%
   IF (thesiz% < 1) OR (thesiz% > dmost%(x%)) THEN EXIT SUB

   DEF SEG = &HA000
   p& = y1v% * 320& + x%
   FOR zx% = 0 TO thesiz%
      vplc& = vplc& + vinc&
      dat% = buf%(picplc% + ((vplc& \ 65536) AND 63))
      POKE p&, dat%
      p& = p& + 320
   NEXT zx%
END SUB

