#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>

static unsigned char vox[128][128][128], linused[128][128];
static long int tantable[1024], yoffset, zoffset, cubedim, halfcubedim;
static short int sintable[2048], uplc[320], dplc[320];

#pragma aux setvmode =\
	"int 10h",\
	parm [eax]\

#pragma aux clearscreen =\
	"mov edi, 000a0000h",\
	"mov ecx, 16000d",\
	"xor eax, eax",\
	"rep stosd",\
	modify [edi ecx eax]\

#pragma aux vlinasm =\
	"add edi, 000a0000h",\
	"shr ecx, 1",\
	"jz vlinskipsome",\
	"lahf",\
"vlinlab: mov byte ptr [edi], al",\
	"mov byte ptr [edi+320], al",\
	"add edi, 640",\
	"loop vlinlab",\
	"sahf",\
"vlinskipsome: jnc vlinskip",\
	"mov byte ptr [edi], al",\
"vlinskip:",\
	parm [al][edi][ecx]\

main(short int argc,char **argv)
{
	char ch;
	short int ang, angvel, pag;

	cubedim = 32;
	if (argc == 2)
	{
		cubedim = (atol(argv[1])&0xfffffffe);
		if ((cubedim > 128) || (cubedim < 8))
			cubedim = 32;
	}
	loadtables();
	setupvoxbuffer();
	setvmode(0x13);
	ang = 128;
	angvel = 16;
	pag = 1;
	ch = 0;
	while (ch != 27)
	{
		pag = 1 - pag;
		outp(0x3cd,pag);
		clearscreen();
		drawvox(ang);
		outp(0x3d4,0xc); outp(0x3d5,pag<<6);
		ang += angvel;
		if (kbhit() != 0)
		{
			ch = getch();
			if (ch == 32) angvel = 0;
			if ((ch == 'S') || (ch == 's')) angvel += 8;
			if ((ch == 'D') || (ch == 'd')) angvel -= 8;
			if (ch == 32) angvel = 0;
			if ((ch == 'A') || (ch == 'a')) yoffset--;
			if ((ch == 'Z') || (ch == 'z')) yoffset++;
			if (ch == 0)
			{
				ch = getch();
				if (ch == 73) zoffset -= (zoffset>>4);
				if (ch == 81) zoffset += (zoffset>>4);
			}
		}
	}
	setvmode(0x3);
	return(0);
}

setupvoxbuffer()
{
	short int i, j, k;
	long int dist;

	halfcubedim = (cubedim>>1);
	for(i=0;i<cubedim;i++)
	{
		for(j=0;j<cubedim;j++)
			for(k=0;k<cubedim;k++)
			{
				vox[i][j][k] = 0;
				dist = (long int)((i-halfcubedim)*(i-halfcubedim) + (j-halfcubedim)*(j-halfcubedim) + (k-halfcubedim)*(k-halfcubedim));
				if ((dist >= (halfcubedim-1)*(halfcubedim-1)) && (dist < halfcubedim*halfcubedim) && (j < (halfcubedim>>1)))
					vox[i][j][k] = ((i+j+k)&63)+32;
				if ((i == halfcubedim) && (k == halfcubedim) && (j < (halfcubedim>>1)+(cubedim>>3)))
					vox[i][j][k] = j+32;
				dist = (long int)((i-halfcubedim)*(i-halfcubedim) + (j-cubedim-4)*(j-cubedim-4) + (k-halfcubedim)*(k-halfcubedim));
				if ((dist >= (halfcubedim-1)*(halfcubedim-1)) && (dist < halfcubedim*halfcubedim))
					vox[i][j][k] = ((i+j+k)&63)+32;
				if ((i == 0) || (j == 0) || (k == 0) || (i == cubedim-1) || (j == cubedim-1) || (k == cubedim-1))
				{
					vox[i][j][k] = ((i-j+k)&63) + 32;
					if ((i >= (cubedim>>3)) && (i < cubedim-(cubedim>>3)) && (j >= (cubedim>>3)) && (j < cubedim-(cubedim>>3)) && ((k == 0) || (k == cubedim-1)))
						vox[i][j][k] = 0;
					if ((i >= (cubedim>>3)) && (i < cubedim-(cubedim>>3)) && (k >= (cubedim>>3)) && (k < cubedim-(cubedim>>3)) && ((j == 0) || (j == cubedim-1)))
						vox[i][j][k] = 0;
					if ((j >= (cubedim>>3)) && (j < cubedim-(cubedim>>3)) && (k >= (cubedim>>3)) && (k < cubedim-(cubedim>>3)) && ((i == 0) || (i == cubedim-1)))
						vox[i][j][k] = 0;
				}
			}
		printf("%d\n",i);
	}
	for(i=0;i<cubedim;i++)
		for(k=0;k<cubedim;k++)
		{
			linused[i][k] = 0;
			for(j=0;j<cubedim;j++)
				linused[i][k] |= vox[i][j][k];
		}
	yoffset = halfcubedim;
	zoffset = (long int)(cubedim<<13);
	return(0);
}

drawvox(ang)
short int ang;
{
	long int cosang, sinang, x[4], z[4], sx[4], sya[4], syb[4];
	char col, coloffs, donewalls;
	short int i, s, news, lmostx, x1, x2;
	long int xp, yp, zp, xps, xpe, xpi, zps, zpe, zpi, yval1, yval2;
	long int y1, y2, yinc1, yinc2;

	cosang = (long int)(sintable[(2560+ang)&2047]>>2);
	sinang = (long int)(sintable[(2048+ang)&2047]>>2);
	if ((ang&1536) == 0) xps=cubedim-1, xpe=-1, xpi=-1, zps=cubedim-1, zpe=-1, zpi=-1;
	if ((ang&1536) == 512) xps=cubedim-1, xpe=-1, xpi=-1, zps=0, zpe=cubedim, zpi=1;
	if ((ang&1536) == 1024) xps=0, xpe=cubedim, xpi=1, zps=0, zpe=cubedim, zpi=1;
	if ((ang&1536) == 1536) xps=0, xpe=cubedim, xpi=1, zps=cubedim-1, zpe=-1, zpi=-1;
	for(xp=xps;xp!=xpe;xp+=xpi)
		for(zp=zps;zp!=zpe;zp+=zpi)
			if (linused[xp][zp] > 0)
			{
				x[0] = (xp-halfcubedim)*cosang - (zp-halfcubedim)*sinang;
				z[0] = (zp-halfcubedim)*cosang + (xp-halfcubedim)*sinang;
				x[1] = x[0]-cosang;
				z[1] = z[0]-sinang;
				x[2] = x[1]+sinang;
				z[2] = z[1]-cosang;
				x[3] = x[0]+sinang;
				z[3] = z[0]-cosang;
        
				lmostx = 0;
				for(i=1;i<=3;i++)
					if (x[i] < x[lmostx]) lmostx = i;
				if (x[lmostx] == x[(lmostx+3)&3]) lmostx=((lmostx+3)&3);

				if (z[lmostx] > -(zoffset>>1))
				{
					for(i=0;i<4;i++)
						sx[i] = ((x[i]<<8)/(z[i]+zoffset)) + 160L;

					yp = cubedim;
					while (yp != halfcubedim)
					{
						if (yp < halfcubedim)
							yp = cubedim-1 - yp;
						else
							yp = cubedim - yp;
						if (vox[xp][yp][zp] != 0)
						{
							col = vox[xp][yp][zp];

							yval1 = ((yp-yoffset)<<22);
							yval2 = yval1+4194304L;
							for(i=0;i<4;i++)
							{
								sya[i] = (yval1 / (z[i]+zoffset)) + 400L;
								syb[i] = (yval2 / (z[i]+zoffset)) + 400L;
							}

							donewalls = 0;
							s = lmostx;
							do
							{
								news = ((s+1)&3);

								x1 = sx[s];
								x2 = sx[news];

								if (x1 != x2)
								{
									yinc1 = ((sya[news]-sya[s])<<14) / (x2-x1);
									yinc2 = ((syb[news]-syb[s])<<14) / (x2-x1);
									if (x1 < x2)
									{
										y1 = (sya[s]<<14);
										y2 = ((syb[s]-1)<<14);
									}
									else
									{
										y1 = (sya[news]<<14);
										y2 = ((syb[news]-1)<<14);
										i = x1, x1 = x2, x2 = i;
										donewalls = 1;
									}
									x2--;
                       
									if (donewalls == 0)
									{
										coloffs = col;
										if ((s&1) > 0) coloffs += 72;
										for(i=x1;i<=x2;i++)
										{
											if ((i >= 0) && (i < 320))
											{
												uplc[i] = (short int)(y1>>16);
												dplc[i] = (short int)(y2>>16);
												vlin(i,uplc[i],dplc[i],coloffs);
											}
											y1 += yinc1;
											y2 += yinc2;
										}
									}
									else
									{
										if (sya[s] > 400)
											if ((yp == 0) || (vox[xp][yp-1][zp] == 0))
												for(i=x1;i<=x2;i++)
												{
													if ((i >= 0) && (i < 320))
														vlin(i,(short int)(y1>>16),uplc[i]-1,col+2);
													y1 += yinc1;
												}
										if (syb[s] < 400)
											if ((yp == cubedim-1) || (vox[xp][yp+1][zp] == 0))
												for(i=x1;i<=x2;i++)
												{
													if ((i >= 0) && (i < 320))
														vlin(i,dplc[i]+1,(short int)(y2>>16),col+74);
													y2 += yinc2;
												}
									}
								}
								s = news;
							}
							while (s != lmostx);
						}
					}
				}
			}
}

vlin(short int x,short int y1,short int y2,char col)
{
	short int i;

	if (y1 < 0) y1 = 0;
	if (y2 > 199) y2 = 199;
	if (y2 >= y1)
		vlinasm(col,(((long int)y1)*320L)+((long int)x),(long int)(y2-y1+1));
}

loadtables()
{
	short int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
	return(0);
}
