#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>

#define maxwalls 4096

static char *pic;
static unsigned char picsiz[maxwalls], picanm[maxwalls];
static long waloff[maxwalls];
static short int sintable[2048];
static char palette[768];
static char keystatus[256], readch, oldreadch, extended;
static (__interrupt __far *oldkeyhandler)();
static void __interrupt __far keyhandler(void);

static long lx[60] =
{
  0L,81L,50L,-50L,-81L,
  0L,81L,131L,81L,0L,
  81L,131L,131L,81L,50L,
  50L,81L,0L,-81L,-50L,
  0L,-81L,-131L,-81L,0L,
  -81L,-131L,-131L,-81L,-50L,
  0L,-81L,-50L,50L,81L,
  0L,-81L,-131L,-81L,0L,
  -81L,-131L,-131L,-81L,-50L,
  -50L,-81L,0L,81L,50L,
  0L,81L,131L,81L,0L,
  81L,131L,131L,81L,50L,
};
static long ly[60] =
{
  85L,26L,-69L,-69L,26L,
  85L,26L,43L,111L,138L,
  26L,43L,-43L,-111L,-69L,
  -69L,-111L,-138L,-111L,-69L,
  85L,26L,43L,111L,138L,
  26L,43L,-43L,-111L,-69L,
  -85L,-26L,69L,69L,-26L,
  -85L,-26L,-43L,-111L,-138L,
  -26L,-43L,43L,111L,69L,
  69L,111L,138L,111L,69L,
  -85L,-26L,-43L,-111L,-138L,
  -26L,-43L,43L,111L,69L,
};
static long lz[60] =
{
  -111L,-111L,-111L,-111L,-111L,
  -111L,-111L,-26L,26L,-26L,
  -111L,-26L,26L,-26L,-111L,
  -111L,-26L,26L,-26L,-111L,
  -111L,-111L,-26L,26L,-26L,
  -111L,-26L,26L,-26L,-111L,
  111L,111L,111L,111L,111L,
  111L,111L,26L,-26L,26L,
  111L,26L,-26L,26L,111L,
  111L,26L,-26L,26L,111L,
  111L,111L,26L,-26L,26L,
  111L,26L,-26L,26L,111L,
};

/*
  0,85,-111,   81,26,-111,  50,-69,-111, -50,-69,-111, -81,26,-111
  0,85,-111,   81,26,-111,  131,43,-26,  81,111,26,    0,138,-26
  81,26,-111,  131,43,-26,  131,-43,26,  81,-111,-26,  50,-69,-111
  50,-69,-111, 81,-111,-26, 0,-138,26,   -81,-111,-26, -50,-69,-111
  0,85,-111,   -81,26,-111, -131,43,-26, -81,111,26,   0,138,-26
  -81,26,-111, -131,43,-26, -131,-43,26, -81,-111,-26, -50,-69,-111
  0,-85,111,   -81,-26,111, -50,69,111,  50,69,111,    81,-26,111
  0,-85,111,   -81,-26,111, -131,-43,26, -81,-111,-26, 0,-138,26
  -81,-26,111, -131,-43,26, -131,43,-26, -81,111,26,   -50,69,111
  -50,69,111,   -81,111,26,  0,138,-26,   81,111,26,    50,69,111
  0,-85,111,   81,-26,111,  131,-43,26,  81,-111,-26,  0,-138,26
  81,-26,111,  131,-43,26,  131,43,-26,  81,111,26,    50,69,111
*/

static long rx[60], ry[60], rz[60];
static long sx[60], sy[60];
static long lmost[200], lxmost[200], lymost[200], lzmost[200];
static long rmost[200], rxmost[200], rymost[200], rzmost[200];

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux clearthedarnscreen =\
	"mov edi, 0xa0000",\
	"mov ecx, 16000d",\
	"xor eax, eax",\
	"rep stosd",\
	modify [eax ecx edi]\

#pragma aux drawpixel =\
	"mov [edi+0xa0000], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov [edi+0xa0000], ax",\
	parm [edi][eax]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	interruptend();
}

main()
{
	short int i, j, ang1, ang2, ang3, ang1vel, ang2vel, ang3vel, fil, page;
	short int picnum;
	long zoom, zoomvel;

	loadtables();
	setvmode(0x13);
	if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		close(fil);
		outp(0x3c8,0);
		for(i=0;i<768;i++)
			outp(0x3c9,palette[i]);
	}
	loadpics("pics.dat");
	page = 0;

	for(i=0;i<60;i++)
	{
	  lx[i] <<= 2;
	  ly[i] <<= 2;
	  lz[i] <<= 2;
	}

	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();

	ang1 = 0, ang2 = 0, ang3 = 0, zoom = 1024L;
	ang1vel = 0, ang2vel = 0, ang3vel = 0, zoomvel = 0L;
	while (keystatus[1] == 0)
	{
		clearthedarnscreen();

		for(i=0;i<12;i++)
			drawpixscrew(ang1,ang2,ang3,zoom,5,picnum,i*5);

		if ((keystatus[0x4e] > 0) && (picnum < maxwalls-1))
		{
			picnum++;
			keystatus[0x4e] = 0;
		}
		if ((keystatus[0x4a] > 0) && (picnum > 0))
		{
			picnum--;
			keystatus[0x4a] = 0;
		}
		if ((keystatus[0x33] > 0) && (ang1vel < 32)) ang1vel += 6;
		if ((keystatus[0x34] > 0) && (ang1vel > -32)) ang1vel -= 6;
		if ((keystatus[0xc8] > 0) && (ang2vel < 32)) ang2vel += 6;
		if ((keystatus[0xd0] > 0) && (ang2vel > -32)) ang2vel -= 6;
		if ((keystatus[0xcb] > 0) && (ang3vel < 32)) ang3vel += 6;
		if ((keystatus[0xcd] > 0) && (ang3vel > -32)) ang3vel -= 6;
		if ((keystatus[0x1e] > 0) && (zoomvel > -32L)) zoomvel -= 6L;
		if ((keystatus[0x2c] > 0) && (zoomvel < 32L)) zoomvel += 6L;
		if (keystatus[0x39] > 0)
		{
			ang1vel = 0;
			ang2vel = 0;
			ang3vel = 0;
			zoomvel = 0L;
		}
		if (ang1vel > 0) ang1vel--;
		if (ang1vel < 0) ang1vel++;
		if (ang2vel > 0) ang2vel--;
		if (ang2vel < 0) ang2vel++;
		if (ang3vel > 0) ang3vel--;
		if (ang3vel < 0) ang3vel++;
		if (zoomvel > 0L) zoomvel--;
		if (zoomvel < 0L) zoomvel++;

		ang1 += ang1vel;
		ang2 += ang2vel;
		ang3 += ang3vel;
		zoom += zoomvel;
		if (zoom < 384L)
			zoom = 384L;

		outp(0x3d4,0xc); outp(0x3d5,page<<6);
		page++;
		if (page >= 3)
			page = 0;
		outp(0x3cd,page);
	}
	_dos_setvect(0x9, oldkeyhandler);
	setvmode(0x3);
	return(0);
}

loadtables()
{
	short int fil;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		close(fil);
	}
	return(0);
}

loadpics(filename)
char filename[20];
{
	long totpicsiz, offscount, siz;
	short int fil, i;

	if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	read(fil,&picsiz[0],maxwalls);
	read(fil,&picanm[0],maxwalls);
	totpicsiz = 0L;
	for(i=0;i<maxwalls;i++)
		if (picsiz[i] > 0)
			totpicsiz += (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
	pic = (char *)malloc(totpicsiz);
	offscount = 0L;
	for(i=0;i<maxwalls;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		if (picsiz[i] > 0)
		{
			siz = (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

drawpixscrew(short ang1, short ang2, short ang3, long zoom, short numsides,
		 short picnume, short linindex)
{
	char *ptr;
	short int i, j, nz, dat;
	long xdim, ydim, x, xinc, d, dinc, topx, topy, xadd, yadd, p, y, ystep;
	long bot, botinc, topxinc, topyinc, xtemp, ytemp, ztemp, x1, x2, picplc;

	if (picsiz[picnume] == 0)
		return(-1);
	for(i=0;i<numsides;i++)
	{
		xtemp = ((lx[linindex+i]*sintable[(2560+ang1)&2047] - ly[linindex+i]*sintable[ang1&2047])>>14);
		ytemp = ((ly[linindex+i]*sintable[(2560+ang1)&2047] + lx[linindex+i]*sintable[ang1&2047])>>14);
		ztemp = ((lz[linindex+i]*sintable[(2560+ang2)&2047] + ytemp*sintable[ang2&2047])>>14);
		rx[i] = ((xtemp*sintable[(2560+ang3)&2047] - ztemp*sintable[ang3&2047])>>14);
		ry[i] = ((ytemp*sintable[(2560+ang2)&2047] - lz[linindex+i]*sintable[ang2&2047])>>14);
		rz[i] = ((ztemp*sintable[(2560+ang3)&2047] + xtemp*sintable[ang3&2047])>>14) + zoom;
		sx[i] = (rx[i]<<8) / rz[i] + 160;
		sy[i] = (ry[i]<<8) / rz[i] + 100;
	}
	for(i=0;i<200;i++)
	{
		lmost[i] = (320L<<16);
		rmost[i] = -1L;
	}
	for(i=0;i<numsides;i++)
	{
		nz = i+1;
		if (nz == numsides) nz = 0;
		if (sy[i] != sy[nz])
		{
			if (sy[nz] > sy[i])
			{
				ydim = sy[nz] - sy[i];
				ystep = 1L;
			}
			else
			{
				ydim = sy[i] - sy[nz];
				ystep = -1L;
			}
			x = (sx[i]<<16); xinc = ((sx[nz]-sx[i])<<16) / ydim;
			d = (rz[i]<<16); dinc = ((rz[nz]-rz[i])<<16) / ydim;
			topx = 0L; topxinc = ((rz[i]*(lx[linindex+nz]-lx[linindex+i]))<<4);
			topy = 0L; topyinc = ((rz[i]*(ly[linindex+nz]-ly[linindex+i]))<<4);
			xadd = (lx[linindex+i]<<8); yadd = (ly[linindex+i]<<8);
			bot = rz[nz]*ydim; botinc = rz[i]-rz[nz];
			for (y=sy[i];y!=sy[nz];y+=ystep)
			{
				if ((y >= 0) && (y < 200))
				{
					if (x < lmost[y])
					{
						lmost[y] = x;
						lxmost[y] = ((topx/bot)<<4) + xadd;
						lymost[y] = ((topy/bot)<<4) + yadd;
						lzmost[y] = d;
					}
					if (x > rmost[y])
					{
						rmost[y] = x;
						rxmost[y] = ((topx/bot)<<4) + xadd;
						rymost[y] = ((topy/bot)<<4) + yadd;
						rzmost[y] = d;
					}
				}
				topx += topxinc;
				topy += topyinc;
				bot += botinc;
				d += dinc;
				x += xinc;
			}
		}
	}
	for (y=0;y<200;y++)
	{
		p = y*320;
		if ((lmost[y]|65535) <= (rmost[y]|65535))
		{
			x1 = (lmost[y]>>16);
			x2 = (rmost[y]>>16);
			xdim = x2-x1;
			if (xdim > 0)
			{
				topx = 0;
				topy = 0;
				bot = ((rzmost[y]>>12) * xdim);
				topxinc = (((lzmost[y]>>16) * (rxmost[y]-lxmost[y]))>>4);
				topyinc = (((lzmost[y]>>16) * (rymost[y]-lymost[y]))>>4);
				botinc = ((lzmost[y]-rzmost[y])>>12);
				xadd = (lxmost[y]>>8)+32; yadd = (lymost[y]>>8) + 32;

				if (x1 < 0)
				{
					bot -= (botinc*x1);
					topx -= (topxinc*x1);
					topy -= (topyinc*x1);
					x1 = 0;
				}
				if (x2 >= 320)
					x2 = 319;

				p += x1;
				picplc = waloff[picnume];
				for(i=x1;i<x2;i+=2)
				{
					ptr = (char *)(picplc+(((topx/bot+xadd)<<3)&0xfc0)+(((topy/bot+yadd)>>3)&63));
					dat = *ptr;
					bot += botinc;
					topx += topxinc;
					topy += topyinc;
					ptr = (char *)(picplc+(((topx/bot+xadd)<<3)&0xfc0)+(((topy/bot+yadd)>>3)&63));
					dat += ((*ptr)<<8);
					bot += botinc;
					topx += topxinc;
					topy += topyinc;
					drawpixels(p,dat);
					p+=2;
				}
				if (((x2-x1)&1) == 0)
				{
					ptr = (char *)(picplc+(((topx/bot+xadd)<<3)&0xfc0)+(((topy/bot+yadd)>>3)&63));
					dat = *ptr;
					drawpixel(p,dat);
				}
			}
		}
	}
	return(0);
}
