#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#define numwalls 64

static int sintable[2048], umost[320], dmost[320];
static long tantable[1024], posx, posy;
static int vidmode, xdim, ydim, halfwidth, halfheight, dside, scrsize, page;
static int takernum, ceilingstat, xtotaldim, type;
unsigned char tempbuf[4096], picanm[1024], picsiz[1024], palette[768];
unsigned int pic, walseg[numwalls], ang, centeroffset;
static long totalclock, numframes;
void interrupt far myhandler(void);
void (interrupt far *oldhandler)();

main(int argc,char **argv)
{
	char ch;
	int i, j, mousx, mousy, picnum, totalcount, posz, y1, y2, y3, y4;
	unsigned l;
	long templong;

	_asm \
	{
		mov ah, 0x4f
		mov al, 0x00
		int 0x10
		mov l, ax
	}
	if (l != 0x004f)
	{
		printf("This program requires a VESA driver.");
		return(-1);
	}
	ceilingstat = 1;
	vidmode = 0;
	xdim = 320;
	ydim = 200;
	scrsize = 18000;
	type = 1;
	if (argc == 2)
	{
		type = atoi(argv[1]);
		if ((type != 0) && (type != 1))
			type = 0;
	}
	xtotaldim = xdim;
	halfwidth = (xdim>>1);
	halfheight = (ydim>>1);
	centeroffset = 0;
	dside = ydim;
	if ((pic = convallocate(numwalls*256)) == -1)
	{
		printf("Allocation failed!");
		exit(-1);
	}
	l = pic;
	for(i=0;i<numwalls;i++)
	{
		walseg[i] = l;
		l += 256;
	}
	for(i=0;i<320;i++)
	{
		umost[i] = 0;
		dmost[i] = ydim;
	}
	loadtables();
	loadpics();
	_asm \
	{
		mov ax, 0
		int 0x33

		mov ax, 0x13
		int 0x10
	}
	if (vidmode == 1)
		setmode360240();
	if ((i = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(i,&palette[0],768);
		close(i);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	posx = 0;
	posy = 0;
	posz = 8192;
	picnum = 2;
	j = 0;
	ang = 0;
	ch = 0;
	totalcount = 0;
	numframes = 0;
	totalclock = 0;
	page = 0;
	oldhandler = _dos_getvect(8);
	_disable(); _dos_setvect(8, myhandler); _enable();
	outp(0x43,54); outp(0x40,4972&255); outp(0x40,4972>>8);
	while (ch != 27)
	{
		_asm \
		{
			mov ax, 11
			int 0x33
			sar cx, 1
			sar dx, 1
			mov mousx, cx
			mov mousy, dx
		}
		ang += mousx;
		posx -= (((long)sintable[(2560+ang)&2047]*mousy)>>12);
		posy -= (((long)sintable[(2048+ang)&2047]*mousy)>>12);
		if (kbhit() != 0)
		{
			ch = getch();
			if (((ch == 'a') || (ch == 'A')) && (posz > 0)) posz -= 128;
			if (((ch == 'z') || (ch == 'Z')) && (posz < 16256)) posz += 128;
			if ((ch == '+') && (picnum < numwalls-1)) picnum++;
			if ((ch == '-') && (picnum > 0)) picnum--;
		}
		if (type == 0)
		{
			for(i=0;i<100;i++)
				hline(0,xdim-1,i,posz,picnum,(char)0);
			for(i=100;i<ydim;i++)
				hline(0,xdim-1,i,16383-posz,picnum,(char)0);
		}
		else
		{
			_asm \
			{
				mov ax, 0xa000
				mov es, ax
				xor di, di
				mov cx, 5120
				xor ax, ax
				rep stosw
				mov di, 64000-10240
				mov cx, 5120
				rep stosw
			}
			for(i=0;i<320;i+=2)
			{
				y1 = 16+(sintable[((numframes<<4)+(i<<4))&2047]>>10);
				y2 = 184-(sintable[(2560-((i*23)-(numframes<<6)))&2047]>>10);
				y3 = 16+(sintable[((numframes<<4)+((i+1)<<4))&2047]>>10);
				y4 = 184-(sintable[(2560-(((i+1)*23)-(numframes<<6)))&2047]>>10);
				//vline(i,y1,y2,(y2-y1)<<2,picnum,(i<<6)&4032,(char)0);
				//vline(i+1,y3,y4,(y4-y3)<<2,picnum,((i+1)<<6)&4032,(char)0);
				vline2(i,y1,y2,y3,y4,(y2-y1)<<2,(y4-y3)<<2,picnum,(i<<6)&4032,((i+1)<<6)&4032,(char)0,(char)0);
			}
		}
		numframes++;
		totalcount+=128;
		outp(0x3d4,0xc), outp(0x3d5,page<<6);
		page++;
		if (page == 3)
			page = 0;
		_asm \
		{
			;mov dx, 0x3cd
			;mov al, page
			;out dx, al
			mov ah, 0x4f       ;vesa set video page
			mov al, 0x05
			xor bh, bh
			xor bl, bl
			mov dx, page
			int 0x10
		}
	}
	_disable(); _dos_setvect(8, oldhandler); _enable();
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	if (totalclock != 0)
	{
		templong = (numframes*24000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(int)(templong/100),(int)((templong/10)%10),(int)(templong%10));
	}
	convdeallocate(pic);
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc allocated
		mov segnum, -1
allocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc deallocated
		mov segnum, -1
deallocated:
	}
	return(segnum);
}

loadtables()
{
	int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
}

loadpics()
{
	int fil, i;

	if ((fil=open("pics.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		return(-1);
	read(fil,&picsiz[0],1024);
	read(fil,&picanm[0],1024);
	for(i=0;i<numwalls;i++)
	{
		read(fil,&tempbuf[0],4096);
		_asm \
		{
			cld
			mov cx, 2048
			mov bx, i
			shl bx, 1
			mov es, word ptr walseg[bx]
			xor di, di
			mov si, offset tempbuf
			mov ax, seg tempbuf
			push ds
			mov ds, ax
			rep movsw
			pop ds
		}
	}
	close(fil);
}

setmode360240()
{
	outp(0x3c4,0x4); outp(0x3c5,0x6);
	outp(0x3c4,0x0); outp(0x3c5,0x1);
	outp(0x3c2,0xe7);
	outp(0x3c4,0x0); outp(0x3c5,0x3);
	outp(0x3d4,0x11); outp(0x3d5,inp(0x3d5)&0x7f);      //Unlock indices 0-7
	outp(0x3d4,0x0); outp(0x3d5,0x6b);
	outp(0x3d4,0x1); outp(0x3d5,0x59);
	outp(0x3d4,0x2); outp(0x3d5,0x5a);
	outp(0x3d4,0x3); outp(0x3d5,0x8e);
	outp(0x3d4,0x4); outp(0x3d5,0x5e);
	outp(0x3d4,0x5); outp(0x3d5,0x8a);
	outp(0x3d4,0x6); outp(0x3d5,0xd);
	outp(0x3d4,0x7); outp(0x3d5,0x3e);
	outp(0x3d4,0x9); outp(0x3d5,0x41);
	outp(0x3d4,0x10); outp(0x3d5,0xea);
	outp(0x3d4,0x11); outp(0x3d5,0xac);
	outp(0x3d4,0x12); outp(0x3d5,0xdf);
	outp(0x3d4,0x13); outp(0x3d5,45);
	outp(0x3d4,0x14); outp(0x3d5,0x0);
	outp(0x3d4,0x15); outp(0x3d5,0xe7);
	outp(0x3d4,0x16); outp(0x3d5,0x6);
	outp(0x3d4,0x17); outp(0x3d5,0xe3);
}

hline (xl, xr, yp, zd, walnume, shadeoffs)
unsigned xl, xr, yp, zd;
int walnume;
char shadeoffs;
{
	int siz;
	unsigned x, y, xc, yc, hd;

	if (yp == halfheight)
		return(-1);
	if (ceilingstat >= 3)
		walnume = 54;
	if (picanm[walnume] > 0)
		walnume += (numframes%(picanm[walnume]+1));
	if (xl > xr)
		_asm \
		{
			mov ax, xl
			xchg ax, xr
			mov xl, ax
		}
	siz = xr-xl;
	takernum = 7;
	_asm \
	{
							  ;hd = (zd<<11)/((long)((xdim>>3)*abs(halfheight-yp)));
		mov ax, halfheight
		sub ax, yp
		jns skipnegatize
		neg ax
skipnegatize:
		mov bx, xtotaldim
		mov cl, 3
		shr bx, cl
		mul bx
		mov di, ax                          ;di is temp second half of equation
		mov ax, word ptr zd[0]
		xor dh, dh
		mov dl, ah
		mov ah, al
		xor al, al
		cmp di, dx
		jbe returnit
		div di
		mov hd, ax
		jmp dontreturnit
returnit:
		mov hd, 0
dontreturnit:
	}
	if (hd == 0)
		return(-1);
	if ((hd>>10) < 8)
		shadeoffs -= (char)(hd>>10);
	else
		shadeoffs -= 8;

	_asm \
	{
											 ;xc = ((hd*sintable[(2048+ang)&2047])>>15);
		mov bx, ang
		and bx, 1023
		shl bx, 1
		mov ax, word ptr sintable[bx]
		mul hd
		mov cl, 15
		shr ax, cl
		ror dx, cl
		and dx, 0xfffe
		or ax, dx
		test ang, 1024
		jz skipsinsign1
		neg ax                                          ;negatize xc
skipsinsign1:
		mov xc, ax
										 ;yc = ((hd*sintable[(2560+ang)&2047])>>15);
		mov bx, ang
		add bx, 2560
		and bx, 1023
		shl bx, 1
		mov ax, word ptr sintable[bx]
		mul hd
		mov cl, 15
		shr ax, cl
		ror dx, cl
		and dx, 0xfffe
		or ax, dx
		mov ax, ax
		mov bx, ang
		add bx, 512
		test bx, 1024
		jz skipsinsign2
		neg ax                                           ;negatize yc
skipsinsign2:
		mov yc, ax
										;xc1 = (long)(xc*xl)+(long)(((xc+yc)>>1)*xdim);
		add ax, xc              ;note: ax = yc at this point
		sar ax, 1
		imul xdim
		mov bx, ax
		mov ax, xc
		imul xl
		sub ax, bx
																			 ;x = xc1-(posx<<6);
		mov bx, word ptr posx[0]
		mov cl, 6
		shl bx, cl
		sub ax, bx
		mov x, ax
										;yc1 = (long)(yc*xl)+(long)(((xc-yc)>>1)*xdim);
		mov ax, xc
		sub ax, yc
		sar ax, 1
		imul xdim
		mov bx, ax
		mov ax, yc
		imul xl
		add ax, bx                                         ;ax = yc1&65535
																			 ;y = yc1+(posy<<6);
		mov bx, word ptr posy[0]
		mov cl, 6
		shl bx, cl
		add ax, bx
		mov y, ax
	}
	takernum = 8;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax

		mov cx, siz
		inc cx
		shr cx, 1
		shr cx, 1
		mov ch, cl
		mov cl, 2

		mov ax, 320            ;di = yp*320+xl+centeroffset;
		mul yp
		add ax, xl
		mov di, ax
		add di, centeroffset

		mov si, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1a+2], ax
		mov word ptr cs:[mach3a+2], ax
		mov word ptr cs:[mach7a+2], ax
		mov word ptr cs:[mach9a+2], ax
		mov ax, yc
		mov word ptr cs:[mach2a+2], ax
		mov word ptr cs:[mach4a+2], ax
		mov word ptr cs:[mach8a+2], ax
		mov word ptr cs:[mach10a+2], ax
		mov al, shadeoffs
		mov byte ptr cs:[mach5a+1], al
		mov byte ptr cs:[mach6a+2], al
		mov byte ptr cs:[mach11a+1], al
		mov byte ptr cs:[mach12a+2], al
		mov bx, walnume
		shl bx, 1
		or ch, ch
		jz hlinendraw
		push ds
		push bp
		mov ds, word ptr walseg[bx]
begindrawa:
mach1a:add si, 0x1234
mach2a:add dx, 0x1234
		mov ax, si
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov bp, ax
mach3a:add si, 0x1234
mach4a:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		mov al, ds:[bp]
mach5a:add al, 0x12
		shr bx, cl
		mov ah, ds:[bx]
mach6a:add ah, 0x12
mach7a:add si, 0x1234
		mov word ptr es:[di], ax
mach8a:add dx, 0x1234
		mov ax, si
		mov al, dh
		shr ah, cl
		shr ax, cl
		mov bp, ax
mach9a:add si, 0x1234
mach10a:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		mov al, ds:[bp]
mach11a:add al, 0x12
		shr bx, cl
		mov ah, ds:[bx]
mach12a:add ah, 0x12
		add di, 4
		mov word ptr es:[di-2], ax
		sub ch, 1
		jnz begindrawa
		pop bp
		pop ds
hlinendraw:
		mov ch, byte ptr siz[0]
		inc ch
		and ch, 3
		jz hlinendall
		push ds
		mov bx, walnume
		shl bx, 1
		mov ds, word ptr walseg[bx]
hlinefinish:
		add si, word ptr cs:[mach3a+2]
		add dx, word ptr cs:[mach4a+2]
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
		add al, byte ptr cs:[mach5a+1]
		stosb
		sub ch, 1
		jnz hlinefinish
		pop ds
hlinendall:
	}
	takernum = 4;
}

void interrupt far myhandler()
{
	totalclock++;
	_asm \
	{
		mov al, 0x20
		out 0x20, al
	}
}

vline(x, y1, y2, siz, walnume, picplc, shadeoffs)
int x, y1, y2, siz, walnume, picplc;
unsigned char shadeoffs;
{
	unsigned int picseg, thesiz, start, minincr, mask1, mask2;
	unsigned long templong;

	thesiz = y2-y1;
	if ((y1 > dmost[x]) || (y2 < umost[x]) || (thesiz <= 0) || (siz <= 0))
		return(0);
	takernum = 5;
	if (ceilingstat >= 3)
		walnume = 55;
	if (picanm[walnume] > 0)
		walnume += (numframes%(picanm[walnume]+1));
	mask1 = (1<<(picsiz[walnume]>>4))-1;
	mask2 = ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	picseg = walseg[walnume];
	picplc &= mask2;
	minincr = 0;
	if (y1 < umost[x])
	{
		templong = (((unsigned long)(umost[x]-y1))<<17) / (((unsigned long)siz));
		minincr = (unsigned)((templong<<8)&65535);
		picplc += (((int)(templong>>8))&mask1);
		thesiz -= (umost[x]-y1);
		y1 = umost[x];
	}
	if (y1+thesiz > dmost[x])
		thesiz -= ((y1+thesiz)-dmost[x]);
	if ((thesiz < 1) || (thesiz > dside))
		return(-1);
	start = y1*320+x+centeroffset;
	templong = 33554432L / ((long)siz);

	if (((char)(templong>>16)) < 8)
		shadeoffs -= (char)(templong>>16);
	else
		shadeoffs -= 8;

	takernum = 6;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax

		mov di, start
		mov cx, thesiz
		mov si, picplc
		mov bx, si
		and bx, mask1
		and si, mask2
		mov word ptr cs:[machvline1+3], si
		mov al, shadeoffs
		mov byte ptr cs:[machvline2+1], al
		mov ax, word ptr templong[0]
		mov word ptr cs:[machvline3+2], ax
		mov ax, word ptr templong[2]
		mov word ptr cs:[machvline4+2], ax
		mov ax, mask1
		mov word ptr cs:[machvline5+2], ax
		mov dx, minincr
		push ds
		mov ds, picseg
beginvline1:
machvline1: mov al, byte ptr ds:[bx+0x8888]
machvline2: add al, 0x88
		mov byte ptr es:[di], al
		add di, 320
machvline3: add dx, 0x8888
machvline4: adc bx, 0x8888
machvline5: and bx, 0x8888
		loop beginvline1
		pop ds
	}
}

vline2(x, y1, y2, y3, y4, siz1, siz2, walnume, picplc1, picplc2, shadeoffs1, shadeoffs2)
int x, y1, y2, y3, y4, siz1, siz2, walnume, picplc1, picplc2;
unsigned char shadeoffs1, shadeoffs2;
{
	static int doublen, they1, they2, they3, they4;
	static unsigned int start, picseg, minincr1, minincr2, mask1, mask2;
	unsigned int thesiz1, thesiz2, start1, start2;
	static unsigned long templong1, templong2;

	thesiz1 = y2-y1;
	thesiz2 = y4-y3;
	they1 = y1;
	they2 = y2;
	they3 = y3;
	they4 = y4;
	if ((they1 > dmost[x]) || (they2 < umost[x]) || (thesiz1 <= 0) || (siz1 <= 0))
	{
		vline(x+1,y3,y4,siz2,walnume,picplc2,shadeoffs2);
		return(-1);
	}
	if ((they3 > dmost[x+1]) || (they4 < umost[x+1]) || (thesiz2 <= 0) || (siz2 <= 0))
	{
		vline(x,y1,y2,siz1,walnume,picplc1,shadeoffs1);
		return(-1);
	}
	takernum = 5;
	if (ceilingstat >= 3)
		walnume = 55;
	mask1 = (1<<(picsiz[walnume]>>4))-1;
	mask2 = ((0xffff>>(16-(picsiz[walnume]&15)))<<(picsiz[walnume]>>4));
	picplc1 &= mask2;
	picplc2 &= mask2;

	minincr1 = 0;
	if (they1 < umost[x])
	{
		templong1 = (((unsigned long)(umost[x]-they1))<<17)/(((unsigned long)siz1));
		minincr1 = (unsigned)((templong1<<8)&65535);
		picplc1 += (((int)(templong1>>8))&mask1);
		thesiz1 -= (umost[x]-they1);
		they1 = umost[x];
	}
	if (they1+thesiz1 > dmost[x])
	{
		thesiz1 -= ((they1+thesiz1)-dmost[x]);
		they2 = dmost[x];
	}
	if ((thesiz1 < 1) || (thesiz1 > dside))
	{
		vline(x+1,y3,y4,siz2,walnume,picplc2,shadeoffs2);
		return(-1);
	}
	start1 = they1*320+x+centeroffset;
	templong1 = 33554432L / ((long)siz1);

	minincr2 = 0;
	if (they3 < umost[x+1])
	{
		templong2 = (((unsigned long)(umost[x+1]-they3))<<17)/(((unsigned long)siz2));
		minincr2 = (unsigned)((templong2<<8)&65535);
		picplc2 += (((int)(templong2>>8))&mask1);
		thesiz2 -= (umost[x+1]-they3);
		they3 = umost[x+1];
	}
	if (they3+thesiz2 > dmost[x+1])
	{
		thesiz2 -= ((they3+thesiz2)-dmost[x+1]);
		they4 = dmost[x+1];
	}
	if ((thesiz2 < 1) || (thesiz2 > dside))
	{
		vline(x,y1,y2,siz1,walnume,picplc1,shadeoffs1);
		return(-1);
	}
	start2 = they3*320+x+centeroffset;
	templong2 = 33554432L / ((long)siz2);

	if (((char)(templong1>>16)) < 8)
		shadeoffs1 -= (char)(templong1>>16);
	else
		shadeoffs1 -= 8;
	if (((char)(templong2>>16)) < 8)
		shadeoffs2 -= (char)(templong2>>16);
	else
		shadeoffs2 -= 8;

	if (they1 < they3)
	{
		start = start1;
		if (they2 < they4)
			doublen = they2-they3;
		else
			doublen = they4-they3;
	}
	else
	{
		start = start2;
		if (they2 < they4)
			doublen = they2-they1;
		else
			doublen = they4-they1;
	}
	if (picanm[walnume] > 0)
		walnume += (numframes%(picanm[walnume]+1));

	picseg = walseg[walnume];
	takernum = 6;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov di, start
		push bp

		mov ax, mask1
		mov word ptr cs:[machvline5a1+2], ax
		mov word ptr cs:[machvline5b1+2], ax
		mov word ptr cs:[machvline5a2+2], ax
		mov word ptr cs:[machvline5b2+2], ax
		mov word ptr cs:[machvline5a3+2], ax
		mov word ptr cs:[machvline5b3+2], ax
		mov ax, picplc1
		mov bx, ax
		and bx, mask1
		and ax, mask2
		mov word ptr cs:[machvline1a1+3], ax
		mov word ptr cs:[machvline1a2+3], ax
		mov word ptr cs:[machvline1a3+3], ax
		mov al, shadeoffs1
		mov byte ptr cs:[machvline2a1+1], al
		mov byte ptr cs:[machvline2a2+1], al
		mov byte ptr cs:[machvline2a3+1], al
		mov ax, word ptr templong1[0]
		mov word ptr cs:[machvline3a1+2], ax
		mov word ptr cs:[machvline3a2+2], ax
		mov word ptr cs:[machvline3a3+2], ax
		mov ax, word ptr templong1[2]
		mov word ptr cs:[machvline4a1+2], ax
		mov word ptr cs:[machvline4a2+2], ax
		mov word ptr cs:[machvline4a3+2], ax
		mov dx, minincr1

		mov ax, picplc2
		mov si, ax
		and si, mask1
		and ax, mask2
		mov word ptr cs:[machvline1b1+3], ax
		mov word ptr cs:[machvline1b2+3], ax
		mov word ptr cs:[machvline1b3+3], ax
		mov al, shadeoffs2
		mov byte ptr cs:[machvline2b1+1], al
		mov byte ptr cs:[machvline2b2+2], al
		mov byte ptr cs:[machvline2b3+1], al
		mov ax, word ptr templong2[0]
		mov word ptr cs:[machvline3b1+2], ax
		mov word ptr cs:[machvline3b2+2], ax
		mov word ptr cs:[machvline3b3+2], ax
		mov ax, word ptr templong2[2]
		mov word ptr cs:[machvline4b1+2], ax
		mov word ptr cs:[machvline4b2+2], ax
		mov word ptr cs:[machvline4b3+2], ax
		mov bp, si
		mov si, minincr2

		push ds
		mov cx, they1
		sub cx, they3
		mov ds, picseg
		jz tobothpixelsvline
		jns beg1machvlineb
		neg cx
beg1machvlinea:
machvline1a1: mov al, byte ptr ds:[bx+0x8888]         ;Draw left pixel
machvline2a1: add al, 0x88
		mov byte ptr es:[di], al
		add di, 320
machvline3a1: add dx, 0x8888
machvline4a1: adc bx, 0x8888
machvline5a1: and bx, 0x8888
		loop beg1machvlinea
		jmp tobothpixelsvline
beg1machvlineb:
machvline1b1: mov al, byte ptr ds:[bp+0x8888]         ;Draw right pixel
machvline2b1: add al, 0x88
		mov byte ptr es:[di+1], al
		add di, 320
machvline3b1: add si, 0x8888
machvline4b1: adc bp, 0x8888
machvline5b1: and bp, 0x8888
		loop beg1machvlineb
tobothpixelsvline:
		pop ds

		push ds
		mov cx, doublen
		or cx, cx
		mov ds, picseg
		jle tofinalpixelsvline
beg2machvline:
machvline1a2: mov al, byte ptr ds:[bx+0x8888]         ;Draw both pixels
machvline2a2: add al, 0x88
machvline1b2: mov ah, byte ptr ds:[bp+0x8888]
machvline2b2: add ah, 0x88
		mov word ptr es:[di], ax
		add di, 320
machvline3a2: add dx, 0x8888
machvline4a2: adc bx, 0x8888
machvline3b2: add si, 0x8888
machvline4b2: adc bp, 0x8888
machvline5a2: and bx, 0x8888
machvline5b2: and bp, 0x8888
		loop beg2machvline
tofinalpixelsvline:
		pop ds

		push ds
		mov cx, they4
		sub cx, they2
		mov ds, picseg
		jz enditallvline
		jns beg3machvlineb
		neg cx
beg3machvlinea:
machvline1a3: mov al, byte ptr ds:[bx+0x8888]         ;Draw left pixel
machvline2a3: add al, 0x88
		mov byte ptr es:[di], al
		add di, 320
machvline3a3: add dx, 0x8888
machvline4a3: adc bx, 0x8888
machvline5a3: and bx, 0x8888
		loop beg3machvlinea
		jmp enditallvline
beg3machvlineb:
machvline1b3: mov al, byte ptr ds:[bp+0x8888]         ;Draw right pixel
machvline2b3: add al, 0x88
		mov byte ptr es:[di+1], al
		add di, 320
machvline3b3: add si, 0x8888
machvline4b3: adc bp, 0x8888
machvline5b3: and bp, 0x8888
		loop beg3machvlineb
enditallvline:
		pop ds
		pop bp
	}
}
