#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>

#define maxwalls 4096
#define maxsides 5
#define numpoints 84
#define scrxdim 320
#define scrydim 200

static char *pic;
static unsigned char picsiz[maxwalls], picanm[maxwalls];
static long waloff[maxwalls], totalclock, numframes;
static short int sintable[2048], detmode = 0;
static char palette[768];
static char keystatus[256], readch, oldreadch, extended;
static long rx[maxsides], ry[maxsides], rz[maxsides];
static long sx[maxsides], sy[maxsides];
static long lmost[scrydim], lxmost[scrydim], lymost[scrydim], lzmost[scrydim];
static long rmost[scrydim], rxmost[scrydim], rymost[scrydim], rzmost[scrydim];

static void (__interrupt __far *oldhand)();
static void __interrupt __far ksmhandler(void);
static (__interrupt __far *oldkeyhandler)();
static void __interrupt __far keyhandler(void);

static long lx[numpoints] =
{
	-128,-128,-128,-128,
	128,128,128,128,
	-128,128,128,-128,
	128,-128,-128,128,
	-128,128,128,-128,
	128,-128,-128,128,

	0,-81,-50,50,81,
	0,-81,-50,50,81,
	0,81,131,81,0,
	0,0,-81,-131,-81,
	81,50,81,131,131,
	-81,-131,-131,-81,-50,
	50,-50,-81,0,81,
	-50,-81,0,81,50,
	-50,-81,-131,-131,-81,
	50,81,131,131,81,
	-81,0,0,-81,-131,
	81,131,81,0,0,
};
static long ly[numpoints] =
{
	-128,-128,128,128,
	-128,-128,128,128,
	-128,-128,128,128,
	-128,-128,128,128,
	-128,-128,-128,-128,
	128,128,128,128,

	85,26,-69,-69,26,
	-85,-26,69,69,-26,
	85,26,43,111,138,
	-85,-138,-111,-43,-26,
	26,-69,-111,-43,43,
	-26,-43,43,111,69,
	-69,-69,-111,-138,-111,
	69,111,138,111,69,
	-69,26,43,-43,-111,
	69,111,43,-43,-26,
	26,85,138,111,43,
	-26,-43,-111,-138,-85,
};
static long lz[numpoints] =
{
	128,-128,-128,128,
	-128,128,128,-128,
	-128,-128,-128,-128,
	128,128,128,128,
	128,128,-128,-128,
	128,128,-128,-128,

	-111,-111,-111,-111,-111,
	111,111,111,111,111,
	-111,-111,-26,26,-26,
	111,26,-26,26,111,
	-111,-111,-26,26,-26,
	111,26,-26,26,111,
	-111,-111,-26,26,-26,
	111,26,-26,26,111,
	-111,-111,-26,26,-26,
	111,26,-26,26,111,
	-111,-111,-26,26,-26,
	111,26,-26,26,111,
};

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux clearthedarnscreen =\
	"mov edi, 0xa0000",\
	"mov ecx, 16000d",\
	"xor eax, eax",\
	"rep stosd",\
	modify [eax ecx edi]\

#pragma aux drawpixel =\
	"mov [edi+0xa0000], al",\
	parm [edi][eax]\
	modify [eax edi]\

#pragma aux drawpixels =\
	"mov [edi+0xa0000], ax",\
	parm [edi][eax]\
	modify [eax edi]\

#pragma aux drawpixelses =\
	"mov [edi+0xa0000], eax",\
	parm [edi][eax]\
	modify [eax edi]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\
	modify [eax]\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\
	modify [eax]\

 //ptr = (char *)(picplc+(((topx/bot+xadd)>>1)&0xfc0)+(((topy/bot+yadd)>>7)&63));
 //dat = *ptr;

#pragma aux getdat =\
	"push ebp",\
	"mov ebp, edx",\
	"cdq",\
	"idiv ecx",\
	"add esi, eax",\
	"shr esi, 1",\
	"and esi, 0x00000fc0",\
	"mov eax, ebp",\
	"cdq",\
	"idiv ecx",\
	"add eax, edi",\
	"shr eax, 7",\
	"and eax, 0x0000003f",\
	"add eax, ebx",\
	"mov al, byte ptr [eax+esi]",\
	"and eax, 0x000000ff",\
	"pop ebp",\
	parm [eax][ebx][ecx][edx][esi][edi]\
	modify [eax ebx ecx edx esi edi]\

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	interruptend();
}

void __interrupt __far ksmhandler()
{
	totalclock++;
	interruptend();
}

main()
{
	short i, j, fil, page, object, picnum;
	long templong;
	short ang1, ang2, ang3, ang1vel, ang2vel, ang3vel;
	long xoff, yoff, zoff, xoffvel, yoffvel, zoffvel;

	loadtables();
	setvmode(0x13);
	if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&palette[0],768);
		close(fil);
		outp(0x3c8,0);
		for(i=0;i<768;i++)
			outp(0x3c9,palette[i]);
	}
	loadpics("pics.dat");

	for(i=0;i<numpoints;i++)
	{
	  lx[i] <<= 1;
	  ly[i] <<= 1;
	  lz[i] <<= 1;
	}

	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();
	oldhand = _dos_getvect(0x8);
	_dos_setvect(0x8, ksmhandler);
	outp(0x43,54); outp(0x40,4972&255); outp(0x40,4972>>8);

	object = 0, picnum = 0, page = 0;
	xoff = 0, yoff = 0, zoff = 1024, xoffvel = 0, yoffvel = 0, zoffvel = 0;
	ang1 = 0, ang2 = 0, ang3 = 0, ang1vel = 0, ang2vel = 0, ang3vel = 0;
	numframes = 0L, totalclock = 0L;
	while (keystatus[1] == 0)
	{
		if (object != 2)
			clearthedarnscreen();

		if (object == 0)
		{
			for(i=0;i<6;i++)
				drawpixscrew((short)ang1,(short)ang2,(short)ang3,(long)xoff,(long)yoff,(long)zoff,(short)4,(short)picnum,(short)(i*4));
		}
		else if (object == 1)
		{
			for(i=0;i<12;i++)
				drawpixscrew((short)ang1,(short)ang2,(short)ang3,(long)xoff,(long)yoff,(long)zoff,(short)5,(short)picnum,(short)(i*5+24));
		}
		else
		{
			if (keystatus[0x39] == 0)
				drawpixscrew((short)(rand()&2047),(short)(rand()&2047),(short)(rand()&2047),(long)(rand()&511)-256L,(long)(rand()&255)-128L,(long)(rand()&1023)+512,(short)4,(short)(rand()%112),(short)0);
		}

		if ((keystatus[0x4e] > 0) && (picnum < maxwalls-1))
		{
			picnum++;
			keystatus[0x4e] = 0;
		}
		if ((keystatus[0x4a] > 0) && (picnum > 0))
		{
			picnum--;
			keystatus[0x4a] = 0;
		}
		if ((keystatus[0x13] > 0) && (ang1vel < 24)) ang1vel += 4;
		if ((keystatus[0x2e] > 0) && (ang1vel > -24)) ang1vel -= 4;
		if ((keystatus[0x12] > 0) && (ang2vel < 24)) ang2vel += 4;
		if ((keystatus[0x2d] > 0) && (ang2vel > -24)) ang2vel -= 4;
		if ((keystatus[0x1f] > 0) && (ang3vel < 24)) ang3vel += 4;
		if ((keystatus[0x20] > 0) && (ang3vel > -24)) ang3vel -= 4;
		if ((keystatus[0xcd] > 0) && (xoffvel > -24L)) xoffvel -= 4L;
		if ((keystatus[0xcb] > 0) && (xoffvel < 24L)) xoffvel += 4L;
		if ((keystatus[0xd0] > 0) && (yoffvel > -24L)) yoffvel -= 4L;
		if ((keystatus[0xc8] > 0) && (yoffvel < 24L)) yoffvel += 4L;
		if ((keystatus[0xc9] > 0) && (zoffvel > -24L)) zoffvel -= 4L;
		if ((keystatus[0xd1] > 0) && (zoffvel < 24L)) zoffvel += 4L;
		if (keystatus[0x1c] > 0)
		{
			object++;
			if (object == 3)
				object = 0;
			keystatus[0x1c] = 0;
			if (object == 2)
			{
				outp(0x3d4,0xc); outp(0x3d5,0);
				outp(0x3cd,0);
				page = 0;
			}
			numframes = 0, totalclock = 0;
		}
		if (keystatus[0x39] > 0)
		{
			ang1vel = 0;
			ang2vel = 0;
			ang3vel = 0;
			xoffvel = 0L;
			yoffvel = 0L;
			zoffvel = 0L;
		}
		if (keystatus[0x10] > 0) detmode = 0;
		if (keystatus[0x11] > 0) detmode = 1;
		if (keystatus[0x1e] > 0) detmode = 2;

		if (ang1vel > 0) ang1vel--;
		if (ang1vel < 0) ang1vel++;
		if (ang2vel > 0) ang2vel--;
		if (ang2vel < 0) ang2vel++;
		if (ang3vel > 0) ang3vel--;
		if (ang3vel < 0) ang3vel++;
		if (xoffvel > 0L) xoffvel--;
		if (xoffvel < 0L) xoffvel++;
		if (yoffvel > 0L) yoffvel--;
		if (yoffvel < 0L) yoffvel++;
		if (zoffvel > 0L) zoffvel--;
		if (zoffvel < 0L) zoffvel++;

		ang1 += ang1vel;
		ang2 += ang2vel;
		ang3 += ang3vel;
		xoff += xoffvel;
		yoff += yoffvel;
		zoff += zoffvel;
		if (zoff < 512)
		{
			zoff = 512;
			zoffvel = 0;
		}

		if (object != 2)
		{
			outp(0x3d4,0xc); outp(0x3d5,page<<6);
			page++;
			if (page >= 3)
				page = 0;
			outp(0x3cd,page);
		}
		numframes++;
	}
	_dos_setvect(0x8, oldhand);
	_dos_setvect(0x9, oldkeyhandler);
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	free(pic);
	setvmode(0x3);
	if (totalclock != 0)
	{
		templong = (numframes*24000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(short int)(templong/100),(short int)((templong/10)%10),(short int)(templong%10));
	}
	return(0);
}

loadtables()
{
	short int fil;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		close(fil);
	}
	return(0);
}

loadpics(filename)
char filename[20];
{
	long totpicsiz, offscount, siz;
	short int fil, i;

	if ((fil = open(filename,O_BINARY|O_RDONLY,S_IREAD)) == -1)
		return(-1);
	read(fil,&picsiz[0],maxwalls);
	read(fil,&picanm[0],maxwalls);
	totpicsiz = 0L;
	for(i=0;i<maxwalls;i++)
		if (picsiz[i] > 0)
			totpicsiz += (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
	pic = (char *)malloc(totpicsiz);
	offscount = 0L;
	for(i=0;i<maxwalls;i++)
	{
		waloff[i] = offscount+FP_OFF(pic);
		if (picsiz[i] > 0)
		{
			siz = (1<<((long)((picsiz[i]&15)+(picsiz[i]>>4))));
			read(fil,&pic[offscount],siz);
			offscount += siz;
		}
	}
	close(fil);
	return(0);
}

drawpixscrew(short ang1, short ang2, short ang3, long xoff, long yoff,
				 long zoff, short numsides, short picnume, short linindex)
{
	char *ptr;
	long i, j, nz, dat, x1, y1, x2, y2, normalx, normaly, normalz;
	long xdim, ydim, x, xinc, d, dinc, topx, topy, xadd, yadd, p, y, ystep;
	long bot, botinc, topxinc, topyinc, xtemp, ytemp, ztemp, picplc;

	if (picsiz[picnume] == 0)
		return(-1);
	for(i=0;i<numsides;i++)
	{
		xtemp = ((lx[linindex+i]*sintable[(2560+ang1)&2047] - ly[linindex+i]*sintable[ang1&2047])>>14);
		ytemp = ((ly[linindex+i]*sintable[(2560+ang1)&2047] + lx[linindex+i]*sintable[ang1&2047])>>14);
		ztemp = ((lz[linindex+i]*sintable[(2560+ang2)&2047] + ytemp*sintable[ang2&2047])>>14);
		rx[i] = xoff + ((xtemp*sintable[(2560+ang3)&2047] - ztemp*sintable[ang3&2047])>>14);
		ry[i] = yoff + ((ytemp*sintable[(2560+ang2)&2047] - lz[linindex+i]*sintable[ang2&2047])>>14);
		rz[i] = zoff + ((ztemp*sintable[(2560+ang3)&2047] + xtemp*sintable[ang3&2047])>>14);
		sx[i] = (rx[i]*scrxdim)/rz[i] + (scrxdim>>1);
		sy[i] = (ry[i]*scrxdim)/rz[i] + (scrydim>>1);
	}

	normalx = (ry[0]-ry[1])*(rz[2]-rz[1]) - (ry[2]-ry[1])*(rz[0]-rz[1]);
	normaly = (rx[2]-rx[1])*(rz[0]-rz[1]) - (rx[0]-rx[1])*(rz[2]-rz[1]);
	normalz = (rx[0]-rx[1])*(ry[2]-ry[1]) - (rx[2]-rx[1])*(ry[0]-ry[1]);

	if ((sx[1]-(scrxdim>>1))*normalx+(sy[1]-(scrydim>>1))*normaly+scrxdim*normalz > 0)
		return(-1);

	//normalx = y1z2-y2z1, normaly = x2z1-x1z2, normalz = x1y2-x2y1
	normalx = (ly[linindex+0]-ly[linindex+1])*(lz[linindex+2]-lz[linindex+1]) - (ly[linindex+2]-ly[linindex+1])*(lz[linindex+0]-lz[linindex+1]);
	normaly = (lx[linindex+2]-lx[linindex+1])*(lz[linindex+0]-lz[linindex+1]) - (lx[linindex+0]-lx[linindex+1])*(lz[linindex+2]-lz[linindex+1]);
	normalz = (lx[linindex+0]-lx[linindex+1])*(ly[linindex+2]-ly[linindex+1]) - (lx[linindex+2]-lx[linindex+1])*(ly[linindex+0]-ly[linindex+1]);

	for(i=0;i<scrydim;i++)
	{
		lmost[i] = (scrxdim<<16);
		rmost[i] = -1L;
	}
	for(i=0;i<numsides;i++)
	{
		nz = i+1;
		if (nz == numsides) nz = 0;

		if ((normalx == 0) && (normaly == 0))
		{
			x1 = lx[linindex+i], x2 = lx[linindex+nz];
			y1 = ly[linindex+i], y2 = ly[linindex+nz];
		}
		else if ((normalx == 0) && (normalz == 0))
		{
			x1 = lx[linindex+i], x2 = lx[linindex+nz];
			y1 = lz[linindex+i], y2 = lz[linindex+nz];
		}
		else if ((normaly == 0) && (normalz == 0))
		{
			x1 = ly[linindex+i], x2 = ly[linindex+nz];
			y1 = lz[linindex+i], y2 = lz[linindex+nz];
		}
		else
		{
			x1 = lx[linindex+i], x2 = lx[linindex+nz];
			y1 = ly[linindex+i], y2 = ly[linindex+nz];
		}

		if (sy[i] == sy[nz])
		{
			if ((sy[i] >= 0) && (sy[i] < scrydim))
			{
				x = (sx[i]<<16);
				if (x < lmost[sy[i]])
				{
					lmost[sy[i]] = x;
					lxmost[sy[i]] = (x1<<8);
					lymost[sy[i]] = (y1<<8);
					lzmost[sy[i]] = (rz[i]<<16);
				}
				if ((sx[i]<<16) > rmost[sy[i]])
				{
					rmost[sy[i]] = x;
					rxmost[sy[i]] = (x1<<8);
					rymost[sy[i]] = (y1<<8);
					rzmost[sy[i]] = (rz[i]<<16);
				}
			}
		}
		else
		{
			if (sy[nz] > sy[i])
			{
				ydim = sy[nz]-sy[i];
				ystep = 1L;
			}
			else
			{
				ydim = sy[i]-sy[nz];
				ystep = -1L;
			}

			x = (sx[i]<<16); xinc = ((sx[nz]-sx[i])<<16) / ydim;
			d = (rz[i]<<16); dinc = ((rz[nz]-rz[i])<<16) / ydim;
			topx = 0L; topxinc = ((rz[i]*(x2-x1))<<4);
			topy = 0L; topyinc = ((rz[i]*(y2-y1))<<4);
			xadd = (x1<<8); yadd = (y1<<8);
			bot = rz[nz]*ydim; botinc = rz[i]-rz[nz];
			for (y=sy[i];y!=sy[nz];y+=ystep)
			{
				if ((y >= 0) && (y < scrydim))
				{
					if (x < lmost[y])
					{
						lmost[y] = x;
						lxmost[y] = ((topx/bot)<<4) + xadd;
						lymost[y] = ((topy/bot)<<4) + yadd;
						lzmost[y] = d;
					}
					if (x > rmost[y])
					{
						rmost[y] = x;
						rxmost[y] = ((topx/bot)<<4) + xadd;
						rymost[y] = ((topy/bot)<<4) + yadd;
						rzmost[y] = d;
					}
				}
				topx += topxinc;
				topy += topyinc;
				bot += botinc;
				d += dinc;
				x += xinc;
			}
		}
	}
	picplc = waloff[picnume];
	for (y=0;y<scrydim;y++)
	{
		p = y*scrxdim;
		if ((lmost[y]|65535) <= (rmost[y]|65535))
		{
			x1 = (lmost[y]>>16);
			x2 = (rmost[y]>>16);
			xdim = x2-x1;
			if (xdim > 0)
			{
				topx = 0;
				topy = 0;
				bot = (((rzmost[y]>>12) * xdim)>>4);
				topxinc = (((lzmost[y]>>16) * (rxmost[y]-lxmost[y]))>>4);
				topyinc = (((lzmost[y]>>16) * (rymost[y]-lymost[y]))>>4);
				botinc = ((lzmost[y]-rzmost[y])>>16);
				xadd = (lxmost[y]>>4)+2; yadd = (lymost[y]>>4)+2;

				if (x1 < 0)
				{
					bot += (botinc*(-x1));
					topx += (topxinc*(-x1));
					topy += (topyinc*(-x1));
					x1 = 0;
				}
				if (x2 >= scrxdim)
					x2 = scrxdim-1;

				if (detmode == 0)
				{
					for(i=p+x1;i<p+x2;i+=2)
					{
						dat = getdat(topx,picplc,bot,topy,xadd,yadd);
						bot += botinc, topx += topxinc, topy += topyinc;
						dat += (getdat(topx,picplc,bot,topy,xadd,yadd)<<8);
						bot += botinc, topx += topxinc, topy += topyinc;
						drawpixels(i,dat);
					}
				}
				else if (detmode == 1)
				{
					botinc <<= 1;
					topxinc <<= 1;
					topyinc <<= 1;
					for(i=p+x1;i<p+x2;i+=2)
					{
						dat = getdat(topx,picplc,bot,topy,xadd,yadd);
						dat += (dat<<8);
						bot += botinc, topx += topxinc, topy += topyinc;
						drawpixels(i,dat);
					}
				}
				else if (detmode == 2)
				{
					botinc <<= 2;
					topxinc <<= 2;
					topyinc <<= 2;
					for(i=p+x1;i<p+x2-2;i+=4)
					{
						dat = getdat(topx,picplc,bot,topy,xadd,yadd);
						dat += (dat<<8)+(dat<<16)+(dat<<24);
						bot += botinc, topx += topxinc, topy += topyinc;
						drawpixelses(i,dat);
					}
					if (((x2-x1+1)&2) > 0)
					{
						dat = getdat(topx,picplc,bot,topy,xadd,yadd);
						dat += (dat<<8);
						bot += (botinc>>1), topx += (topxinc>>1), topy += (topyinc>>1);
						drawpixels(i,dat);
					}
				}
				if (((x2-x1+1)&1) > 0)
				{
					dat = getdat(topx,picplc,bot,topy,xadd,yadd);
					drawpixel(p+x2,dat);
				}
			}
		}
	}
	return(0);
}
