// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#define MAIN
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include "build.h"

static unsigned char tempbuf[maxlines], oshade[maxlines];
static unsigned short tempbufword[maxlines];
static short int mousx, mousy, bstatus, obstatus, boardprep, videocard;
static long highlight[maxlines], highlightnum, zoom, grid, linehighlight;
static struct walldata
{
	short unsigned int xa1, ya1, xa2, ya2;
	short unsigned int picnum[3], heinum[2];
	unsigned char shade[3], z[2], got, cstat, zosc, repeat;
};
extern short int numlines;
extern struct walldata lin[maxlines+2];
extern short searchit;
extern long searchx, searchy, searchreturn, waloff[maxtiles];
extern unsigned char picsiz[maxtiles], picanm[maxtiles];
extern unsigned char palette[768];

#pragma aux readmouse =\
	"mov ax, 11d",\
	"int 33h",\
	"sar cx, 1",\
	"sar dx, 1",\
	"mov mousx, cx",\
	"mov mousy, dx",\
	"mov ax, 5d",\
	"int 33h",\
	"mov bx, bstatus",\
	"mov obstatus, bx",\
	"mov bstatus, ax",\
	modify [eax ecx edx]\

#pragma aux showmouse320200 =\
	"mov byte ptr [edi+4], 0x1f",\
	"mov byte ptr [edi+324], 0x1f",\
	"mov byte ptr [edi+644], 0x1f",\
	"mov byte ptr [edi+964], 0x1f",\
	"mov dword ptr [edi+1280], 0x1f1f1f1f",\
	"mov dword ptr [edi+1285], 0x1f1f1f1f",\
	"mov byte ptr [edi+1604], 0x1f",\
	"mov byte ptr [edi+1924], 0x1f",\
	"mov byte ptr [edi+2244], 0x1f",\
	"mov byte ptr [edi+2564], 0x1f",\
	parm [edi]\
	modify [edi]\

#pragma aux limitrate =\
	"mov dx, 0x3da",\
	"wait1: in al, dx",\
	"test al, 8",\
	"jnz wait1",\
	"wait2: in al, dx",\
	"test al, 8",\
	"jz wait2",\

#pragma aux fillscreen =\
	"mov ah, al",\
	"mov cx, ax",\
	"shl ecx, 16",\
	"or eax, ecx",\
	"mov edi, 0xa0000",\
	"mov ecx, 16384",\
	"rep stosd",\
	parm [eax]\
	modify [eax ecx edi]\

#pragma aux drawpixel =\
	"mov [edi+0xa0000], al",\
	parm [edi][eax]\

#pragma aux drawpixels =\
	"mov [edi+0xa0000], ax",\
	parm [edi][eax]\

#pragma aux drawpixel640400 =\
	"mov ah, al",\
	"mov cx, di",\
	"mov dx, 0x3c5",\
	"mov al, 0x11",\
	"rol al, cl",\
	"out dx, al",\
	"shr edi, 2",\
	"mov [edi+0xa0000], ah",\
	parm [edi][eax]\
	modify [ecx edx]\

#pragma aux getpixel =\
	"xor eax, eax",\
	"mov al, [edi+0xa0000]",\
	parm [edi]\

#pragma aux clearseg =\
	"mov edi, 0xa0000",\
	"mov ecx, 16384",\
	"xor eax, eax",\
	"rep stosd",\
	modify [eax edi ecx]\

#pragma aux checkvesa =\
	"mov ax, 0x4f00",\
	"int 0x10",\
	"cmp ax, 0x004f",\
	"sete al",\
	"and eax, 0x000000ff",\
	modify [eax]\

#pragma aux vesasetmode =\
	"mov ax, 0x4f02",\
	"int 0x10",\
	parm [ebx]\
	modify [eax ebx]\

#pragma aux vesasetpage =\
	"mov ax, 0x4f05",\
	"xor bx, bx",\
	"int 0x10",\
	parm [edx]\
	modify [eax ebx]\

main(short int argc,char **argv)
{
	char boardfilename[80], tempchar, ch;
	char cstatv, zv, searchtypev, shadev, tempshade, somethingintab;
	short unsigned int temppicnum, tempshort, picnumv, pag;
	long i, j, k, templong, x, y, startx, starty, daang, newang, bestang;

	if (argc >= 2)
	{
		strcpy(&boardfilename,argv[1]);
		if(strchr(boardfilename,'.') == 0)
			strcat(boardfilename,".dat");
	}
	else
		strcpy(&boardfilename,"boards.dat");

	loadpics("pics.dat");
	loadboard(boardfilename);
	videocard = getcard();
	setgamemode();
	initengine();
	boardprep = 0;
	searchx = 160;
	searchy = 100;
	highlightnum = 0;
	somethingintab = 0;
	zoom = 512, grid = 1;
	while (keystatus[1] == 0)
	{
		readmouse();
		searchx += mousx;
		searchy += mousy;
		if (searchx < 4) searchx = 4;
		if (searchx > 315) searchx = 315;
		if (searchy < 4) searchy = 4;
		if (searchy > 195) searchy = 195;

		if (boardprep != 0)
		{
			prepareboard();  //use only when wall's inserted, deleted, or moved.
			boardprep = 0;
		}

		if (highlightnum > 0)
		{
			for(i=0;i<highlightnum;i++)
			{
				oshade[i] = lin[highlight[i]&8191].shade[highlight[i]>>16];
				lin[highlight[i]&8191].shade[highlight[i]>>16] += (((numframes&1)<<1)-1);
			}
		}
		templong = drawscreen(2);
		if (highlightnum > 0)
			for(i=0;i<highlightnum;i++)
				lin[highlight[i]&8191].shade[highlight[i]>>16] = oshade[i];

		if (highlightnum <= 1)
		{
			if (templong == -1)
				highlight[0] = -1, highlightnum = 0;
			else
				highlight[0] = templong, highlightnum = 1;
			showmouse320200(0x000a0000+(searchy-4)*320L+(searchx-4));
		}

		engineinputforeditor();
		if (highlightnum > 0)
		{
			if (keystatus[0x4a] > 0)  // -
			{
				for(i=0;i<highlightnum;i++)
					lin[highlight[i]&8191].shade[highlight[i]>>16]--;
				keystatus[0x4a] = 0;
			}
			if (keystatus[0x4e] > 0)  // +
			{
				for(i=0;i<highlightnum;i++)
					lin[highlight[i]&8191].shade[highlight[i]>>16]++;
				keystatus[0x4e] = 0;
			}
			if ((keystatus[0xc9] > 0) && ((highlight[0]>>16) > 0)) // PGUP
			{
				for(i=0;i<highlightnum;i++)
				{
					j = highlight[i];
					if (lin[j&8191].z[(j>>16)-1] > 0)
					{
						lin[j&8191].z[(j>>16)-1]--;
						if (lin[j&8191].z[0] > lin[j&8191].z[1])
							flipwall(i);
					}
				}
				keystatus[0xc9] = 0;
			}
			if ((keystatus[0xd1] > 0) && ((highlight[0]>>16) > 0)) // PGDN
			{
				for(i=0;i<highlightnum;i++)
				{
					j = highlight[i];
					if (lin[j&8191].z[(j>>16)-1] < 255)
					{
						lin[j&8191].z[(j>>16)-1]++;
						if (lin[j&8191].z[0] > lin[j&8191].z[1])
							flipwall(i);
					}
				}
				keystatus[0xd1] = 0;
			}
			if (keystatus[0xc7] > 0)  // Home
			{
				for(i=0;i<highlightnum;i++)
					if (lin[highlight[i]&8191].zosc <= 252)
						lin[highlight[i]&8191].zosc += 4;
				keystatus[0xc7] = 0;
			}
			if (keystatus[0xcf] > 0)  // End
			{
				for(i=0;i<highlightnum;i++)
					if (lin[highlight[i]&8191].zosc >= 4)
						lin[highlight[i]&8191].zosc -= 4;
				keystatus[0xcf] = 0;
			}
			if (keystatus[0x2e] > 0)  // C (clip xor)
			{
				for(i=0;i<highlightnum;i++)
					lin[highlight[i]&8191].cstat ^= 128;
				cliploadlocal();
				keystatus[0x2e] = 0;
			}
			if (keystatus[0x19] > 0)  // P (parallax)
			{
				for(i=0;i<highlightnum;i++)
					lin[highlight[i]&8191].cstat ^= 64;
				keystatus[0x19] = 0;
			}
			if (keystatus[0x22] > 0)  // G (groudraw)
			{
				for(i=0;i<highlightnum;i++)
					lin[highlight[i]&8191].cstat ^= 32;
				keystatus[0x22] = 0;
			}
			if (keystatus[0xb5] > 0)  // /
			{
				for(i=0;i<highlightnum;i++)
				{
					j = (lin[highlight[i]&8191].cstat);
					lin[highlight[i]&8191].cstat &= 240;
					if (j == 6) lin[highlight[i]&8191].cstat |= 3;
					if (j == 9) lin[highlight[i]&8191].cstat |= 6;
					if (j == 3) lin[highlight[i]&8191].cstat |= 9;
				}
				keystatus[0xb5] = 0;
			}
			if (keystatus[0x37] > 0)  // *
			{
				for(i=0;i<highlightnum;i++)
				{
					j = (lin[highlight[i]&8191].cstat&15);
					lin[highlight[i]&8191].cstat &= 240;
					if (j == 6) lin[highlight[i]&8191].cstat |= 9;
					if (j == 9) lin[highlight[i]&8191].cstat |= 3;
					if (j == 3) lin[highlight[i]&8191].cstat |= 6;
				}
				keystatus[0x37] = 0;
			}
			if (keystatus[0x0f] > 0)  //TAB
			{
				temppicnum = lin[highlight[0]&8191].picnum[highlight[0]>>16];
				tempshade = lin[highlight[0]&8191].shade[highlight[0]>>16];
				somethingintab = 1;
				keystatus[0x0f] = 0;
			}
			if ((keystatus[0x39] > 0) && (somethingintab > 0))  //SPACE
			{
				for(i=0;i<highlightnum;i++)
				{
					lin[highlight[i]&8191].picnum[highlight[i]>>16] = temppicnum;
					lin[highlight[i]&8191].shade[highlight[i]>>16] = tempshade;
				}
				keystatus[0x39] = 0;
			}
			if (keystatus[0x4b] > 0)  //4 (keypad)
			{
				for(i=0;i<highlightnum;i++)
					if ((lin[highlight[i]&8191].repeat&15) > 0)
						lin[highlight[i]&8191].repeat--;
				keystatus[0x4b] = 0;
			}
			if (keystatus[0x4d] > 0)  //6 (keypad)
			{
				for(i=0;i<highlightnum;i++)
					if ((lin[highlight[i]&8191].repeat&15) < 15)
						lin[highlight[i]&8191].repeat++;
				keystatus[0x4d] = 0;
			}
			if (keystatus[0x48] > 0)  //2 (keypad)
			{
				for(i=0;i<highlightnum;i++)
					if (lin[highlight[i]&8191].repeat >= 16)
						lin[highlight[i]&8191].repeat -= 16;
				keystatus[0x48] = 0;
			}
			if (keystatus[0x50] > 0)  //8 (keypad)
			{
				for(i=0;i<highlightnum;i++)
					if (lin[highlight[i]&8191].repeat < 240)
						lin[highlight[i]&8191].repeat += 16;
				keystatus[0x50] = 0;
			}
			if (keystatus[0x21] > 0)  // F
			{
				for(i=0;i<highlightnum;i++)
					flipwall(i);
				keystatus[0x21] = 0;
			}
			if (keystatus[0x2f] > 0)  //V
			{
				templong = lin[highlight[0]&8191].picnum[highlight[0]>>16];
				templong = gettile(templong);
				if ((highlight[0]>>16) == 0)
					lin[highlight[0]&8191].picnum[highlight[0]>>16] = templong;
				else
					for(i=0;i<highlightnum;i++)
						lin[highlight[i]&8191].picnum[highlight[i]>>16] = templong;
			}
			if ((keystatus[0x23] > 0) && ((highlight[0]>>16) > 0))  //H
			{
				templong = lin[highlight[0]&8191].heinum[(highlight[0]>>16)-1];
				templong = gettile(templong);
				for(i=0;i<highlightnum;i++)
					lin[highlight[i]&8191].heinum[(highlight[i]>>16)-1] = templong;
			}
			if ((((bstatus&1) > (obstatus&1)) || (keystatus[0x36] > 0)) && ((highlight[0]>>16) > 0))
			{
				//HIGHLIGHT SEARCHING!

				//Step 1: Knock out all walls with different attributes.
				cstatv = lin[highlight[0]&8191].cstat;
				zv = lin[highlight[0]&8191].z[(highlight[0]>>16)-1];
				shadev = lin[highlight[0]&8191].shade[highlight[0]>>16];
				picnumv = lin[highlight[0]&8191].picnum[highlight[0]>>16];
													//searchtypev: 0 - ceiling, 1 - floor
				searchtypev = 2;
				if ((cstatv&15) == 6) searchtypev = 1;
				if ((cstatv&15) == 9) searchtypev = 0;
				if ((cstatv&15) == 3) searchtypev = (highlight[0]>>16)-1;
				for(i=0;i<numlines;i++)
				{
					tempbuf[i] = 0;

					if ((lin[i].cstat&15) == 6)
						if (searchtypev == 1)
						{
							if (zv == lin[i].z[0])
								if (picnumv == lin[i].picnum[1])
									if (shadev == lin[i].shade[1])
										tempbuf[i] |= (1+8);
							if (zv == lin[i].z[1])
								if (picnumv == lin[i].picnum[2])
									if (shadev == lin[i].shade[2])
										tempbuf[i] |= (2+4);
						}
					if ((lin[i].cstat&15) == 9)
						if (searchtypev == 0)
						{
							if (zv == lin[i].z[0])
								if (picnumv == lin[i].picnum[1])
									if (shadev == lin[i].shade[1])
										tempbuf[i] |= (1+4);
							if (zv == lin[i].z[1])
								if (picnumv == lin[i].picnum[2])
									if (shadev == lin[i].shade[2])
										tempbuf[i] |= (2+8);
						}
					if ((lin[i].cstat&15) == 3)
					{
						if (searchtypev == 0)
							if (zv == lin[i].z[0])
								if (picnumv == lin[i].picnum[1])
									if (shadev == lin[i].shade[1])
										tempbuf[i] |= (1+4);
						if (searchtypev == 1)
							if (zv == lin[i].z[1])
								if (picnumv == lin[i].picnum[2])
									if (shadev == lin[i].shade[2])
										tempbuf[i] |= (2+4);
					}
				}
				//tempbuf[x] > 0 only if tempbuf[x] can be part of sector
				//Step 2: Now check by following vertices.

				highlightnum = 1;
				if ((tempbuf[highlight[0]&8191]&12) == 12)
				{
					if (searchtypev == 1)
					{
						if ((highlight[0]>>16) == 1)
							tempbuf[highlight[0]&8191] &= (255-4);
						if ((highlight[0]>>16) == 2)
							tempbuf[highlight[0]&8191] &= (255-8);
					}
					if (searchtypev == 0)
					{
						if ((highlight[0]>>16) == 1)
							tempbuf[highlight[0]&8191] &= (255-8);
						if ((highlight[0]>>16) == 2)
							tempbuf[highlight[0]&8191] &= (255-4);
					}
				}
				if ((tempbuf[highlight[0]&8191]&4) > 0)
				{
					startx = lin[highlight[0]&8191].xa1;
					starty = lin[highlight[0]&8191].ya1;
					x = lin[highlight[0]&8191].xa2;
					y = lin[highlight[0]&8191].ya2;
				}
				else
				{
					startx = lin[highlight[0]&8191].xa2;
					starty = lin[highlight[0]&8191].ya2;
					x = lin[highlight[0]&8191].xa1;
					y = lin[highlight[0]&8191].ya1;
				}
				daang = getangle(startx-x,starty-y);
				bestang = ((daang+1)&2047);
				tempbuf[highlight[0]&8191] = 0;
				do
				{
					j = -1;
					for(i=0;i<numlines;i++)
						if (tempbuf[i] > 0)
						{
							if ((tempbuf[i]&4) > 0)  //front matches
								if ((x == lin[i].xa1) && (y == lin[i].ya1))
								{
									newang = getangle(lin[i].xa2-x,lin[i].ya2-y);
									if (((daang+2048-newang)&2047) < ((daang+2048-bestang)&2047))
									{
										bestang = newang;
										j = i;
									}
								}
							if ((tempbuf[i]&8) > 0)  //back matches
								if ((x == lin[i].xa2) && (y == lin[i].ya2))
								{
									newang = getangle(lin[i].xa1-x,lin[i].ya1-y);
									if (((daang+2048-newang)&2047) < ((daang+2048-bestang)&2047))
									{
										bestang = newang;
										j = i;
									}
								}
						}
					if (j >= 0)
					{
						if ((tempbuf[j]&3) == 1)
							highlight[highlightnum++] = j+65536;
						if ((tempbuf[j]&3) == 2)
							highlight[highlightnum++] = j+131072;
						if ((tempbuf[j]&3) == 3)
						{
							if (searchtypev == 1)
							{
								if ((x == lin[j].xa1) && (y == lin[j].ya1))
									highlight[highlightnum++] = j+131072;
								else
									highlight[highlightnum++] = j+65536;
							}
							if (searchtypev == 0)
							{
								if ((x == lin[j].xa1) && (y == lin[j].ya1))
									highlight[highlightnum++] = j+65536;
								else
									highlight[highlightnum++] = j+131072;
							}
						}
						if ((x == lin[j].xa2) && (y == lin[j].ya2))
						{
							x = lin[j].xa1, y = lin[j].ya1;
						}
						else
						{
							x = lin[j].xa2, y = lin[j].ya2;
						}
						tempbuf[j] = 0;
						daang = (2048-bestang)&2047;
						bestang = ((daang+1)&2047);
						if ((x == startx) && (y == starty))
							j = -1;
					}
				}
				while (j >= 0);
			}
			if ((((bstatus&1) < (obstatus&1)) || (keystatus[0x35] > 0)) && (highlightnum > 1))
				highlightnum = 1;
			if (keystatus[0x9c] > 0)  // Enter
			{
				overheadeditor();
				keystatus[0x9c] = 0;
			}
		}

		nextpage();
	}
	uninitengine();

	setvmode(0x3);
	printf("Save changes?\n");
	do
	{
		ch = getch();
	}
	while ((ch != 'y') && (ch != 'Y') && (ch != 'n') && (ch != 'N'));
	if ((ch == 'y') || (ch == 'Y'))
		saveboard(boardfilename);
}

saveboard(filename)
char filename[20];
{
	short int fil, i, j;
	unsigned short tempword;
	long templong;

	if ((fil = open(filename,O_BINARY|O_TRUNC|O_CREAT|O_WRONLY,S_IWRITE)) != -1)
	{
		tempword = (unsigned short)(posx>>5), write(fil,&tempword,2);
		tempword = (unsigned short)(posy>>5), write(fil,&tempword,2);
		write(fil,&ang,2);
		write(fil,&numlines,2);

		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].xa1>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].ya1>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].xa2>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(i=0;i<numlines;i++)
			tempbufword[i] = (unsigned short)(lin[i].ya2>>5);
		write(fil,&tempbufword[0],numlines<<1);
		for(j=0;j<3;j++)
		{
			for(i=0;i<numlines;i++)
				tempbufword[i] = (unsigned short)(lin[i].picnum[j]);
			write(fil,&tempbufword[0],numlines<<1);
		}
		for(j=0;j<2;j++)
		{
			for(i=0;i<numlines;i++)
				tempbufword[i] = (unsigned short)(lin[i].heinum[j]);
			write(fil,&tempbufword[0],numlines<<1);
		}
		for(j=0;j<3;j++)
		{
			for(i=0;i<numlines;i++)
				tempbuf[i] = lin[i].shade[j];
			write(fil,&tempbuf[0],numlines);
		}
		for(j=0;j<2;j++)
		{
			for(i=0;i<numlines;i++)
				tempbuf[i] = lin[i].z[j];
			write(fil,&tempbuf[0],numlines);
		}
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].cstat;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].zosc;
		write(fil,&tempbuf[0],numlines);
		for(i=0;i<numlines;i++)
			tempbuf[i] = lin[i].repeat;
		write(fil,&tempbuf[0],numlines);
		close(fil);
	}
	return(0);
}

engineinputforeditor()
{
	int doubvel;

	if (vel < 0)
	{
		vel+=((clockspeed>>3)+1);
		if (vel > 0) vel = 0;
	}
	if (vel > 0)
	{
		vel-=((clockspeed>>3)+1);
		if (vel < 0) vel = 0;
	}
	if (svel < 0)
	{
		svel+=((clockspeed>>2)+1);
		if (svel > 0) svel = 0;
	}
	if (svel > 0)
	{
		svel-=((clockspeed>>2)+1);
		if (svel < 0) svel = 0;
	}
	if (hvel < 0)
	{
		hvel += 4;
		if (hvel > 0) hvel = 0;
	}
	if (hvel > 0)
	{
		hvel -= 4;
		if (hvel < 0) hvel = 0;
	}
	if (angvel < 0)
	{
		angvel+=((clockspeed>>1)+1);
		if (angvel > 0) angvel = 0;
	}
	if (angvel > 0)
	{
		angvel-=((clockspeed>>1)+1);
		if (angvel < 0) angvel = 0;
	}
	if (keystatus[0x2a] > 0)
		doubvel = 2;
	else
		doubvel = 1;

	if (keystatus[0x9d] == 0)
	{
		if (keystatus[0xcb] > 0) angvel -= 10;
		if (keystatus[0xcd] > 0) angvel += 10;
	}
	else
	{
		if (keystatus[0xcb] > 0) svel += 6*doubvel;
		if (keystatus[0xcd] > 0) svel -= 6*doubvel;
	}
	if (keystatus[0x1e] > 0) hvel -= 6*doubvel;
	if (keystatus[0x2c] > 0) hvel += 6*doubvel;
	if (keystatus[0xc8] > 0) vel += 6*doubvel;
	if (keystatus[0xd0] > 0) vel -= 6*doubvel;

	if (vel < -16*doubvel) vel = -16*doubvel;
	if (vel > 16*doubvel) vel = 16*doubvel;
	if (svel < -16*doubvel) svel = -16*doubvel;
	if (svel > 16*doubvel) svel = 16*doubvel;
	if (hvel < -16*doubvel) hvel = -16*doubvel;
	if (hvel > 16*doubvel) hvel = 16*doubvel;
	if (angvel < -24) angvel = -24;
	if (angvel > 24) angvel = 24;

	if (angvel != 0)
	{
		ang += ((angvel*clockspeed)>>3);
		ang = (ang+2048)&2047;
	}
	if (vel != 0)
		clipmove(vel*clockspeed);
	if (svel != 0)
	{
		ang = ((ang+1536)&2047);
		clipmove(svel*clockspeed);
		ang = ((ang+512)&2047);
	}
	if (hvel != 0)
	{
		newposz += (hvel<<7)+(hvel<<6);
		if (posz < 0) posz = 0;
		if (posz > 65535) posz = 65535;
	}
	posz = (posz+posz+posz+newposz)>>2;
}

drawsvgarow(long picstart)
{
	long i, j, vidpos, vidpos2, dat, wallnum, xdime, ydime;
	char *picptr;

	if (videocard == 1)
		outp(0x3cd,(picstart>>4)&15);
	else
		vesasetpage((picstart>>4)&15);

	vidpos = 0;
	clearseg();
	for(wallnum=picstart;wallnum<picstart+16;wallnum++)
	{
		if (picsiz[wallnum] != 0)
		{
			picptr = (char *)(waloff[wallnum]);
			xdime = (1<<(picsiz[wallnum]&15));
			ydime = (1<<(picsiz[wallnum]>>4));

			if ((xdime <= 64) && (ydime <= 64))
			{
				vidpos2 = vidpos;
				for(i=0;i<xdime;i++)
				{
					for(j=0;j<ydime;j++)
					{
						dat = *picptr++;
						drawpixel(vidpos2, dat);
						vidpos2 += 1024L;
					}
					vidpos2 = (vidpos2&1023)+1;
				}
			}
			else
			{
				vidpos2 = vidpos;
				for(i=0;i<xdime;i+=2)
				{
					for(j=0;j<ydime;j+=2)
					{
						dat = *picptr;
						picptr += 2;
						drawpixel(vidpos2, dat);
						vidpos2 += 1024L;
					}
					vidpos2 = (vidpos2&1023)+1;
					picptr += ydime;
				}
			}
		}
		vidpos += 64;
	}
	return(0);
}

drawopenboxsvga(long picstart, char col)
{
	long i, vidpos, vidpos1, vidpos2, dat;

	dat = (long)col;
	dat += (dat<<8);
	if (videocard == 1)
		outp(0x3cd,(picstart>>4)&15);
	else
		vesasetpage((picstart>>4)&15);

	vidpos = ((picstart&15)<<6);
	vidpos1 = vidpos;
	vidpos2 = vidpos+62;
	for(i=0;i<64;i++)
	{
		drawpixels(vidpos1,dat);
		drawpixels(vidpos2,dat);
		vidpos1 += 1024;
		vidpos2 += 1024;
	}
	vidpos1 = vidpos;
	vidpos2 = (63<<10)+vidpos;
	for(i=0;i<62;i+=2)
	{
		drawpixels(vidpos1,dat);
		drawpixels(vidpos1+1024L,dat);
		drawpixels(vidpos2,dat);
		drawpixels(vidpos2-1024L,dat);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

backupboxsvga(long picstart)
{
	long i, vidpos, vidpos1, vidpos2, tempbufcnt;

	if (videocard == 1)
		outp(0x3cd,((picstart>>4)&15)<<4);
	else
		vesasetpage(((picstart>>4)&15)<<4);

	vidpos = ((picstart&15)<<6);
	vidpos1 = vidpos;
	vidpos2 = vidpos+62;
	tempbufcnt = 0;
	for(i=0;i<64;i++)
	{
		tempbuf[tempbufcnt++] = getpixel(vidpos1);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1);
		tempbuf[tempbufcnt++] = getpixel(vidpos2);
		tempbuf[tempbufcnt++] = getpixel(vidpos2+1);
		vidpos1 += 1024;
		vidpos2 += 1024;
	}
	vidpos1 = vidpos;
	vidpos2 = (63<<10)+vidpos;
	for(i=0;i<62;i+=2)
	{
		tempbuf[tempbufcnt++] = getpixel(vidpos1);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1024);
		tempbuf[tempbufcnt++] = getpixel(vidpos1+1025);
		tempbuf[tempbufcnt++] = getpixel(vidpos2);
		tempbuf[tempbufcnt++] = getpixel(vidpos2+1);
		tempbuf[tempbufcnt++] = getpixel(vidpos2-1024);
		tempbuf[tempbufcnt++] = getpixel(vidpos2-1023);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

restoreboxsvga(long picstart)
{
	long i, vidpos, vidpos1, vidpos2, tempbufcnt;

	if (videocard == 1)
		outp(0x3cd,(picstart>>4)&15);
	else
		vesasetpage((picstart>>4)&15);

	vidpos = ((picstart&15)<<6);
	vidpos1 = vidpos;
	vidpos2 = vidpos+62;
	tempbufcnt = 0;
	for(i=0;i<64;i++)
	{
		drawpixel(vidpos1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2+1,tempbuf[tempbufcnt++]);
		vidpos1 += 1024;
		vidpos2 += 1024;
	}
	vidpos1 = vidpos;
	vidpos2 = (63<<10)+vidpos;
	for(i=0;i<62;i+=2)
	{
		drawpixel(vidpos1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1024,tempbuf[tempbufcnt++]);
		drawpixel(vidpos1+1025,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2+1,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2-1024,tempbuf[tempbufcnt++]);
		drawpixel(vidpos2-1023,tempbuf[tempbufcnt++]);
		vidpos1+=2;
		vidpos2+=2;
	}
	return(0);
}

checkforscroll(long currentscreenplace, long realplace)
{
	long place;

	if (realplace < currentscreenplace)
	{
		currentscreenplace -= 16L;
		drawsvgarow(currentscreenplace);
	}
	if (realplace >= currentscreenplace+192)
	{
		drawsvgarow(currentscreenplace+192);
		currentscreenplace += 16L;
	}
	place = (((currentscreenplace>>4)&15)<<6);
	outp(0x3d4,0x33); outp(0x3d5,place>>8);
	outp(0x3d4,0xc); outp(0x3d5,place&255);
	return(currentscreenplace);
}

gettile(long templong)
{
	long i, j, otemplong;

	if (videocard == 1)
		setvmode(0x38);
	else
		vesasetmode(0x105);

	otemplong = templong;
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	j = (templong&0xfff0)-96;
	if (j < 0) j = 0;
	j = checkforscroll(j, templong);
	for(i=0;i<192;i+=16)
		drawsvgarow(i+j);
	backupboxsvga(templong);
	while ((keystatus[0x1c]|keystatus[1]) == 0)
	{
		restoreboxsvga(templong);
		if ((keystatus[0xcb] > 0) && (templong > 0))
			templong--, keystatus[0xcb] = 0;
		if ((keystatus[0xcd] > 0) && (templong < maxtiles-1))
			templong++, keystatus[0xcd] = 0;
		if ((keystatus[0xc8] > 0) && (templong >= 16))
			templong-=16, keystatus[0xc8] = 0;
		if ((keystatus[0xd0] > 0) && (templong < maxtiles-16))
			templong+=16, keystatus[0xd0] = 0;
		j = checkforscroll(j, templong);
		backupboxsvga(templong);

		readmouse();
		if ((mousx != 0) || (mousy != 0))
		{
			restoreboxsvga(templong);
			if ((mousx < 0) && ((templong&15) > 0)) templong--;
			if ((mousx > 0) && ((templong&15) < 15)) templong++;
			if ((mousy < 0) && (templong >= 16)) templong-=16;
			if ((mousy > 0) && (templong < maxtiles-16)) templong+=16;
			j = checkforscroll(j, templong);
			backupboxsvga(templong);
		}

		limitrate();
		drawopenboxsvga(templong,31);
		limitrate();
		drawopenboxsvga(templong,0);
	}
	if (keystatus[0x1c] == 0)
		templong = otemplong;
	else
		keystatus[0x1c] = 0;
	setvmode(0x13);
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	return(templong);
}

getangle(long xvect,long yvect)
{
	long d1, d2, d3, daang, incr, i;

	daang = 1024; incr = 512;
	for(i=0;i<10;i++)
	{
		if (yvect*sintable[(daang+512)&2047] > xvect*sintable[daang&2047])
			daang += incr;
		else
			daang -= incr;
		incr >>= 1;
	}
	d1 = yvect*sintable[(daang+2559)&1023] - xvect*sintable[(daang+2047)&1023];
	d2 = yvect*sintable[(daang+2560)&1023] - xvect*sintable[(daang+2048)&1023];
	d3 = yvect*sintable[(daang+2561)&1023] - xvect*sintable[(daang+2049)&1023];
	if (d1 < d2) daang--;
	if (d3 < d2) daang++;
	daang = ((daang+2048)&2047);
	return(daang);
}

flipwall(long i)
{
	char tempchar;
	short tempshort;
	long j;

	j = (highlight[i]&8191);
	tempshort = lin[j].xa1; lin[j].xa1 = lin[j].xa2; lin[j].xa2 = tempshort;
	tempshort = lin[j].ya1; lin[j].ya1 = lin[j].ya2; lin[j].ya2 = tempshort;
	tempshort = lin[j].picnum[1]; lin[j].picnum[1] = lin[j].picnum[2]; lin[j].picnum[2] = tempshort;
	tempshort = lin[j].heinum[0]; lin[j].heinum[0] = lin[j].heinum[1]; lin[j].heinum[1] = tempshort;
	tempchar = lin[j].shade[1]; lin[j].shade[1] = lin[j].shade[2]; lin[j].shade[2] = tempchar;
	tempchar = lin[j].z[0]; lin[j].z[0] = lin[j].z[1]; lin[j].z[1] = tempchar;
	if ((highlight[i]>>16) != 0)
		 highlight[i] = (highlight[i]^(65536+131072));
}

drawline640400(long x0, long y0, long x1, long y1, char col)
{
	long i, xdim, ydim, cnt, pinc, p;

	if ((x0 == x1) && (y0 == y1)) return(0);
	if ((x0 < 0) && (x1 < 0)) return(0);
	if ((x0 >= 640) && (x1 >= 640)) return(0);
	if ((y0 < 0) && (y1 < 0)) return(0);
	if ((y0 >= 400) && (y1 >= 400)) return(0);

	if ((x0 < 0) && (x0 != x1)) y0 -= ((y1-y0)*x0) / (x1-x0), x0 = 0;
	if ((x1 < 0) && (x0 != x1)) y1 -= ((y1-y0)*x1) / (x1-x0), x1 = 0;
	if ((y0 < 0) && (y0 != y1)) x0 -= ((x1-x0)*y0) / (y1-y0), y0 = 0;
	if ((y1 < 0) && (y0 != y1)) x1 -= ((x1-x0)*y1) / (y1-y0), y1 = 0;
	if ((x0 >= 640) && (x0 != x1)) y0 += ((y1-y0)*(639-x0)) / (x1-x0), x0 = 639;
	if ((x1 >= 640) && (x0 != x1)) y1 += ((y1-y0)*(639-x1)) / (x1-x0), x1 = 639;
	if ((y0 >= 400) && (y0 != y1)) x0 += ((x1-x0)*(399-y0)) / (y1-y0), y0 = 399;
	if ((y1 >= 400) && (y0 != y1)) x1 += ((x1-x0)*(399-y1)) / (y1-y0), y1 = 399;

	if ((x0 < 0) && (x1 < 0)) return(0);
	if ((x0 >= 640) && (x1 >= 640)) return(0);
	if ((y0 < 0) && (y1 < 0)) return(0);
	if ((y0 >= 400) && (y1 >= 400)) return(0);

	if (x1 > x0)
		xdim = x1-x0+1;
	else
		xdim = x0-x1+1;
	if (y1 > y0)
		ydim = y1-y0+1;
	else
		ydim = y0-y1+1;

	outp(0x3c4, 0x2);
	if (xdim >= ydim)
	{
		if (x1 < x0)
		{
			i = x0; x0 = x1; x1 = i;
			i = y0; y0 = y1; y1 = i;
		}
		p = y0 * 640 + x0;
		cnt = 0;
		if (y1 > y0) pinc = 640; else pinc = -640;
		for(i=xdim;i>0;i--)
		{
			drawpixel640400(p,col);
			cnt += ydim;
			if (cnt >= xdim)
				cnt -= xdim, p += pinc;
			p++;
		}
	}
	if (xdim < ydim)
	{
		if (y1 < y0)
		{
			i = x0; x0 = x1; x1 = i;
			i = y0; y0 = y1; y1 = i;
		}
		p = y0 * 640 + x0;
		cnt = 0;
		if (x1 > x0) pinc = 1; else pinc = -1;
		for(i=ydim;i>0;i--)
		{
			drawpixel640400(p,col);
			cnt += xdim;
			if (cnt >= ydim)
				cnt -= ydim, p += pinc;
			p += 640;
		}
	}
	return(0);
}

qsetmode320200()
{
	short i;

	if (videocard == 1)
	{
		outp(0x3c4, 0x4); outp(0x3c5, inp(0x3c5)|8);
		outp(0x3d4, 0x17); outp(0x3d5, inp(0x3d5)&(255-64));
		outp(0x3d4, 0x14); outp(0x3d5, inp(0x3d5)|64);
		outpw(0x3c4, 0x0f02), fillscreen(0);
		outp(0x3d4, 0x13); outp(0x3d5,40);
		outp(0x3d4, 0x14); outp(0x3d5, inp(0x3d5)&(255 - 32));
		outp(0x3d4, 0x17); outp(0x3d5, inp(0x3d5)&(255 - 8));
		outp(0x3d4, 0x9); outp(0x3d5, inp(0x3d5)|1);
		inp(0x3da); outp(0x3c0, 0x10 + 32); outp(0x3c0, inp(0x3c1)|64);
		outp(0x3ce, 0x5); outp(0x3cf, inp(0x3cf)&(255-32)|64);
	}
	else
	{
		setvmode(0x13);
		outp(0x3c8,0);
		for(i=0;i<768;i++)
			outp(0x3c9,palette[i]);
	}
	return(0);
}

qsetmode640400()
{
	short i;

	if (videocard == 1)
	{
		outp(0x3c4, 0x4); outp(0x3c5, inp(0x3c5)&(255-8));
		outp(0x3d4, 0x17); outp(0x3d5, inp(0x3d5)|64);
		outp(0x3d4, 0x14); outp(0x3d5, inp(0x3d5)&(255-64));
		outpw(0x3c4, 0x0f02), fillscreen(0);
		outp(0x3d4, 0x13); outp(0x3d5, 80);
		outp(0x3d4, 0x14); outp(0x3d5, inp(0x3d5)|32);
		outp(0x3d4, 0x17); outp(0x3d5, inp(0x3d5)|8);
		outp(0x3d4, 0x9); outp(0x3d5, inp(0x3d5)&(255-1));
		inp(0x3da); outp(0x3c0, 0x10 + 32); outp(0x3c0, inp(0x3c1)&(255-64));
		outp(0x3ce, 0x5); outp(0x3cf, inp(0x3cf)&(255-32)|64);
	}
	if (videocard == 2)
	{
		vesasetmode(0x100);
		outp(0x3c4, 0x4); outp(0x3c5, inp(0x3c5)&(255-8));
		outp(0x3d4, 0x17); outp(0x3d5, inp(0x3d5)|64);
		outp(0x3d4, 0x14); outp(0x3d5, inp(0x3d5)&(255-64));
		outp(0x3c8,0);
		for(i=0;i<768;i++)
			outp(0x3c9,palette[i]);
	}
	return(0);
}

drawboardlinrot(long posxe, long posye, short ange, long zoome)
{
	long i, j, xp1, yp1, xp2, yp2;
	char col;

	if (grid == 1)
		for(i=0;i<=65536;i+=1024)
		{
			xp1 = (((long)(i-posxe)*(long)sintable[(2048+ange)&2047]-(long)(-posye)*(long)sintable[(2560+ange)&2047])>>15);
			yp1 = (((long)(i-posxe)*(long)sintable[(2560+ange)&2047]+(long)(-posye)*(long)sintable[(2048+ange)&2047])>>15);
			xp2 = (((long)(i-posxe)*(long)sintable[(2048+ange)&2047]-(long)(65536-posye)*(long)sintable[(2560+ange)&2047])>>15);
			yp2 = (((long)(i-posxe)*(long)sintable[(2560+ange)&2047]+(long)(65536-posye)*(long)sintable[(2048+ange)&2047])>>15);
			xp1 = ((xp1*zoome)>>13);
			yp1 = ((yp1*zoome)>>13);
			xp2 = ((xp2*zoome)>>13);
			yp2 = ((yp2*zoome)>>13);
			drawline640400(320-xp1,200-yp1,320-xp2,200-yp2,12);

			xp1 = (((long)(0-posxe)*(long)sintable[(2048+ange)&2047]-(long)(i-posye)*(long)sintable[(2560+ange)&2047])>>15);
			yp1 = (((long)(0-posxe)*(long)sintable[(2560+ange)&2047]+(long)(i-posye)*(long)sintable[(2048+ange)&2047])>>15);
			xp2 = (((long)(65536-posxe)*(long)sintable[(2048+ange)&2047]-(long)(i-posye)*(long)sintable[(2560+ange)&2047])>>15);
			yp2 = (((long)(65536-posxe)*(long)sintable[(2560+ange)&2047]+(long)(i-posye)*(long)sintable[(2048+ange)&2047])>>15);
			xp1 = ((xp1*zoome)>>13);
			yp1 = ((yp1*zoome)>>13);
			xp2 = ((xp2*zoome)>>13);
			yp2 = ((yp2*zoome)>>13);
			drawline640400(320-xp1,200-yp1,320-xp2,200-yp2,12);
		}
	for(i=0;i<numlines;i++)
	{
		col = 16;
		if ((lin[i].cstat&15) == 6) col = 159;
		if ((lin[i].cstat&15) == 9) col = 191;
		if ((lin[i].cstat&15) == 3) col = 31;
		if (i == linehighlight)
			col += (numframes&1);

		xp1 = (((long)(lin[i].xa1-posxe)*(long)sintable[(2048+ange)&2047]-(long)(lin[i].ya1-posye)*(long)sintable[(2560+ange)&2047])>>15);
		yp1 = (((long)(lin[i].xa1-posxe)*(long)sintable[(2560+ange)&2047]+(long)(lin[i].ya1-posye)*(long)sintable[(2048+ange)&2047])>>15);
		xp2 = (((long)(lin[i].xa2-posxe)*(long)sintable[(2048+ange)&2047]-(long)(lin[i].ya2-posye)*(long)sintable[(2560+ange)&2047])>>15);
		yp2 = (((long)(lin[i].xa2-posxe)*(long)sintable[(2560+ange)&2047]+(long)(lin[i].ya2-posye)*(long)sintable[(2048+ange)&2047])>>15);
		xp1 = ((xp1*zoome)>>13);
		yp1 = ((yp1*zoome)>>13);
		xp2 = ((xp2*zoome)>>13);
		yp2 = ((yp2*zoome)>>13);

		drawline640400(320-xp1,200-yp1,320-xp2,200-yp2,col);
	}
	drawline640400(320,195,320,205,63);
	drawline640400(320,196,316,200,63);
	drawline640400(320,196,324,200,63);
}

int getcard()         //returns: 0 = nothing, 1 = TSENG ET4000, 2 = VESA
{
	int value, newvalue, oldvalue, bas, tseng, vesa, card;

	outp(0x3bf,3);                       //Check TSENG
	if ((inp(0x3cc)&1) == 1)
		outp(0x3d8, 0xa0);
	else
		outp(0x3b8, 0xa0);
	inp(0x3da); outp(0x3c0,0x16); oldvalue = inp(0x3c1);
	inp(0x3da); outp(0x3c0,0x16); newvalue = (oldvalue^16);
	outp(0x3c0, newvalue);
	inp(0x3da); outp(0x3c0,0x16); value = inp(0x3c1);
	inp(0x3da); outp(0x3c0,0x16); outp(0x3c0,oldvalue);
	tseng = 0;
	if (value == newvalue)
	{
		if ((inp(0x3cc)&1) == 1)
			bas = 0x3d0;
		else
			bas = 0x3b0;
		outp(bas+4,0x33); oldvalue = inp(bas+5);
		outp(bas+5,oldvalue^15); newvalue = inp(bas+5);
		outp(bas+5,oldvalue);
		if (newvalue == (oldvalue^15))
			tseng = 4000;  //TSENG ET4000
		else
			tseng = 3000;  //TSENG ET3000
	}

	vesa = checkvesa();                   //Check VESA

	if (tseng == 4000)
		card = 1;
	else if (vesa == 1)
		card = 2;
	else
		card = 0;

	return(card);
}

overheadeditor()
{
	long mousxplc, mousyplc, markx, marky, oposz;
	short pag;

	searchx <<= 1;
	searchy <<= 1;
	oposz = posz;

	qsetmode640400();
	outpw(0x3d4,0x000c);
	outpw(0x3d4,0x000d);
	pag = 0;
	keystatus[0x9c] = 0;
	while ((keystatus[0x9c]|keystatus[0x1]) == 0)
	{

		readmouse();
		searchx += mousx;
		searchy += mousy;
		if (searchx < 8) searchx = 8;
		if (searchx > 631) searchx = 631;
		if (searchy < 8) searchy = 8;
		if (searchy > 391) searchy = 391;
		getpoint(searchx,searchy,&mousxplc,&mousyplc);
		linehighlight = getlinehighlight(mousxplc, mousyplc);

		drawboardlinrot(posx,posy,ang,zoom);
		drawline640400(searchx,searchy-8,searchx,searchy-1,31);
		drawline640400(searchx+1,searchy-8,searchx+1,searchy-1,31);
		drawline640400(searchx,searchy+2,searchx,searchy+9,31);
		drawline640400(searchx+1,searchy+2,searchx+1,searchy+9,31);
		drawline640400(searchx-8,searchy,searchx-1,searchy,31);
		drawline640400(searchx-8,searchy+1,searchx-1,searchy+1,31);
		drawline640400(searchx+2,searchy,searchx+9,searchy,31);
		drawline640400(searchx+2,searchy+1,searchx+9,searchy+1,31);

		if ((bstatus&1) > 0)
		{
			searchx = 320;
			searchy = 200;
			adjustmark(&mousxplc,&mousyplc);
			posx = mousxplc;
			posy = mousyplc;
		}

		engineinputforeditor();
		if ((keystatus[0x1e] > 0) && (zoom < 2048)) zoom += (zoom>>4);
		if ((keystatus[0x2c] > 0) && (zoom > 48)) zoom -= (zoom>>4);
		if (keystatus[0x22] > 0)  // G (grid on/off)
			grid = 1-grid, keystatus[0x22] = 0;
		if (keystatus[0x39] > 0)  //Space
		{
			adjustmark(&mousxplc,&mousyplc);
			markx = mousxplc, marky = mousyplc;
		}
		if ((keystatus[0x1c] > 0) && (numlines < maxlines-1))  //Enter
		{
			adjustmark(&mousxplc,&mousyplc);
			lin[numlines].xa1 = markx;
			lin[numlines].ya1 = marky;
			lin[numlines].xa2 = mousxplc;
			lin[numlines].ya2 = mousyplc;
			lin[numlines].picnum[0] = 0;
			lin[numlines].picnum[1] = 0;
			lin[numlines].picnum[2] = 0;
			lin[numlines].heinum[0] = 0;
			lin[numlines].heinum[1] = 0;
			lin[numlines].shade[0] = 0;
			lin[numlines].shade[1] = 0;
			lin[numlines].shade[2] = 0;
			lin[numlines].z[0] = (oposz>>8)-32;
			lin[numlines].z[1] = (oposz>>8)+32;
			lin[numlines].cstat = 3;
			lin[numlines].zosc = 0;
			lin[numlines].repeat = 1;
			numlines++;
			markx = mousxplc;
			marky = mousyplc;
			boardprep = 1;
			keystatus[0x1c] = 0;
		}
		if ((keystatus[0x2b] > 0) && (numlines < maxlines-1))  //Ceilingstep
		{
			adjustmark(&mousxplc,&mousyplc);
			lin[numlines].xa1 = markx;
			lin[numlines].ya1 = marky;
			lin[numlines].xa2 = mousxplc;
			lin[numlines].ya2 = mousyplc;
			lin[numlines].picnum[0] = 0;
			lin[numlines].picnum[1] = 0;
			lin[numlines].picnum[2] = 0;
			lin[numlines].heinum[0] = 0;
			lin[numlines].heinum[1] = 0;
			lin[numlines].shade[0] = 0;
			lin[numlines].shade[1] = 0;
			lin[numlines].shade[2] = 0;
			lin[numlines].z[0] = (oposz>>8)-32;
			lin[numlines].z[1] = (oposz>>8)-32;
			lin[numlines].cstat = 9;
			lin[numlines].zosc = 0;
			lin[numlines].repeat = 1;
			numlines++;
			markx = mousxplc;
			marky = mousyplc;
			boardprep = 1;
			keystatus[0x2b] = 0;
		}
		if ((keystatus[0x36] > 0) && (numlines < maxlines-1))  //Floorstep
		{
			adjustmark(&mousxplc,&mousyplc);
			lin[numlines].xa1 = markx;
			lin[numlines].ya1 = marky;
			lin[numlines].xa2 = mousxplc;
			lin[numlines].ya2 = mousyplc;
			lin[numlines].picnum[0] = 0;
			lin[numlines].picnum[1] = 0;
			lin[numlines].picnum[2] = 0;
			lin[numlines].heinum[0] = 0;
			lin[numlines].heinum[1] = 0;
			lin[numlines].shade[0] = 0;
			lin[numlines].shade[1] = 0;
			lin[numlines].shade[2] = 0;
			lin[numlines].z[0] = (oposz>>8)+32;
			lin[numlines].z[1] = (oposz>>8)+32;
			lin[numlines].cstat = 6;
			lin[numlines].zosc = 0;
			lin[numlines].repeat = 1;
			numlines++;
			markx = mousxplc;
			marky = mousyplc;
			boardprep = 1;
			keystatus[0x36] = 0;
		}
		if ((keystatus[0xd3] > 0) && (linehighlight >= 0))  //Delete
		{
			numlines--;
			lin[linehighlight].xa1 = lin[numlines].xa1;
			lin[linehighlight].ya1 = lin[numlines].ya1;
			lin[linehighlight].xa2 = lin[numlines].xa2;
			lin[linehighlight].ya2 = lin[numlines].ya2;
			lin[linehighlight].picnum[0] = lin[numlines].picnum[0];
			lin[linehighlight].picnum[1] = lin[numlines].picnum[1];
			lin[linehighlight].picnum[2] = lin[numlines].picnum[2];
			lin[linehighlight].heinum[0] = lin[numlines].heinum[0];
			lin[linehighlight].heinum[1] = lin[numlines].heinum[1];
			lin[linehighlight].shade[0] = lin[numlines].shade[0];
			lin[linehighlight].shade[1] = lin[numlines].shade[1];
			lin[linehighlight].shade[2] = lin[numlines].shade[2];
			lin[linehighlight].z[0] = lin[numlines].z[0];
			lin[linehighlight].z[1] = lin[numlines].z[1];
			lin[linehighlight].cstat = lin[numlines].cstat;
			lin[linehighlight].zosc = lin[numlines].zosc;
			lin[linehighlight].repeat = lin[numlines].repeat;
			markx = lin[numlines].xa2;
			marky = lin[numlines].ya2;
			boardprep = 1;
			keystatus[0xd3] = 0;
		}

		if (videocard == 1) outpw(0x3d4,0x33+(pag<<8));
		pag++;
		if (pag == 3) pag = 0;
		if (videocard == 1) outp(0x3cd,pag);
		numframes++;
		totalclock += ((long)clockspeed), clockspeed = 0;
		outpw(0x3c4,0x0f02), fillscreen(0);
	}
	qsetmode320200();
	if (videocard == 1) outpw(0x3d4,0x0033);

	posz = oposz;
	searchx >>= 1;
	searchy >>= 1;
}

getpoint(long searchxe, long searchye, long *x1, long *y1)
{
	long x2, y2;

	x2 = ((searchxe-320)<<13)/zoom;
	y2 = ((searchye-200)<<13)/zoom;
	*x1 = ((x2*(long)sintable[(2048-ang)&2047]-y2*(long)sintable[(2560-ang)&2047])>>13);
	*y1 = ((x2*(long)sintable[(2560-ang)&2047]+y2*(long)sintable[(2048-ang)&2047])>>13);
	*x1 += posx;
	*y1 += posy;
	if (*x1 < 0) *x1 = 0;
	if (*x1 >= 65536) *x1 = 65535;
	if (*y1 < 0) *y1 = 0;
	if (*y1 >= 65536) *y1 = 65535;
}

getlinehighlight(long xplc, long yplc)
{
	long i, dst, dist, closest;

	if (numlines == 0)
		return(-1);
	dist = 0x7fffffff;
	closest = numlines-1;
	for(i=0;i<numlines;i++)
	{
		dst = labs(xplc - ((lin[i].xa1 + lin[i].xa2)>>1));
		dst += labs(yplc - ((lin[i].ya1 + lin[i].ya2)>>1));
		if (dst <= dist)
			dist = dst, closest = i;
	}
	return(closest);
}

adjustmark(long *xplc, long *yplc)
{
	long i, dst, dist, closest, tempx, tempy;

	if (numlines == 0)
		return(-1);
	dist = 0x7fffffff;
	closest = numlines-1;
	tempx = *xplc;
	tempy = *yplc;
	for(i=0;i<numlines;i++)
	{
		dst = labs(*xplc - lin[i].xa1) + labs(*yplc - lin[i].ya1);
		if ((dst <= dist) && (dst < 192))
		{
			dist = dst;
			tempx = lin[i].xa1;
			tempy = lin[i].ya1;
		}
		dst = labs(*xplc - lin[i].xa2) + labs(*yplc - lin[i].ya2);
		if ((dst <= dist) && (dst < 192))
		{
			dist = dst;
			tempx = lin[i].xa2;
			tempy = lin[i].ya2;
		}
	}
	if (dist == 0x7fffffff)
	{
		dst = labs((*xplc)-((*xplc+512)&0xfffffc00))+labs((*yplc)-((*yplc+512)&0xfffffc00));
		if ((dst <= dist) && (dst < 192))
		{
			dist = dst;
			tempx = ((*xplc+512)&0xfffffc00);
			tempy = ((*yplc+512)&0xfffffc00);
		}
	}
	*xplc = tempx;
	*yplc = tempy;
	return(0);
}

