#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <conio.h>
#define numwalls 64

static int sintable[2048];
static long tantable[1024], posx, posy;
static int vidmode, xdim, ydim, halfwidth, halfheight, scrsize;
unsigned char tempbuf[4096];
unsigned int pic, walseg[numwalls], pageoffset, lastpageoffset, ang;
static unsigned char paldef[16][3] =
{
	0,30,63,28,34,60,0,50,20,41,52,28,63,63,25,63,63,63,63,20,20,63,0,63,
	63,48,27,63,40,25,63,48,48,45,63,45,55,55,63,63,40,63,63,30,20,55,25,30
};
static long totalclock, numframes;
void interrupt far myhandler(void);
void (interrupt far *oldhandler)();

main(int argc,char **argv)
{
	char ch;
	int i, j, mousx, mousy, picnum, totalcount;
	unsigned l;
	long posz, templong, templong1, templong2, xp1, yp1, xp2, yp2;

	vidmode = 0;
	xdim = 320;
	ydim = 200;
	scrsize = 18000;
	if (argc == 2)
		if (atoi(argv[1]) < 0)
		{
			vidmode = 1;
			xdim = 360;
			ydim = 240;
			scrsize = 21600;
		}
	halfwidth = (xdim>>1);
	halfheight = (ydim>>1);
	if ((pic = convallocate(numwalls*256)) == -1)
	{
		printf("Allocation failed!");
		exit(-1);
	}
	l = pic;
	for(i=0;i<numwalls;i++)
	{
		walseg[i] = l;
		l += 256;
	}
	loadtables();
	loadpics();
	_asm \
	{
		mov ax, 0
		int 0x33

		mov ax, 0x13
		int 0x10
	}
	if (vidmode == 1)
		setmode360240();
	outp(0x3c8,0);
	for(i=0;i<16;i++)
		for(j=1;j<17;j++)
		{
			outp(0x3c9,(paldef[i][0]*j)/17);
			outp(0x3c9,(paldef[i][1]*j)/17);
			outp(0x3c9,(paldef[i][2]*j)/17);
		}
	outp(0x3d4,0x14); outp(0x3d5, inp(0x3d5)&(255-64));  //WORD MODE
	outp(0x3d4,0x17); outp(0x3d5, inp(0x3d5)|64);        //2-WORD MODE
	outp(0x3c4,0x4); outp(0x3c5, inp(0x3c5)&247);        //CHAIN 4 OFF
	outp(0x3d4,0x13); outp(0x3d5, 45);                   //Bytes per line
	posx = 0;
	posy = 0;
	posz = 8192L;
	picnum = 2;
	j = 0;
	ang = 0;
	ch = 0;
	pageoffset = 2880;
	lastpageoffset = 2880;
	totalcount = 0;
	numframes = 0;
	totalclock = 0;
	oldhandler = _dos_getvect(8);
	_disable(); _dos_setvect(8, myhandler); _enable();
	outp(0x43,54); outp(0x40,4972&255); outp(0x40,4972>>8);
	while (ch != 27)
	{
		_asm \
		{
			mov ax, 11
			int 0x33
			sar cx, 1
			sar dx, 1
			mov mousx, cx
			mov mousy, dx
		}
		ang += mousx;
		posx -= (((long)sintable[(2560+ang)&2047]*mousy)>>12);
		posy -= (((long)sintable[(2048+ang)&2047]*mousy)>>12);
		if (kbhit() != 0)
		{
			ch = getch();
			if (((ch == 'a') || (ch == 'A')) && (posz > 0)) posz -= 128;
			if (((ch == 'z') || (ch == 'Z')) && (posz < 16256)) posz += 128;
			if ((ch == '+') && (picnum < numwalls-1)) picnum++;
			if ((ch == '-') && (picnum > 0)) picnum--;
		}
		for(i=0;i<halfheight;i++)
			hline(0,xdim-1,i,posz,picnum,0);
		for(i=halfheight;i<ydim;i++)
			hline(0,xdim-1,i,16383L-posz,picnum,0);
		numframes++;
		totalcount+=128;
			//shadecoffs = (4-(templong>>7))

		lastpageoffset = pageoffset;
		_asm \
		{
			mov bx, lastpageoffset
			mov al, 0xc
			mov ah, bh
			mov cl, 0xd
			mov ch, bl
			mov dx, 0x3d4
			out dx, al
			inc dx
			mov al, ah
			out dx, al
			mov ax, cx
			dec dx
			out dx, al
			inc dx
			mov al, ah
			out dx, al
		}
		if (vidmode == 0)
		{
			if (lastpageoffset < 18176) pageoffset = 18176;
			if (lastpageoffset == 18176) pageoffset = 36352;
			if (lastpageoffset > 18176) pageoffset = 0;
		}
		else
		{
			if (lastpageoffset < 21760) pageoffset = 21760;
			if (lastpageoffset == 21760) pageoffset = 43520;
			if (lastpageoffset > 21760) pageoffset = 0;
		}
	}
	_disable(); _dos_setvect(8, oldhandler); _enable();
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	if (totalclock != 0)
	{
		templong = (numframes*24000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(int)(templong/100),(int)((templong/10)%10),(int)(templong%10));
	}
	convdeallocate(pic);
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc allocated
		mov segnum, -1
allocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc deallocated
		mov segnum, -1
deallocated:
	}
	return(segnum);
}

loadtables()
{
	int fil, i;

	if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(fil,&sintable[0],4096);
		read(fil,&tantable[0],4096);
		close(fil);
	}
}

loadpics()
{
	int fil, i;

	if ((fil=open("pics.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		return(-1);
	read(fil,&tempbuf[0],1024);
	for(i=0;i<numwalls;i++)
	{
		read(fil,&tempbuf[0],4096);
		_asm \
		{
			cld
			mov cx, 2048
			mov bx, i
			shl bx, 1
			mov es, word ptr walseg[bx]
			xor di, di
			mov si, offset tempbuf
			mov ax, seg tempbuf
			push ds
			mov ds, ax
			rep movsw
			pop ds
		}
	}
	close(fil);
}

setmode360240()
{
	outp(0x3c4,0x4); outp(0x3c5,0x6);
	outp(0x3c4,0x0); outp(0x3c5,0x1);
	outp(0x3c2,0xe7);
	outp(0x3c4,0x0); outp(0x3c5,0x3);
	outp(0x3d4,0x11); outp(0x3d5,inp(0x3d5)&0x7f);      //Unlock indices 0-7
	outp(0x3d4,0x0); outp(0x3d5,0x6b);
	outp(0x3d4,0x1); outp(0x3d5,0x59);
	outp(0x3d4,0x2); outp(0x3d5,0x5a);
	outp(0x3d4,0x3); outp(0x3d5,0x8e);
	outp(0x3d4,0x4); outp(0x3d5,0x5e);
	outp(0x3d4,0x5); outp(0x3d5,0x8a);
	outp(0x3d4,0x6); outp(0x3d5,0xd);
	outp(0x3d4,0x7); outp(0x3d5,0x3e);
	outp(0x3d4,0x9); outp(0x3d5,0x41);
	outp(0x3d4,0x10); outp(0x3d5,0xea);
	outp(0x3d4,0x11); outp(0x3d5,0xac);
	outp(0x3d4,0x12); outp(0x3d5,0xdf);
	outp(0x3d4,0x13); outp(0x3d5,45);
	outp(0x3d4,0x14); outp(0x3d5,0x0);
	outp(0x3d4,0x15); outp(0x3d5,0xe7);
	outp(0x3d4,0x16); outp(0x3d5,0x6);
	outp(0x3d4,0x17); outp(0x3d5,0xe3);
}

hline (xl, xr, yp, zd, walnume, shadeoffs)
unsigned xl, xr, yp;
int walnume, shadeoffs;
long zd;
{
	unsigned char planum;
	int i, siz, picplc, temp1, temp2;
	unsigned p, x, y, xc, yc, hd;

	//if (ceilingstat >= 3)
	//   walnume = 54;
	if (xl > xr)
	{
		i = xl, xl = xr, xr = i;
	}
	siz = xr-xl;
	if ((siz < 0) || (yp == halfheight))
		return(-1);
	//takernum = 7;
	_asm \
	{
		mov cx, pageoffset        ;p = yp*90+(xl>>2)+pageoffset;
		;add cx, centeroffset
		mov bx, xl
		shr bx, 1
		shr bx, 1
		add cx, bx
		mov ax, yp
		mov bx, 90
		mul bx
		add cx, ax
		mov p, cx
							  ;hd = (zd<<11)/((long)((xdim>>3)*abs(halfheight-yp)));
		mov ax, halfheight
		sub ax, yp
		jns skipnegatize
		neg ax
skipnegatize:
		mov bx, xdim
		mov cl, 3
		shr bx, cl
		mul bx
		mov di, ax                  ;di is temp second half of equation
		mov ax, word ptr zd[0]
		mov dx, word ptr zd[2]
		mov dh, dl
		mov dl, ah
		mov ah, al
		xor al, al
		cmp di, dx
		ja dontreturn
	}
	return(-1);
	_asm \
	{
dontreturn:
		div di
		mov hd, ax
										 ;temp1 = ((hd*sintable[(2048+ang)&2047])>>13);
		mov bx, ang
		and bx, 1023
		shl bx, 1
		mov ax, word ptr sintable[bx]
		mul hd
		mov cl, 13
		shr ax, cl
		ror dx, cl
		and dx, 0xfff8
		or ax, dx
		mov temp1, ax
		test ang, 1024
		jz skipsinsign1
		neg temp1                                          ;negatize templong1
skipsinsign1:
																		 ;xc = (unsigned)temp1;
		mov ax, temp1
		mov xc, ax
										 ;temp2 = ((hd*sintable[(2560+ang)&2047])>>13);
		mov bx, ang
		add bx, 2560
		and bx, 1023
		shl bx, 1
		mov ax, word ptr sintable[bx]
		mul hd
		mov cl, 13
		shr ax, cl
		ror dx, cl
		and dx, 0xfff8
		or ax, dx
		mov temp2, ax
		mov bx, ang
		add bx, 512
		test bx, 1024
		jz skipsinsign2
		neg temp2                                           ;negatize templong2
skipsinsign2:
																		 ;yc = (unsigned)temp2;
		mov ax, temp2
		mov yc, ax
					  ;xc1 = ((long)temp1)*xl-((long)temp1+(long)temp2)*(xdim>>1);
		mov ax, temp1
		add ax, temp2
		sar ax, 1
		imul xdim
		mov bx, ax
		mov cx, dx
		mov ax, temp1
		imul xl
		sub ax, bx
		sbb dx, cx
													  ;x = (unsigned)((xc1-(posx<<8))>>2);
		mov bh, byte ptr posx[0]
		xor bl, bl
		mov cx, word ptr posx[1]
		sub ax, bx
		sbb dx, cx
		shr dx, 1
		rcr ax, 1
		shr dx, 1
		rcr ax, 1
		mov x, ax
					;yc1 = ((long)temp2)*xl+((long)temp1-(long)temp2)*(xdim>>1);
		mov ax, temp1
		sub ax, temp2
		sar ax, 1
		imul xdim
		mov bx, ax
		mov cx, dx
		mov ax, temp2
		imul xl
		add ax, bx
		adc dx, cx
													  ;y = (unsigned)((yc1+(posy<<8))>>2);
		mov bh, byte ptr posy[0]
		xor bl, bl
		mov cx, word ptr posy[1]
		add ax, bx
		adc dx, cx
		shr dx, 1
		rcr ax, 1
		shr dx, 1
		rcr ax, 1
		mov y, ax
	}
	//takernum = 8;
	_asm \
	{
		mov ax, 0xa000
		mov es, ax
		mov al, 0x11
		mov cl, byte ptr xl[0]
		and cl, 3
		rol al, cl
		mov planum, al
		cld
	}
	if (siz < 8)
	{
		_asm \
		{
			mov dx, 0x3c4
			mov al, 0x2
			out dx, al
			inc dx
			mov al, planum
			out dx, al

			mov cx, word ptr siz
			inc cx
			mov di, p
			mov si, x
			mov dx, y
			mov bx, walnume
			shl bx, 1
			add si, xc
			add dx, yc
			sar xc, 1
			sar yc, 1
			sar xc, 1
			sar yc, 1
			push ds
			mov ds, word ptr walseg[bx]
begindrawsmall:
			add si, xc
			add dx, yc
			mov bx, si
			mov bl, dh
			shr bh, 1
			shr bh, 1
			shr bx, 1
			shr bx, 1
			mov ah, ds:[bx]
			add ah, byte ptr shadeoffs[0]
			mov bx, dx
			mov es:[di], ah
			mov dx, 0x3c5
			rol byte ptr planum, 1
			mov al, byte ptr planum
			out dx, al
			mov dx, bx
			cmp al, 0x11
			ja skipdrawpre
			inc di
skipdrawpre:
			loop begindrawsmall
			pop ds
		}
		//takernum = 4;
		return(0);
	}
	_asm \
	{
		mov dx, 0x3c4
		mov al, 0x2
		out dx, al
		inc dx
		mov al, planum
		out dx, al

		mov cx, siz
		sub cx, 4
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov si, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1a+2], ax
		mov word ptr cs:[mach3a+2], ax
		mov ax, yc
		mov word ptr cs:[mach2a+2], ax
		mov word ptr cs:[mach4a+2], ax
		mov ax, shadeoffs
		mov byte ptr cs:[mach5a+1], al
		mov byte ptr cs:[mach6a+2], al
		mov bx, walnume
		shl bx, 1
		push ds
		mov ds, word ptr walseg[bx]
begindrawa:
mach1a:add si, 0x1234
mach2a:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
mach3a:add si, 0x1234
mach4a:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov ah, ds:[bx]
mach5a:add al, 0x12
mach6a:add ah, 0x12
		stosw
		sub ch, 4
		jnc begindrawa
		cmp ch, -2
		jl enda
		add si, word ptr cs:[mach1a+2]
		add dx, word ptr cs:[mach2a+2]
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
		add al, byte ptr cs:[mach5a+1]
		stosb
enda:
		pop ds

		mov dx, 0x3c5
		rol byte ptr planum, 1
		rol byte ptr planum, 1
		mov al, byte ptr planum
		out dx, al
		cmp al, 0x22
		ja skipdrawb
		inc p
skipdrawb:

		mov cx, siz
		sub cx, 6
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov si, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1b+2], ax
		mov word ptr cs:[mach3b+2], ax
		sar ax, 1
		add si, ax
		mov ax, yc
		mov word ptr cs:[mach2b+2], ax
		mov word ptr cs:[mach4b+2], ax
		sar ax, 1
		add dx, ax
		mov ax, shadeoffs
		mov byte ptr cs:[mach5b+1], al
		mov byte ptr cs:[mach6b+2], al
		mov bx, walnume
		shl bx, 1
		push ds
		mov ds, word ptr walseg[bx]
begindrawb:
mach1b:add si, 0x1234
mach2b:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
mach3b:add si, 0x1234
mach4b:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov ah, ds:[bx]
mach5b:add al, 0x12
mach6b:add ah, 0x12
		stosw
		sub ch, 4
		jnc begindrawb
		cmp ch, -2
		jl endb
		add si, word ptr cs:[mach1b+2]
		add dx, word ptr cs:[mach2b+2]
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
		add al, byte ptr cs:[mach5b+1]
		stosb
endb:
		pop ds
	}
	_asm \
	{
		mov dx, 0x3c5                          ;Higher precision
		ror byte ptr planum, 1
		mov al, byte ptr planum
		out dx, al
		cmp al, 0x88
		jne skipdrawc
		dec p
skipdrawc:

		mov cx, siz
		sub cx, 5
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov si, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1c+2], ax
		mov word ptr cs:[mach3c+2], ax
		sar ax, 1
		sar ax, 1
		add si, ax
		mov ax, yc
		mov word ptr cs:[mach2c+2], ax
		mov word ptr cs:[mach4c+2], ax
		sar ax, 1
		sar ax, 1
		add dx, ax
		mov ax, shadeoffs
		mov byte ptr cs:[mach5c+1], al
		mov byte ptr cs:[mach6c+2], al
		mov bx, walnume
		shl bx, 1
		push ds
		mov ds, word ptr walseg[bx]
begindrawc:
mach1c:add si, 0x1234
mach2c:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
mach3c:add si, 0x1234
mach4c:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov ah, ds:[bx]
mach5c:add al, 0x12
mach6c:add ah, 0x12
		stosw
		sub ch, 4
		jnc begindrawc
		cmp ch, -2
		jl endc
		add si, word ptr cs:[mach1c+2]
		add dx, word ptr cs:[mach2c+2]
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
		add al, byte ptr cs:[mach5c+1]
		stosb
endc:
		pop ds

		mov dx, 0x3c5
		rol byte ptr planum, 1
		rol byte ptr planum, 1
		mov al, byte ptr planum
		out dx, al
		cmp al, 0x22
		ja skipdrawd
		inc p
skipdrawd:

		mov cx, siz
		sub cx, 7
		shr cx, 1
		mov ch, cl
		mov cl, 2
		mov di, p
		mov si, x
		mov dx, y
		mov ax, xc
		mov word ptr cs:[mach1d+2], ax
		mov word ptr cs:[mach3d+2], ax
		sar ax, 1
		add si, ax
		sar ax, 1
		add si, ax
		mov ax, yc
		mov word ptr cs:[mach2d+2], ax
		mov word ptr cs:[mach4d+2], ax
		sar ax, 1
		add dx, ax
		sar ax, 1
		add dx, ax
		mov ax, shadeoffs
		mov byte ptr cs:[mach5d+1], al
		mov byte ptr cs:[mach6d+2], al
		mov bx, walnume
		shl bx, 1
		push ds
		mov ds, word ptr walseg[bx]
begindrawd:
mach1d:add si, 0x1234
mach2d:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
mach3d:add si, 0x1234
mach4d:add dx, 0x1234
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov ah, ds:[bx]
mach5d:add al, 0x12
mach6d:add ah, 0x12
		stosw
		sub ch, 4
		jnc begindrawd
		cmp ch, -2
		jl endd
		add si, word ptr cs:[mach1d+2]
		add dx, word ptr cs:[mach2d+2]
		mov bx, si
		mov bl, dh
		shr bh, cl
		shr bx, cl
		mov al, ds:[bx]
		add al, byte ptr cs:[mach5d+1]
		stosb
endd:
		pop ds
	}
	//takernum = 4;
}

void interrupt far myhandler()
{
	totalclock++;
	_asm \
	{
		mov al, 0x20
		out 0x20, al
	}
}
