; "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
; Ken Silverman's official web site: "http://www.advsys.net/ken"
; See the included license file "BUILDLIC.TXT" for license info.

.386P

EXTRN _asm1 : dword
EXTRN _asm2 : dword
EXTRN _asm3 : dword
EXTRN _asm4 : dword

CODE SEGMENT BYTE PUBLIC USE32 'CODE'
ASSUME cs:CODE

PUBLIC sethlinesizes_
sethlinesizes_:
	mov byte ptr ds:[machxbits1+2], al
	mov byte ptr ds:[machxbits2+2], al
	neg al
	mov byte ptr ds:[hxsiz1+2], al
	mov byte ptr ds:[hxsiz2+2], al
	mov byte ptr ds:[hxsiz3+2], al
	mov byte ptr ds:[machnegxbits1+2], al

	mov byte ptr ds:[hysiz1+3], bl
	mov byte ptr ds:[hysiz2+3], bl
	mov byte ptr ds:[hysiz3+3], bl
	mov byte ptr ds:[hmach3a+2], bl
	mov byte ptr ds:[hmach3b+2], bl
	mov byte ptr ds:[hmach3c+2], bl
	mov byte ptr ds:[hmach3d+2], bl

	mov dword ptr ds:[hoffs1+2], ecx
	mov dword ptr ds:[hoffs2+2], ecx
	mov dword ptr ds:[hoffs3+2], ecx
	mov dword ptr ds:[hoffs4+2], ecx
	mov dword ptr ds:[hoffs5+2], ecx
	mov dword ptr ds:[hoffs6+2], ecx
	mov dword ptr ds:[hoffs7+2], ecx

	mov edx, 0ffffffffh
	mov cl, al
	sub cl, bl
	shl edx, cl
	mov cl, al
	ror edx, cl
	mov dword ptr ds:[hmach2a+2], edx
	mov dword ptr ds:[hmach2b+1], edx
	mov dword ptr ds:[hmach2c+2], edx
	mov dword ptr ds:[hmach2d+1], edx

	ret

PUBLIC setpalookupaddress_
setpalookupaddress_:
	mov dword ptr ds:[pal1+2], eax
	mov dword ptr ds:[pal2+2], eax
	mov dword ptr ds:[pal3+2], eax
	mov dword ptr ds:[pal4+2], eax
	mov dword ptr ds:[pal5+2], eax
	mov dword ptr ds:[pal6+2], eax
	mov dword ptr ds:[pal7+2], eax
	ret

	;Non-256-stuffed ceiling&floor method with NO SHLD!:
	;yinc&0xffffff00   lea eax, [edx+88888800h]           1     1/2
	;ybits...xbits     and edx, 88000088h                 1     1/2
	;ybits             rol edx, 6                         2     1/2
	;xinc<<xbits       add esi, 88888888h                 1     1/2
	;xinc>>(32-xbits)  adc al, 88h                        1     1/2
	;bufplc            mov cl, byte ptr [edx+88888888h]   1     1/2
	;paloffs&255       mov bl, byte ptr [ecx+88888888h]   1     1/2
PUBLIC hlineasm64_
hlineasm64_:
	push ebp

	mov ebp, eax

	mov ch, cl

	shr ebp, 1
	jnc short skipthe1byte

	mov eax, esi
hxsiz1: shr eax, 26
hysiz1: shld eax, edx, 6
hoffs1: mov cl, byte ptr [eax+88888888h]
pal1: mov bl, byte ptr [ecx+88888888h]
	add esi, _asm1
	add edx, _asm2
	mov byte ptr [edi], bl
	inc edi

skipthe1byte:
	shr ebp, 1
	jnc short skipthe2byte

	mov eax, esi
hxsiz2: shr eax, 26
hysiz2: shld eax, edx, 6
hoffs2: mov cl, byte ptr [eax+88888888h]
pal2: mov bl, byte ptr [ecx+88888888h]
	add esi, _asm1
	add edx, _asm2

	mov eax, esi
hxsiz3: shr eax, 26
hysiz3: shld eax, edx, 6
hoffs3: mov cl, byte ptr [eax+88888888h]
pal3: mov bh, byte ptr [ecx+88888888h]
	add esi, _asm1
	add edx, _asm2
	mov word ptr [edi], bx
	add edi, 2

skipthe2byte:
	test ebp, ebp
	jz skipthe4byte

	mov eax, esi
machxbits1: shl esi, 6                     ;xbits
	and edx, 0ffffff00h
machnegxbits1: shr eax, 32-6               ;32-xbits
	add dl, al

	sub edi, 4

	add ebx, ebx
	jc beginhline64

	mov eax, _asm2
	and eax, 0ffffff00h
	mov dword ptr ds:[hmach1a+2], eax
	mov dword ptr ds:[hmach1b+2], eax
	mov dword ptr ds:[hmach1c+2], eax
	mov dword ptr ds:[hmach1d+2], eax
	mov eax, _asm1
machxbits2: rol eax, 6                     ;xbits
	mov dword ptr ds:[hmach4a+2], eax
	mov dword ptr ds:[hmach4b+2], eax
	mov dword ptr ds:[hmach4c+2], eax
	mov dword ptr ds:[hmach4d+2], eax
	mov byte ptr ds:[hmach5a+1], al
	mov byte ptr ds:[hmach5b+2], al
	mov byte ptr ds:[hmach5c+1], al
	mov byte ptr ds:[hmach5d+2], al

	jmp beginhline64
beginhline64:

hmach1a: lea eax, [edx+88888800h]
hmach2a: and edx, 88000088h
hmach3a: rol edx, 6
hmach4a: add esi, 88888888h
hmach5a: adc al, 88h
hoffs4: mov cl, byte ptr [edx+88888888h]

hmach1b: lea edx, [eax+88888800h]
hmach2b: and eax, 88000088h
pal4: mov bl, byte ptr [ecx+88888888h]
hmach3b: rol eax, 6
hmach4b: add esi, 88888888h
hmach5b: adc dl, 88h
hoffs5: mov cl, byte ptr [eax+88888888h]

hmach1c: lea eax, [edx+88888800h]
hmach2c: and edx, 88000088h
pal5: mov bh, byte ptr [ecx+88888888h]
hmach3c: rol edx, 6
hmach4c: add esi, 88888888h
hmach5c: adc al, 88h
	shl ebx, 16
hoffs6: mov cl, byte ptr [edx+88888888h]

hmach1d: lea edx, [eax+88888800h]
hmach2d: and eax, 88000088h
pal6: mov bl, byte ptr [ecx+88888888h]
hmach3d: rol eax, 6
hmach4d: add esi, 88888888h
hmach5d: adc dl, 88h
hoffs7: mov cl, byte ptr [eax+88888888h]
	add edi, 4
pal7: mov bh, byte ptr [ecx+88888888h]

	rol ebx, 16
	dec ebp
	mov dword ptr [edi], ebx
	jnz beginhline64
skipthe4byte:

	pop ebp
	ret

PUBLIC setvlinebpl_
setvlinebpl_:
	mov dword ptr ds:[fixchain1a+2], eax
	mov dword ptr ds:[fixchain1b+2], eax
	mov dword ptr ds:[fixchain1m+2], eax
	mov dword ptr ds:[fixchain1t+2], eax
	mov dword ptr ds:[fixchain1s+2], eax
	mov dword ptr ds:[tfixchain1s+2], eax
	mov dword ptr ds:[fixchain2a+2], eax
	mov dword ptr ds:[fixchain2m+2], eax
	mov dword ptr ds:[fixchaint2a+1], eax
	mov dword ptr ds:[fixchaint2b+2], eax
	mov dword ptr ds:[fixchaint2c+2], eax
	mov dword ptr ds:[fixchaint2d+2], eax
	mov dword ptr ds:[fixchaint2e+2], eax
	neg eax
	mov dword ptr ds:[fixchain2b+2], eax

	mov dword ptr ds:[fixchain2m1+2], eax   ;0-bpl
	mov dword ptr ds:[fixchain2m3+3], eax   ;0-bpl
	mov dword ptr ds:[fixchain2m5+2], eax   ;0-bpl
	mov dword ptr ds:[fixchain2m8+3], eax   ;0-bpl
	mov dword ptr ds:[fixchain2m11+2], eax  ;0-bpl
	mov dword ptr ds:[fixchain2m15+3], eax  ;0-bpl
	mov dword ptr ds:[fixchain2m18+2], eax  ;0-bpl
	mov dword ptr ds:[fixchain2m22+2], eax  ;0-bpl
	inc eax
	mov dword ptr ds:[fixchain2m2+2], eax   ;1-bpl
	mov dword ptr ds:[fixchain2m7+3], eax   ;1-bpl
	mov dword ptr ds:[fixchain2m13+2], eax  ;1-bpl
	mov dword ptr ds:[fixchain2m20+2], eax  ;1-bpl
	inc eax
	mov dword ptr ds:[fixchain2m4+2], eax   ;2-bpl
	mov dword ptr ds:[fixchain2m6+2], eax   ;2-bpl
	mov dword ptr ds:[fixchain2m9+2], eax   ;2-bpl
	mov dword ptr ds:[fixchain2m17+3], eax  ;2-bpl
	mov dword ptr ds:[fixchain2m19+3], eax  ;2-bpl
	mov dword ptr ds:[fixchain2m21+3], eax  ;2-bpl
	inc eax
	mov dword ptr ds:[fixchain2m10+2], eax  ;3-bpl
	mov dword ptr ds:[fixchain2m12+2], eax  ;3-bpl
	mov dword ptr ds:[fixchain2m14+2], eax  ;3-bpl
	mov dword ptr ds:[fixchain2m16+2], eax  ;3-bpl
	ret

PUBLIC prevlineasm1_
prevlineasm1_:
	cmp ecx, 256
	jae vlineasm1_

	add eax, edx
	shr edx, cl
	mov dl, byte ptr [esi+edx]
	mov cl, byte ptr [ebx+edx]
	mov byte ptr [edi], cl
	ret

PUBLIC vlineasm1_
vlineasm1_:
	mov byte ptr ds:[mach3a+2], cl
	mov dword ptr ds:[mach3b+2], eax
	mov dword ptr ds:[mach3c+2], ebx
	shr ecx, 8
	inc ecx
fixchain1a: sub edi, 320
	jmp short beginvline
beginvline:
	mov ebx, edx
mach3a: shr ebx, 32
fixchain1b: add edi, 320
	mov bl, byte ptr [esi+ebx]
mach3b: add edx, 88888888h
	dec ecx
mach3c: mov al, byte ptr [ebx+88888888h]
	mov byte ptr [edi], al
	jnz short beginvline
	mov eax, edx
	ret

PUBLIC mvlineasm1_      ;Masked vline
mvlineasm1_:
	push ebp
	mov ebp, eax
	mov byte ptr ds:[maskmach3a+2], cl
	shr ecx, 8
	inc ecx
	mov dword ptr ds:[maskmach3c+2], ebx
	jmp short beginmvline

beginmvline:
	mov ebx, edx
maskmach3a: shr ebx, 32
	mov bl, byte ptr [esi+ebx]
	cmp bl, 255
	je short skipmask1
maskmach3c: mov al, [ebx+88888888h]
	mov byte ptr [edi], al
skipmask1:
	add edx, ebp
fixchain1m: add edi, 320
	dec ecx
	jnz short beginmvline

	pop ebp
	mov eax, edx
	ret

PUBLIC fixtransluscence_
fixtransluscence_:
	mov dword ptr ds:[transmach4+2], eax
	mov dword ptr ds:[tmach1+2], eax
	mov dword ptr ds:[tmach2+2], eax
	mov dword ptr ds:[tmach3+2], eax
	mov dword ptr ds:[tmach4+2], eax
	mov dword ptr ds:[tran2traa+2], eax
	mov dword ptr ds:[tran2trab+2], eax
	mov dword ptr ds:[tran2trac+2], eax
	mov dword ptr ds:[tran2trad+2], eax
	ret

PUBLIC tvlineasm1_        ;Masked & transluscent vline
tvlineasm1_:
	push ebp
	mov ebp, eax
	xor eax, eax
	mov byte ptr ds:[transmach3a+2], cl
	shr ecx, 8
	inc ecx
	mov dword ptr ds:[transmach3c+2], ebx
	jmp short begintvline

begintvline:
	mov ebx, edx
transmach3a: shr ebx, 32
	mov bl, byte ptr [esi+ebx]
	cmp bl, 255
	je short skiptrans1
transmach3c: mov al, [ebx+88888888h]
	mov ah, byte ptr [edi]
transmach4: mov al, byte ptr [eax+88888888h]   ;_transluc[eax]
	mov byte ptr [edi], al
skiptrans1:
	add edx, ebp
fixchain1t: add edi, 320
	dec ecx
	jnz short begintvline

	pop ebp
	mov eax, edx
	ret

PUBLIC vlineasm4_
vlineasm4_:
	push ebp

	mov byte ptr ds:[machv13+2], cl
	mov byte ptr ds:[machv14+2], cl
	mov byte ptr ds:[machv15+2], cl
	mov byte ptr ds:[machv16+2], cl

	mov ebp, dword ptr [edx+0]        ;palookupoffse
	mov dword ptr ds:[machv1+2], ebp
	mov ebp, dword ptr [edx+4]
	mov dword ptr ds:[machv4+2], ebp
	mov ebp, dword ptr [edx+8]
	mov dword ptr ds:[machv7+2], ebp
	mov ebp, dword ptr [edx+12]
	mov dword ptr ds:[machv10+2], ebp

	mov ebp, dword ptr [esi+0]        ;bufplce
	mov dword ptr ds:[machv2+2], ebp
	mov ebp, dword ptr [esi+4]
	mov dword ptr ds:[machv5+2], ebp
	mov ebp, dword ptr [esi+8]
	mov dword ptr ds:[machv8+2], ebp
	mov ebp, dword ptr [esi+12]
	mov dword ptr ds:[machv11+2], ebp

	mov ebp, dword ptr [ebx+0]        ;vince
	and ebp, 0ffffff00h           ;make sure dl (counter2) doesn't get changed
	mov dword ptr ds:[machv3+2], ebp
	mov ebp, dword ptr [ebx+4]
	mov dword ptr ds:[machv6+2], ebp
	mov ebp, dword ptr [ebx+8]
	mov dword ptr ds:[machv9+2], ebp
	mov ebp, dword ptr [ebx+12]
	and ebp, 0ffffff00h           ;make sure cl (counter) doesn't get changed
	mov dword ptr ds:[machv12+2], ebp

	mov ebx, ecx
	shr ebx, 8
	mov _asm2, eax
	mov edx, dword ptr [eax+0]
	mov esi, dword ptr [eax+4]
	mov ebp, dword ptr [eax+8]
	mov ecx, dword ptr [eax+12]
	mov cl, bl
	mov dl, bh
	inc cl
	inc dl

	jmp short beginvlineasm4
beginvlineasm4:

	mov eax, ecx
machv14: shr eax, 32
machv12: add ecx, 88888888h ;vince[3]
machv10: mov al, byte ptr [eax+88888888h] ;bufplce[3]
machv11: mov bh, byte ptr [eax+88888888h] ;palookupoffs[3]

	mov eax, ebp
machv13: shr eax, 32
machv9: add ebp, 88888888h ;vince[2]
machv7: mov al, byte ptr [eax+88888888h] ;bufplce[2]
fixchain2a: add edi, 320
machv8: mov bl, byte ptr [eax+88888888h] ;palookupoffs[2]

	mov eax, esi
machv16: shr eax, 32
	shl ebx, 16
machv4: mov al, byte ptr [eax+88888888h] ;bufplce[1]
machv6: add esi, 88888888h ;vince[1]
machv5: mov bh, byte ptr [eax+88888888h] ;palookupoffs[1]

	mov eax, edx
machv15: shr eax, 32
machv3: add edx, 88888888h ;vince[0]
machv1: mov al, byte ptr [eax+88888888h] ;bufplce[0]
	dec cl
machv2: mov bl, byte ptr [eax+88888888h] ;palookupoffs[0]

fixchain2b: mov dword ptr [edi-320], ebx
	jnz short beginvlineasm4

	dec dl
	jnz short beginvlineasm4

	mov eax, _asm2
	mov dword ptr [eax+0], edx
	mov dword ptr [eax+4], esi
	mov dword ptr [eax+8], ebp
	mov dword ptr [eax+12], ecx
	mov eax, edi

	pop ebp
	ret

PUBLIC mvlineasm4_
mvlineasm4_:
	push ebp

	mov byte ptr ds:[machmv13+2], cl
	mov byte ptr ds:[machmv14+2], cl
	mov byte ptr ds:[machmv15+2], cl
	mov byte ptr ds:[machmv16+2], cl

	mov ebp, dword ptr [edx+0]        ;palookupoffse
	mov dword ptr ds:[machmv1+2], ebp
	mov ebp, dword ptr [edx+4]
	mov dword ptr ds:[machmv4+2], ebp
	mov ebp, dword ptr [edx+8]
	mov dword ptr ds:[machmv7+2], ebp
	mov ebp, dword ptr [edx+12]
	mov dword ptr ds:[machmv10+2], ebp

	mov ebp, dword ptr [esi+0]        ;bufplce
	mov dword ptr ds:[machmv2+2], ebp
	mov ebp, dword ptr [esi+4]
	mov dword ptr ds:[machmv5+2], ebp
	mov ebp, dword ptr [esi+8]
	mov dword ptr ds:[machmv8+2], ebp
	mov ebp, dword ptr [esi+12]
	mov dword ptr ds:[machmv11+2], ebp

	mov ebp, dword ptr [ebx+0]        ;vince
	and ebp, 0ffffff00h           ;make sure dl (counter) doesn't get changed
	mov dword ptr ds:[machmv3+2], ebp
	mov ebp, dword ptr [ebx+4]
	mov dword ptr ds:[machmv6+2], ebp
	mov ebp, dword ptr [ebx+8]
	mov dword ptr ds:[machmv9+2], ebp
	mov ebp, dword ptr [ebx+12]
	and ebp, 0ffffff00h           ;make sure cl (counter) doesn't get changed
	mov dword ptr ds:[machmv12+2], ebp

	mov ebx, ecx
	shr ebx, 8
	mov _asm2, eax
	mov edx, dword ptr [eax+0]
	mov esi, dword ptr [eax+4]
	mov ebp, dword ptr [eax+8]
	mov ecx, dword ptr [eax+12]
	mov cl, bl
	inc cl
	inc bh
	mov byte ptr _asm3[0], bh


	jmp short beginmvlineasm4
beginmvlineasm4:
	xor dl, dl

	mov eax, ecx
machmv16: shr eax, 32
machmv12: add ecx, 88888888h ;vince[3]
machmv10: mov al, byte ptr [eax+88888888h] ;bufplce[3]
	cmp al, 255
	adc dl, dl
machmv11: mov bh, byte ptr [eax+88888888h] ;palookupoffs[3]

	mov eax, ebp
machmv15: shr eax, 32
machmv9: add ebp, 88888888h ;vince[2]
machmv7: mov al, byte ptr [eax+88888888h] ;bufplce[2]
	cmp al, 255
	adc dl, dl
machmv8: mov bl, byte ptr [eax+88888888h] ;palookupoffs[2]

	mov eax, esi
machmv14: shr eax, 32
	shl ebx, 16
machmv4: mov al, byte ptr [eax+88888888h] ;bufplce[1]
	cmp al, 255
	adc dl, dl
machmv6: add esi, 88888888h ;vince[1]
machmv5: mov bh, byte ptr [eax+88888888h] ;palookupoffs[1]

	mov eax, edx
machmv13: shr eax, 32
machmv3: add edx, 88888888h ;vince[0]
machmv1: mov al, byte ptr [eax+88888888h] ;bufplce[0]
	cmp al, 255
	adc dl, dl
machmv2: mov bl, byte ptr [eax+88888888h] ;palookupoffs[0]

fixchain2m: add edi, 320

	mov al, dl                 ;32 byte cases
	shl eax, 5
	add eax, offset mvcase0
	jmp eax

endmvlineasm4:
	dec byte ptr _asm3[0]
	jnz beginmvlineasm4

	mov eax, _asm2
	mov dword ptr [eax+0], edx
	mov dword ptr [eax+4], esi
	mov dword ptr [eax+8], ebp
	mov dword ptr [eax+12], ecx
	mov eax, edi

	pop ebp
	ret

mvcase0:
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase1:
fixchain2m1: mov byte ptr [edi-320], bl
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase2:
fixchain2m2: mov byte ptr [edi-319], bh
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase3:
fixchain2m3: mov word ptr [edi-320], bx
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase4:
	shr ebx, 16
fixchain2m4: mov byte ptr [edi-318], bl
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase5:
fixchain2m5: mov byte ptr [edi-320], bl
	shr ebx, 16
fixchain2m6: mov byte ptr [edi-318], bl
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
mvcase6:
	shr ebx, 8
fixchain2m7: mov word ptr [edi-319], bx
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase7:
fixchain2m8: mov word ptr [edi-320], bx
	shr ebx, 16
fixchain2m9: mov byte ptr [edi-318], bl
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
mvcase8:
	shr ebx, 16
fixchain2m10: mov byte ptr [edi-317], bh
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase9:
fixchain2m11: mov byte ptr [edi-320], bl
	shr ebx, 16
fixchain2m12: mov byte ptr [edi-317], bh
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
mvcase10:
fixchain2m13: mov byte ptr [edi-319], bh
	shr ebx, 16
fixchain2m14: mov byte ptr [edi-317], bh
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
mvcase11:
fixchain2m15: mov word ptr [edi-320], bx
	shr ebx, 16
fixchain2m16: mov byte ptr [edi-317], bh
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
mvcase12:
	shr ebx, 16
fixchain2m17: mov word ptr [edi-318], bx
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
mvcase13:
fixchain2m18: mov byte ptr [edi-320], bl
	shr ebx, 16
fixchain2m19: mov word ptr [edi-318], bx
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
mvcase14:
fixchain2m20: mov byte ptr [edi-319], bh
	shr ebx, 16
fixchain2m21: mov word ptr [edi-318], bx
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	nop
	nop
	nop
mvcase15:
fixchain2m22: mov dword ptr [edi-320], ebx
	dec cl
	jnz beginmvlineasm4
	jmp endmvlineasm4
	
	PUBLIC setupspritevline_
setupspritevline_:
	mov dword ptr ds:[spal+2], eax

	mov eax, esi                      ;xinc's
	shl eax, 16
	mov dword ptr ds:[smach1+2], eax
	mov dword ptr ds:[smach4+2], eax
	mov eax, esi
	sar eax, 16
	add eax, ebx                      ;watch out with ebx - it's passed
	mov dword ptr ds:[smach2+2], eax
	add eax, edx
	mov dword ptr ds:[smach5+2], eax

	mov dword ptr ds:[smach3+2], ecx  ;yinc's
	ret

	PUBLIC spritevline_
	;eax = 0, ebx = x, ecx = cnt, edx = y, esi = yplc, edi = p
prestartsvline:
smach1: add ebx, 88888888h              ;xincshl16
	mov al, byte ptr [esi]
smach2: adc esi, 88888888h              ;xincshr16+yalwaysinc

startsvline:
	cmp al, 255
	je short skipsvline
spal: mov al, [eax+88888888h]           ;palookup
	mov byte ptr [edi], al
skipsvline:
fixchain1s: add edi, 320

spritevline_:
smach3: add edx, 88888888h              ;dayinc
	dec ecx
	ja short prestartsvline     ;jump if (no carry (add)) and (not zero (dec))!
	jz short endsvline
smach4: add ebx, 88888888h              ;xincshl16
	mov al, byte ptr [esi]
smach5: adc esi, 88888888h              ;xincshr16+yalwaysinc+daydime
	jmp short startsvline
endsvline:
	ret

	PUBLIC tsetupspritevline_
tsetupspritevline_:
	mov dword ptr ds:[tspal+2], eax

	mov eax, esi                      ;xinc's
	shl eax, 16
	mov dword ptr ds:[tsmach1+2], eax
	mov dword ptr ds:[tsmach4+2], eax
	mov eax, esi
	sar eax, 16
	add eax, ebx                      ;watch out with ebx - it's passed
	mov dword ptr ds:[tsmach2+2], eax
	add eax, edx
	mov dword ptr ds:[tsmach5+2], eax

	mov dword ptr ds:[tsmach3+2], ecx  ;yinc's
	ret

	PUBLIC tspritevline_
tspritevline_:
	;eax = 0, ebx = x, ecx = cnt, edx = y, esi = yplc, edi = p
	push ebp
	mov ebp, ebx
	xor ebx, ebx
	jmp tenterspritevline

tprestartsvline:
tsmach1: add ebp, 88888888h              ;xincshl16
	mov al, byte ptr [esi]
tsmach2: adc esi, 88888888h              ;xincshr16+yalwaysinc

tstartsvline:
	cmp al, 255
	je short tskipsvline
	mov bh, byte ptr [edi]
tspal: mov bl, [eax+88888888h]               ;palookup
tmach4: mov al, byte ptr [ebx+88888888h]     ;transluc
	mov byte ptr [edi], al
tskipsvline:
tfixchain1s: add edi, 320

tenterspritevline:
tsmach3: add edx, 88888888h              ;dayinc
	dec ecx
	ja short tprestartsvline     ;jump if (no carry (add)) and (not zero (dec))!
	jz short tendsvline
tsmach4: add ebp, 88888888h              ;xincshl16
	mov al, byte ptr [esi]
tsmach5: adc esi, 88888888h              ;xincshr16+yalwaysinc+daydime
	jmp short tstartsvline
tendsvline:
	pop ebp
	ret

PUBLIC msethlineshift_
msethlineshift_:
	neg al
	mov byte ptr ds:[msh1d+2], al
	mov byte ptr ds:[msh2d+3], bl
	mov byte ptr ds:[msh3d+2], al
	mov byte ptr ds:[msh4d+3], bl
	mov byte ptr ds:[msh5d+2], al
	mov byte ptr ds:[msh6d+3], bl
	ret

PUBLIC mhline_
mhline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax = picoffs
	;ebx = bx
	;ecx = cnt
	;edx = ?
	;esi = by
	;edi = p

	mov dword ptr ds:[mmach1d+2], eax
	mov dword ptr ds:[mmach5d+2], eax
	mov dword ptr ds:[mmach9d+2], eax
	mov eax, _asm3
	mov dword ptr ds:[mmach2d+2], eax
	mov dword ptr ds:[mmach2da+2], eax
	mov dword ptr ds:[mmach2db+2], eax
	mov dword ptr ds:[mmach6d+2], eax
	mov dword ptr ds:[mmach10d+2], eax
	mov eax, _asm1
	mov dword ptr ds:[mmach3d+2], eax
	mov dword ptr ds:[mmach7d+2], eax
	mov eax, _asm2
	mov dword ptr ds:[mmach4d+2], eax
	mov dword ptr ds:[mmach8d+2], eax
	jmp short mhlineskipmodify_

PUBLIC mhlineskipmodify_
mhlineskipmodify_:

	push ebp

	xor eax, eax
	mov ebp, ebx

	test ecx, 00010000h
	jnz short mbeghline

msh1d: shr ebx, 26
msh2d: shld ebx, esi, 6
	add ebp, _asm1
mmach9d: mov al, byte ptr [ebx+88888888h]    ;picoffs
	add esi, _asm2
	cmp al, 255
	je mskip5

	mmach10d: mov cl, byte ptr [eax+88888888h]    ;shadeoffs
	mov byte ptr [edi], cl
mskip5:
	inc edi
	sub ecx, 65536
	jc mendhline
	jmp short mbeghline

mpreprebeghline:                                            ;1st only
	mov al, cl
mmach2d: mov al, byte ptr [eax+88888888h]    ;shadeoffs
	mov byte ptr [edi], al

mprebeghline:
	add edi, 2
	sub ecx, 131072
	jc short mendhline
mbeghline:
mmach3d: lea ebx, [ebp+88888888h]            ;bxinc
msh3d: shr ebp, 26
msh4d: shld ebp, esi, 6
mmach4d: add esi, 88888888h                  ;byinc
mmach1d: mov cl, byte ptr [ebp+88888888h]    ;picoffs
mmach7d: lea ebp, [ebx+88888888h]            ;bxinc

msh5d: shr ebx, 26
msh6d: shld ebx, esi, 6
mmach8d: add esi, 88888888h                  ;byinc
mmach5d: mov ch, byte ptr [ebx+88888888h]    ;picoffs

	cmp cl, 255
	je short mskip1
	cmp ch, 255
	je short mpreprebeghline

	mov al, cl                                                  ;BOTH
mmach2da: mov bl, byte ptr [eax+88888888h]    ;shadeoffs
	mov al, ch
mmach2db: mov bh, byte ptr [eax+88888888h]    ;shadeoffs
	mov word ptr [edi], bx
	add edi, 2
	sub ecx, 131072
	jnc short mbeghline
	jmp mendhline

mskip1:                                                     ;2nd only
	cmp ch, 255
	je short mprebeghline

	mov al, ch
mmach6d: mov al, byte ptr [eax+88888888h]    ;shadeoffs
	mov byte ptr [edi+1], al
	add edi, 2
	sub ecx, 131072
	jnc short mbeghline
mendhline:

	pop ebp
	ret

PUBLIC tsethlineshift_
tsethlineshift_:
	neg al
	mov byte ptr ds:[tsh1d+2], al
	mov byte ptr ds:[tsh2d+3], bl
	mov byte ptr ds:[tsh3d+2], al
	mov byte ptr ds:[tsh4d+3], bl
	mov byte ptr ds:[tsh5d+2], al
	mov byte ptr ds:[tsh6d+3], bl
	ret

PUBLIC thline_
thline_:
	;_asm1 = bxinc
	;_asm2 = byinc
	;_asm3 = shadeoffs
	;eax = picoffs
	;ebx = bx
	;ecx = cnt
	;edx = ?
	;esi = by
	;edi = p

	mov dword ptr ds:[tmach1d+2], eax
	mov dword ptr ds:[tmach5d+2], eax
	mov dword ptr ds:[tmach9d+2], eax
	mov eax, _asm3
	mov dword ptr ds:[tmach2d+2], eax
	mov dword ptr ds:[tmach6d+2], eax
	mov dword ptr ds:[tmach10d+2], eax
	mov eax, _asm1
	mov dword ptr ds:[tmach3d+2], eax
	mov dword ptr ds:[tmach7d+2], eax
	mov eax, _asm2
	mov dword ptr ds:[tmach4d+2], eax
	mov dword ptr ds:[tmach8d+2], eax
	jmp thlineskipmodify_

PUBLIC thlineskipmodify_
thlineskipmodify_:

	push ebp

	xor eax, eax
	xor edx, edx
	mov ebp, ebx

	test ecx, 00010000h
	jnz short tbeghline

tsh1d: shr ebx, 26
tsh2d: shld ebx, esi, 6
	add ebp, _asm1
tmach9d: mov al, byte ptr [ebx+88888888h]    ;picoffs
	add esi, _asm2
	cmp al, 255
	je tskip5

tmach10d: mov dl, byte ptr [eax+88888888h]   ;shadeoffs
	mov dh, byte ptr [edi]
tmach1: mov al, byte ptr [edx+88888888h]     ;transluc
	mov byte ptr [edi], al
tskip5:
	inc edi
	sub ecx, 65536
	jc tendhline
	jmp short tbeghline

tprebeghline:
	add edi, 2
	sub ecx, 131072
	jc short tendhline
tbeghline:
tmach3d: lea ebx, [ebp+88888888h]            ;bxinc
tsh3d: shr ebp, 26
tsh4d: shld ebp, esi, 6
tmach4d: add esi, 88888888h                  ;byinc
tmach1d: mov cl, byte ptr [ebp+88888888h]    ;picoffs
tmach7d: lea ebp, [ebx+88888888h]            ;bxinc

tsh5d: shr ebx, 26
tsh6d: shld ebx, esi, 6
tmach8d: add esi, 88888888h                  ;byinc
tmach5d: mov ch, byte ptr [ebx+88888888h]    ;picoffs

	cmp cx, 0ffffh
	je short tprebeghline

	mov bx, word ptr [edi]

	cmp cl, 255
	je short tskip1
	mov al, cl
tmach2d: mov dl, byte ptr [eax+88888888h]    ;shadeoffs
	mov dh, bl
tmach2: mov al, byte ptr [edx+88888888h]     ;transluc
	mov byte ptr [edi], al

	cmp ch, 255
	je short tskip2
tskip1:
	mov al, ch
tmach6d: mov dl, byte ptr [eax+88888888h]    ;shadeoffs
	mov dh, bh
tmach3: mov al, byte ptr [edx+88888888h]     ;transluc
	mov byte ptr [edi+1], al
tskip2:

	add edi, 2
	sub ecx, 131072
	jnc tbeghline
tendhline:

	pop ebp
	ret


	;eax=shiftval, ebx=palookup1, ecx=palookup2
PUBLIC setuptvlineasm2_
setuptvlineasm2_:
	mov byte ptr ds:[tran2shra+2], al
	mov byte ptr ds:[tran2shrb+2], al
	mov dword ptr ds:[tran2pala+2], ebx
	mov dword ptr ds:[tran2palb+2], ecx
	mov dword ptr ds:[tran2palc+2], ebx
	mov dword ptr ds:[tran2pald+2], ecx
	ret

	;Pass:   eax=vplc2, ebx=vinc1, ecx=bufplc1, edx=bufplc2, esi=vplc1, edi=p
	;        _asm1=vinc2, _asm2=pend
	;Return: _asm1=vplc1, _asm2=vplc2
PUBLIC tvlineasm2_
tvlineasm2_:
	push ebp

	mov ebp, eax

	mov dword ptr ds:[tran2inca+2], ebx
	mov eax, _asm1
	mov dword ptr ds:[tran2incb+2], eax

	mov dword ptr ds:[tran2bufa+2], ecx         ;bufplc1
	mov dword ptr ds:[tran2bufb+2], edx         ;bufplc2

	mov eax, _asm2
	sub edi, eax
	mov dword ptr ds:[tran2edia+3], eax
	mov dword ptr ds:[tran2edic+2], eax
	inc eax
	mov dword ptr ds:[tran2edie+2], eax
fixchaint2a: sub eax, 320
	mov dword ptr ds:[tran2edif+2], eax
	dec eax
	mov dword ptr ds:[tran2edib+3], eax
	mov dword ptr ds:[tran2edid+2], eax

	xor ecx, ecx
	xor edx, edx
	jmp short begintvline2

		;eax 0000000000  temp  temp
		;ebx 0000000000 odat2 odat1
		;ecx 0000000000000000 ndat1
		;edx 0000000000000000 ndat2
		;esi          vplc1
		;edi videoplc--------------
		;ebp          vplc2

		;LEFT ONLY
skipdraw2:
tran2edic: mov ah, byte ptr [edi+88888888h]      ;getpixel
tran2palc: mov al, byte ptr [ecx+88888888h]      ;palookup1
fixchaint2d: add edi, 320
tran2trac: mov bl, byte ptr [eax+88888888h]      ;_transluc
tran2edid: mov byte ptr [edi+88888888h-320], bl  ;drawpixel
	jnc short begintvline2
	jmp endtvline2

skipdraw1:
	cmp dl, 255
	jne short skipdraw3
fixchaint2b: add edi, 320
	jc short endtvline2

begintvline2:
	mov eax, esi
	mov ebx, ebp
tran2shra: shr eax, 88h                      ;globalshift
tran2inca: add esi, 88888888h                ;vinc1
tran2shrb: shr ebx, 88h                      ;globalshift
tran2incb: add ebp, 88888888h                ;vinc2
tran2bufa: mov cl, byte ptr [eax+88888888h]  ;bufplc1
tran2bufb: mov dl, byte ptr [ebx+88888888h]  ;bufplc2

	cmp cl, 255
	je short skipdraw1
	cmp dl, 255
	je short skipdraw2

		;BOTH
tran2edia: mov bx, word ptr [edi+88888888h]      ;getpixels
tran2pala: mov al, byte ptr [ecx+88888888h]      ;palookup1
	mov ah, bl
tran2palb: mov bl, byte ptr [edx+88888888h]      ;palookup2
fixchaint2c: add edi, 320
tran2traa: mov al, byte ptr [eax+88888888h]      ;_transluc
tran2trab: mov ah, byte ptr [ebx+88888888h]      ;_transluc
tran2edib: mov word ptr [edi+88888888h-320], ax  ;drawpixels
	jnc short begintvline2
	jmp short endtvline2

		;RIGHT ONLY
skipdraw3:
tran2edie: mov ah, byte ptr [edi+88888889h]      ;getpixel
tran2pald: mov al, byte ptr [edx+88888888h]      ;palookup2
fixchaint2e: add edi, 320
tran2trad: mov bl, byte ptr [eax+88888888h]      ;_transluc
tran2edif: mov byte ptr [edi+88888889h-320], bl  ;drawpixel
	jnc short begintvline2

endtvline2:
	mov _asm1, esi
	mov _asm2, ebp

	pop ebp
	ret

CODE ENDS
END
