DECLARE SUB hbline (xl&, xr&, yp&, hd&, id&, walnume%, shadeoffs%)
DECLARE SUB vbline (xp&, yl&, yr&, hd&, id&, walnume%, shadeoffs%)
DECLARE SUB setupscreen ()
DECLARE SUB loadnewall (wallnum%)
DECLARE SUB loadtables ()
CONST MAXTILES = 4096, XDIM = 320, YDIM = 200

COMMON SHARED posx&, posy&, posz&, ang%, bang%
DIM SHARED buf%(4096), sintable&(2048), umost%(XDIM), dmost%(XDIM)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)

RANDOMIZE TIMER
CALL loadtables
CALL setupscreen
CALL loadnewall(2)

DO
   ang% = INT(2048 * RND): bang% = INT(2048 * RND)
   posx& = INT(64 * RND): posy& = INT(64 * RND)
   posz& = INT(4096 * RND) + 6144
   FOR y& = 0 TO 199
      CALL hbline(0, 319, y&, hd&, id&, 0, 0)
   NEXT y&
  
   ang% = INT(2048 * RND): bang% = INT(2048 * RND)
   posx& = INT(64 * RND): posy& = INT(64 * RND)
   posz& = INT(4096 * RND) + 6144
   FOR x& = 0 TO 319
      CALL vbline(x&, 0, 199, hd&, id&, 0, 0)
   NEXT x&
LOOP WHILE INKEY$ = ""

SUB hbline (xl&, xr&, yp&, hd&, id&, walnume%, shadeoffs%)
   IF tilesizx%(walnume%) = 0 OR tilesizy%(walnume%) = 0 THEN EXIT SUB
   IF xl& > xr& THEN SWAP xl&, xr&
  
   cosbang& = sintable&((bang% + 2560) AND 2047)
   sinbang& = sintable&((bang% + 2048) AND 2047)
   top& = ((160& * cosbang& - (yp& - 100) * sinbang&) \ 256) * posz&
   bot& = ((yp& - 100) * cosbang& + 160& * sinbang&) \ 256
   IF bot& = 0 THEN EXIT SUB
   hd& = top& \ bot&
   IF ABS(hd&) >= 131072 THEN EXIT SUB
   id& = (hd& * cosbang& + posz& * sinbang&) \ 16384&
  
   xx& = (hd& * sintable&((2048 + ang%) AND 2047)) \ 4096&
   yy& = (hd& * sintable&((2560 + ang%) AND 2047)) \ 4096&
   xc& = (id& * sintable&((1536 + ang%) AND 2047)) \ 4096&
   yc& = (id& * sintable&((2048 + ang%) AND 2047)) \ 4096&
   x& = xl& * xc& + (xx& - xc&) * (XDIM \ 2) - (posx& * 4096&)
   y& = xl& * yc& + (yy& - yc&) * (XDIM \ 2) + (posy& * 4096&)
  
   p& = yp& * 320& + xl&: DEF SEG = &HA000
   cnt& = xr& - xl& + 1: shade% = hd& \ 8192&
   WHILE cnt& > 0
      POKE p&, buf%(((x& \ 65536) AND 63) * 64 + ((y& \ 65536) AND 63))
      p& = p& + 1: x& = x& + xc&: y& = y& + yc&: cnt& = cnt& - 1
   WEND
END SUB

SUB loadnewall (wallnum%)
   OPEN "tiles000.art" FOR BINARY AS #1

   GET #1, , version&
   GET #1, , numtiles&
   GET #1, , localtilestart&
   GET #1, , localtileend&
   FOR z% = 0 TO localtileend& - localtilestart& - 1
      GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart& - 1
      GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO localtileend& - localtilestart& - 1
      GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      totsiz& = totsiz& + tilesizx%(z%) * tilesizy%(z%)
   NEXT z%
   SEEK #1, totsiz& + 16 + (localtileend& - localtilestart& + 1) * 8 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 63
      FOR zz% = 0 TO 63
         buf%(bufplc& + z% * 64 + zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB setupscreen
   SCREEN 13
   'OUT &H3C4, &H4: OUT &H3C5, INP(&H3C5) AND (255 - 8)    'CHAIN 4 OFF
   'OUT &H3D4, &H17: OUT &H3D5, INP(&H3D5) OR 64           'WORD MODE
   'OUT &H3D4, &H14: OUT &H3D5, INP(&H3D5) AND (255 - 64)  '2-WORD MODE
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   CLOSE #1
END SUB

SUB vbline (xp&, yl&, yr&, hd&, id&, walnume%, shadeoffs%)
   IF tilesizx%(walnume%) = 0 OR tilesizy%(walnume%) = 0 THEN EXIT SUB
   IF yl& > yr& THEN SWAP yl&, yr&
  
   cosbang& = sintable&((bang% + 2560) AND 2047)
   sinbang& = sintable&((bang% + 2048) AND 2047)
  
   top& = ((100& * cosbang& - (xp& - 160) * sinbang&) \ 256) * posz&
   bot& = ((xp& - 160) * cosbang& + 100& * sinbang&) \ 256
   IF bot& = 0 THEN EXIT SUB
   hd& = top& \ bot&
   IF ABS(hd&) >= 131072 THEN EXIT SUB
   id& = (hd& * cosbang& + posz& * sinbang&) \ 16384&
  
   xx& = (hd& * sintable&((2560 + ang%) AND 2047)) \ 4096&
   yy& = (hd& * sintable&((2048 + ang%) AND 2047)) \ 4096&
   xc& = (id& * sintable&((2560 + ang%) AND 2047)) \ 4096&
   yc& = (id& * sintable&((2048 - ang%) AND 2047)) \ 4096&
   y& = yl& * yc& + (xx& - yc&) * (YDIM \ 2)
   x& = yl& * xc& + (yy& - xc&) * (YDIM \ 2)
  
   p& = yl& * 320& + xp&: DEF SEG = &HA000
   cnt& = yr& - yl&: shade% = id& \ 8192&
   WHILE cnt& >= 0
      POKE p&, buf%(((x& \ 65536) AND 63) * 64 + ((y& \ 65536) AND 63))
      p& = p& + 320&: x& = x& + xc&: y& = y& + yc&: cnt& = cnt& - 1
   WEND
END SUB

