#include <malloc.h>
#include <dos.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#define MAXTILES 4096
#define MAXTILEFILES 256
#define MAXPALOOKUPS 256
#define XDIM 320
#define YDIM 200

static char picsiz[MAXTILES], artfilename[20];
static short tilesizx[MAXTILES], tilesizy[MAXTILES], numtiles;
static long picanm[MAXTILES], waloff[MAXTILES], artversion;
static long localtilestart[MAXTILEFILES], localtileend[MAXTILEFILES];
static long numtilefiles;
static char *pic[MAXTILEFILES];

static char palette[768], paletteloaded = 0;
short numpalookups;
char *palookup[MAXPALOOKUPS];
static short int sintable[2048];

static long posx, posy, posz, ang, bang;

long totalclock, numframes;
volatile char keystatus[256];
volatile unsigned char readch, oldreadch, extended;
static void (__interrupt __far *oldtimerhandler)();
static void __interrupt __far timerhandler(void);
static void (__interrupt __far *oldkeyhandler)();
static void __interrupt __far keyhandler(void);

long asm1, asm2, asm3, asm4;
extern long setpalookupaddress(long);
#pragma aux setpalookupaddress parm [eax];
extern long sethlinesizes(long,long,long);
#pragma aux sethlinesizes parm [eax][ebx][ecx];
extern long hlineasm64(long,long,long,long,long,long);
#pragma aux hlineasm64 parm [eax][ebx][ecx][edx][esi][edi];

#pragma aux scale =\
	"imul ebx",\
	"idiv ecx",\
	parm [eax][ebx][ecx]\
	modify [eax edx]\

#pragma aux mulscale =\
	"imul ebx",\
	"shrd eax, edx, cl",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux divscale =\
	"cdq",\
	"shld edx, eax, cl",\
	"sal eax, cl",\
	"idiv ebx",\
	parm [eax][ebx][ecx]\
	modify [edx]\

#pragma aux setvmode =\
	"int 0x10",\
	parm [eax]\

#pragma aux drawpixel =\
	"mov byte ptr [edi], al",\
	parm [edi][eax]\

#pragma aux interruptend =\
	"mov al, 20h",\
	"out 20h, al",\
	modify [eax]\

#pragma aux readkey =\
	"in al, 0x60",\
	"mov readch, al",\
	"in al, 0x61",\
	"or al, 0x80",\
	"out 0x61, al",\
	"and al, 0x7f",\
	"out 0x61, al",\
	modify [eax]\

void __interrupt __far timerhandler()
{
	totalclock++;
	interruptend();
}

void __interrupt __far keyhandler()
{
	oldreadch = readch;
	readkey();
	if ((readch|1) == 0xe1)
		extended = 128;
	else
	{
		if (oldreadch != readch)
			keystatus[(readch&127)+extended] = ((readch>>7)^1);
		extended = 0;
	}
	interruptend();
}

main()
{
	char ch, orientation;
	short picnum;
	long x, y, top, bot, hd, id, cosbang, sinbang, daposz, templong;

	loadtables();
	loadpics("tiles000.art");
	setgamemode();
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();

	picnum = 0;
	posx = 0, posy = 0, posz = 4096, ang = 0, bang = 512;
	orientation = 0;

	oldtimerhandler = _dos_getvect(0x8);
	_dos_setvect(0x8, timerhandler);
	outp(0x43,54); outp(0x40,9942&255); outp(0x40,9942>>8);
	totalclock = 0L;
	numframes = 0;

	while (keystatus[1] == 0)
	{
		if (orientation == 0)
		{
			sethlinesizes(picsiz[picnum]&15,picsiz[picnum]>>4,waloff[picnum]);
			for(y=0;y<YDIM;y++)
				hbline(0L,(long)XDIM-1,y,picnum,0);
		}
		else
		{
			cosbang = sintable[(bang+2560)&2047];
			sinbang = sintable[(bang+2048)&2047];
			for(x=0;x<XDIM;x++)
			{
				top = (((YDIM>>1)*cosbang - (x-(XDIM>>1))*sinbang)>>8);
				bot = (((x-(XDIM>>1))*cosbang + (YDIM>>1)*sinbang)>>8);
				if (bot != 0)
				{
					daposz = posz; if (bot > 0) daposz = (8192-posz);
					hd = (top*daposz) / bot;
					if (labs(hd) < 131072)
					{
						id = ((hd*cosbang + daposz*sinbang)>>14);
						if (bot < 0) hd = -hd, id = -id;
						vbline(x,0L,(long)YDIM-1,hd,id,picnum,0);
					}
				}
			}
		}

		if (keystatus[0xc9] > 0) bang -= 8;
		if (keystatus[0xd1] > 0) bang += 8;

		if (keystatus[0xc8] > 0)
		{
			posx += (sintable[(2560+ang)&2047]>>10);
			posy += (sintable[(2048+ang)&2047]>>10);
		}
		if (keystatus[0xd0] > 0)
		{
			posx -= (sintable[(2560+ang)&2047]>>10);
			posy -= (sintable[(2048+ang)&2047]>>10);
		}
		if (keystatus[0xcb] > 0) ang += 8;
		if (keystatus[0xcd] > 0) ang -= 8;
		if ((keystatus[0x1e] > 0) && (posz > 128)) posz -= 128;
		if ((keystatus[0x2c] > 0) && (posz < 8192-128)) posz += 128;
		if (keystatus[0x4a] > 0)  // -
		{
			if (picnum > 0) picnum--;
			keystatus[0x4a] = 0;
		}
		if (keystatus[0x4e] > 0)  // +
		{
			if (picnum < MAXTILES-1) picnum++;
			keystatus[0x4e] = 0;
		}
		if (keystatus[0x39] > 0)
		{
			orientation = 1 - orientation;
			keystatus[0x39] = 0;
		}
		numframes++;
	}
	_dos_setvect(0x9, oldkeyhandler);
	_dos_setvect(0x8, oldtimerhandler);
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	setvmode(0x3);
	if (totalclock != 0)
	{
		templong = (numframes*12000L)/totalclock;
		printf("%d.%1d%1d frames per second\n",(short)(templong/100),(short)((templong/10)%10),(short)(templong%10));
	}
	free(pic);
}

hbline (long xl, long xr, long yp, short picnum, char shade)
{
	char *ptr, dat, bad;
	long temp, xx, yy, xc, yc, x, y, p, siz;
	long top, bot, hd, id, cosbang, sinbang, daposz, templong;

	if (picsiz[picnum] == 0) return(0);
	if (xl > xr)
	{
		temp = xl;
		xl = xr;
		xr = temp;
	}

	cosbang = sintable[(bang+2560)&2047];
	sinbang = sintable[(bang+2048)&2047];

	top = (((XDIM>>1)*cosbang - (yp-(YDIM>>1))*sinbang)>>8);
	bot = (((yp-(YDIM>>1))*cosbang + (XDIM>>1)*sinbang)>>8);
	if (bot == 0) return(-1);
	daposz = posz; if (bot > 0) daposz = (8192-posz);
	hd = scale(daposz,top,bot);
	id = mulscale(hd,cosbang,14) + mulscale(daposz,sinbang,14);
	if (bot < 0) hd = -hd, id = -id;

	xx = mulscale(hd,sintable[(2048+ang)&2047],12);
	yy = mulscale(hd,sintable[(2560+ang)&2047],12);
	xc = mulscale(id,sintable[(1536+ang)&2047],12);
	yc = mulscale(id,sintable[(2048+ang)&2047],12);
	x = (xx-xc) * (XDIM>>1) + (posy<<12);
	y = (yy-yc) * (XDIM>>1) + (posx<<12);

	shade = (id>>12);
	if (shade > numpalookups) shade = numpalookups-1;
	p = yp*320+xl+0xa0000;
	siz = xr-xl+1;

	asm1 = xc<<10;
	asm2 = yc<<10;
	asm3 = siz;
	hlineasm64(0L,0L,(long)shade,(long)y<<10,(long)x<<10,(long)p);

	return(0);
}

vbline (long xp, long yl, long yr, long hd, long id, short picnum, char shade)
{
	char *ptr, dat;
	long temp, bufplc, xx, yy, xc, yc, x, y, p, siz;

	if (picsiz[picnum] == 0) return(0);
	if (yl > yr)
	{
		temp = yl;
		yl = yr;
		yr = temp;
	}

	xx = ((hd*sintable[(2560+ang)&2047])>>12);
	yy = ((hd*sintable[(2048+ang)&2047])>>12);
	xc = ((id*sintable[(2560+ang)&2047])>>12);
	yc = ((id*sintable[(2048-ang)&2047])>>12);
	y = (xx-yc) * (YDIM>>1) + (posy<<12);
	x = (yy-xc) * (YDIM>>1) - (posx<<12);

	//shade = (id>>13);
	p = yl*320+xp+0xa0000;
	bufplc = waloff[picnum];
	siz = yr-yl;
	while (siz >= 0)
	{
		ptr = (char *)(bufplc+(((x>>16)&63)<<6)+((y>>16)&63));
		dat = *ptr;
		drawpixel(p,(long)dat);
		p += 320;
		x += xc;
		y += yc;
		siz--;
	}
	return(0);
}

loadpics(char filename[20])
{
	long totpicsiz, offscount, siz;
	short int fil, i, j, k;

	strcpy(artfilename,filename);

	for(i=0;i<MAXTILES;i++)
	{
		tilesizx[i] = 0;
		tilesizy[i] = 0;
		picanm[i] = 0L;
	}

	numtilefiles = 0;
	do
	{
		k = numtilefiles;

		artfilename[7] = (k%10)+48;
		artfilename[6] = ((k/10)%10)+48;
		artfilename[5] = ((k/100)%10)+48;
		if ((fil = open(artfilename,O_BINARY|O_RDONLY,S_IREAD)) != -1)
		{
			read(fil,&artversion,4);
			if (artversion != 1) return(-1);
			read(fil,&numtiles,4);
			read(fil,&localtilestart[k],4);
			read(fil,&localtileend[k],4);
			read(fil,&tilesizx[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&tilesizy[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<1);
			read(fil,&picanm[localtilestart[k]],(localtileend[k]-localtilestart[k]+1)<<2);

			totpicsiz = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
				totpicsiz += (long)(tilesizx[i]*tilesizy[i]);
			pic[k] = (char *)malloc(totpicsiz);

			offscount = 0L;
			for(i=localtilestart[k];i<=localtileend[k];i++)
			{
				waloff[i] = offscount+FP_OFF(pic[k]);
				siz = tilesizx[i]*tilesizy[i];
				if (siz > 0)
				{
					read(fil,&(pic[k])[offscount],siz);
					offscount += siz;
				}
			}
			close(fil);

			numtilefiles++;
		}
	}
	while (k != numtilefiles);

	for(i=0;i<MAXTILES;i++)
	{
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizx[i]))
			j--;
		picsiz[i] = ((char)j);
		j = 15;
		while ((j > 0) && ((1<<j) > tilesizy[i]))
			j--;
		picsiz[i] += ((char)(j<<4));
	}

	return(0);
}

loadtables()
{
	short fil;

	//if (tablesloaded == 0)
	//{
		if ((fil = open("tables.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			read(fil,&sintable[0],4096);
			//read(fil,&tantable[0],4096);
			//read(fil,&radarang[0],640);
			close(fil);
			//tablesloaded = 1;
		}
	//}
	return(0);
}

setgamemode()
{
	short i, fil;

	setvmode(0x13);
	loadpalette();

	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);

	//if (videocard == 1)
	//{
	//   outp(0x3cd,1), clearbuf(0xa0000,16000L,0L);
	//   outp(0x3cd,2), clearbuf(0xa0000,16000L,0L);
	//}

	return(0);
}

loadpalette()
{
	long i, j, fil;

	if (paletteloaded == 0)
	{
		if ((fil = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
		{
			numpalookups = ((filelength(fil)-768)>>7);
			if ((numpalookups&1) > 0)
			{   //Transluscent palette found in palette.dat
				numpalookups = ((numpalookups-255)>>1);
			}
			else
			{    //No transluscent palette in palette.dat
				numpalookups >>= 1;
			}
			read(fil,&palette[0],768);

				//Allocate palookup buffer
			palookup[0] = (char *)malloc(numpalookups<<8);

			setpalookupaddress(FP_OFF(palookup[0]));

			read(fil,palookup[0],(numpalookups<<8));
			close(fil);
		}
		paletteloaded = 1;
	}
}

faketimerhandler()
{
}
