DECLARE SUB loadtables ()
DECLARE SUB drawceilsprite ()
DECLARE FUNCTION mulscale& (eax&, ebx&, ecx&)
DECLARE FUNCTION divscale& (eax&, ebx&, ecx&)
DECLARE SUB ceilspritescan (lx&, rx&)
DECLARE SUB ceilspritehline (x1&, x2&, y&)

CONST XDIM = 320
CONST YDIM = 200

COMMON SHARED posx&, posy&, posz&, horiz&, ang%
COMMON SHARED sx&, sy&, sz&, sang%
COMMON SHARED xoff&, yoff&, xspan&, yspan&, xrepeat&, yrepeat&

DIM SHARED pic%(4096), umost&(XDIM), dmost&(XDIM), lastx&(YDIM)
DIM SHARED sintable&(2048)

DIM SHARED rxi&(8), ryi&(8), rzi&(8), rxi2&(8), ryi2&(8), rzi2&(8)
DIM SHARED xsi&(8), ysi&(8)
DIM SHARED horizlookup&(400)

DIM SHARED globalzd&, globalxpanning&, globalypanning&
DIM SHARED globalx1&, globaly1&, globalx2&, globaly2&

SCREEN 13
CALL loadtables

posx& = 0: posy& = 0: posz& = 0: horiz& = 100: ang% = 0
                               
sx& = 1536: sy& = 0: sz& = 512: sang% = 0
xspan& = 64: yspan& = 64: xoff& = xspan& \ 2: yoff& = yspan& \ 2
xrepeat& = 64: yrepeat& = 64

FOR z% = 0 TO 63
   FOR zz% = 0 TO 63
      pic%(z% * 64 + zz%) = z% + zz%
      IF (z% - 31) * (z% - 32) + (zz% - 31) * (zz% - 32) > 1024 AND RND < .5 THEN pic%(z% * 64 + zz%) = 255
   NEXT zz%
NEXT z%

FOR y& = 0 TO 399
   IF y& <> 200 THEN horizlookup&(y&) = 65536 \ (y& - 200)
NEXT y&

DO
   'LINE (0, 0)-(319, 199), 0, BF
  
   CALL drawceilsprite
  
   'ang% = ((ang% + 8) AND 2047)
   sang% = ((sang% - 32) AND 2047)
  
   z$ = INKEY$
LOOP WHILE z$ <> CHR$(27)

SUB ceilspritehline (x1&, x2&, y&)
   'x = x1 + (x2-x1)t + (y1-y2)u    x = 160v
   'y = y1 + (y2-y1)t + (x2-x1)u    y = (scrx-160)v
   'z = z1 = z2                     z = posz + (scry-horiz)v
  
   v& = mulscale&(globalzd&, horizlookup&(y& - horiz& + 200), 16)
   a& = v& * 160 - globalypanning&
   b& = v& * (x1& - 160) - globalxpanning&
   bxinc& = mulscale&(globalx2&, v&, 16)
   byinc& = mulscale&(globaly2&, v&, 16)
   bx& = mulscale&(globalx1&, a&, 16) + mulscale&(globalx2&, b&, 16)
   by& = mulscale&(globaly1&, a&, 16) + mulscale&(globaly2&, b&, 16)
  
   p& = y& * 320 + x1&: DEF SEG = &HA000
   FOR x& = x1& TO x2&
      dat% = pic%(((bx& \ 65536) * 64 + (by& \ 65536)) AND 4095)
      IF dat% <> 255 THEN POKE p&, dat%
      p& = p& + 1
      bx& = bx& + bxinc&: by& = by& + byinc&
   NEXT x&
END SUB

SUB ceilspritescan (lx&, rx&)
   y1& = umost&(lx&): y2& = umost&(lx&)
   IF y1& < -1 THEN y1& = -1
   IF y1& > YDIM - 1 THEN y1& = YDIM - 1
   IF y2& < 0 THEN y2& = 0
   IF y2& > YDIM THEN y2& = YDIM
   FOR x& = lx& TO rx& - 1
      twall& = umost&(x&)
      bwall& = dmost&(x&)
      IF twall& < bwall& - 1 THEN
       
         IF twall& < -1 THEN twall& = -1
         IF twall& > YDIM - 1 THEN twall& = YDIM - 1
         IF bwall& < 0 THEN bwall& = 0
         IF bwall& > YDIM THEN bwall& = YDIM
       
         IF twall& >= y2& THEN
            WHILE y1& < y2& - 1
               y1& = y1& + 1
               CALL ceilspritehline(lastx&(y1&), x& - 1, y1&)
            WEND
            y1& = twall&
         ELSE
            WHILE y1& < twall&
               y1& = y1& + 1
               CALL ceilspritehline(lastx&(y1&), x& - 1, y1&)
            WEND
            WHILE y1& > twall&
               lastx&(y1&) = x&
               y1& = y1& - 1
            WEND
         END IF

         WHILE y2& > bwall&
            y2& = y2& - 1
            CALL ceilspritehline(lastx&(y2&), x& - 1, y2&)
         WEND
         WHILE y2& < bwall&
            lastx&(y2&) = x&
            y2& = y2& + 1
         WEND
      ELSE
         WHILE y1& < y2& - 1
            y1& = y1& + 1
            CALL ceilspritehline(lastx&(y1&), x& - 1, y1&)
         WEND
         y1& = umost&(x& + 1)
         y2& = y1&
       
         IF y1& < -1 THEN y1& = -1
         IF y1& > YDIM - 1 THEN y1& = YDIM - 1
         IF y2& < 0 THEN y2& = 0
         IF y2& > YDIM THEN y2& = YDIM
      END IF
   NEXT x&
   WHILE y1& < y2& - 1
      y1& = y1& + 1
      CALL ceilspritehline(lastx&(y1&), rx& - 1, y1&)
   WEND
END SUB

FUNCTION divscale& (eax&, ebx&, ecx&)
   'divscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 99                                cdq
   '66 0f a5 c2                          shld    edx,eax,cl
   '66 d3 e0                             shl     eax,cl
   '66 f7 fb                             idiv    ebx

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(divscale&): offset& = VARPTR(divscale&)

   DIM asmprog%(27)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &H99
   POKE p& + 28, &H66: POKE p& + 29, &HF: POKE p& + 30, &HA5: POKE p& + 31, &HC2
   POKE p& + 32, &H66: POKE p& + 33, &HD3: POKE p& + 34, &HE0
   POKE p& + 35, &H66: POKE p& + 36, &HF7: POKE p& + 37, &HFB
   POKE p& + 38, &H26: POKE p& + 39, &HA3: POKE p& + 40, offset& AND 255: POKE p& + 41, (offset& \ 256) AND 255
   POKE p& + 42, &H66: POKE p& + 43, &HC1: POKE p& + 44, &HE8: POKE p& + 45, &H10
   POKE p& + 46, &H26: POKE p& + 47, &HA3: POKE p& + 48, (offset& + 2) AND 255: POKE p& + 49, ((offset& + 2) \ 256) AND 255
   POKE p& + 50, &H5D                                         'pop bp
   POKE p& + 51, &HCA: POKE p& + 52, &H2: POKE p& + 53, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

SUB drawceilsprite
      'Rotate center point
   globalcosang& = sintable&((ang% + 512) AND 2047)
   globalsinang& = sintable&(ang% AND 2047)
   rzi&(0) = (globalcosang& * sx& - globalsinang& * sy&) \ 16384
   rxi&(0) = (globalcosang& * sy& + globalsinang& * sx&) \ 16384
 
      'Get top-left corner
   cosang& = sintable&((ang% + sang% + 512) AND 2047)
   sinang& = sintable&((ang% + sang%) AND 2047)
   dax& = xoff& * xrepeat&: day& = yoff& * yrepeat&
   rzi&(0) = rzi&(0) + (sinang& * dax& + cosang& * day&) \ 65536
   rxi&(0) = rxi&(0) + (sinang& * day& - cosang& * dax&) \ 65536
  
      'Get other 3 corners
   dax& = xspan& * xrepeat&: day& = yspan& * yrepeat&
   rzi&(1) = rzi&(0) - (sinang& * dax&) \ 65536
   rxi&(1) = rxi&(0) + (cosang& * dax&) \ 65536
   dax& = -(cosang& * day&) \ 65536
   day& = -(sinang& * day&) \ 65536
   rzi&(2) = rzi&(1) + dax&: rxi&(2) = rxi&(1) + day&
   rzi&(3) = rzi&(0) + dax&: rxi&(3) = rxi&(0) + day&
  
      'Put all points on same z
   ryi&(0) = sz& - posz&
   ryi&(1) = sz& - posz&
   ryi&(2) = sz& - posz&
   ryi&(3) = sz& - posz&
  

      'Calculate globals for hline texture mapping function
   globalxpanning& = rxi&(0) * 65536
   globalypanning& = rzi&(0) * 65536
   globalzd& = (sz& - posz&) * 65536
 
   dax& = rzi&(1) - rzi&(0): day& = rxi&(1) - rxi&(0)
   bot& = dax& * dax& + day& * day&
   globalx1& = divscale&(dax&, bot&, 22)
   globalx2& = divscale&(day&, bot&, 22)

   dax& = rzi&(3) - rzi&(0): day& = rxi&(3) - rxi&(0)
   bot& = dax& * dax& + day& * day&
   globaly1& = divscale&(dax&, bot&, 22)
   globaly2& = divscale&(day&, bot&, 22)

     
      'Clip polygon in 3-space
   npoints& = 4
  
      'Clip edge 1
   npoints2& = 0
   zzsgn& = rxi&(0) + rzi&(0)
   FOR z& = 0 TO npoints& - 1
      zz& = z& + 1: IF zz& = npoints& THEN zz& = 0
      zsgn& = zzsgn&: zzsgn& = rxi&(zz&) + rzi&(zz&)
      IF zsgn& >= 0 THEN
         rxi2&(npoints2&) = rxi&(z&)
         ryi2&(npoints2&) = ryi&(z&)
         rzi2&(npoints2&) = rzi&(z&)
         npoints2& = npoints2& + 1
      END IF
      IF (zsgn& XOR zzsgn&) < 0 THEN
         t& = divscale&(zsgn&, zsgn& - zzsgn&, 16)
         rxi2&(npoints2&) = rxi&(z&) + mulscale&(t&, rxi&(zz&) - rxi&(z&), 16)
         ryi2&(npoints2&) = ryi&(z&) + mulscale&(t&, ryi&(zz&) - ryi&(z&), 16)
         rzi2&(npoints2&) = rzi&(z&) + mulscale&(t&, rzi&(zz&) - rzi&(z&), 16)
         npoints2& = npoints2& + 1
      END IF
   NEXT z&
   IF npoints2& <= 2 THEN EXIT SUB
     
      'Clip edge 2
   npoints& = 0
   zzsgn& = rxi2&(0) - rzi2&(0)
   FOR z& = 0 TO npoints2& - 1
      zz& = z& + 1: IF zz& = npoints2& THEN zz& = 0
      zsgn& = zzsgn&: zzsgn& = rxi2&(zz&) - rzi2&(zz&)
      IF zsgn& <= 0 THEN
         rxi&(npoints&) = rxi2&(z&)
         ryi&(npoints&) = ryi2&(z&)
         rzi&(npoints&) = rzi2&(z&)
         npoints& = npoints& + 1
      END IF
      IF (zsgn& XOR zzsgn&) < 0 THEN
         t& = divscale&(zsgn&, zsgn& - zzsgn&, 16)
         rxi&(npoints&) = rxi2&(z&) + mulscale&(t&, rxi2&(zz&) - rxi2&(z&), 16)
         ryi&(npoints&) = ryi2&(z&) + mulscale&(t&, ryi2&(zz&) - ryi2&(z&), 16)
         rzi&(npoints&) = rzi2&(z&) + mulscale&(t&, rzi2&(zz&) - rzi2&(z&), 16)
         npoints& = npoints& + 1
      END IF
   NEXT z&
   IF npoints& <= 2 THEN EXIT SUB
     
      'Clip edge 3
   npoints2& = 0
   zzsgn& = ryi&(0) * 160 + (rzi&(0) * horiz&)
   FOR z& = 0 TO npoints& - 1
      zz& = z& + 1: IF zz& = npoints& THEN zz& = 0
      zsgn& = zzsgn&: zzsgn& = ryi&(zz&) * 160 + (rzi&(zz&) * horiz&)
      IF zsgn& >= 0 THEN
         rxi2&(npoints2&) = rxi&(z&)
         ryi2&(npoints2&) = ryi&(z&)
         rzi2&(npoints2&) = rzi&(z&)
         npoints2& = npoints2& + 1
      END IF
      IF (zsgn& XOR zzsgn&) < 0 THEN
         t& = divscale&(zsgn&, zsgn& - zzsgn&, 16)
         rxi2&(npoints2&) = rxi&(z&) + mulscale&(t&, rxi&(zz&) - rxi&(z&), 16)
         ryi2&(npoints2&) = ryi&(z&) + mulscale&(t&, ryi&(zz&) - ryi&(z&), 16)
         rzi2&(npoints2&) = rzi&(z&) + mulscale&(t&, rzi&(zz&) - rzi&(z&), 16)
         npoints2& = npoints2& + 1
      END IF
   NEXT z&
   IF npoints2& <= 2 THEN EXIT SUB

      'Clip edge 4
   npoints& = 0
   zzsgn& = ryi2&(0) * 160 - (rzi2&(0) * (200 - horiz&))
   FOR z& = 0 TO npoints2& - 1
      zz& = z& + 1: IF zz& = npoints2& THEN zz& = 0
      zsgn& = zzsgn&: zzsgn& = ryi2&(zz&) * 160 - (rzi2&(zz&) * (200 - horiz&))
      IF zsgn& <= 0 THEN
         rxi&(npoints&) = rxi2&(z&)
         ryi&(npoints&) = ryi2&(z&)
         rzi&(npoints&) = rzi2&(z&)
         npoints& = npoints& + 1
      END IF
      IF (zsgn& XOR zzsgn&) < 0 THEN
         t& = divscale&(zsgn&, zsgn& - zzsgn&, 16)
         rxi&(npoints&) = rxi2&(z&) + mulscale&(t&, rxi2&(zz&) - rxi2&(z&), 16)
         ryi&(npoints&) = ryi2&(z&) + mulscale&(t&, ryi2&(zz&) - ryi2&(z&), 16)
         rzi&(npoints&) = rzi2&(z&) + mulscale&(t&, rzi2&(zz&) - rzi2&(z&), 16)
         npoints& = npoints& + 1
      END IF
   NEXT z&
   IF npoints& <= 2 THEN EXIT SUB

      'Project onto screen
   lpoint% = -1: lmax& = &H7FFFFFFF
   rpoint% = -1: rmax& = &H80000000
   FOR z% = 0 TO npoints& - 1
      xsi&(z%) = divscale&(rxi&(z%) * 160, rzi&(z%), 16) + 160 * 65536
      ysi&(z%) = divscale&((sz& - posz&) * 160, rzi&(z%), 16) + horiz& * 65536
      IF xsi&(z%) < 0 THEN xsi&(z%) = 0
      IF xsi&(z%) > XDIM * 65536 THEN xsi&(z%) = XDIM * 65536
      IF ysi&(z%) < 0 THEN ysi&(z%) = 0
      IF ysi&(z%) > YDIM * 65536 THEN ysi&(z%) = YDIM * 65536
      IF xsi&(z%) < lmax& THEN lmax& = xsi&(z%): lpoint% = z%
      IF xsi&(z%) > rmax& THEN rmax& = xsi&(z%): rpoint% = z%
   NEXT z%
       
      'Get umost arrays
   z% = lpoint%
   WHILE z% <> rpoint%
      zz% = z% + 1: IF zz% = npoints& THEN zz% = 0
      
      dax1& = (xsi&(z%) + 65535) \ 65536
      dax2& = (xsi&(zz%) + 65535) \ 65536
      IF dax2& > dax1& THEN
         yinc& = divscale&(ysi&(zz%) - ysi&(z%), xsi&(zz%) - xsi&(z%), 16)
         y& = ysi&(z%) + mulscale&(dax1& * 65536 - xsi&(z%), yinc&, 16)
         FOR x& = dax1& TO dax2& - 1
            umost&(x&) = y& \ 65536: y& = y& + yinc&
         NEXT x&
      END IF
   
      z% = zz%
   WEND
    
      'Get dmost arrays
   WHILE z% <> lpoint%
      zz% = z% + 1: IF zz% = npoints& THEN zz% = 0
         
      dax1& = (xsi&(zz%) + 65535) \ 65536
      dax2& = (xsi&(z%) + 65535) \ 65536
      IF dax2& > dax1& THEN
         yinc& = divscale&(ysi&(zz%) - ysi&(z%), xsi&(zz%) - xsi&(z%), 16)
         y& = ysi&(zz%) + mulscale&(dax1& * 65536 - xsi&(zz%), yinc&, 16)
         FOR x& = dax1& TO dax2& - 1
            dmost&(x&) = y& \ 65536: y& = y& + yinc&
         NEXT x&
      END IF
     
      z% = zz%
   WEND
     
      'Additional umost/dmost clipping goes here
      
      'Draw it!
   CALL ceilspritescan((lmax& + 65535) \ 65536, (rmax& + 65535) \ 65536)
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

FUNCTION mulscale& (eax&, ebx&, ecx&)
   'mulscale
   '66 b8 01 00 00 00                    mov     eax,00000001H
   '66 bb 02 00 00 00                    mov     ebx,00000002H
   '66 b9 03 00 00 00                    mov     ecx,00000003H
   '66 f7 eb                             imul    ebx
   '66 0f ad d0                          shrd    eax,edx,cl

   '26 a3 00 00 00 00                   mov es:[00000000H], ax
   '66 c1 e8 10                         shr eax, 10H
   '26 a3 00 00 00 00                   mov es:[00000000H], ax

   deax$ = MKL$(eax&): debx$ = MKL$(ebx&): decx$ = MKL$(ecx&)
   segment& = VARSEG(mulscale&): offset& = VARPTR(mulscale&)

   DIM asmprog%(25)
   DEF SEG = VARSEG(asmprog%(0)): p& = VARPTR(asmprog%(0))
   POKE p& + 0, &H55                                          'push bp
   POKE p& + 1, &H8B: POKE p& + 2, &HEC                       'mov bp, sp
   POKE p& + 3, &HB8: POKE p& + 4, (segment& AND 255): POKE p& + 5, (segment& \ 256) AND 255
   POKE p& + 6, &H8E: POKE p& + 7, &HC0                       'mov es, ax
   POKE p& + 8, &H66: POKE p& + 9, &HB8: POKE p& + 10, ASC(MID$(deax$, 1, 1)): POKE p& + 11, ASC(MID$(deax$, 2, 1)): POKE p& + 12, ASC(MID$(deax$, 3, 1)): POKE p& + 13, ASC(MID$(deax$, 4, 1))
   POKE p& + 14, &H66: POKE p& + 15, &HBB: POKE p& + 16, ASC(MID$(debx$, 1, 1)): POKE p& + 17, ASC(MID$(debx$, 2, 1)): POKE p& + 18, ASC(MID$(debx$, 3, 1)): POKE p& + 19, ASC(MID$(debx$, 4, 1))
   POKE p& + 20, &H66: POKE p& + 21, &HB9: POKE p& + 22, ASC(MID$(decx$, 1, 1)): POKE p& + 23, ASC(MID$(decx$, 2, 1)): POKE p& + 24, ASC(MID$(decx$, 3, 1)): POKE p& + 25, ASC(MID$(decx$, 4, 1))
   POKE p& + 26, &H66: POKE p& + 27, &HF7: POKE p& + 28, &HEB
   POKE p& + 29, &H66: POKE p& + 30, &HF: POKE p& + 31, &HAD: POKE p& + 32, &HD0
   POKE p& + 33, &H26: POKE p& + 34, &HA3: POKE p& + 35, offset& AND 255: POKE p& + 36, (offset& \ 256) AND 255
   POKE p& + 37, &H66: POKE p& + 38, &HC1: POKE p& + 39, &HE8: POKE p& + 40, &H10
   POKE p& + 41, &H26: POKE p& + 42, &HA3: POKE p& + 43, (offset& + 2) AND 255: POKE p& + 44, ((offset& + 2) \ 256) AND 255
   POKE p& + 45, &H5D                                         'pop bp
   POKE p& + 46, &HCA: POKE p& + 47, &H2: POKE p& + 48, &H0   'ret 2
   CALL ABSOLUTE(0, p&)
   DEF SEG
   ERASE asmprog%
END FUNCTION

