DECLARE SUB getcliplines (x&, y&, goalx&, goaly&)
DECLARE FUNCTION keepaway% (x&, y&, clipwall%)
DECLARE FUNCTION raytrace% (x&, y&, xvect&, yvect&, intx&, inty&)
DECLARE FUNCTION clockdir% ()
DECLARE SUB clipmove (x&, y&, xvect&, yvect&)
DECLARE SUB loadtables ()
DECLARE FUNCTION inside% (x&, y&)
DECLARE SUB getlines ()
CONST xdim = 640, ydim = 350, MAXWALLS = 1024, MAXCLIPNUM = 256
COMMON SHARED numwalls%, pag%, posx&, posy&
DIM SHARED sintable&(2048)

COMMON SHARED clipnum%, walldist&
DIM SHARED clipx1&(MAXCLIPNUM), clipy1&(MAXCLIPNUM)
DIM SHARED clipx2&(MAXCLIPNUM), clipy2&(MAXCLIPNUM)
DIM SHARED theclipwall%(MAXCLIPNUM)

TYPE walltype
   x AS LONG
   y AS LONG
   point2 AS INTEGER
END TYPE

DIM SHARED wall(MAXWALLS) AS walltype

CALL loadtables
CALL getlines

walldist& = 256
searchx& = 160
searchy& = 100
numhits% = 0
ang% = 1536
dragit& = -1
DO
   LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
   FOR z% = 0 TO numwalls% - 1
      LINE (wall(z%).x \ 16, wall(z%).y \ 16)-(wall(wall(z%).point2).x \ 16, wall(wall(z%).point2).y \ 16), 12
   NEXT z%
   CIRCLE (posx& \ 16, posy& \ 16), 3, 15
   LINE ((posx& - walldist&) \ 16, (posy& - walldist&) \ 16)-((posx& + walldist&) \ 16, (posy& + walldist&) \ 16), 7, B
   
   z$ = INKEY$

   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   searchx& = searchx& + regs%(2)
   searchy& = searchy& + regs%(3)
   IF searchx& < 4 THEN searchx& = 4
   IF searchx& > 635 THEN searchx& = 635
   IF searchy& < 4 THEN searchy& = 4
   IF searchy& > 345 THEN searchy& = 345
  
   IF dragit& >= 0 THEN
      wall(dragit&).x = searchx& * 16
      wall(dragit&).y = searchy& * 16
   END IF
  
   CIRCLE (searchx&, searchy&), 3, 15
   regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
   obstatus% = bstatus%: bstatus% = regs%(0)
   IF (bstatus% AND 1) > (obstatus% AND 1) THEN
      mindist& = &H7FFFFFFF
      closest% = -1
      FOR z% = 0 TO numwalls% - 1
         dist& = ABS(searchx& * 16 - wall(z%).x) + ABS(searchy& * 16 - wall(z%).y)
         IF dist& < mindist& THEN
            closest% = z%
            mindist& = dist&
         END IF
      NEXT z%
      IF mindist& < 1024 THEN dragit& = closest%
   END IF
   IF bstatus% < obstatus% THEN
      dragit& = -1
   END IF
  
   'CALL clipmove(posx&, posy&, cosang&, sinang&)

   pag% = 1 - pag%: SCREEN 9, , pag%, 1 - pag%
   WAIT &H3DA, &H8, &H8: WAIT &H3DA, &H8
LOOP WHILE z$ <> CHR$(27)
END

SUB clipmove (x&, y&, xvect&, yvect&)
   DIM hitwalls%(3)

   IF (xvect& OR yvect&) = 0 THEN EXIT SUB
  
   oxvect& = xvect&: oyvect& = yvect&
  
   goalx& = x& + xvect& \ 16384
   goaly& = y& + yvect& \ 16384

   CALL getcliplines(x&, y&, goalx&, goaly&)
  
   hitwall% = 0
   cnt% = 3
   WHILE (xvect& OR yvect&) <> 0 AND hitwall% >= 0 AND cnt% > 0
     
      hitwall% = raytrace%(x&, y&, xvect&, yvect&, intx&, inty&)

      IF hitwall% >= 0 THEN
         IF keepaway%(intx&, inty&, hitwall%) = 1 THEN intx& = x&: inty& = y&
        
         lx& = clipx2&(hitwall%) - clipx1&(hitwall%)
         ly& = clipy2&(hitwall%) - clipy1&(hitwall%)
         dist& = SQR(lx& * lx& + ly& * ly&)
         slidex& = (lx& * 16384) \ dist&
         slidey& = (ly& * 16384) \ dist&
         slidevel& = ((goalx& - intx&) * slidex& + (goaly& - inty&) * slidey&) \ 128
         xvect& = (slidex& * slidevel&) \ 128
         yvect& = (slidey& * slidevel&) \ 128
        
         bad% = 0
         templong1& = lx& * (oxvect& \ 64) + ly& * (oyvect& \ 64)
         FOR z% = cnt% + 1 TO 3
            templong2& = (clipx2&(hitwalls%(z%)) - clipx1&(hitwalls%(z%))) * (oxvect& \ 64) + (clipy2&(hitwalls%(z%)) - clipy1&(hitwalls%(z%))) * (oyvect& \ 64)
            IF (templong1& < 0) <> (templong2& < 0) THEN bad% = 1: EXIT SUB
         NEXT z%
        
         IF bad% = 0 THEN
            LINE (x& \ 16, y& \ 16)-(x& \ 16 + xvect& \ 2048, y& \ 16 + yvect& \ 2048), 15
            goalx& = intx& + xvect& \ 16384
            goaly& = inty& + yvect& \ 16384
            snot% = keepaway%(goalx&, goaly&, hitwall%)
            xvect& = (goalx& - intx&) * 16384
            yvect& = (goaly& - inty&) * 16384
         END IF
        
         hitwalls%(cnt%) = hitwall%
         cnt% = cnt% - 1
      END IF

      x& = intx&
      y& = inty&
     
   WEND

END SUB

FUNCTION clockdir%
   minx& = &H7FFFFFFF
   themin% = -1
   i% = -1
   DO
      i% = i% + 1
      IF (wall(wall(i%).point2).x < minx&) THEN
         minx& = wall(wall(i%).point2).x
         themin% = i%
      END IF
   LOOP WHILE (wall(i%).point2 <> 0)

   x0& = wall(themin%).x
   y0& = wall(themin%).y
   x1& = wall(wall(themin%).point2).x
   y1& = wall(wall(themin%).point2).y
   x2& = wall(wall(wall(themin%).point2).point2).x
   y2& = wall(wall(wall(themin%).point2).point2).y

   IF ((y1& >= y2&) AND (y1& <= y0&)) THEN clockdir% = 0: EXIT FUNCTION
   IF ((y1& >= y0&) AND (y1& <= y2&)) THEN clockdir% = 1: EXIT FUNCTION

   templong& = (x0& - x1&) * (y2& - y1&) - (x2& - x1&) * (y0& - y1&)
   IF (templong& < 0) THEN
      clockdir% = 0: EXIT FUNCTION
   ELSE
      clockdir% = 1: EXIT FUNCTION
   END IF

END FUNCTION

SUB getcliplines (x&, y&, goalx&, goaly&)
   clipnum% = 0
  
   cx& = (x& + goalx&) \ 2
   cy& = (y& + goaly&) \ 2
   rad& = SQR((goalx& - x&) * (goalx& - x&) + (goaly& - y&) * (goaly& - y&)) + walldist& + 8
   xmin& = cx& - rad&: ymin& = cy& - rad&
   xmax& = cx& + rad&: ymax& = cy& + rad&

   LINE (xmin& \ 16, ymin& \ 16)-(xmax& \ 16, ymax& \ 16), 1, BF
  
  
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: y1& = wall(z%).y
      x2& = wall(wall(z%).point2).x: y2& = wall(wall(z%).point2).y
     
      bad% = 0
      IF (x1& < xmin& AND x2& < xmin&) THEN bad% = 1
      IF (x1& > xmax& AND x2& > xmax&) THEN bad% = 1
      IF (y1& < ymin& AND y2& < ymin&) THEN bad% = 1
      IF (y1& > ymax& AND y2& > ymax&) THEN bad% = 1
     
      IF y2& > y1& THEN
         IF x2& > x1& THEN
            IF (x2& - x1&) * (ymin& - y1&) - (xmax& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         ELSE
            IF (x2& - x1&) * (ymax& - y1&) - (xmax& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         END IF
      ELSE
         IF x2& > x1& THEN
            IF (x2& - x1&) * (ymin& - y1&) - (xmin& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         ELSE
            IF (x2& - x1&) * (ymax& - y1&) - (xmin& - x1&) * (y2& - y1&) >= 0 THEN bad% = 1
         END IF
      END IF
      
      IF bad% = 0 THEN
         IF x2& > x1& THEN
            y1& = y1& + walldist&: y2& = y2& + walldist&
         ELSE
            y1& = y1& - walldist&: y2& = y2& - walldist&
         END IF
         IF y2& > y1& THEN
            x1& = x1& - walldist&: x2& = x2& - walldist&
         ELSE
            x1& = x1& + walldist&: x2& = x2& + walldist&
         END IF
        
         clipx1&(clipnum%) = x1&: clipy1&(clipnum%) = y1&
         clipx2&(clipnum%) = x2&: clipy2&(clipnum%) = y2&
         theclipwall%(clipnum%) = z%
         LINE (x1& \ 16, y1& \ 16)-(x2& \ 16, y2& \ 16), 8
         PSET (x1& \ 16, y1& \ 16), 7
         PSET (x2& \ 16, y2& \ 16), 7
         clipnum% = clipnum% + 1
      END IF
   NEXT z%
  
   theclipnum% = clipnum%
  
   FOR z% = 0 TO theclipnum% - 1
      zz% = theclipwall%(z%)
      x1& = wall(zz%).x: y1& = wall(zz%).y
      x2& = wall(wall(zz%).point2).x: y2& = wall(wall(zz%).point2).y
     
      IF goalx& > x& THEN
         clipx1&(clipnum%) = x1& - walldist&
         clipy1&(clipnum%) = y1& - walldist&
         clipx2&(clipnum%) = x1& - walldist&
         clipy2&(clipnum%) = y1& + walldist&
      ELSE
         clipx1&(clipnum%) = x1& + walldist&
         clipy1&(clipnum%) = y1& + walldist&
         clipx2&(clipnum%) = x1& + walldist&
         clipy2&(clipnum%) = y1& - walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
     
      IF goaly& > y& THEN
         clipx1&(clipnum%) = x1& + walldist&
         clipy1&(clipnum%) = y1& - walldist&
         clipx2&(clipnum%) = x1& - walldist&
         clipy2&(clipnum%) = y1& - walldist&
      ELSE
         clipx1&(clipnum%) = x1& - walldist&
         clipy1&(clipnum%) = y1& + walldist&
         clipx2&(clipnum%) = x1& + walldist&
         clipy2&(clipnum%) = y1& + walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
     
      IF goalx& > x& THEN
         clipx1&(clipnum%) = x2& - walldist&
         clipy1&(clipnum%) = y2& - walldist&
         clipx2&(clipnum%) = x2& - walldist&
         clipy2&(clipnum%) = y2& + walldist&
      ELSE
         clipx1&(clipnum%) = x2& + walldist&
         clipy1&(clipnum%) = y2& + walldist&
         clipx2&(clipnum%) = x2& + walldist&
         clipy2&(clipnum%) = y2& - walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
    
      IF goaly& > y& THEN
         clipx1&(clipnum%) = x2& + walldist&
         clipy1&(clipnum%) = y2& - walldist&
         clipx2&(clipnum%) = x2& - walldist&
         clipy2&(clipnum%) = y2& - walldist&
      ELSE
         clipx1&(clipnum%) = x2& - walldist&
         clipy1&(clipnum%) = y2& + walldist&
         clipx2&(clipnum%) = x2& + walldist&
         clipy2&(clipnum%) = y2& + walldist&
      END IF
      LINE (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16)-(clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 8
      PSET (clipx1&(clipnum%) \ 16, clipy1&(clipnum%) \ 16), 7
      PSET (clipx2&(clipnum%) \ 16, clipy2&(clipnum%) \ 16), 7
      clipnum% = clipnum% + 1
     
   NEXT z%
END SUB

SUB getlines
   DIM regs%(7): regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
   pag% = 0: SCREEN 9, , pag%, pag%
   numwalls% = 0
   mousx& = xdim \ 2
   mousy& = ydim \ 2
   oldcol% = 0
   obstatus% = 1
   FOR z% = mousx& - 2 TO mousx& + 2
      FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
         PSET (z%, zz%), POINT(z%, zz%) XOR 15
      NEXT zz%
   NEXT z%
   DO
      DO
         z$ = INKEY$
         regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
         IF regs%(2) <> 0 OR regs%(3) <> 0 THEN
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
            mousx& = mousx& + regs%(2)
            mousy& = mousy& + regs%(3)
            IF mousx& < 0 THEN mousx& = 0
            IF mousx& >= xdim THEN mousx& = xdim - 1
            IF mousy& < 0 THEN mousy& = 0
            IF mousy& >= ydim THEN mousy& = ydim - 1
            FOR z% = mousx& - 2 TO mousx& + 2
               FOR zz% = mousy& - 2 + ABS(z% - mousx&) TO mousy& + 2 - ABS(z% - mousx&)
                  PSET (z%, zz%), POINT(z%, zz%) XOR 15
               NEXT zz%
            NEXT z%
         END IF
         regs%(0) = 5: CALL int86old(&H33, regs%(), regs%())
         obstatus% = bstatus%: bstatus% = regs%(0)
      LOOP WHILE z$ = "" AND bstatus% = obstatus%
      IF z$ = " " OR (bstatus% AND 1) > (obstatus% AND 1) THEN
         SCREEN 9, , 1 - pag%, pag%
         LINE (0, 0)-(xdim - 1, ydim - 1), 0, BF
         wall(numwalls%).x = mousx&
         wall(numwalls%).y = mousy&
         IF numwalls% > 0 THEN wall(numwalls% - 1).point2% = numwalls%
         wall(numwalls%).point2 = 0
         numwalls% = numwalls% + 1
         FOR z% = 0 TO numwalls% - 1
            z2% = wall(z%).point2
            LINE (wall(z%).x, wall(z%).y)-(wall(z2%).x, wall(z2%).y), 12
         NEXT z%
         pag% = 1 - pag%: SCREEN 9, , pag%, pag%
         WAIT &H3DA, &H8, &H8
         WAIT &H3DA, &H8
      END IF
   LOOP WHILE z$ <> CHR$(13) AND (bstatus% AND 6) <= (obstatus% AND 6)
  
   IF clockdir% = 1 THEN
      FOR z% = 0 TO numwalls% \ 2 - 1
         SWAP wall(z%).x, wall(numwalls% - 1 - z%).x
         SWAP wall(z%).y, wall(numwalls% - 1 - z%).y
      NEXT z%
   END IF
  
   FOR z% = 0 TO numwalls% - 1
      wall(z%).x = wall(z%).x * 16
      wall(z%).y = wall(z%).y * 16
   NEXT z%
   posx& = mousx& * 16: posy& = mousy& * 16
END SUB

FUNCTION inside% (x&, y&)
   cnt% = 0
   FOR z% = 0 TO numwalls% - 1
      x1& = wall(z%).x: x2& = wall(wall(z%).point2).x
      IF (x1& >= x& OR x2& >= x&) THEN
         y1& = wall(z%).y: y2& = wall(wall(z%).point2).y
         IF y1& > y2& THEN SWAP x1&, x2&: SWAP y1&, y2&
         IF (y1& <= y& AND y2& > y&) THEN
            IF x1& * (y& - y2&) + x2& * (y1& - y&) <= x& * (y1& - y2&) THEN cnt% = 1 - cnt%
         END IF
      END IF
   NEXT z%
   inside% = cnt%
END FUNCTION

FUNCTION keepaway% (x&, y&, clipwall%)
   bakx& = 0: baky& = 0
   IF clipx2&(clipwall%) > clipx1&(clipwall%) THEN baky& = 1
   IF clipx2&(clipwall%) < clipx1&(clipwall%) THEN baky& = -1
   IF clipy2&(clipwall%) > clipy1&(clipwall%) THEN bakx& = -1
   IF clipy2&(clipwall%) < clipy1&(clipwall%) THEN bakx& = 1
  
   IF ABS(clipx2&(clipwall%) - clipx1&(clipwall%)) > ABS(clipy2&(clipwall%) - clipy1&(clipwall%)) THEN
      first% = 0
   ELSE
      first% = 1
   END IF

   daside& = (clipx2&(clipwall%) - clipx1&(clipwall%)) * (y& - clipy1&(clipwall%)) - (x& - clipx1&(clipwall%)) * (clipy2&(clipwall%) - clipy1&(clipwall%))
   WHILE daside& <= 0
     IF first% = 0 THEN
        x& = x& + bakx&
     ELSE
        y& = y& + baky&
     END IF
     first% = 1 - first%
     daside& = (clipx2&(clipwall%) - clipx1&(clipwall%)) * (y& - clipy1&(clipwall%)) - (x& - clipx1&(clipwall%)) * (clipy2&(clipwall%) - clipy1&(clipwall%))
   WEND

   bad% = 0
   z% = clipwall% + 1: IF z% >= clipnum% THEN z% = z% - clipnum%
   zz% = clipwall% + clipnum% - 1: IF zz% >= clipnum% THEN zz% = zz% - clipnum%
   IF clipx1&(z%) <> clipx2&(clipwall%) OR clipy1&(z%) <> clipy2&(clipwall%) THEN
      daside& = (clipx2&(z%) - clipx1&(z%)) * (y& - clipy1&(z%)) - (x& - clipx1&(z%)) * (clipy2&(z%) - clipy1&(z%))
      IF daside& < 0 THEN bad% = 1
   END IF
   IF clipx2&(zz%) <> clipx1&(clipwall%) OR clipy2&(zz%) <> clipy1&(clipwall%) THEN
      daside& = (clipx2&(zz%) - clipx1&(zz%)) * (y& - clipy1&(zz%)) - (x& - clipx1&(zz%)) * (clipy2&(zz%) - clipy1&(zz%))
      IF daside& < 0 THEN bad% = 1
   END IF
  
   keepaway% = bad%
END FUNCTION

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

FUNCTION raytrace% (x&, y&, xvect&, yvect&, intx&, inty&)
  
   x3& = x&: y3& = y&
   x4& = x3& + xvect& \ 16384: y4& = y3& + yvect& \ 16384
   intx& = x4&: inty& = y4&
   hitwall% = -1

   FOR z% = 0 TO clipnum% - 1
      x1& = clipx1&(z%): y1& = clipy1&(z%)
      x2& = clipx2&(z%): y2& = clipy2&(z%)

      templong1& = (x2& - x1&) * (y3& - y1&) - (x3& - x1&) * (y2& - y1&)
      templong2& = (x2& - x1&) * (y4& - y1&) - (x4& - x1&) * (y2& - y1&)
      IF (templong1& >= 0) AND (templong2& < 0) THEN
         templong3& = (x4& - x3&) * (y1& - y3&) - (x1& - x3&) * (y4& - y3&)
         templong4& = (x4& - x3&) * (y2& - y3&) - (x2& - x3&) * (y4& - y3&)
         IF (templong3& <= 0) AND (templong4& > 0) THEN
            bot& = (x2& - x1&) * (y3& - y4&) - (x3& - x4&) * (y2& - y1&)
            IF bot& <> 0 THEN
               topu& = (x2& - x1&) * (y3& - y1&) - (x3& - x1&) * (y2& - y1&)
               nintx& = x3& + ((x4& - x3&) * topu&) \ bot&
               ninty& = y3& + ((y4& - y3&) * topu&) \ bot&
               IF ABS(x3& - nintx&) + ABS(y3& - ninty&) < ABS(x3& - intx&) + ABS(y3& - inty&) THEN
                  intx& = nintx&
                  inty& = ninty&
                  hitwall% = z%
               END IF
            END IF
         END IF
      END IF
   NEXT z%

   raytrace% = hitwall%
END FUNCTION

