DECLARE SUB loadtables ()
DECLARE SUB drawframe (snum%)
CONST MAXPLAYERS = 16

DIM SHARED sx&(MAXPLAYERS), sy&(MAXPLAYERS), v&(MAXPLAYERS)
DIM SHARED frameskipcnt&(MAXPLAYERS)
DIM SHARED sintable&(2048)
DIM SHARED regs%(7)

RANDOMIZE TIMER

SCREEN 13
OUT &H3C8, 0
FOR z% = 0 TO 63: OUT &H3C9, z%: OUT &H3C9, z%: OUT &H3C9, z%: NEXT z%
FOR z% = 0 TO 63: OUT &H3C9, 63 - z%: OUT &H3C9, 63 - z%: OUT &H3C9, 63 - z%: NEXT z%

regs%(0) = 0: CALL int86old(&H33, regs%(), regs%())
CALL loadtables

FOR z% = 0 TO MAXPLAYERS - 1
   sx&(z%) = INT(320 * RND)
   sy&(z%) = INT(200 * RND)
NEXT z%

screenpeek% = INT(MAXPLAYERS * RND)
ocol% = POINT(sx&(screenpeek%), sy&(screenpeek%))
DO
   regs%(0) = 11: CALL int86old(&H33, regs%(), regs%())
   PSET (sx&(screenpeek%), sy&(screenpeek%)), ocol%
   sx&(screenpeek%) = sx&(screenpeek%) + regs%(2)
   sy&(screenpeek%) = sy&(screenpeek%) + regs%(3)
   IF sx&(screenpeek%) < 0 THEN sx&(screenpeek%) = 0
   IF sx&(screenpeek%) > 319 THEN sx&(screenpeek%) = 319
   IF sy&(screenpeek%) < 0 THEN sy&(screenpeek%) = 0
   IF sy&(screenpeek%) > 199 THEN sy&(screenpeek%) = 199
   ocol% = POINT(sx&(screenpeek%), sy&(screenpeek%))
   PSET (sx&(screenpeek%), sy&(screenpeek%)), 64

   dax& = sx&(screenpeek%): day& = sy&(screenpeek%): maxdist& = 0
   FOR z% = 0 TO MAXPLAYERS - 1
      IF z% <> screenpeek% THEN
         dx& = sx&(z%) - dax&: dy& = sy&(z%) - day&
         dist& = dx& * dx& + dy& * dy&
         IF dist& < 64 THEN dist& = 16384 ELSE dist& = 1048576 \ dist&
         dist& = dist& * frameskipcnt&(z%)
         IF dist& > maxdist& THEN maxdist& = dist&: snum% = z%
      END IF
   NEXT z%

   CALL drawframe(snum%)
   v&(snum%) = ((v&(snum%) + 25) AND 2047)
  
   FOR z% = MAXPLAYERS - 1 TO 0 STEP -1
      frameskipcnt&(z%) = frameskipcnt&(z%) + 1
   NEXT z%
   frameskipcnt&(snum%) = 0
  
LOOP

SUB drawframe (snum%)
   dax& = sx&(snum%): day& = sy&(snum%)
   FOR z% = 0 TO 2047 STEP 64
      ang% = v&(snum%) + z%
      x& = sintable&((ang% + 512) AND 2047) \ 2049
      y& = sintable&(ang% AND 2047) \ 2049
      LINE (dax& + x&, day& + y&)-(dax&, day&), z% \ 16
   NEXT z%
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

