DECLARE SUB vline (x&, walnume%)
DECLARE SUB vline4 (x&, walnume%)
DECLARE SUB loadnewall (bufplc&, wallnum%)
DECLARE SUB setupscreen ()
DECLARE SUB loadtables ()

CONST numpalookups = 32, xdim = 320, ydim = 200, MAXTILES = 4096

DIM SHARED palookup%(numpalookups, 256)
DIM SHARED buf%(4096), sintable&(2048), umost%(xdim), dmost%(xdim)
DIM SHARED tilesizx%(MAXTILES), tilesizy%(MAXTILES), picanm&(MAXTILES)
DIM SHARED uwall&(xdim), dwall&(xdim), swall&(xdim), lwall&(xdim)

CALL loadtables
CALL setupscreen
CALL loadnewall(0&, 2)

FOR x& = 0 TO 319
   umost%(x&) = (64 + sintable&(((x& + 616) * 16) AND 2047) \ 256)
   dmost%(x&) = (136 - sintable&(((x& + 1734) * 10) AND 2047) \ 512)
   uwall&(x&) = 65536 * (32 + sintable&(((x& + 346) * 9) AND 2047) \ 512)
   dwall&(x&) = 65536 * (168 - sintable&(((x& + 1373) * 12) AND 2047) \ 512)
   swall&(x&) = (dwall&(x&) - uwall&(x&)) * 4&
   lwall&(x&) = x& * 64&
NEXT x&
FOR z% = 0 TO 10
   z1% = INT(320 * RND)
   z2% = INT(320 * RND)
   SWAP umost%(z1%), umost%(z2%)
   SWAP dmost%(z1%), dmost%(z2%)
   SWAP uwall&(z1%), uwall&(z2%)
   SWAP dwall&(z1%), dwall&(z2%)
   SWAP swall&(z1%), swall&(z2%)
   SWAP lwall&(z1%), lwall&(z2%)
NEXT z%

DO
   FOR x& = 0 TO 319
      LINE (x&, 0)-(x&, 199), 0
      CALL vline(x&, 0)
   NEXT x&
   FOR x& = 0 TO 319 STEP 4
      LINE (x&, 0)-(x& + 3, 199), 0, BF
      CALL vline4(x&, 0)
   NEXT x&
LOOP

DO: LOOP WHILE INKEY$ = ""

SUB loadnewall (bufplc&, wallnum%)
   OPEN "tiles.art" FOR BINARY AS #1

   SEEK #1, 1
   GET #1, , version&
   GET #1, , numtiles&
   FOR z% = 0 TO numtiles& - 1
      GET #1, , tilesizx%(z%)
   NEXT z%
   FOR z% = 0 TO numtiles& - 1
      GET #1, , tilesizy%(z%)
   NEXT z%
   FOR z% = 0 TO numtiles& - 1
      GET #1, , picanm&(z%)
   NEXT z%

   totsiz& = 0
   FOR z% = 0 TO wallnum% - 1
      totsiz& = totsiz& + tilesizx%(z%) * tilesizy%(z%)
   NEXT z%
   SEEK #1, totsiz& + 8 + numtiles& * 8 + 1

   buf$ = STRING$(4096, 0)
   GET #1, , buf$
   DEF SEG = VARSEG(buf$)
   offs& = SADD(buf$)
   FOR z% = 0 TO 63
      FOR zz% = 0 TO 63
         buf%(bufplc& + z% * 64 + zz%) = PEEK(offs&): offs& = offs& + 1
      NEXT zz%
   NEXT z%
   asksave% = 0
   CLOSE #1
END SUB

SUB loadtables
   FOR z& = 0 TO 511
      sintable&(z&) = 16384& * SIN(z& * 3.141592 / 1024)
   NEXT z&
   FOR z& = 512 TO 1023
      sintable&(z&) = sintable&(1023 - z&)
   NEXT z&
   FOR z& = 1024 TO 2047
      sintable&(z&) = -sintable&(z& - 1024)
   NEXT z&
END SUB

SUB setupscreen
   SCREEN 13
   OPEN "palette.dat" FOR BINARY AS #1
   pal$ = STRING$(768, 0)
   GET #1, , pal$
   OUT &H3C8, 0
   FOR z% = 1 TO 768
      OUT &H3C9, ASC(MID$(pal$, z%, 1))
   NEXT z%
   pal$ = STRING$(256, 0)
   FOR z% = 0 TO numpalookups
      GET #1, , pal$
      FOR zz% = 0 TO 255
         palookup%(z%, zz%) = ASC(MID$(pal$, zz% + 1, 1))
      NEXT zz%
   NEXT z%
   CLOSE #1

END SUB

SUB vline (x&, walnume%)
   IF (x& < 0) OR (x& >= xdim) THEN EXIT SUB
  
   y1v% = uwall&(x&) \ 65536
   y2v% = dwall&(x&) \ 65536
   IF (y1v% > dmost%(x&)) OR (y2v% < umost%(x&)) OR (y2v% <= y1v%) OR ((swall&(x&) \ 65536) <= 0) THEN EXIT SUB

      'CALCULATE READOFFS
   picplc& = ((lwall&(x&) * 8) \ 8) AND &HFC0 'wall(walnume%).xrepeat
  
      'CALCULATE VINC
   vinc& = (33554432 * 32) \ (swall&(x&) \ 2048)
  
      'CALCULATE VPLC
   vplc& = ((((uwall&(x&) AND 65535 XOR 65535) * (vinc& \ 256)) \ 256) AND 65535)
   IF (y1v% < umost%(x&)) THEN vplc& = vplc& + (umost%(x&) - y1v%) * vinc&: y1v% = umost%(x&)
   IF (y2v% >= dmost%(x&)) THEN y2v% = dmost%(x&) - 1

      'CALCULATE THESIZ
   thesiz% = y2v% - y1v%
   IF (thesiz% < 1) OR (thesiz% > dmost%(x&)) THEN EXIT SUB
  
      'CALCULATE SHADE
   shade% = vinc& \ 16384&
   IF shade% < 0 THEN shade% = 0
   IF shade% >= numpalookups THEN shade% = numpalookups - 1

      'CALCULATE WRITEOFFS
   DEF SEG = &HA000: p& = y1v% * 320& + x&

      'DRAW!
   FOR zx% = 0 TO thesiz%
      POKE p&, palookup%(shade%, buf%(picplc& + ((vplc& \ 65536) AND 63)))
      vplc& = vplc& + vinc&
      p& = p& + 320
   NEXT zx%
END SUB

SUB vline4 (xstart&, walnume%)
   DIM y1v%(4), y2v%(4), vplc&(4), vinc&(4), shade%(4), picplc&(4), thesiz%(4)

   IF (xstart& + 3 < 0) OR (xstart& >= xdim) THEN EXIT SUB
  
   bad% = 0
   u1& = ydim: u4& = 0: d4& = ydim: d1& = 0
   FOR x& = xstart& TO xstart& + 3
      z% = x& - xstart&
      IF (x& < 0) OR (x& >= xdim) THEN
         y1v%(z%) = ydim
         y2v%(z%) = 0
         bad% = bad% + 1
      ELSE
         y1v%(z%) = uwall&(x&) \ 65536
         y2v%(z%) = dwall&(x&) \ 65536
         IF (y1v%(z%) > dmost%(x&)) OR (y2v%(z%) < umost%(x&)) OR (y2v%(z%) <= y1v%(z%)) OR ((swall&(x&) \ 65536) <= 0 OR swall&(x&) < 2048) THEN
            y1v%(z%) = ydim
            y2v%(z%) = 0
            bad% = bad% + 1
         ELSE
            picplc&(z%) = ((lwall&(x&) * 8) \ 8) AND &HFC0 'wall(walnume%).xrepeat
            vinc&(z%) = (33554432 * 32) \ (swall&(x&) \ 2048)
            vplc&(z%) = ((((uwall&(x&) AND 65535 XOR 65535) * (vinc&(z%) \ 256)) \ 256) AND 65535)
            IF (y1v%(z%) < umost%(x&)) THEN vplc&(z%) = vplc&(z%) + (umost%(x&) - y1v%(z%)) * vinc&(z%): y1v%(z%) = umost%(x&)
            IF (y2v%(z%) >= dmost%(x&)) THEN y2v%(z%) = dmost%(x&) - 1
            thesiz% = y2v%(z%) - y1v%(z%)
            IF (thesiz% < 1) OR (thesiz% > dmost%(x&)) THEN
               y1v%(z%) = ydim
               y2v%(z%) = 0
               bad% = bad% + 1
            END IF
            shade%(z%) = vinc&(z%) \ 16384&
            IF shade%(z%) < 0 THEN shade%(z%) = 0
            IF shade%(z%) >= numpalookups THEN shade%(z%) = numpalookups - 1
         END IF
      END IF
      IF y1v%(z%) < u1& THEN u1& = y1v%(z%)
      IF y1v%(z%) > u4& THEN u4& = y1v%(z%)
      IF y2v%(z%) < d4& THEN d4& = y2v%(z%)
      IF y2v%(z%) > d1& THEN d1& = y2v%(z%)
   NEXT x&
   IF u4& > d4& AND bad% = 0 THEN bad% = 1
   IF bad% > 0 THEN
      u4& = d1& + 1
      d4& = d1&
   END IF

  
   IF bad% > 0 THEN
      FOR z% = 0 TO 3
         IF y2v%(z%) >= y1v%(z%) THEN
            p& = y1v%(z%) * 320& + xstart& + z%: DEF SEG = &HA000
            FOR zx% = y2v%(z%) - y1v%(z%) TO 0 STEP -1
               POKE p&, palookup%(shade%(z%), buf%(picplc&(z%) + ((vplc&(z%) \ 65536) AND 63)))
               vplc&(z%) = vplc&(z%) + vinc&(z%)
               p& = p& + 320&
            NEXT zx%
         END IF
      NEXT z%
   ELSE
      p& = u1& * 320& + xstart&: DEF SEG = &HA000
     
      'Draw 1 pixel at a time for top
      FOR z% = 0 TO 3
         thesiz%(z%) = (y1v%(z%) - u1&)
      NEXT z%
      FOR zx% = u1& TO u4& - 1
         FOR z% = 0 TO 3
            IF thesiz%(z%) <= 0 THEN
               POKE p& + z%, palookup%(shade%(z%), buf%(picplc&(z%) + ((vplc&(z%) \ 65536) AND 63)))
               vplc&(z%) = vplc&(z%) + vinc&(z%)
            END IF
            thesiz%(z%) = thesiz%(z%) - 1
         NEXT z%
         p& = p& + 320&
      NEXT zx%
   
      'Draw 4 pixels at a time
      FOR zx% = u4& TO d4&
         dat0% = palookup%(shade%(0), buf%(picplc&(0) + ((vplc&(0) \ 65536) AND 63)))
         dat1% = palookup%(shade%(1), buf%(picplc&(1) + ((vplc&(1) \ 65536) AND 63)))
         dat2% = palookup%(shade%(2), buf%(picplc&(2) + ((vplc&(2) \ 65536) AND 63)))
         dat3% = palookup%(shade%(3), buf%(picplc&(3) + ((vplc&(3) \ 65536) AND 63)))
         POKE p& + 0, dat0%
         POKE p& + 1, dat1%
         POKE p& + 2, dat2%
         POKE p& + 3, dat3%
         vplc&(0) = vplc&(0) + vinc&(0)
         vplc&(1) = vplc&(1) + vinc&(1)
         vplc&(2) = vplc&(2) + vinc&(2)
         vplc&(3) = vplc&(3) + vinc&(3)
         p& = p& + 320&
      NEXT zx%
     
      'Draw 1 pixel at a time for bottom
      FOR z% = 0 TO 3
         thesiz%(z%) = (y2v%(z%) - d4&)
      NEXT z%
      FOR zx% = d4& + 1 TO d1&
         FOR z% = 0 TO 3
            IF thesiz%(z%) > 0 THEN
               POKE p& + z%, palookup%(shade%(z%), buf%(picplc&(z%) + ((vplc&(z%) \ 65536) AND 63)))
               vplc&(z%) = vplc&(z%) + vinc&(z%)
               thesiz%(z%) = thesiz%(z%) - 1
            END IF
         NEXT z%
         p& = p& + 320&
      NEXT zx%
   END IF
END SUB

