#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>
#define maxpics 256

static int numpics, curpic, mousx, mousy, bstatus;
static int trailstat, xsiz, ysiz;
static unsigned pics;
static long picoffs[maxpics], picseg[maxpics];
static unsigned char picx[maxpics], picy[maxpics], xbuf[2048], ybuf[2048];
static unsigned char tempbuf[16384], tempbuf2[16384], palette[768];
static unsigned char paldef[16][3] =
{
	0,30,63,28,34,60,0,50,20,41,52,28,63,63,25,63,63,63,63,20,20,63,0,63,
	63,48,27,63,40,25,63,48,48,45,63,45,55,55,63,63,40,63,63,30,20,55,25,30
};

main()
{
	char ch, palrot;
	unsigned char col, tempcol, shiftstate;
	int i, j, k, x, y, x1, x2, y1, y2, temp, oldx, oldy, thisx, thisy;
	int xstep, ystep;

	ch = 0;
	x1 = 0;
	y1 = 0;
	x2 = 0;
	y2 = 0;
	if ((pics = convallocate(0x4000)) == -1)        //Danger: 256K maximum
	{
		printf("Allocation failed!");
		exit(-1);
	}
	_asm \
	{
		xor ax, ax
		int 0x33
	}
	printf("Loading data...\n");
	loadpics();
	_asm \
	{
		mov ax, 0x13
		int 0x10
	}
	for(i=0;i<16;i++)
		for(j=1;j<17;j++)
		{
			palette[k++] = (paldef[i][0]*j)/17;
			palette[k++] = (paldef[i][1]*j)/17;
			palette[k++] = (paldef[i][2]*j)/17;
		}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	palrot = 0;
	curpic = 0;
	col = 0;
	drawcolors(col);
	x = (picx[curpic]>>1);
	y = (picy[curpic]>>1);
	xsiz = picx[curpic];
	ysiz = picy[curpic];
	getpic(curpic);
	drawpic(curpic);
	trailstat = 0;
	while (ch != 27)
	{
		mousx = 0;
		mousy = 0;
		bstatus = 0;
		while ((kbhit() == 0) && (mousx == 0) && (mousy == 0) && (bstatus == 0))
		{
			_asm \
			{
				mov dx, 0x3da
waitretr1:
				in al, dx
				test al, 8
				jz waitretr1
waitretr2:
				in al, dx
				test al, 8
				jnz waitretr2

				mov dx, 0x3c8
				mov al, 255
				out dx, al
				inc dx
				mov al, palrot
				out dx, al
				out dx, al
				out dx, al
				inc al
				and al, 63
				mov palrot, al
			}
			hidecurs(x,y);
			showcurs(x,y);
			_asm \
			{
				mov ax, 11
				int 0x33
				sar cx, 1
				sar dx, 1
				mov mousx, cx
				mov mousy, dx
				mov ax, 5
				int 0x33
				mov bstatus, ax
			}
		}
		hidecurs(x,y);
		oldx = x;
		oldy = y;
		x += mousx;
		y += mousy;
		if (x < 0) x = 0;
		if (y < 0) y = 0;
		if (x >= xsiz) x = xsiz-1;
		if (y >= ysiz) y = ysiz-1;
		if (bstatus > 0)
		{
			for(i=0;i<=16;i++)
			{
				thisx = ((x*i)+(oldx*(16-i)))>>4;
				thisy = ((y*i)+(oldy*(16-i)))>>4;
				tempbuf[thisx*ysiz+thisy] = col;
				hidecurs(thisx,thisy);
			}
		}
		if (kbhit() != 0)
		{
			ch = getch();
			if (ch == 0)
			{
				ch = getch();
				_asm \
				{
					xor ax, ax
					mov es, ax
					mov al, byte ptr es:[0x417]
					mov shiftstate, al
				}
				if ((shiftstate&3) > 0)
				{
					if ((ch == 75) && (col >= 16)) col -= 16, drawcolors(col);
					if ((ch == 77) && (col < 240)) col += 16, drawcolors(col);
					if ((ch == 72) && (col > 0)) col--, drawcolors(col);
					if ((ch == 80) && (col < 255)) col++, drawcolors(col);
				}
				else
				{
					if ((ch == 75) && (x > 0)) x--;
					if ((ch == 77) && (x < xsiz-1)) x++;
					if ((ch == 72) && (y > 0)) y--;
					if ((ch == 80) && (y < ysiz-1)) y++;
				}
				if ((ch == 73) && (curpic > 0))
				{
					putpic(curpic);
					curpic--;
					_asm \
					{
						cld
						mov ax, 0xa000
						mov es, ax
						mov cx, 32768
						xor di, di
						xor ax, ax
						rep stosw
					}
					x = (picx[curpic]>>1);
					y = (picy[curpic]>>1);
					xsiz = picx[curpic];
					ysiz = picy[curpic];
					getpic(curpic);
					drawpic(curpic);
					drawcolors(col);
				}
				if ((ch == 81) && (curpic < numpics-1))
				{
					putpic(curpic);
					curpic++;
					_asm \
					{
						cld
						mov ax, 0xa000
						mov es, ax
						mov cx, 32768
						xor di, di
						xor ax, ax
						rep stosw
					}
					x = (picx[curpic]>>1);
					y = (picy[curpic]>>1);
					xsiz = picx[curpic];
					ysiz = picy[curpic];
					getpic(curpic);
					drawpic(curpic);
					drawcolors(col);
				}
				if (ch == 82)
				{
					putpic(curpic);
					_asm \
					{
						cld
						mov ax, 0xa000
						mov es, ax
						mov cx, 32768
						xor di, di
						xor ax, ax
						rep stosw
					}
					xsiz = 64;
					ysiz = 64;
					openrect(0,0,(xsiz<<1)+3,(ysiz<<1)+3,15);
					ch = 0;
					while ((ch != 13) && (ch != 27))
					{
						ch = getch();
						if (ch == 0)
						{
							ch = getch();
							openrect(0,0,(xsiz<<1)+3,(y<<1)+3,0);
							if ((ch == 75) && (xsiz > 4)) xsiz -= 4;
							if ((ch == 77) && (xsiz < 252)) xsiz += 4;
							if ((ch == 72) && (ysiz > 4)) ysiz -= 4;
							if ((ch == 80) && (ysiz < 252)) ysiz += 4;
							openrect(0,0,(xsiz<<1)+3,(ysiz<<1)+3,15);
						}
					}
					if (ch == 13)
					{
						curpic = numpics;
						picx[curpic] = xsiz;
						picy[curpic] = ysiz;
						picseg[curpic] = picseg[curpic-1]+((((unsigned)picx[curpic-1])>>2)*(((unsigned)picy[curpic-1])>>2));
						x = (xsiz>>1);
						y = (ysiz>>1);
						numpics++;
					}
					getpic(curpic);
					drawpic(curpic);
					drawcolors(col);
					ch = 0;
				}
				if ((ch == 83) && (numpics > 0))
				{
					putpic(curpic);
					_asm \
					{
						cld
						mov ax, 0xa000
						mov es, ax
						mov cx, 32768
						xor di, di
						xor ax, ax
						rep stosw
					}
					numpics--;
					picx[curpic] = picx[numpics];
					picy[curpic] = picy[numpics];
					if (curpic >= numpics)
						curpic = numpics-1;
					xsiz = picx[curpic];
					ysiz = picy[curpic];
					x = (xsiz>>1);
					y = (ysiz>>1);
					getpic(curpic);
					drawpic(curpic);
					drawcolors(col);
				}
				ch = 0;
			}
			if (ch == 92)                             // It'a a \!
			{
				x = (xsiz>>1);
				y = (ysiz>>1);
			}
			if ((ch == 32) || (trailstat == 1))
			{
				tempbuf[x*ysiz+y] = col;
				hidecurs(x,y);
			}
			if (ch == 9)
			{
				col = tempbuf[x*ysiz+y];
				drawcolors(col);
			}
			if ((ch == 'T') || (ch == 't'))
			{
				trailstat = 1 - trailstat;
				if (trailstat == 1)
				{
					tempbuf[x*ysiz+y] = col;
					hidecurs(x,y);
				}
			}
			if ((ch == 'R') || (ch == 'r'))
			{
				ch = getch();
				if (ch == 0)
				{
					ch = getch();
					if (ch == 75)
						for(i=xsiz-1;i>=1;i--)
							for(j=0;j<ysiz;j++)
							{
								tempcol = tempbuf[i*ysiz+j];
								tempbuf[i*ysiz+j] = tempbuf[((i+1)%xsiz)*ysiz+j];
								tempbuf[((i+1)%xsiz)*ysiz+j] = tempcol;
							}
					if (ch == 77)
						for(i=1;i<xsiz;i++)
							for(j=0;j<ysiz;j++)
							{
								tempcol = tempbuf[i*ysiz+j];
								tempbuf[i*ysiz+j] = tempbuf[((i+1)%xsiz)*ysiz+j];
								tempbuf[((i+1)%xsiz)*ysiz+j] = tempcol;
							}
					if (ch == 72)
						for(i=0;i<xsiz;i++)
							for(j=ysiz;j>=1;j--)
							{
								tempcol = tempbuf[i*ysiz+j];
								tempbuf[i*ysiz+j] = tempbuf[i*ysiz+((j+1)%ysiz)];
								tempbuf[i*ysiz+((j+1)%ysiz)] = tempcol;
							}
					if (ch == 80)
						for(i=0;i<xsiz;i++)
							for(j=1;j<ysiz;j++)
							{
								tempcol = tempbuf[i*ysiz+j];
								tempbuf[i*ysiz+j] = tempbuf[i*ysiz+((j+1)%ysiz)];
								tempbuf[i*ysiz+((j+1)%ysiz)] = tempcol;
							}
					drawpic(curpic);
				}
			}
			if ((ch == 'C') || (ch == 'c'))
			{
				tempcol = tempbuf[x*ysiz+y];
				for(i=0;i<xsiz;i++)
					for(j=0;j<ysiz;j++)
						if (tempbuf[i*ysiz+j] == tempcol)
							tempbuf[i*ysiz+j] = col;
				drawpic(curpic);
			}
			if ((ch == 'F') || (ch == 'f'))
			{
				fillregion(x,y,col,col);
				drawpic(curpic);
			}
			if ((ch == '-') && (col > 0))
			{
				col = tempbuf[x*ysiz+y]-1;
				tempbuf[x*ysiz+y] = col;
				drawcolors(col);
			}
			if ((ch == '+') && (col < 255))
			{
				col = tempbuf[x*ysiz+y]+1;
				tempbuf[x*ysiz+y] = col;
				drawcolors(col);
			}
			if (ch == 8)
			{
				col = 255;
				tempbuf[x*ysiz+y] = col;
				drawcolors(col);
			}
			if (ch == '1')
			{
				x1 = x;
				y1 = y;
			}
			if (ch == '2')
			{
				x2 = x;
				y2 = y;
				if (x1 > x2) temp = x1, x1 = x2, x2 = temp;
				if (y1 > y2) temp = y1, y1 = y2, y2 = temp;
				for (i=x1;i<=x2;i++)
					for(j=y1;j<=y2;j++)
						tempbuf2[(i-x1)*ysiz+(j-y1)] = tempbuf[i*ysiz+j];
				x2 = x2-x1;
				y2 = y2-y1;
				x1 = 0;
				y1 = 0;
			}
			if (ch == '3')
			{
				for(i=0;i<=x2;i++)
					for(j=0;j<=y2;j++)
						if ((i+x >= 0) && (i+x < xsiz) && (j+y >= 0) && (j+y < ysiz))
							if (tempbuf2[i*ysiz+j] != 255)
								tempbuf[(i+x)*ysiz+(j+y)] = tempbuf2[i*ysiz+j];
				drawpic(curpic);
			}
			if (ch == '4')
			{
				for(i=0;i<=(x2>>1);i++)
					for(j=0;j<=y2;j++)
					{
						temp = tempbuf2[i*ysiz+j];
						tempbuf2[i*ysiz+j] = tempbuf2[(x2-i)*ysiz+j];
						tempbuf2[(x2-i)*ysiz+j] = temp;
					}
			}
			if (ch == '5')
			{
				for(i=0;i<=x2;i++)
					for(j=0;j<=(y2>>1);j++)
					{
						temp = tempbuf2[i*ysiz+j];
						tempbuf2[i*ysiz+j] = tempbuf2[i*ysiz+(y2-j)];
						tempbuf2[i*ysiz+(y2-j)] = temp;
					}
			}
			if (ch == '6')
			{
				for(i=0;i<xsiz;i++)
					for(j=0;j<ysiz;j++)
						if (i > j)
						{
							temp = tempbuf2[i*ysiz+j];
							tempbuf2[i*ysiz+j] = tempbuf2[j*ysiz+i];
							tempbuf2[j*ysiz+i] = temp;
						}
				temp = x2, x2 = y2, y2 = temp;
			}
			if (ch == '/')
			{
				for(i=x1;i<=x2;i++)
					for(j=y1;j<=y2;j++)
						if ((i<(x2>>1)) && (j<(y2>>1)))
							tempbuf2[i*ysiz+j] = tempbuf2[(i<<1)*ysiz+(j<<1)];
				x2 >>= 1;
				y2 >>= 1;
			}
			if (ch == '*')
			{
				x2 = (x2<<1)+1;
				y2 = (y2<<1)+1;
				for(i=x2;i>=x1;i--)
					for(j=y2;j>=y1;j--)
						if ((i<(x2<<1)) && (j<(y2<<1)))
							tempbuf2[i*ysiz+j] = tempbuf2[(i>>1)*ysiz+(j>>1)];
			}
			if ((ch == ',') || (ch == '.') || (ch == '<') || (ch == '>'))
			{
				xstep = 0;
				ystep = 0;
				if (x > x1) xstep = 1;
				if (x < x1) xstep = -1;
				if (y > y1) ystep = 1;
				if (y < y1) ystep = -1;
				i = x1-xstep;
				do
				{
					i += xstep;
					j = y1-ystep;
					do
					{
						j += ystep;
						if ((tempbuf[i*ysiz+j]&15) > 0)
							if (ch == ',') tempbuf[i*ysiz+j]--;
						if ((tempbuf[i*ysiz+j]&15) < 15)
							if (ch == '.') tempbuf[i*ysiz+j]++;
						if (ch == '<')
						{
							tempbuf[i*ysiz+j] += 240;
							tempbuf[i*ysiz+j] &= 255;
						}
						if (ch == '>')
						{
							tempbuf[i*ysiz+j] += 16;
							tempbuf[i*ysiz+j] &= 255;
						}
					}
					while (j != y);
				}
				while (i != x);
				drawpic(curpic);
			}
			if ((ch == 'M') || (ch == 'm'))
				for(i=0;i<xsiz;i++)
					for(j=0;j<xsiz;j++)
						tempbuf2[i*ysiz+j] = tempbuf[i*ysiz+j];
			if ((ch == 'P') || (ch == 'p'))
			{
				for(i=0;i<xsiz;i++)
					for(j=0;j<xsiz;j++)
						tempbuf[i*ysiz+j] = tempbuf2[i*ysiz+j];
				drawpic(curpic);
			}
		}
	}
	putpic(curpic);
	_asm \
	{
		mov ax, 0x3
		int 0x10
	}
	savepics();
	printf("Saving data...\n");
	convdeallocate(pics);
}

loadpics()
{
	int fil, i;
	unsigned u, siz;

	if ((fil=open("pics.dat",O_BINARY|O_RDONLY,S_IREAD))==-1)
		return(-1);
	read(fil,&numpics,2);
	read(fil,&picoffs[0],numpics<<2);
	read(fil,&picx[0],numpics);
	read(fil,&picy[0],numpics);
	read(fil,&palette[0],768);
	u = pics;
	for(i=0;i<numpics;i++)
	{
		siz = ((int)picx[i])*((int)picy[i]);
		read(fil,&tempbuf[0],siz);
		picseg[i] = u;
		putpic(i);
		u += (siz>>4);
	}
	close(fil);
}

savepics()
{
	int fil, i;
	unsigned u;

	if ((fil=open("pics.dat",O_BINARY|O_WRONLY|O_CREAT,S_IWRITE))==-1)
		return(-1);
	write(fil,&numpics,2);
	write(fil,&picoffs[0],numpics<<2);
	write(fil,&picx[0],numpics);
	write(fil,&picy[0],numpics);
	write(fil,&palette[0],768);
	for(i=0;i<numpics;i++)
	{
		getpic(i);
		write(fil,&tempbuf[0],((int)picx[i])*((int)picy[i]));
	}
	close(fil);
}

drawpic(picnume)
int picnume;
{
	int i, j, x, y, cnt, siz;

	x = (int)(picx[picnume]);
	y = (int)(picy[picnume]);
	trailstat = 0;
	siz = x*y;
	openrect(0,0,(x<<1)+1,(y<<1)+1,15);
	_asm \
	{
		cld
		mov ax, 0xa000
		mov es, ax
	}
	cnt = 0;
	for(i=0;i<x;i++)
		for(j=0;j<y;j++)
		{
			_asm \
			{
				mov di, j
				shl di, 1
				mov cl, 6
				shl di, cl
				mov ax, di
				shl ax, 1
				shl ax, 1
				add di, ax
				mov ax, i
				add di, ax
				add di, ax
				mov bx, cnt
				mov al, byte ptr tempbuf[bx]
				mov ah, al
				mov word ptr es:[di+321], ax
				mov word ptr es:[di+641], ax
				inc cnt
			}
		}
}

hidecurs(x,y)
int x, y;
{
	int cnt;

	cnt = (x*ysiz)+y;
	_asm \
	{
		cld
		mov ax, 0xa000
		mov es, ax
		mov di, y
		shl di, 1
		mov cl, 6
		shl di, cl
		mov ax, di
		shl ax, 1
		shl ax, 1
		add di, ax
		mov ax, x
		add di, ax
		add di, ax
		mov bx, cnt
		mov al, byte ptr tempbuf[bx]
		mov ah, al
		mov word ptr es:[di+321], ax
		mov word ptr es:[di+641], ax
	}

}

showcurs(x,y)
int x, y;
{
	int cnt;

	cnt = (x*ysiz)+y;
	_asm \
	{
		cld
		mov ax, 0xa000
		mov es, ax
		mov di, y
		shl di, 1
		mov cl, 6
		shl di, cl
		mov ax, di
		shl ax, 1
		shl ax, 1
		add di, ax
		mov ax, x
		add di, ax
		add di, ax
		mov bx, cnt
		mov al, byte ptr tempbuf[bx]
		xor al, 0x55
		mov ah, al
		mov word ptr es:[di+321], ax
		mov word ptr es:[di+641], ax
	}
}

openrect(x1,y1,x2,y2,col)
unsigned x1, y1, x2, y2;
unsigned char col;
{
	unsigned int i, j, p1, p2;

	if (x1 > x2) i = x1, x1 = x2, x2 = i;
	if (y1 > y2) i = y1, y1 = y2, y2 = i;
	if ((x2 < 0) || (x1 >= 320) || (y2 < 0) || (y1 >= 200))
		return(-1);
	if (x1 < 0) x1 = 0;
	if (x2 >= 320) x2 = 319;
	if (y1 < 0) y1 = 0;
	if (y2 >= 200) y2 = 199;
	p1 = y1*320+x1;
	p2 = y2*320+x2;
	_asm \
	{
		cld
		mov ax, 0xa000
		mov es, ax
	}
	for(i=p1;i<=p1+x2-x1;i++)
		_asm \
		{
			mov di, i
			mov al, col
			mov byte ptr es:[di], al
		}
	for(i=p2+x1-x2;i<=p2;i++)
		_asm \
		{
			mov di, i
			mov al, col
			mov byte ptr es:[di], al
		}
	for(i=p1;i<=p2;i+=320)
		_asm \
		{
			mov di, i
			mov al, col
			mov byte ptr es:[di], al
		}
	for(i=p1+x2-x1;i<=p2;i+=320)
		_asm \
		{
			mov di, i
			mov al, col
			mov byte ptr es:[di], al
		}
}

convallocate(numparagraphs)
unsigned numparagraphs;
{
	unsigned segnum;

	_asm \
	{
		mov ah, 0x48
		mov bx, numparagraphs
		int 0x21
		mov segnum, ax
		jnc allocated
		mov segnum, -1
allocated:
	}
	return(segnum);
}

convdeallocate(segnum)
unsigned segnum;
{
	_asm \
	{
		mov ah, 0x49
		mov es, segnum
		int 0x21
		mov segnum, 0
		jnc deallocated
		mov segnum, -1
deallocated:
	}
	return(segnum);
}

getpic(picnume)
int picnume;
{
	int siz;

	siz = ((int)picx[picnume])*((int)picy[picnume]);
	_asm \
	{
		cld                             ;tempbuf = conventional memory buffer
		mov ax, seg tempbuf
		mov es, ax
		mov di, offset tempbuf
		xor si, si
		mov cx, siz
		shr cx, 1
		mov bx, picnume
		shl bx, 1
		mov ax, word ptr picseg[bx]
		push ds
		mov ds, ax
		rep movsw
		pop ds
	}
}

putpic(picnume)
int picnume;
{
	int siz;

	siz = ((int)picx[picnume])*((int)picy[picnume]);
	_asm \
	{
		cld                           ;conventional memory buffer = tempbuf
		mov si, offset tempbuf
		mov bx, picnume
		shl bx, 1
		mov es, word ptr picseg[bx]
		xor di, di
		mov cx, siz
		shr cx, 1
		rep movsw
	}
}

drawcolors(curcol)
unsigned char curcol;
{
	_asm \
	{
		cld
		mov ax, 0xa000
		mov es, ax
		mov di, 288
		xor al, al
		mov dx, 15
		mov cx, 15
moreofpalette:
		cmp al, curcol
		je skipnormalpaldraw
		mov ah, al
		mov word ptr es:[di+0], ax
		mov word ptr es:[di+320], ax
		jmp skippaldraw2
skipnormalpaldraw:
		mov word ptr es:[di+0], 0x0f0f
		mov word ptr es:[di+320], 0x0f0f
skippaldraw2:
		inc al
		add di, 640
		sub cx, 1
		jns moreofpalette
		sub di, 10238
		mov cx, 15
		sub dx, 1
		jns moreofpalette
	}
}

fillregion(x,y,col,bound)
int x, y;
unsigned char col, bound;
{
	unsigned char tstat, bstat, tlast, blast;
	int i, leftz, z, zz, c;

	c = 1;
	xbuf[c] = x;
	ybuf[c] = y;
	if (tempbuf[x*ysiz+y] == bound)
		return(-1);
	while (c > 0)
	{
		z = xbuf[c];
		zz = ybuf[c];
		c--;
		while ((tempbuf[(z-1)*ysiz+zz] != bound) && (z > 0))
			z--;
		leftz = z;
		tlast = 0;
		blast = 0;
		while ((tempbuf[z*ysiz+zz] != bound) && (z < xsiz))
		{
			if (zz > 0)
			{
				tstat = tempbuf[z*ysiz+zz-1];
				if ((tstat != bound) && (tstat != col))
				{
					if (tlast == 0)
					{
						c++;
						xbuf[c] = z;
						ybuf[c] = zz-1;
						tlast = 1;
					}
				}
				else
					tlast = 0;
			}
			if (zz < ysiz-1)
			{
				bstat = tempbuf[z*ysiz+zz+1];
				if ((bstat != bound) && (bstat != col))
				{
					if (blast == 0)
					{
						c++;
						xbuf[c] = z;
						ybuf[c] = zz+1;
						blast = 1;
					}
				}
				else
					blast = 0;
			}
			z++;
		}
		z--;
		while (z >= leftz)
		{
			i = z*ysiz+zz;
			if ((i&0xc000) == 0)
				tempbuf[z*ysiz+zz] = col;
			z--;
		}
	}
}

/*
		if (ch == '7')
			col1 = tempbuf[x*16+y];
			col2 = col;
			newcol = ((col1+col2)>>1);
			if (col1 == 240)
				newcol = (col2&0xf0)+((col2&15)>>1);
			if (col2 == 240)
				newcol = (col1&0xf0)+((col1&15)>>1);
			if (((newcol == col1) || (newcol == col2) || ((col1>>4) != (col2>>4))) && (col1 != 240) && (col2 != 240))
			else
				for i = 0 TO 63
					for j = 0 TO 63
						if buf(i, j) = col1
							if buf((i + 63) && ( 63, j) = col2
							{
								buf((i+63)&63, j) = newcol
								line(((i + 63) &63) * 3, j * 3)-((((i + 63) ) && ( 63)) * 3 + 2, j * 3 + 2), buf(((i + 63) ) && ( 63),j), BF
							}
						if buf(i, j) = col1
							if buf((i + 1) ) && ( 63, j) = col2
								buf((i + 1) ) && ( 63, j) = newcol
								LINE (((i + 1) ) && ( 63) * 3, j * 3)-((((i + 1) ) && ( 63)) * 3 + 2, j * 3 + 2), buf(((z + 1) ) && ( 63), zz), BF
							END if
						END if
						if buf(z, zz) = col1
							if buf(z, (zz + 63) ) && ( 63) = col2
								buf(z, (zz + 63) ) && ( 63) = newcol
								LINE (z * 3, ((zz + 63) ) && ( 63) * 3)-(z * 3 + 2, ((zz + 63) ) && ( 63) * 3 + 2), buf(z, (zz + 63) ) && ( 63), BF
							END if
						END if
						if buf(z, zz) = col1
							if buf(z, (zz + 1) ) && ( 63) = col2
								buf(z, (zz + 1) ) && ( 63) = newcol
								LINE (z * 3, ((zz + 1) ) && ( 63) * 3)-(z * 3 + 2, ((zz + 1) ) && ( 63) * 3 + 2), buf(z, (zz + 1) ) && ( 63), BF
							END if
						END if
					NEXT zz
				NEXT z
			END if
		END if
		if z$ = "g" OR z$ = "G"
			for z = 0 TO 63 STEP 2
				for zz = 0 TO 63
					if (buf(z, zz) ) && ( 15) > 0
						buf(z, zz) = buf(z, zz) - 1
						LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
					END if
					if (buf(zz, z) ) && ( 15) > 0
						buf(zz, z) = buf(zz, z) - 1
						LINE (zz * 3, z * 3)-(zz * 3 + 2, z * 3 + 2), buf(zz, z), BF
					END if
				NEXT zz
			NEXT z
			asksave = 1
		END if
		if z$ = "S"
			LOCATE 2, 26: INPUT "Search?"; z
			z = z&255
			if z >= 0 ) && ( z <= 255
				outp( 0x3C7, z
				oldcol1 = INP(0x3C9)
				oldcol2 = INP(0x3C9)
				oldcol3 = INP(0x3C9)
				zz = 0
				DO
					zz = (zz + 1) ) && ( 255
					WAIT 0x3DA, 8
					WAIT 0x3DA, 8, 255
					outp( 0x3C8, z
					outp( 0x3C9, zz
					outp( 0x3C9, zz
					outp( 0x3C9, zz
				LOOP WHILE INKEY$ = ""
				outp( 0x3C8, z
				outp( 0x3C9, oldcol1
				outp( 0x3C9, oldcol2
				outp( 0x3C9, oldcol3
			END if
			LOCATE 2, 26: PRINT "            ";
		END if
		if z$ = "J"
			asksave = 1
			col1 = buf(x, y)
			col2 = col
			for z = 0 TO 63
				for zz = 0 TO 63
					if buf(z, zz) = col1
						if INT(10 * RND) = 0  buf(z, zz) = col2
						LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
					END if
				NEXT zz
			NEXT z
			 262, .1
		END if
		if z$ = "'"
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					snot = 0
					totzx = 0
					for zx = 1 TO 6
						x = INT(7 * RND)
						y = INT(7 * RND)
						if abs(x + y) > 4
							x = INT(7 * RND)
							y = INT(7 * RND)
						END if
						avg = buf2((x + z + 63) ) && ( 63, (y + zz + 63) ) && ( 63)
						if (avg ) && ( 0xF0) = bany
							snot = snot + avg
							totzx = totzx + 1
						END if
					NEXT zx
					if totzx > 0
						snot = snot \ totzx
						buf(z, zz) = snot + (buf2(z, zz) - snot) * 1.5
						if (buf(z, zz) ) && ( 0xF0) < bany  buf(z, zz) = bany
						if (buf(z, zz) ) && ( 0xF0) > bany + 15  buf(z, zz) = bany + 15
					END if
					LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
				NEXT zz
			NEXT z
		END if
		if z$ = ":"
			zz = 0
			DO
				zz = (zz + 1) ) && ( 255
				WAIT 0x3DA, 8
				WAIT 0x3DA, 8, 255
				for z = 0 TO 240 STEP 16
					outp( 0x3C8, z
					outp( 0x3C9, zz
					outp( 0x3C9, zz
					outp( 0x3C9, zz
					outp( 0x3C8, z + 15
					outp( 0x3C9, zz
					outp( 0x3C9, zz
					outp( 0x3C9, zz
				NEXT z
			LOOP WHILE INKEY$ = ""
			GOSUB setupcolors
		END if
		if z$ = ";"
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					for zx = 1 TO 1
						x = INT(3 * RND)
						y = INT(3 * RND)
						if abs(x + y) > 1
							x = INT(3 * RND)
							y = INT(3 * RND)
						END if
						dat = buf2((x + z + 63) ) && ( 63, (y + zz + 63) ) && ( 63)
						if (dat ) && ( 0xF0) != bany
							if (buf(z, zz) ) && ( 15) < (dat ) && ( 15) - 1  buf(z, zz) = buf(z, zz) + 1
							if (buf(z, zz) ) && ( 15) > (dat ) && ( 15) + 1  buf(z, zz) = buf(z, zz) - 1
						END if
					NEXT zx
					LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
				NEXT zz
			NEXT z
		END if
		if z$ = "]"
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					snot = 0
					totzx = 0
					for zx = 1 TO 16
						x = INT(3 * RND)
						y = INT(3 * RND)
						if abs(x + y) > 1
							x = INT(3 * RND)
							y = INT(3 * RND)
						END if
						avg = buf2((x + z + 63) ) && ( 63, (y + zz + 63) ) && ( 63)
						if (avg ) && ( 0xF0) = bany
							snot = snot + avg
							totzx = totzx + 1
						END if
					NEXT zx
					if totzx > 0  buf(z, zz) = snot \ totzx
					LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
				NEXT zz
			NEXT z
		END if
		if z$ = "["
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					snot = 0
					totzx = 0
					for zx = 1 TO 6
						x = INT(3 * RND)
						y = INT(3 * RND)
						if abs(x + y) > 1
							x = INT(3 * RND)
							y = INT(3 * RND)
						END if
						avg = buf2((x + z + 63) ) && ( 63, (y + zz + 63) ) && ( 63)
						if (avg ) && ( 0xF0) = bany
							snot = snot + (avg ) && ( 15) * (avg ) && ( 15)
							totzx = totzx + 1
						END if
					NEXT zx
					if totzx > 0
						snot = SQR(snot \ totzx)
						buf(z, zz) = (buf(z, zz) ) && ( 0xF0) + (snot ) && ( 15)
						LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
					END if
				NEXT zz
			NEXT z
		END if
		if z$ = "}"
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					colbany = buf(z, zz) ) && ( 15
					for zx = 1 TO 2
						x = INT(3 * RND) - 1
						y = INT(3 * RND) - 1
						if abs(x + y) > 1
							x = INT(3 * RND)
							y = INT(3 * RND)
						END if
						datzx = buf2((x + z + 64) ) && ( 63, (y + zz + 64) ) && ( 63)
						if (datzx ) && ( 0xF0) != bany
							if x + y > 0 ) && ( colbany > 0  colbany = colbany - 1
							if x + y < 0 ) && ( colbany < 15  colbany = colbany + 1
						END if
					NEXT zx
					buf(z, zz) = (buf(z, zz) ) && ( 0xF0) OR (colbany ) && ( 15)
					LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
				NEXT zz
			NEXT z
		END if
		if z$ = "?"
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					colbany = buf(z, zz) ) && ( 15
					for zx = 1 TO 2
						x = INT(3 * RND) - 1
						y = INT(3 * RND) - 1
						if abs(x + y) > 1
							x = INT(3 * RND)
							y = INT(3 * RND)
						END if
						datzx = buf2((x + z + 64) ) && ( 63, (y + zz + 64) ) && ( 63)
						if (datzx ) && ( 0xF0) != bany ) && ( (datzx ) && ( 0xF0) = (col ) && ( 0xF0)
							if x + y > 0 ) && ( colbany > 0  colbany = colbany - 1
							if x + y < 0 ) && ( colbany < 15  colbany = colbany + 1
						END if
					NEXT zx
					buf(z, zz) = (buf(z, zz) ) && ( 0xF0) OR (colbany ) && ( 15)
					LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
				NEXT zz
			NEXT z
		END if
		if z$ = "{"
			asksave = 1
			for z = 0 TO 63
				for zz = 0 TO 63
					buf2(z, zz) = buf(z, zz)
				NEXT zz
			NEXT z
			for z = 0 TO 63
				for zz = 0 TO 63
					bany = buf2(z, zz) ) && ( 0xF0
					for zx = 1 TO 2
						x = INT(5 * RND) - 1
						y = INT(5 * RND) - 1
						if abs(x + y) > 3
							x = INT(5 * RND)
							y = INT(5 * RND)
						END if
						if abs(x + y) > 1
							x = INT(5 * RND)
							y = INT(5 * RND)
						END if
						datzx = buf2((x + z + 64) ) && ( 63, (y + zz + 64) ) && ( 63)
						if (datzx ) && ( 0xF0) = bany
							if (datzx ) && ( 15) < (buf2(z, zz) ) && ( 15) ) && ( (buf(z, zz) ) && ( 15) > 0  buf(z, zz) = buf(z, zz) - 1
							if (datzx ) && ( 15) > (buf2(z, zz) ) && ( 15) ) && ( (buf(z, zz) ) && ( 15) < 15  buf(z, zz) = buf(z, zz) + 1
						END if
					NEXT zx
					LINE (z * 3, zz * 3)-(z * 3 + 2, zz * 3 + 2), buf(z, zz), BF
				NEXT zz
			NEXT z
		END if
*/

