// "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
// Ken Silverman's official web site: "http://www.advsys.net/ken"
// See the included license file "BUILDLIC.TXT" for license info.

#define MAIN
#include "build.h"

#pragma aux setupmouse =\
	"mov ax, 0",\
	"int 33h",\
	"mov moustat,1",\

#pragma aux setvmode =\
	"int 10h",\
	parm [eax]\

#pragma aux clearscreen =\
	"mov edi, 000a0000h",\
	"mov ecx, 16000d",\
	"xor eax, eax",\
	"rep stosd",\
	parm [edi][ax]\

main(short int argc,char **argv)
{
	unsigned short int l;
	long templong, templong1;
	short int i, j, k, numarg;

	numarg = argc;
	ceilingstat = 1;
	vidmode = 0;
	xdim = 320;
	ydim = 200;
	xtotaldim = 320;
	ytotaldim = 200;
	if (argc >= 3)
	{
		xdim = (atoi(argv[1])&0xfff8);
		ydim = (atoi(argv[2])&0xfff8);
		if (xdim > 320) xdim = 320;
		if (xdim < 8) xdim = 8;
		if (ydim > 200) ydim = 200;
		if (ydim < 8) ydim = 8;
		if ((xdim > 320) || (ydim > 200))
		{
			vidmode = 1;
			xtotaldim = 360;
			ytotaldim = 240;
		}
	}

	centeroffset = (long)(((ytotaldim-ydim)>>1)*320) + ((xtotaldim-xdim)>>1);
	scrsize = ((long)(xdim>>2))*320L;
	loadpics();
	for(i=0;i<242;i++)
	{
		uxsave[i] = -1;
		dxsave[i] = -1;
	}
	capturecount = 0;
	halfwidth = (xdim>>1);
	eigthwidth = (xdim>>3);
	halfheight = (ydim>>1);
	loadtables();
	setupmouse();
	k = 0;
	setvmode(0x13);
	loadboard();
	if (argc == 5)
	{
		posx = ((atol(argv[3]))<<5);
		posy = ((atol(argv[4]))<<5);
	}
	else
	{
		loadintroscreen();
		getch();
		clearscreen();
	}
	if ((i = open("palette.dat",O_BINARY|O_RDWR,S_IREAD)) != -1)
	{
		read(i,&palette[0],768);
		close(i);
	}
	outp(0x3c8,0);
	for(i=0;i<768;i++)
		outp(0x3c9,palette[i]);
	for(i=2;i>=0;i--)
	{
		outp(0x3cd,i);
		clearscreen();
	}
	for(i=0;i<256;i++)
		keystatus[i] = 0;
	clockspeed = 0;
	totalclock = 0;
	takernum = 0;
	for(i=0;i<numtimecounts;i++)
		timetakercount[i] = 0;
	posz = 40960L;
	mousx = 0;
	mousy = 0;
	numframes = 0;
	lintalplc = 0;
	page = 0;
	oldkeyhandler = _dos_getvect(0x9);
	_disable(); _dos_setvect(0x9, keyhandler); _enable();
	oldhand = _dos_getvect(0x8);
	_dos_setvect(0x8, ksmhandler);
	outp(0x43,54); outp(0x40,4972&255); outp(0x40,4972>>8);
	while (keystatus[1] == 0)
	{
		drawscreen();
		nextpage();
		engineinput();

		numframes++;
		totalclock += ((long)clockspeed);
		clockspeed = 0;
	}
	_dos_setvect(0x8, oldhand);
	_dos_setvect(0x9, oldkeyhandler);
	outp(0x43,54); outp(0x40,255); outp(0x40,255);
	free(pic);
	if (numarg != 5)
	{
		setvmode(0x3);
		templong = 0;
		for(i=0;i<numtimecounts;i++)
			templong += timetakercount[i];
		if (templong != 0)
			for(i=0;i<numtimecounts;i++)
			{
				templong1 = (10000L*timetakercount[i])/templong;
				printf("%d - %2d.%1d%1d%% - %s",i,(short int)(templong1/100),(short int)((templong1/10)%10),(short int)(templong1%10),timenames[i]);
				j = (short int)((templong1+50)/100);
				for(k=0;k<(j>>1);k++)
					printf("");
				if ((j&1) > 0)
					printf("");
				printf("\n");
			}
		if (totalclock != 0)
		{
			templong1 = (numframes*24000L)/totalclock;
			printf("%d.%1d%1d frames per second\n",(short int)(templong1/100),(short int)((templong1/10)%10),(short int)(templong1%10));
		}
		printf("Lintalcnt = %d",lintalcnt);
	}
	return(0);
}
